
/* the structure for checking which subnets have been assigned to pterms */
struct node {
	octId nodename; 

	int shape;   /* shape of the AVL tree: LT,EVEN,RT */
	int path;    /* next son on path : LARGE,SMALL */
	struct node *largeson;
	struct node *smallson;
	struct node **nextptr; /* points to pointers in the binary tree */
};

struct Terminal {
	octId termname; /* name of the terminal for width calculations */

	double powreq; /* power requirements for each phase */
/*	struct PowReq *powreq; */

	struct ChildPtr *leftmostson; /* pointer to the array of children */
	struct ChildPtr *currentson; /* points to the leftmost unvisited son */

	struct Terminal *nextterm; /* used for stack */

	struct Terminal *qnext,*qprev;  /* double pointer for queue operations */
};


struct PowReq {
	int clockname; /* CLOCK1, CLOCK2, CLOCK12 */
	double c1phi1r; /* power requirements for phase 1 of clock 1 */
	double c1phi2r;
	double c1phi3r;
	double c1phi4r;
	double c2phi1r; /* power requirements for phase 1 of clock 2 */
	double c2phi2r;
	double c2phi3r;
	double c2phi4r;
};

struct ChildPtr {
	struct Terminal *sonptr;
	struct ChildPtr *nextson;
};
