#include "standard.h"
#define MAXMACRO 50 

typedef struct macrobox {
    int mx ;
    int my ;
} MACROBOX ;

extern int celllen ;
extern double rowSep ;
extern double indent ;
extern int *blkToRow ;
extern int rowHeight ;
extern double macspace[] ;
extern double *padspace ;
extern double *relativeLen ;
extern int *fixLRBT ;

extern MACROBOX *macroArray ;
extern int macNumber , row , totalR ;
extern int totalBlock , borient , empty , cell , middleRow ;
extern int extraSpace , pad , height , width , rows , bot , top , trow ;
extern int brow , rite , left , coreHeight , coreWidth , count , macro ;
extern int maxHeight , space , separation , yshift , xshift , last ;
extern int coreTop , coreRite ,
			block , maxWidth , *padArray , numMacro ;
extern int URmacro , Rmacro , edge ;
extern int k , blk , zxshift , zyshift ;
extern int mttshift , mbbshift ;
extern double dsum , ratio ;

configf( feed_length )
int feed_length ;
{

double totalF , modulation , constant ;
int M , r , topRowY , centerY ;
CBOXPTR padptr ;


for( row = 1 ; row <= numRows ; row++ ) {
    rowArray[row].endx1   = -1 ;
    rowArray[row].startx2 = -1 ;
}

totalR = celllen + feed_length ;

for( row = 1 ; row <= numRows ; row++ ) {
    rowArray[row].startx = 0 ;
    rowArray[row].ypos = (row - 1) * (rowSep + 1) * rowHeight +
						rowHeight / 2 ;
}

if( numRows > 1 ) {
    totalF = 0.0 ;
    for( r = 1 ; r <= numRows ; r++ ) {
	totalF += relativeLen[r] ;
    }
    topRowY = rowArray[numRows].ypos ;
    centerY = (topRowY + rowArray[1].ypos) / 2 ;
    M = (int) ( (double) totalR / totalF ) ;

    dsum = 0.0 ;
    for( r = 1 ; r <= numRows ; r++ ) {
	dsum += relativeLen[r] * 
			    (double)(ABS(rowArray[r].ypos - centerY));
    }
    dsum /= totalF ;
    dsum *= 1.0 / (double)( topRowY - centerY ) ;

    constant = 1.0 + (1.0 - indent) * (1.0 - dsum) ;
    for( r = 1 ; r <= numRows ; r++ ) {
	rowArray[r].endx = (int)((double) M * 
				    constant * relativeLen[r]);
	modulation = 1.0 + (1.0 - indent) * ( 
			  ((double)(ABS(rowArray[r].ypos - centerY)) / 
			   (double)(topRowY - centerY)) - dsum);
	rowArray[r].desiredL = (int) ( 
		    (double) M * relativeLen[r] * modulation ) + 1 ;
    }
} else {
    rowArray[1].endx = totalR ;
    rowArray[1].desiredL = rowArray[1].endx ;
}


macNumber = 0 ;
for( macro = 1 ; macro <= numMacro ; macro++ ) {
    pad = padArray[macro] ;
    padptr = carray[pad] ;
    height = padptr->tileptr->top - padptr->tileptr->bottom ;
    width  = padptr->tileptr->right - padptr->tileptr->left ;

    macNumber++ ;

    switch( padptr->padside ) {
      case MUL : for( row = numRows ; row >= 1 ; row-- ) {
		    if( rowArray[row].ypos + 
				rowSep * rowHeight * 0.33 <= 
				rowArray[numRows].ypos - height ) {
			break ;
		    }
		}
		rows = numRows - row ;
		for( row++ ; row <= numRows ; row++ ) {
		    rowArray[row].startx = width + macspace[MUL] ;
		    rowArray[row].desiredL -= width + macspace[MUL] ;
		}
		for( row = 1 ; row <= numRows ; row++ ) {
		    rowArray[row].endx += (rows * 
				(width + macspace[MUL]) ) / numRows ;
		    rowArray[row].desiredL += (rows * 
				(width + macspace[MUL]) ) / numRows ;
		}
		macroArray[macNumber].mx = width / 2 ;
		macroArray[macNumber].my =
			(rowArray[numRows].ypos + rowHeight / 2) -
							height / 2 ;
		break ;
      case MUR : for( row = numRows ; row >= 1 ; row-- ) {
		    if( rowArray[row].ypos + 
				 rowSep * rowHeight * 0.33 <= 
				 rowArray[numRows].ypos - height ) {
			break ;
		    }
		}
		rows = numRows - row ;
		for( row++ ; row <= numRows ; row++ ) {
		    rowArray[row].endx -= width + macspace[MUR] ;
		    rowArray[row].desiredL -= width + macspace[MUR] ;
		}
		for( row = 1 ; row <= numRows ; row++ ) {
		    rowArray[row].endx += (rows * 
				(width + macspace[MUR]) ) / numRows ;
		    rowArray[row].desiredL += (rows * 
				(width + macspace[MUR]) ) / numRows ;
		}
		macroArray[macNumber].mx = rowArray[numRows].endx +
					   macspace[MUR] + width / 2 ;
		macroArray[macNumber].my =
			(rowArray[numRows].ypos + rowHeight / 2) -
							height / 2 ;
		break ;
      case MLL : for( row = 1 ; row <= numRows ; row++ ) {
		    if( rowArray[row].ypos - 
					rowSep * rowHeight * 0.33 >= 
					rowArray[1].ypos + height ) {
			break ;
		    }
		}
		rows = row - 1 ;
		for( row-- ; row >= 1 ; row-- ) {
		    rowArray[row].startx = width + macspace[MLL] ;
		    rowArray[row].desiredL -= width + macspace[MLL] ;
		}
		for( row = 1 ; row <= numRows ; row++ ) {
		    rowArray[row].endx += (rows * 
				(width + macspace[MLL]) ) / numRows ;
		    rowArray[row].desiredL += (rows * 
				(width + macspace[MLL]) ) / numRows ;
		}
		macroArray[macNumber].mx = width / 2 ;
		macroArray[macNumber].my =
			(rowArray[1].ypos - rowHeight / 2) +
							height / 2 ;
		break ;
      case MLR : for( row = 1 ; row <= numRows ; row++ ) {
		    if( rowArray[row].ypos - 
					rowSep * rowHeight * 0.33 >= 
					rowArray[1].ypos + height ) {
			break ;
		    }
		}
		rows = row - 1 ;
		for( row-- ; row >= 1 ; row-- ) {
		    rowArray[row].endx -= width + macspace[MLR] ;
		    rowArray[row].desiredL -= width + macspace[MLR] ;
		}
		for( row = 1 ; row <= numRows ; row++ ) {
		    rowArray[row].endx += (rows * 
				(width + macspace[MLR]) ) / numRows ;
		    rowArray[row].desiredL += (rows * 
				(width + macspace[MLR]) ) / numRows ;
		}
		if( URmacro != 0 ) {
		    macroArray[URmacro].mx += (rows *
			    (width + macspace[MLR]) ) / numRows ;
		}
		if( Rmacro != 0 ) {
		    macroArray[Rmacro].mx += (rows *
			    (width + macspace[MLR]) ) / numRows ;
		}
		macroArray[macNumber].mx = rowArray[1].endx +
					   macspace[MLR] + width / 2 ;
		macroArray[macNumber].my =
			(rowArray[1].ypos - rowHeight / 2) +
							height / 2 ;
		break ;
      case ML  : bot = rowArray[middleRow].ypos - height / 2 ;
		top = bot + height ;
		for( row = 1 ; row <= numRows ; row++ ) {
		    if( rowArray[row].ypos - rowHeight / 2 - 
			    rowSep * rowHeight * 0.33 >= top ) {
			break ;
		    }
		}
		trow = row ;
		for( row = numRows ; row >= 1 ; row-- ) {
		    if( rowArray[row].ypos + rowHeight / 2 + 
				    rowSep * rowHeight * 0.33 <= bot ) {
			break ;
		    }
		}
		brow = row ;
		rows = trow - brow - 1 ;
		for( row = brow + 1 ; row < trow ; row++ ) {
		    rowArray[row].startx = width + macspace[ML] ;
		    rowArray[row].desiredL -= width + macspace[ML] ;
		}
		for( row = 1 ; row <= numRows ; row++ ) {
		    rowArray[row].endx += (rows * 
				(width + macspace[ML]) ) / numRows ;
		    rowArray[row].desiredL += (rows * 
				(width + macspace[ML]) ) / numRows ;
		}
		macroArray[macNumber].mx = width / 2 ;
		macroArray[macNumber].my = rowArray[middleRow].ypos;
		break ;
      case MR  : bot = rowArray[middleRow].ypos - height / 2 ;
		top = bot + height ;
		for( row = 1 ; row <= numRows ; row++ ) {
		    if( rowArray[row].ypos - rowHeight / 2 -
				    rowSep * rowHeight * 0.33 >= top ) {
			break ;
		    }
		}
		trow = row ;
		for( row = numRows ; row >= 1 ; row-- ) {
		    if( rowArray[row].ypos + rowHeight / 2 +
				    rowSep * rowHeight * 0.33 <= bot ) {
			break ;
		    }
		}
		brow = row ;
		rows = trow - brow - 1 ;
		for( row = brow + 1 ; row < trow ; row++ ) {
		    rowArray[row].endx -= width + macspace[MR] ;
		    rowArray[row].desiredL -= width + macspace[MR] ;
		}
		for( row = 1 ; row <= numRows ; row++ ) {
		    rowArray[row].endx += (rows * 
				(width + macspace[MR]) ) / numRows ;
		    rowArray[row].desiredL += (rows * 
				(width + macspace[MR]) ) / numRows ;
		}
		if( URmacro != 0 ) {
		    macroArray[URmacro].mx += (rows *
				(width + macspace[MR]) ) / numRows ;
		}
		macroArray[macNumber].mx = 
				    rowArray[middleRow].endx +
				    macspace[MR] + width / 2 ;
		macroArray[macNumber].my = rowArray[middleRow].ypos;
		break ;
    }
}

coreHeight = rowArray[numRows].ypos + rowHeight - rowHeight / 2 ;
coreWidth = 0 ;
for( row = 1 ; row <= numRows ; row++ ) {
    if( rowArray[row].endx > coreWidth ) {
	coreWidth = rowArray[row].endx ;
    }
}
for( macro = 1 ; macro <= numMacro ; macro++ ) {
    pad = padArray[macro] ;
    edge = macroArray[macro].mx + carray[pad]->tileptr->right ;
    if( edge > coreWidth ) {
	coreWidth = edge ;
    }
}

mttshift = 0 ;
mbbshift = 0 ;
for( pad = numcells + 1 ; pad <= numcells + numterms ; pad++ ) {
    padptr = carray[pad] ;
    if( padptr->padside == MBB ) {
	height = padptr->tileptr->top - padptr->tileptr->bottom ;
	width  = padptr->tileptr->right - padptr->tileptr->left ;

	mbbshift = height + rowSep * rowHeight ;
	if( width > coreWidth ) {
	    coreWidth = width ;
	}
	coreHeight += mbbshift ;
	padptr->cxcenter = width / 2  ;
	padptr->cycenter = height / 2 ;
	for( row = 1 ; row <= numRows ; row++ ) {
	    rowArray[row].ypos += mbbshift ;
	}

	break ;
    }
}
for( pad = numcells + 1 ; pad <= numcells + numterms ; pad++ ) {
    padptr = carray[pad] ;
    if( padptr->padside == MTT ) {
	height = padptr->tileptr->top - padptr->tileptr->bottom ;
	width  = padptr->tileptr->right - padptr->tileptr->left ;

	padptr->cxcenter = width / 2  ;
	padptr->cycenter = coreHeight + rowSep * rowHeight + 
						    height / 2 ;
	if( width > coreWidth ) {
	    coreWidth = width ;
	}
	mttshift = height + rowSep * rowHeight ;
	coreHeight += mttshift ;
	break ;
    }
}
return ;
}
