#include "standard.h"
#define break_pt 5
int prev_net , curr_net , test_newnet ;
int validL , validR , validB , validT ;
int xmax , xmin , ymax , ymin ;
TEBOXPTR memoptr[50] ;
int k ;

new_dbox( antrmptr , costptr )
TEBOXPTR antrmptr ;
int *costptr ;
{

DBOXPTR  dimptr   ;
TEBOXPTR termptr , nextptr ;

prev_net = -1 ;
validR = validL = validB = validT = 0 ;
for( termptr = antrmptr ; termptr != TERMNULL ; termptr =
					    termptr->nextterm ) {
    curr_net = termptr->net ;
    test_newnet = ( prev_net == curr_net ) ? 0 : 1 ;
    if( test_newnet ) {
	memoptr[ k = 0 ] = termptr ;
    }
    prev_net = curr_net ;
    dimptr = netarray[ curr_net ] ;
    memoptr[ ++k ] = nextptr = termptr->nextterm ;
    if( dimptr->dflag == 0  || dimptr->ignore ) { 
	continue ;
    }
    if( dimptr->numpins <= break_pt ) {
	dimptr->dflag = 0 ;
	wire_boundary1( dimptr ) ;
    } else { 
	check_validbound( dimptr , termptr , nextptr ) ;
	if( nextptr != TERMNULL && curr_net == nextptr->net ) {
		continue ;
	}
	dimptr->dflag = 0 ;
	wire_boundary2( validL + 2*validB + 4*validR + 8*validT  
			                             , dimptr ) ;
        validR = validL = validB = validT = 0 ;
    }
    *costptr += ((int)( dimptr->Hweight *
	    (double)(dimptr->newxmax - dimptr->newxmin))) - 
	    ((int)( dimptr->Hweight *
	    (double)(dimptr->xmax - dimptr->xmin))) +
	    ((int)( dimptr->Vweight *
	    (double)( dimptr->newymax - dimptr->newymin))) -
	    ((int)( dimptr->Vweight *
	    (double)( dimptr->ymax - dimptr->ymin)));
}
}


new_dbox2( antrmptr , bntrmptr , costptr )
TEBOXPTR antrmptr , bntrmptr ;
int *costptr ;
{

DBOXPTR  dimptr   ;
TEBOXPTR termptr , nextptr ;
int anet , bnet ;
int aflag ;

if( antrmptr == TERMNULL ) {
    new_dbox( bntrmptr , costptr ) ;
    return ;
} 
if( bntrmptr == TERMNULL ) {
    new_dbox( antrmptr , costptr ) ;
    return ;
}
validR = validL = validB = validT = 0 ;
aflag = ( antrmptr->net <= bntrmptr->net ) ? 1 : 0 ;
if( aflag ) {
    termptr = antrmptr ;
    antrmptr = antrmptr->nextterm ;
} else {
    termptr = bntrmptr ;
    bntrmptr = bntrmptr->nextterm ;
}
prev_net = -1 ;
for( ; termptr != TERMNULL ; termptr = nextptr ) { 
    curr_net = termptr->net ;
    test_newnet = ( prev_net == curr_net ) ? 0 : 1 ;
    if( test_newnet ) {
	memoptr[ k = 0 ] = termptr ;
    }
    prev_net = curr_net ;
    dimptr = netarray[ curr_net ] ;
    if( antrmptr != TERMNULL && bntrmptr != TERMNULL ) {
	if( (anet = antrmptr->net) < (bnet = bntrmptr->net) ) {
	    nextptr = antrmptr ;
	    antrmptr = antrmptr->nextterm ;
	    aflag = 1 ;
	} else if( anet > bnet ) {
	    nextptr = bntrmptr ;
	    bntrmptr = bntrmptr->nextterm ;
	    aflag = 0 ;
	} else {  /* anet is equal to bnet */
	    if( aflag ) { /* the current pointer is on antrmptr list*/
		nextptr = antrmptr ;
		antrmptr = antrmptr->nextterm ;
	    } else {      /* the current pointer is on bntrmptr list*/
		nextptr = bntrmptr ;
		bntrmptr = bntrmptr->nextterm ;
	    }
	}
    } else if( antrmptr == TERMNULL && bntrmptr != TERMNULL ) {
	nextptr = bntrmptr ;
	bntrmptr = bntrmptr->nextterm ;
    } else if( antrmptr != TERMNULL && bntrmptr == TERMNULL ) {
	nextptr = antrmptr ;
	antrmptr = antrmptr->nextterm ;
    } else {
	nextptr = TERMNULL ;
    }
    memoptr[ ++k ] = nextptr ;
    if( dimptr->dflag == 0  || dimptr->ignore ) { 
	continue ;
    }
    if( dimptr->numpins <= break_pt ) {
	dimptr->dflag = 0 ;
	wire_boundary1( dimptr ) ;
    } else { /* The pin No. of the net is greater than break_pt */
	check_validbound( dimptr , termptr , nextptr ) ;
	if( nextptr != TERMNULL && curr_net == nextptr->net ) {
	    continue ;
	}
	dimptr->dflag = 0 ;
	wire_boundary2( validL + 2*validB + 4*validR + 8*validT  
			     , dimptr ) ;
        validR = validL = validB = validT = 0 ;
    }
    *costptr += ((int)( dimptr->Hweight *
	    (double)(dimptr->newxmax - dimptr->newxmin))) - 
	    ((int)( dimptr->Hweight *
	    (double)(dimptr->xmax - dimptr->xmin))) +
	    ((int)( dimptr->Vweight *
	    (double)( dimptr->newymax - dimptr->newymin))) -
	    ((int)( dimptr->Vweight *
	    (double)( dimptr->ymax - dimptr->ymin)));
}
}


wire_boundary1( dimptr )
DBOXPTR dimptr ;
{

NBOXPTR netptr ;
int x , y ;

if( (netptr = dimptr->netptr) != NETNULL ) {
    if( netptr->flag == 1 ) {
	dimptr->newxmin = dimptr->newxmax = netptr->newx ;
	dimptr->newymin = dimptr->newymax = netptr->newy ;
	netptr->flag = 0 ;
    } else {
	dimptr->newxmin = dimptr->newxmax = netptr->xpos ;
	dimptr->newymin = dimptr->newymax = netptr->ypos ;
    }
}
for( netptr = netptr->nterm ; netptr != NETNULL ;
			      netptr = netptr->nterm ) {
    if( netptr->flag == 1 ) {
	x = netptr->newx ;
	y = netptr->newy ;
	netptr->flag = 0 ;
    } else {
	x = netptr->xpos ;
	y = netptr->ypos ;
    }
    if( x < dimptr->newxmin ) {
	dimptr->newxmin = x ;
    } else if( x > dimptr->newxmax ) {
	dimptr->newxmax = x ;
    }
    if( y < dimptr->newymin ) {
	dimptr->newymin = y ;
    } else if( y > dimptr->newymax ) {
	dimptr->newymax = y ;
    }
}
}

check_validbound( dimptr , termptr , nextptr )
DBOXPTR dimptr ;
TEBOXPTR termptr , nextptr ;
{

NBOXPTR ttermptr ;
int nux , nuy , x , y ;

ttermptr = termptr->termptr ;
nux = ttermptr->newx ;
nuy = ttermptr->newy ;
x   = ttermptr->xpos ;
y   = ttermptr->ypos ;
if( test_newnet ) {
    dimptr->newxmax = xmax = dimptr->xmax ;
    dimptr->newxmin = xmin = dimptr->xmin ;
    dimptr->newymax = ymax = dimptr->ymax ;
    dimptr->newymin = ymin = dimptr->ymin ;
    dimptr->newRnum = dimptr->Rnum ;
    dimptr->newLnum = dimptr->Lnum ;
    dimptr->newBnum = dimptr->Bnum ;
    dimptr->newTnum = dimptr->Tnum ;
} 

if( nux > dimptr->newxmax ) {
    dimptr->newxmax = nux ;
    dimptr->newRnum = 1 ;
    validR = 1 ;
} else if( x != nux && nux == dimptr->newxmax ) {
    dimptr->newRnum++ ;
    validR = 1 ;
} else if( x == dimptr->newxmax && nux < dimptr->newxmax ) {
    dimptr->newRnum-- ;
}

if( nux < dimptr->newxmin ) {
    dimptr->newxmin = nux ;
    dimptr->newLnum = 1 ;
    validL = 1 ;
} else if( x != nux &&  nux == dimptr->newxmin ) {
    dimptr->newLnum++ ;
    validL = 1 ;
} else if( x == dimptr->newxmin && nux > dimptr->newxmin ) {
    dimptr->newLnum-- ;
}

if( nuy > dimptr->newymax ) {
    dimptr->newymax = nuy ;
    dimptr->newTnum = 1 ;
    validT = 1 ;
} else if( y != nuy &&  nuy == dimptr->newymax ) {
    dimptr->newTnum++ ;
    validT = 1 ;
} else if( y == dimptr->newymax && nuy < dimptr->newymax ) {
    dimptr->newTnum-- ;
}

if( nuy < dimptr->newymin ) {
    dimptr->newymin = nuy ;
    dimptr->newBnum = 1 ;
    validB = 1 ;
} else if( y != nuy &&  nuy == dimptr->newymin ) {
    dimptr->newBnum++ ;
    validB = 1 ;
} else if( y == dimptr->newymin && nuy > dimptr->newymin ) {
    dimptr->newBnum-- ;
}

if( nextptr == TERMNULL || curr_net != nextptr->net ) { 
    if( !validR && dimptr->newxmax == xmax
			   && dimptr->newRnum > 0 ) {
	validR = 1 ;
    }
    if( !validL && dimptr->newxmin == xmin
			   && dimptr->newLnum > 0 ) {
	validL = 1 ;
    }
    if( !validT && dimptr->newymax == ymax
			   && dimptr->newTnum > 0 ) {
	validT = 1 ;
    }
    if( !validB && dimptr->newymin == ymin
			   && dimptr->newBnum > 0 ) {
	validB = 1 ;
    }
}
}

wire_boundary2( c , dimptr )
DBOXPTR dimptr ;
int c ;
{

NBOXPTR netptr ;
int x , y , i ;

if( c == 15 ) {
    for( i = 0 ; i <= k-1 ; i++ ) {
        memoptr[i]->termptr->flag = 0 ;
    }
    return ;
}
if( (netptr = dimptr->netptr) != NETNULL ) {
    if( netptr->flag == 1 ) {
	netptr->flag = 0 ;
	switch( c ) {
	case  0 :  /* L , R , B , T false */
	    dimptr->newxmin = dimptr->newxmax = netptr->newx ;
	    dimptr->newymin = dimptr->newymax = netptr->newy ;
	    break ;
	case  1 :  /* R , B , T false */
	    dimptr->newxmax = netptr->newx ;
	    dimptr->newymin = dimptr->newymax = netptr->newy ;
	    break ;
	case  2 :  /* L , R , T false */
	    dimptr->newxmin = dimptr->newxmax = netptr->newx ;
	    dimptr->newymax = netptr->newy ;
	    break ;
	case  3 :  /* R , T false */
	    dimptr->newxmax = netptr->newx ;
	    dimptr->newymax = netptr->newy ;
	    break ;
	case  4 :  /* L , B , T false */
	    dimptr->newxmin = netptr->newx ;
	    dimptr->newymin = dimptr->newymax = netptr->newy ;
	    break ;
	case  5 :  /* B , T false */
	    dimptr->newymin = dimptr->newymax = netptr->newy ;
	    break ;
	case  6 :  /* L , T false */
	    dimptr->newxmin = netptr->newx ;
	    dimptr->newymax = netptr->newy ;
	    break ;
	case  7 :  /* T false */
	    dimptr->newymax = netptr->newy ;
	    break ;
	case  8 :  /* L , R , B false */
	    dimptr->newxmin = dimptr->newxmax = netptr->newx ;
	    dimptr->newymin = netptr->newy ;
	    break ;
	case  9 :  /* R , B false */
	    dimptr->newxmax = netptr->newx ;
	    dimptr->newymin = netptr->newy ;
	    break ;
	case 10 :  /* L , R false */
	    dimptr->newxmin = dimptr->newxmax = netptr->newx ;
	    break ;
	case 11 :  /* R false */
	    dimptr->newxmax = netptr->newx ;
	    break ;
	case 12 :  /* L , B false */
	    dimptr->newxmin = netptr->newx ;
	    dimptr->newymin = netptr->newy ;
	    break ;
	case 13 :  /* B false */
	    dimptr->newymin = netptr->newy ;
	    break ;
	case 14 :  /* L false */
	    dimptr->newxmin = netptr->newx ;
	    break ;
	}
    } else {
	switch( c ) {
	case  0 :  /* L , R , B , T false */
	    dimptr->newxmin = dimptr->newxmax = netptr->xpos ;
	    dimptr->newymin = dimptr->newymax = netptr->ypos ;
	    break ;
	case  1 :  /* R , B , T false */
	    dimptr->newxmax = netptr->xpos ;
	    dimptr->newymin = dimptr->newymax = netptr->ypos ;
	    break ;
	case  2 :  /* L , R , T false */
	    dimptr->newxmin = dimptr->newxmax = netptr->xpos ;
	    dimptr->newymax = netptr->ypos ;
	    break ;
	case  3 :  /* R , T false */
	    dimptr->newxmax = netptr->xpos ;
	    dimptr->newymax = netptr->ypos ;
	    break ;
	case  4 :  /* L , B , T false */
	    dimptr->newxmin = netptr->xpos ;
	    dimptr->newymin = dimptr->newymax = netptr->ypos ;
	    break ;
	case  5 :  /* B , T false */
	    dimptr->newymin = dimptr->newymax = netptr->ypos ;
	    break ;
	case  6 :  /* L , T false */
	    dimptr->newxmin = netptr->xpos ;
	    dimptr->newymax = netptr->ypos ;
	    break ;
	case  7 :  /* T false */
	    dimptr->newymax = netptr->ypos ;
	    break ;
	case  8 :  /* L , R , B false */
	    dimptr->newxmin = dimptr->newxmax = netptr->xpos ;
	    dimptr->newymin = netptr->ypos ;
	    break ;
	case  9 :  /* R , B false */
	    dimptr->newxmax = netptr->xpos ;
	    dimptr->newymin = netptr->ypos ;
	    break ;
	case 10 :  /* L , R false */
	    dimptr->newxmin = dimptr->newxmax = netptr->xpos ;
	    break ;
	case 11 :  /* R false */
	    dimptr->newxmax = netptr->xpos ;
	    break ;
	case 12 :  /* L , B false */
	    dimptr->newxmin = netptr->xpos ;
	    dimptr->newymin = netptr->ypos ;
	    break ;
	case 13 :  /* B false */
	    dimptr->newymin = netptr->ypos ;
	    break ;
	case 14 :  /* L false */
	    dimptr->newxmin = netptr->xpos ;
	    break ;
	}
    }
}
if( !validL ) {
    dimptr->newLnum = 1 ;
}
if( !validR ) {
    dimptr->newRnum = 1 ;
}
if( !validB ) {
    dimptr->newBnum = 1 ;
}
if( !validT ) {
    dimptr->newTnum = 1 ;
}
for( netptr = netptr->nterm ; netptr != NETNULL ;
			      netptr = netptr->nterm ) {
    if( netptr->flag == 1 ) {
	x = netptr->newx ;
	y = netptr->newy ;
	netptr->flag = 0 ;
    } else {
	x = netptr->xpos ;
	y = netptr->ypos ;
    }
    switch( c ) {
    case  0 :  /* L , R , B , T false */
	if( x < dimptr->newxmin ) {
	    dimptr->newxmin = x ;
	    dimptr->newLnum = 1 ;
	} else if( x > dimptr->newxmax ) {
	    dimptr->newxmax = x ;
	    dimptr->newRnum = 1 ;
	} else if( x == dimptr->newxmin ) {
	    dimptr->newLnum++ ;
	    if( x == dimptr->newxmax ) {
		dimptr->newRnum++ ;
	    }
	} else if( x == dimptr->newxmax ) { 
	    dimptr->newRnum++ ;
	}
	if( y < dimptr->newymin ) {
	    dimptr->newymin = y ;
	    dimptr->newBnum = 1 ;
	} else if( y > dimptr->newymax ) {
	    dimptr->newymax = y ;
	    dimptr->newTnum = 1 ;
	} else if( y == dimptr->newymin ) {
	    dimptr->newBnum++ ;
	    if( y == dimptr->newymax ) {
		dimptr->newTnum++ ;
	    }
	} else if( y == dimptr->newymax ) { 
	    dimptr->newTnum++ ;
	}
	break ;
    case  1 :  /* R , B , T false */
	if( x > dimptr->newxmax ) {
	    dimptr->newxmax = x ;
	    dimptr->newRnum = 1 ;
	} else if( x == dimptr->newxmax ) { 
	    dimptr->newRnum++ ;
	}
	if( y < dimptr->newymin ) {
	    dimptr->newymin = y ;
	    dimptr->newBnum = 1 ;
	} else if( y > dimptr->newymax ) {
	    dimptr->newymax = y ;
	    dimptr->newTnum = 1 ;
	} else if( y == dimptr->newymin ) {
	    dimptr->newBnum++ ;
	    if( y == dimptr->newymax ) {
		dimptr->newTnum++ ;
	    }
	} else if( y == dimptr->newymax ) { 
	    dimptr->newTnum++ ;
	}
	break ;
    case  2 :  /* L , R , T false */
	if( x < dimptr->newxmin ) {
	    dimptr->newxmin = x ;
	    dimptr->newLnum = 1 ;
	} else if( x > dimptr->newxmax ) {
	    dimptr->newxmax = x ;
	    dimptr->newRnum = 1 ;
	} else if( x == dimptr->newxmin ) {
	    dimptr->newLnum++ ;
	    if( x == dimptr->newxmax ) {
		dimptr->newRnum++ ;
	    }
	} else if( x == dimptr->newxmax ) { 
	    dimptr->newRnum++ ;
	}
	if( y > dimptr->newymax ) {
	    dimptr->newymax = y ;
	    dimptr->newTnum = 1 ;
	} else if( y == dimptr->newymax ) { 
	    dimptr->newTnum++ ;
	}
	break ;
    case  3 :  /* R , T false */
	if( x > dimptr->newxmax ) {
	    dimptr->newxmax = x ;
	    dimptr->newRnum = 1 ;
	} else if( x == dimptr->newxmax ) { 
	    dimptr->newRnum++ ;
	}
	if( y > dimptr->newymax ) {
	    dimptr->newymax = y ;
	    dimptr->newTnum = 1 ;
	} else if( y == dimptr->newymax ) { 
	    dimptr->newTnum++ ;
	}
	break ;
    case  4 :  /* L , B , T false */
	if( x < dimptr->newxmin ) {
	    dimptr->newxmin = x ;
	    dimptr->newLnum = 1 ;
	} else if( x == dimptr->newxmin ) {
	    dimptr->newLnum++ ;
	}
	if( y < dimptr->newymin ) {
	    dimptr->newymin = y ;
	    dimptr->newBnum = 1 ;
	} else if( y > dimptr->newymax ) {
	    dimptr->newymax = y ;
	    dimptr->newTnum = 1 ;
	} else if( y == dimptr->newymin ) {
	    dimptr->newBnum++ ;
	    if( y == dimptr->newymax ) {
		dimptr->newTnum++ ;
	    }
	} else if( y == dimptr->newymax ) { 
	    dimptr->newTnum++ ;
	}
	break ;
    case  5 :  /* B , T false */
	if( y < dimptr->newymin ) {
	    dimptr->newymin = y ;
	    dimptr->newBnum = 1 ;
	} else if( y > dimptr->newymax ) {
	    dimptr->newymax = y ;
	    dimptr->newTnum = 1 ;
	} else if( y == dimptr->newymin ) {
	    dimptr->newBnum++ ;
	    if( y == dimptr->newymax ) {
		dimptr->newTnum++ ;
	    }
	} else if( y == dimptr->newymax ) { 
	    dimptr->newTnum++ ;
	}
	break ;
    case  6 :  /* L , T false */
	if( x < dimptr->newxmin ) {
	    dimptr->newxmin = x ;
	    dimptr->newLnum = 1 ;
	} else if( x == dimptr->newxmin ) {
	    dimptr->newLnum++ ;
	}
	if( y > dimptr->newymax ) {
	    dimptr->newymax = y ;
	    dimptr->newTnum = 1 ;
	} else if( y == dimptr->newymax ) { 
	    dimptr->newTnum++ ;
	}
	break ;
    case  7 :  /* T false */
	if( y > dimptr->newymax ) {
	    dimptr->newymax = y ;
	    dimptr->newTnum = 1 ;
	} else if( y == dimptr->newymax ) { 
	    dimptr->newTnum++ ;
	}
	break ;
    case  8 :  /* L , R , B false */
	if( x < dimptr->newxmin ) {
	    dimptr->newxmin = x ;
	    dimptr->newLnum = 1 ;
	} else if( x > dimptr->newxmax ) {
	    dimptr->newxmax = x ;
	    dimptr->newRnum = 1 ;
	} else if( x == dimptr->newxmin ) {
	    dimptr->newLnum++ ;
	    if( x == dimptr->newxmax ) {
		dimptr->newRnum++ ;
	    }
	} else if( x == dimptr->newxmax ) { 
	    dimptr->newRnum++ ;
	}
	if( y < dimptr->newymin ) {
	    dimptr->newymin = y ;
	    dimptr->newBnum = 1 ;
	} else if( y == dimptr->newymin ) {
	    dimptr->newBnum++ ;
	}
	break ;
    case  9 :  /* R , B false */
	if( x > dimptr->newxmax ) {
	    dimptr->newxmax = x ;
	    dimptr->newRnum = 1 ;
	} else if( x == dimptr->newxmax ) { 
	    dimptr->newRnum++ ;
	}
	if( y < dimptr->newymin ) {
	    dimptr->newymin = y ;
	    dimptr->newBnum = 1 ;
	} else if( y == dimptr->newymin ) {
	    dimptr->newBnum++ ;
	}
	break ;
    case 10 :  /* L , R false */
	if( x < dimptr->newxmin ) {
	    dimptr->newxmin = x ;
	    dimptr->newLnum = 1 ;
	} else if( x > dimptr->newxmax ) {
	    dimptr->newxmax = x ;
	    dimptr->newRnum = 1 ;
	} else if( x == dimptr->newxmin ) {
	    dimptr->newLnum++ ;
	    if( x == dimptr->newxmax ) {
		dimptr->newRnum++ ;
	    }
	} else if( x == dimptr->newxmax ) { 
	    dimptr->newRnum++ ;
	}
	break ;
    case 11 :  /* R false */
	if( x > dimptr->newxmax ) {
	    dimptr->newxmax = x ;
	    dimptr->newRnum = 1 ;
	} else if( x == dimptr->newxmax ) { 
	    dimptr->newRnum++ ;
	}
	break ;
    case 12 :  /* L , B false */
	if( x < dimptr->newxmin ) {
	    dimptr->newxmin = x ;
	    dimptr->newLnum = 1 ;
	} else if( x == dimptr->newxmin ) {
	    dimptr->newLnum++ ;
	}
	if( y < dimptr->newymin ) {
	    dimptr->newymin = y ;
	    dimptr->newBnum = 1 ;
	} else if( y == dimptr->newymin ) {
	    dimptr->newBnum++ ;
	}
	break ;
    case 13 :  /* B false */
	if( y < dimptr->newymin ) {
	    dimptr->newymin = y ;
	    dimptr->newBnum = 1 ;
	} else if( y == dimptr->newymin ) {
	    dimptr->newBnum++ ;
	}
	break ;
    case 14 :  /* L false */
	if( x < dimptr->newxmin ) {
	    dimptr->newxmin = x ;
	    dimptr->newLnum = 1 ;
	} else if( x == dimptr->newxmin ) {
	    dimptr->newLnum++ ;
	}
	break ;
    }
}
}

dbox_pos( antrmptr ) 
TEBOXPTR antrmptr ;
{

DBOXPTR dimptr ;
TEBOXPTR termptr ;

for( termptr = antrmptr ; termptr != TERMNULL ; termptr =
					termptr->nextterm ) {
    dimptr = netarray[ termptr->net ] ;
    dimptr->xmin = dimptr->newxmin ;
    dimptr->xmax = dimptr->newxmax ;
    dimptr->ymin = dimptr->newymin ;
    dimptr->ymax = dimptr->newymax ;
    if( dimptr->numpins >= break_pt + 1 ) { 
	dimptr->Lnum = dimptr->newLnum ;
	dimptr->Rnum = dimptr->newRnum ;
	dimptr->Bnum = dimptr->newBnum ;
	dimptr->Tnum = dimptr->newTnum ;
    }
    termptr->termptr->xpos = termptr->termptr->newx ;
    termptr->termptr->ypos = termptr->termptr->newy ;
}
}	
