typedef struct blockbox {
    int bxcenter  ;
    int bycenter  ;
    short int bleft     ;
    short int bright    ;
    short int bbottom   ;
    short int btop      ;
    short int bheight   ;
    short int blength   ;
    short int desire    ;
    short int oldsize   ;
    short int newsize   ;
    short int bclass    ;
    short int borient   ;
}
*BBOXPTR ,
BBOX ;

typedef struct netbox {
    struct netbox *nterm ;
    int terminal ;
    int extint   ;
    int xpos     ;
    int ypos     ;
    int newx     ;
    int newy     ;
    short int row  ;
    short int cell ;
    short int net ;
    char pinloc   ;
    char unequiv  ;
    char flag     ;
    char layer    ;
}
*NBOXPTR ,
NBOX ;

typedef struct termbox { 
    struct termbox *nextterm ;
    NBOXPTR  termptr;
    int cellterm    ;
    int ei          ;
    short int net   ;
    short int txpos[2] ;
    short int typos[2] ;
    short int ue    ;
}
*TEBOXPTR ,
TEBOX ;

typedef struct tilebox { 
    short int left     ;
    short int right    ;
    short int bottom   ;
    short int top      ;
    TEBOXPTR termsptr ;
}
*TIBOXPTR ,
TIBOX ;

typedef struct cellbox { 
    char *cname           ;
    char corient          ;
    char orflag           ;
    int cxcenter          ;
    int cycenter          ;
    short int cclass      ;
    short int cheight     ;
    short int clength     ;
    short int border      ;
    short int cblock      ;
    short int numterms    ;
    short int padside     ;
    TIBOXPTR tileptr ;
}
*CBOXPTR ,
CBOX ;

typedef struct dimbox {
    NBOXPTR netptr ;
    char *name   ;
    char dflag    ;
    char feedflag ;
    char ignore   ;
    int xmin     ;
    int newxmin  ;
    int xmax     ;
    int newxmax  ;
    int ymin     ;
    int newymin  ;
    int ymax     ;
    int newymax  ;
    short int Lnum     ;
    short int newLnum  ;
    short int Rnum     ;
    short int newRnum  ;
    short int Bnum     ;
    short int newBnum  ;
    short int Tnum     ;
    short int newTnum  ;
    short int numpins  ;
    double Vweight ;
    double Hweight ;
}
*DBOXPTR ,
DBOX ;


typedef struct hash {
    char *hname ;
    int hnum ;
    struct hash *hnext ;
}
HASHBOX , 
*HASHPTR ;

typedef struct binbox {
    int left ;
    int right ;
    int *cell ;
    int penalty ;
    int nupenalty ;
} BINBOX ,
*BINPTR ;

typedef struct rowbox {
    int startx  ;
    int endx    ;
    int endx1   ;
    int startx2 ;
    int ypos    ;
    int desiredL ;
} ROWBOX ;

typedef struct changrdbox {
    NBOXPTR netptr ;
    short int tracks ;
    short int ntracks ;
    short int SegType ;
    short int nSegType ;
    struct changrdbox *prevgrd ;
    struct changrdbox *nprevgrd ;
    struct changrdbox *nextgrd ;
    struct changrdbox *nnextgrd ;
    struct densitybox *dptr ;
}
*CHANGRDPTR ,
CHANGRDBOX ;

HASHPTR *hashtab ;
CBOXPTR  *carray  ;
DBOXPTR   *netarray   ;
NBOXPTR *tearray  ;
BBOXPTR *barray ;
BINBOX ***binptr ;
ROWBOX *rowArray ;
CHANGRDPTR ULgrdptr , URgrdptr , LLgrdptr , LRgrdptr , *Shuffle ;

int netctr ;
int bdxlen , bdylen ;

int numblock ;
int numcells ;
int numterms ;
int numRows  ;
int numnets  ;

int penalty  ;
int funccost ;

int numBins  ;
int binWidth ;
int binOffst ;

int feeds ;
short int **rowgrid ;
int windx ;
int randVar ;
int max_blklength ;
int desiredL ;
int binpenal ;
int rowpenal ;
int newbinpenal ;
int newrowpenal ;
int uneven_cell_height ;
int implicit_feed_count ;
int *feeds_in_row ;
int **cedgebin , cedge_binwidth , num_edgebin ;
int Left_bound , Rite_bound ;
int gtopChan , gbotChan ;
int track_spacing ;
int one_pin_feedthru ;
