#include "standard.h"

extern FILE *fpo;

#ifdef TESTMEM
extern char *testmalloc(), *testrealloc(), *testcalloc();
#define malloc(a) (testmalloc(a))
#define realloc(a,b) (testrealloc(a,b))
#define calloc(a,b) (testcalloc(a,b))
#endif

char *safe_malloc(size)
unsigned size;
{
    char *p;

    if ((p = malloc(size)) == (char *) 0) {
	fprintf(stderr, "malloc: Out of memory in TimberWolf\n");
	print_stats(stderr);
	fprintf(fpo, "malloc: Out of memory in TimberWolf\n");
	print_stats(fpo);
	exit(TW_FAIL);
    }
    return p;
}


char *safe_realloc(obj, size)
char *obj;
unsigned size;
{
    char *p;

    if ((p = realloc(obj, size)) == (char *) 0) {
	fprintf(stderr, "realloc: Out of memory in TimberWolf\n");
	print_stats(stderr);
	fprintf(fpo, "realloc: Out of memory in TimberWolf\n");
	print_stats(fpo);
	exit(TW_FAIL);
    }
    return p;
}


char *safe_calloc(size, num)
unsigned size, num;
{
    char *p;

    if ((p = calloc(size, num)) == (char *) 0) {
	fprintf(stderr, "calloc: Out of memory in TimberWolf\n");
	print_stats(stderr);
	fprintf(fpo, "calloc: Out of memory in TimberWolf\n");
	print_stats(fpo);
	exit(TW_FAIL);
    }
    return p;
}
