/*
 * apTrace.c
 *
 * Application access to various parameters and functions used by ace.
 */

#include "aceInternal.h"

/*
 * aceSetTrace
 *
 * Set the trace mask and trace file pointer.
 */
void
aceSetTrace( traceMask, traceFp)
unsigned traceMask;	/* trace mask (ie, what to trace)               */
FILE *traceFp;		/* where to write the trace output              */
{
    ACE_START( "aceSetTrace");

    if( traceMask & ACE_TRACE_ALL_MASK){
	/* tracing, traceFp better not be NIL				*/
	if( traceFp == NIL(FILE)){
	    errRaise( ACE_PKG_NAME, ACE_BAD_ARG, "traceFp is NIL");
	}
    }

    /* set global params						*/
    AceG.traceMask = traceMask;
    AceG.traceFp = traceFp;

    ACE_END();
}
