/*
 * error.c
 *
 * Handle errors in ace.
 */

#include "aceInternal.h"

/*
 * ace_error_handler
 *
 * Add an appropriate string onto an error message and
 * pass it to the next handler.
 */
void
ace_error_handler( pkgName, code, message)
char *pkgName;
int code;
char *message;
{
    char *estring;

    if( strcmp( ACE_PKG_NAME, pkgName) == 0){
	switch(( aceErrCode) code){
	    case ACE_NO_ERR:
		estring = "no error";
		break;
	    case ACE_BAD_ID:
		estring = "bad ace id";
		break;
	    case ACE_BAD_TYPE:
		estring = "wrong type";
		break;
	    case ACE_BAD_ARG:
		estring = "bad funct arg";
		break;
	    case ACE_NO_MEM:
		estring = "no memory";
		break;
	    case ACE_OUT_OF_BOUNDS:
		estring = "out of bounds";
		break;
	    case ACE_GENERAL_ERR:
		estring = "general";
		break;
	    default:
		estring = "unknown";
		break;
	}
	errPass( "in %s: unexpected %s error [%s]: %s",
		    AceG.errName, pkgName, estring, message);
    } else {
	errPass( "in %s: unexpected %s error: %s",
		    AceG.errName, pkgName, message);
    }
}
