#include "copyright.h"
#include "port.h"
#include "alba.h"


alba_checkMasters()
{
  octObject		Instance;
  octGenerator		genInst;
  octStatus		s;
  char			masterName[256];
  void alba_checkAreaInformation();
  void alba_checkTerminalImplementation();
  
  if (verbose) printf("---------  Checking all the masters ---------\n");

  OCT_ASSERT(octInitGenContents(&Chip,  OCT_INSTANCE_MASK, &genInst));

  while ((s=octGenerate(&genInst,&Instance))==OCT_OK) {
    (void) sprintf(masterName,"%s:%s",
	    Instance.contents.instance.master, Instance.contents.instance.view);
    if (st_is_member(st_masters, masterName)==FALSE) {     
      if (st_insert(st_masters, strsav(masterName), 0)==1) {
	printf("checkMasters: this is strange"); /* debug */
      }
      alba_checkAreaInformation(&Instance);
      alba_checkTerminalImplementation(&Instance);
    }
  }
  if (s!=OCT_GEN_DONE) FatalError("failing generating instances");
}



