/*
 *  FILE: initObjects.c
 *
 *  DESCRIPTION:
 *
 *
 *  CREATION DATE: 03/03/87		AUTHOR: A. Casotto
 *
 *  FUNCTIONS:
 */
#include "copyright.h"
#include "port.h"
#include "oct.h"


octObject	LayerPlace; 
octObject	LayerMET1; 
octObject	Mobility;
octObject	FloorplanBag;
octObject	ModuleGenerator;
octObject	MinHeightOverWidth;
octObject	MaxHeightOverWidth;
octObject	FloatingEdge;
octObject	TermEdge;
octObject	TermType;
octObject	SideRestrictions;
octObject	JoinedTerms;
octObject	OrderTerms;
octObject	PermTerms;
octObject	NetType;
octObject	Criticality;


/*
 *   alba_initPlacementObjects()
 *   Initializes some useful oct objects
 */
alba_initPlacementObjects()
{
  LayerPlace.type = OCT_LAYER;
  LayerPlace.contents.layer.name = "PLACE";

  LayerMET1.type = OCT_LAYER;
  LayerMET1.contents.layer.name = "MET1";

  TermType.type = OCT_PROP;
  TermType.contents.prop.name = "TERMTYPE";
  TermType.contents.prop.type = OCT_STRING;

  SideRestrictions.type = OCT_PROP;
  SideRestrictions.contents.prop.name = "SIDERESTRICTIONS";
  SideRestrictions.contents.prop.type = OCT_STRING;

  JoinedTerms.type = OCT_BAG;
  JoinedTerms.contents.bag.name = "JOINEDTERMS";

  OrderTerms.type = OCT_BAG;
  OrderTerms.contents.bag.name = "ORDERTERMS";

  PermTerms.type = OCT_BAG;
  PermTerms.contents.bag.name = "PERMTERMS";

  NetType.type = OCT_PROP;
  NetType.contents.prop.name = "NETTYPE";
  NetType.contents.prop.type = OCT_STRING;

  Criticality.type = OCT_PROP;
  Criticality.contents.prop.name = "NETCRITICALITY";
  Criticality.contents.prop.type = OCT_INTEGER;

  Mobility.type = OCT_PROP;
  Mobility.contents.prop.name = "MOBILITY";
  Mobility.contents.prop.type = OCT_STRING;

  FloorplanBag.type = OCT_BAG;
  FloorplanBag.contents.bag.name = "FLOORPLAN";
    

  ModuleGenerator.type = OCT_PROP;
  ModuleGenerator.contents.prop.name = "MODULE_GENERATOR";
  ModuleGenerator.contents.prop.type = OCT_STRING;
    
  MinHeightOverWidth.type = OCT_PROP;
  MinHeightOverWidth.contents.prop.name = "MIN_Y_OVER_X";
  MinHeightOverWidth.contents.prop.type = OCT_REAL;

  MaxHeightOverWidth.type = OCT_PROP;
  MaxHeightOverWidth.contents.prop.name = "MAX_Y_OVER_X";
  MaxHeightOverWidth.contents.prop.type = OCT_REAL;

  FloatingEdge.type = OCT_PROP;
  FloatingEdge.contents.prop.name = "TERM_FLOATING_EDGES";
  FloatingEdge.contents.prop.type = OCT_STRING;
    
  TermEdge.type = OCT_PROP;
  TermEdge.contents.prop.name = "TERM_EDGE";
  TermEdge.contents.prop.type = OCT_STRING;

}

