/*
 *   riipup.c
 * >>>> ROUTINES
 */

#include "copyright.h"
#include "port.h"
#include "oct.h"
#include "alba.h"
#include "oh.h"

int
ripupNet( net )
    octObject* net;
{
  octGenerator gen, genTerm;
  octObject path, term;
  octObject facet;
  octObject connBag;
  octStatus status;

  octGetFacet( net, &facet );
  ohGetByBagName( &facet, &connBag, "CONNECTORS" );
  /* Delete all path belonging to this net */
  OH_ASSERT(octInitGenContents(net, OCT_PATH_MASK, &gen));
  while ((status = octGenerate(&gen, &path)) == OCT_OK) {
      octInitGenContents( &path, OCT_TERM_MASK, &genTerm );
      while ( octGenerate(&genTerm,&term) == OCT_OK ) {
	  octObject conn;
	  ohGetById( &conn, term.contents.term.instanceId );
	  if (octIsAttached( &connBag, &conn ) == OCT_OK) {
	      octDelete( &conn );
	  }
      }
      octDelete( &path );
  }
  OH_ASSERT(status == OCT_GEN_DONE ? OCT_OK : status);

  return 1;
}

int
ripupAllNets( facet )
    octObject* facet;
{
    octObject net;
    octGenerator genNet;
    char msg[256];
    octInitGenContents( facet, OCT_NET_MASK, &genNet ) ;
    while ( octGenerate( &genNet, &net ) == OCT_OK ) {
	if ( ! ripupNet( &net )  ) {
	    sprintf( msg,"Could not rip up a %s in %s",
		    ohFormatName( &net ), ohFormatName( facet ));
	    Message( msg );
	    return 0;
	}
    }
    return 1;
}
