/*
 * allocate.c
 *
 * Do some of the more fancy memory allocation.
 */

#include "copyright.h"
#include "port.h"
#include "anchor.h"

/*
 * allocCore
 * allocate a 2D array of chars, referced as core[ row ][ col ].
 */
char **
allocCore(rows, cols)
int	rows, cols;
{
    int i, j;
    char **core;

    core = ALLOC( char *, rows );
    for( i = 0; i < rows; ++i ) {
	core[i] = ALLOC(char, cols + 1);
	memset( core[ i ], 0, sizeof(char) * ( cols + 1) );
    }
    for( i = rows - 1; i >= 0; --i){
	for( j = cols - 1; j >= 0; --j){
	    core[i][j] = DOT;
	}
    }
    return( core );
}

/*
 * newInput
 *
 * malloc and initialize a new s_input structure
 */
s_input *
newInput(name)
char	*name;
{
    s_input	*newIn;

    newIn = ALLOC( s_input, 1 );
    memset( (char *) newIn, 0, sizeof (s_input));
    newIn->name = util_strsav( name );
    newIn->col = -1; /* to see if its ever really used or not		*/
    return( newIn );
}

/*
 * newOutput
 *
 * malloc and initialize a new s_output structure
 */
s_output *
newOutput(name)
char	*name;
{
    s_output	*newOut;

    newOut = ALLOC( s_output, 1 );
    memset((char *) newOut, 0, sizeof (s_output));
    newOut->name = util_strsav( name );
    return( newOut );
}

/*
 * newInputColArray
 *
 * malloc and initialize a new s_output structure
 */
s_inputCol *
newInputColArray(num)
int	num;
{
    s_inputCol	*newInCol;

    newInCol = ALLOC( s_inputCol, num );
    memset((char *) newInCol, 0, num * sizeof (s_inputCol));
    return( newInCol );
}
