#include "copyright.h"
#include "port.h"
#include "anchor.h"
#include "st.h"

/* hash.c
 *
 * maintain hash table for inputs to allow by-name access
 */

static st_table	*inTable = NIL(st_table);
st_table	*st_init_table();

/* getInputByName
 *
 * returns pointer to name's input structure.  If it doesn't exits,
 * it is allocated here and the name field is set.
 */
s_input *
getInputByName(name)
char	*name;
{
    s_input		*in, *newInput();

    /* if rediculous input, return					*/
    if (name == NIL( char ))
	return (NIL (s_input) );

    /* if there is no table, create one					*/
    if (inTable == NIL(st_table)) {
	inTable = st_init_table( strcmp, st_strhash );
    /* else if there is a table, try to lookup name			*/
    } else {
	/* if name is in the table, return name's structure		*/
	if (st_lookup( inTable, name, (char **)(&in)) != 0)
	    return (in);
    }

    /* if name hasn't been alloced yet, initialize it and return in	*/
    in = newInput ( name );

    /* add it to the hash table						*/
    if ( st_insert( inTable, in->name, (char *)in ) == 1) {
	errRaise( optProgName, -1, "internal st error - insert failed.");
    }

    return (in);
}
