/*
 * palette.c
 *
 * A somewhat sloppy file that defines a program to construct the
 * standard palette for anchor.
 */

#include "copyright.h"
#include "port.h"
#include "anchor.h"

optionStruct optionList[] = {
    { "T",     "technology", "name of the technology ( \"scmos\" default )"}, 
    { OPT_RARG, "cell:view", "cell and view of the palette"},
    { 0, 	0,	0}};
typedef struct {
    octObject andPullup;
    octObject andPlaneGnd;
    octObject andTran;
    octObject andGnd;
    octObject andCont;
    octObject andOrInterface;
    octObject orPullup;
    octObject orPlaneGnd;
    octObject orTran;
    octObject orGnd;
    octObject orCont;
    octObject input;
    octObject input_clk;
    octObject output1;
    octObject output1_clk;
    octObject output2;
    octObject output2_clk;
    octObject pom1;
    octObject pom1_1;
    octObject pom1_2;
    octObject m1m1;
    octObject m1m1_1;
    octObject m2m2;
    octObject m2m2_1;
    octObject vdd_via;
    octObject vss_via;
} s_cellObjs;

s_options Options;
s_cells Cells;
s_ruleNames RuleNames;
s_cellObjs CellObjs;
octObject oPalette;
octObject oFacet;	/* not used, stubbed out so defaults work	*/

#define CONTACT "t"
#define GATE "GATE"
#define DRAIN "DRAIN"
#define SOURCE "SOURCE"
#define IN "IN"
#define IN1 "IN1"
#define NEG "NEG"
#define POS "POS"
#define VDD "VDD"
#define GND "GND"
#define GND1 "GND1"
#define GND2 "GND2"
#define PHI "PHI"
#define PHIBAR "PHIBAR"

/*
 * createPalette
 *
 * a program which creates the palette for the PLA generator Octopus
 */

main( argc, argv )
int argc;
char **argv;
{

    octObject oRule;
    octObject oConnect;
    octObject oTgroup;

    setCellAndRuleNameDefaults();
    optionsDefaults();
    parseComLine(argc, argv);
    openPalette();
    createInstances();
    doLayers();


    /* OR plane output rules 					*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.orOutput );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.orOutput );
    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.orCont, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.orPullup, DRAIN );
    attachTermByName( &oTgroup, &CellObjs.output1, IN );
    attachTermByName( &oTgroup, &CellObjs.output1_clk, IN );
    attachTermByName( &oTgroup, &CellObjs.output2, IN );
    attachTermByName( &oTgroup, &CellObjs.output2_clk, IN );
    attachTermByName( &oTgroup, &CellObjs.output2, IN1 );
    attachTermByName( &oTgroup, &CellObjs.output2_clk, IN1 );

    /* product term rules					*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.productTerm );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.productTerm );
    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.andCont, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.andOrInterface, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.orTran, GATE );
    attachTermByName( &oTgroup, &CellObjs.andPullup, DRAIN );

    /* and pullup rules						*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.andPullup );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.andPullup );
    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.andPullup, GATE );
    attachTermByName( &oTgroup, &CellObjs.pom1, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.andPullup, SOURCE );
    attachTermByName( &oTgroup, &CellObjs.vdd_via, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.pom1, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.m1m1_1, CONTACT );

    /* or pullup rules						*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.orPullup );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.orPullup );
    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.orPullup, GATE );
    attachTermByName( &oTgroup, &CellObjs.pom1, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.pom1, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.m1m1, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.orPullup, SOURCE );
    attachTermByName( &oTgroup, &CellObjs.m1m1, CONTACT );

    /* or diffusion rules */
    /* orTranDiffusion: connects sources and drains to diffusion pads	*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.orTranDiffusion );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.orTranDiffusion );

    /* OR plane tran DRAINs to contacts 				*/
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.orTran, DRAIN );
    attachTermByName( &oConnect, &CellObjs.orCont, CONTACT );
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.orCont, CONTACT );
    attachTermByName( &oConnect, &CellObjs.orTran, DRAIN );

    /* OR plane tran SOURCEs to ground 					*/
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.orTran, SOURCE );
    attachTermByName( &oConnect, &CellObjs.orGnd, CONTACT );
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.orGnd, CONTACT );
    attachTermByName( &oConnect, &CellObjs.orTran, SOURCE );

    /* orGndDiffusion: connects diff pads and plane ground contacts	*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.orGndDiffusion );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.orGndDiffusion );

    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.orGnd, CONTACT );
    attachTermByName( &oConnect, &CellObjs.orPlaneGnd, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.orPlaneGnd, CONTACT );
    attachTermByName( &oConnect, &CellObjs.orGnd, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.orGnd, CONTACT );

    /* AND diffusion rules */
    /* andTranDiffusion: connects sources and drains to diffusion pads	*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.andTranDiffusion );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.andTranDiffusion );

    /* AND plane tran DRAINs to contacts 				*/
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.andTran, DRAIN );
    attachTermByName( &oConnect, &CellObjs.andCont, CONTACT );
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.andCont, CONTACT );
    attachTermByName( &oConnect, &CellObjs.andTran, DRAIN );

    /* AND plane tran SOURCEs to ground 				*/
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.andTran, SOURCE );
    attachTermByName( &oConnect, &CellObjs.andGnd, CONTACT );
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.andGnd, CONTACT );
    attachTermByName( &oConnect, &CellObjs.andTran, SOURCE );

    /* andGndDiffusion: connects sources and drains to diffusion pads	*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.andGndDiffusion );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.andGndDiffusion );
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.andGnd, CONTACT );
    attachTermByName( &oConnect, &CellObjs.andPlaneGnd, CONTACT );
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.andPlaneGnd, CONTACT );
    attachTermByName( &oConnect, &CellObjs.andGnd, CONTACT );
    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.andGnd, CONTACT );

    /* OR plane ground rule for linking plane ground contacts		*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.orGround );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.orGround );
    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.orPlaneGnd, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.vss_via, CONTACT );

    /* AND plane ground rule for linking plane ground contacts		*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.andGround );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.andGround );
    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.andPlaneGnd, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.vss_via, CONTACT );

    /* literal ( inputs) rules */
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.literal );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.literal );
    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.input, NEG );
    attachTermByName( &oTgroup, &CellObjs.input_clk, NEG );
    attachTermByName( &oTgroup, &CellObjs.input, POS );
    attachTermByName( &oTgroup, &CellObjs.input_clk, POS );
    attachTermByName( &oTgroup, &CellObjs.andTran, GATE );
    attachTermByName( &oConnect, &CellObjs.andTran, GATE );

    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.andTran, GATE );
    OH_ASSERT( octAttach( &oConnect, &oTgroup ));

    /* center power track rules						*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.cPower );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.cPower );
    newBag( &oRule, &oConnect, CONNECTBAG );
    newIntProp( &oConnect, MK_ORIENTATION_PROP, MK_VER_SEG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.m1m1_1, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.m1m1, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.pom1, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.vss_via, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.vdd_via, CONTACT );
    attachTermByName( &oConnect, &CellObjs.m1m1, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    attachTermByName( &oConnect, &CellObjs.m1m1, CONTACT );
    attachTermByName( &oConnect, &CellObjs.vdd_via, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.pom1_1, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.pom1_2, CONTACT );

    /* VDD and GND to IO buffers rule					*/
    newBag( &oPalette, &oRule, RULEBAG );
    newStringProp( &oRule, RULENAMEPROP, RuleNames.buffer );
    newStringProp( &oPalette, RULENAMEPROP, RuleNames.buffer );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newIntProp( &oConnect, MK_WIDTH_PROP, MK_MAX_WIDTH );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.input, VDD );
    attachTermByName( &oTgroup, &CellObjs.input_clk, VDD );
    attachTermByName( &oTgroup, &CellObjs.m2m2_1, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.vdd_via, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newIntProp( &oConnect, MK_WIDTH_PROP, MK_MAX_WIDTH );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.output1, VDD );
    attachTermByName( &oTgroup, &CellObjs.output1_clk, VDD );
    attachTermByName( &oTgroup, &CellObjs.output2, VDD );
    attachTermByName( &oTgroup, &CellObjs.output2_clk, VDD );
    attachTermByName( &oTgroup, &CellObjs.vdd_via, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.m2m2, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newIntProp( &oConnect, MK_WIDTH_PROP, MK_MAX_WIDTH );
    newIntProp( &oConnect, MK_ORIENTATION_PROP, MK_VER_SEG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.m2m2, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.m2m2_1, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.output1_clk, PHI );
    attachTermByName( &oTgroup, &CellObjs.output2_clk, PHI );
    attachTermByName( &oTgroup, &CellObjs.pom1_1, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.input_clk, PHI );
    attachTermByName( &oTgroup, &CellObjs.pom1_1, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.input_clk, PHIBAR );
    attachTermByName( &oTgroup, &CellObjs.pom1_2, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newIntProp( &oConnect, MK_WIDTH_PROP, MK_MAX_WIDTH );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.input, GND );
    attachTermByName( &oTgroup, &CellObjs.input_clk, GND );
    attachTermByName( &oTgroup, &CellObjs.m1m1_1, CONTACT );

    /*
    newBag( &oRule, &oConnect, CONNECTBAG );
    newIntProp( &oConnect, MK_WIDTH_PROP, MK_MAX_WIDTH );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.vss_via, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.m1m1, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.m1m1_1, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.pom1, CONTACT );
    */

    newBag( &oRule, &oConnect, CONNECTBAG );
    newIntProp( &oConnect, MK_WIDTH_PROP, MK_MAX_WIDTH );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.input, GND1 );
    attachTermByName( &oTgroup, &CellObjs.input_clk, GND1 );
    attachTermByName( &oTgroup, &CellObjs.pom1, CONTACT );
    attachTermByName( &oTgroup, &CellObjs.m1m1, CONTACT );

    newBag( &oRule, &oConnect, CONNECTBAG );
    newIntProp( &oConnect, MK_WIDTH_PROP, MK_MAX_WIDTH );
    newBag( &oConnect, &oTgroup, TERMGROUPBAG );
    attachTermByName( &oTgroup, &CellObjs.output1, GND );
    attachTermByName( &oTgroup, &CellObjs.output1_clk, GND );
    attachTermByName( &oTgroup, &CellObjs.output2, GND );
    attachTermByName( &oTgroup, &CellObjs.output2_clk, GND );
    attachTermByName( &oTgroup, &CellObjs.vss_via, CONTACT );

    OH_ASSERT( octCloseFacet( &oPalette ));
    exit( 0 );
}

newBag( oContainer, oBag, name )
octObject *oContainer;
octObject *oBag;
char *name;
{
    oBag->type = OCT_BAG;
    oBag->contents.bag.name = name;
    OH_ASSERT( octCreate( oContainer, oBag ));
}
newStringProp( oContainer, name, value )
octObject *oContainer;
char *name;
char *value;
{
    octObject oProp;
    oProp.type = OCT_PROP;
    oProp.contents.prop.name = name;
    oProp.contents.prop.type = OCT_STRING;
    oProp.contents.prop.value.string = value;
    OH_ASSERT( octCreate( oContainer, &oProp ));
}
attachTermByName( oContainer, oInst, name )
octObject *oContainer;
octObject *oInst;
char *name;
{
    octObject oTerm;

    oTerm.type = OCT_TERM;
    oTerm.contents.term.name = name;
    if( octGetByName( oInst, &oTerm ) < OCT_OK ){
	errRaise( optProgName, -1, "Could not get %s by name from %s: %s.",
		 ohFormatName( &oTerm ),
		 ohFormatName( oInst ),
		 octErrorString());
    }
    OH_ASSERT( octAttach( oContainer, &oTerm ));
}

parseComLine( argc, argv )
int argc;
char **argv;
{
    extern char *optarg;
    int option;

    if( argc == 1 ){
	optUsage();
	exit(1);
    }
    while((option = optGetOption( argc, argv )) != EOF ){
	switch( option ) {
	    case 'T':
		Options.technology = util_strsav( optarg );
		break;
	    default:
		optUsage();
		break;
	}
    }
    Options.paletteName = argv[ optind ];
}

openPalette()
{
    octObject oProp;

    oPalette.type = OCT_FACET;
    oPalette.contents.facet.view = "symbolic";
    oPalette.contents.facet.facet = "contents";
    oPalette.contents.facet.mode = "w";
    oPalette.contents.facet.version = OCT_CURRENT_VERSION;

    OH_ASSERT( ohUnpackFacetName( &oPalette, Options.paletteName ));
    if ( octOpenFacet( &oPalette ) < OCT_OK ){
	errRaise( optProgName, -1, "Could not open facet %s:%s:%s: %s.",
		oPalette.contents.facet.cell,
		oPalette.contents.facet.view,
		oPalette.contents.facet.facet,
		octErrorString());
    }
    OH_ASSERT( ohCreatePropStr( &oPalette, &oProp, 
				 "TECHNOLOGY", Options.technology ));
    OH_ASSERT( ohCreatePropStr( &oPalette, &oProp, "VIEWTYPE", "symbolic" ));
    OH_ASSERT( ohCreatePropStr( &oPalette, &oProp, "EDITSTYLE", "symbolic" ));
}
createInstances()
{
    octObject oInstBag;
    octObject oConnBag;

    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.andPullup, 
		      Cells.andPullup.name, Cells.andPullup.master, 
		      Cells.andPullup.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.andPlaneGnd,
		      Cells.andPlaneGnd.name, Cells.andPlaneGnd.master, 
		      Cells.andPlaneGnd.view, 200, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.andTran,
		      Cells.andTran.name, Cells.andTran.master, 
		      Cells.andTran.view, 200, 200, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.andGnd,
		      Cells.andGnd.name, Cells.andGnd.master, 
		      Cells.andGnd.view, 200, 400, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.andCont,
		      Cells.andCont.name, Cells.andCont.master, 
		      Cells.andCont.view, 200, 600, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.andOrInterface,
		      Cells.andOrInterface.name, Cells.andOrInterface.master, 
		      Cells.andOrInterface.view, 0, 400, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.orPullup, 
		      Cells.orPullup.name, Cells.orPullup.master, 
		      Cells.orPullup.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.orPlaneGnd,
		      Cells.orPlaneGnd.name, Cells.orPlaneGnd.master, 
		      Cells.orPlaneGnd.view, 400, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.orTran,
		      Cells.orTran.name, Cells.orTran.master, 
		      Cells.orTran.view, 400, 200, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.orGnd,
		      Cells.orGnd.name, Cells.orGnd.master, 
		      Cells.orGnd.view, 400, 400, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.orCont,
		      Cells.orCont.name, Cells.orCont.master, 
		      Cells.orCont.view, 400, 600, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.input,
		      Cells.input.name, Cells.input.master, 
		      Cells.input.view, 600, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.input_clk,
		      Cells.input_clk.name, Cells.input_clk.master, 
		      Cells.input_clk.view, 600, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.output1,
		      Cells.output1.name, Cells.output1.master, 
		      Cells.output1.view, 1000, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.output1_clk,
		      Cells.output1_clk.name, Cells.output1_clk.master, 
		      Cells.output1_clk.view, 1000, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.output2,
		      Cells.output2.name, Cells.output2.master, 
		      Cells.output2.view, 1000, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.output2_clk,
		      Cells.output2_clk.name, Cells.output2_clk.master, 
		      Cells.output2_clk.view, 1000, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.pom1, 
		      Cells.pom1.name, Cells.pom1.master, 
		      Cells.pom1.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.pom1_1, 
		      Cells.pom1_1.name, Cells.pom1_1.master, 
		      Cells.pom1_1.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.pom1_2, 
		      Cells.pom1_2.name, Cells.pom1_2.master, 
		      Cells.pom1_2.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.m1m1, 
		      Cells.m1m1.name, Cells.m1m1.master, 
		      Cells.m1m1.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.m1m1_1, 
		      Cells.m1m1_1.name, Cells.m1m1_1.master, 
		      Cells.m1m1_1.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.m2m2, 
		      Cells.m2m2.name, Cells.m2m2.master, 
		      Cells.m2m2.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.m2m2_1, 
		      Cells.m2m2_1.name, Cells.m2m2_1.master, 
		      Cells.m2m2_1.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.vdd_via, 
		      Cells.vdd_via.name, Cells.vdd_via.master, 
		      Cells.vdd_via.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( ohCreateInstance( &oPalette, &CellObjs.vss_via, 
		      Cells.vss_via.name, Cells.vss_via.master, 
		      Cells.vss_via.view, 0, 0, OCT_NO_TRANSFORM ));

    OH_ASSERT( ohGetOrCreateBag( &oPalette, &oInstBag, "INSTANCES" ));
    OH_ASSERT( ohGetOrCreateBag( &oPalette, &oConnBag, "CONNECTORS" ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.andPullup ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.andPlaneGnd ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.andTran ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.andGnd ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.andCont ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.andOrInterface ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.orPullup ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.orPlaneGnd ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.orTran ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.orGnd ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.orCont ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.input ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.input_clk ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.output1 ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.output1_clk ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.output2 ));
    OH_ASSERT( octAttach( &oInstBag, &CellObjs.output2_clk ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.m1m1 ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.m1m1_1 ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.m2m2 ));
    OH_ASSERT( octAttach( &oConnBag, &CellObjs.m2m2_1 ));
}

/*
 * doLayers
 *
 * create the layers and horizontal and vertical precedence
 */
doLayers()
{
    octObject oHorBag;
    octObject oVerBag;
    octObject oMet2;
    octObject oMet1;
    octObject oPoly;
    octObject oNDif;
    octObject oPDif;
    octObject oProp;

    oHorBag.type = oVerBag.type = OCT_BAG;
    oHorBag.contents.bag.name = HORIZONTAL_LAYERS;
    oVerBag.contents.bag.name = VERTICAL_LAYERS;

    OH_ASSERT( octCreate( &oPalette, &oHorBag ));
    OH_ASSERT( octCreate( &oPalette, &oVerBag ));

    oMet2.type = oMet1.type = oPoly.type = oNDif.type = oPDif.type = OCT_LAYER;
    oMet2.contents.layer.name = "MET2";
    oMet1.contents.layer.name = "MET1";
    oPoly.contents.layer.name = "POLY";
    oNDif.contents.layer.name = "NDIF";
    oPDif.contents.layer.name = "PDIF";

    OH_ASSERT( octCreate( &oPalette, &oMet2 ));
    OH_ASSERT( octCreate( &oPalette, &oMet1 ));
    OH_ASSERT( octCreate( &oPalette, &oPoly ));
    OH_ASSERT( octCreate( &oPalette, &oNDif ));
    OH_ASSERT( octCreate( &oPalette, &oPDif ));

    oProp.type = OCT_PROP;
    oProp.contents.prop.name = MK_WIDTH_PROP;
    oProp.contents.prop.type = OCT_INTEGER;
    oProp.contents.prop.value.integer = MK_MAX_WIDTH;
    OH_ASSERT( octCreate( &oPalette, &oProp ));
    OH_ASSERT( octDetach( &oPalette, &oProp ));

    OH_ASSERT( octAttach( &oNDif, &oProp ));
    OH_ASSERT( octAttach( &oPDif, &oProp ));

    OH_ASSERT( octAttach( &oHorBag, &oMet2 ));
    OH_ASSERT( octAttach( &oHorBag, &oMet1 ));
    OH_ASSERT( octAttach( &oHorBag, &oPoly ));
    OH_ASSERT( octAttach( &oHorBag, &oNDif ));
    OH_ASSERT( octAttach( &oHorBag, &oPDif ));

    OH_ASSERT( octAttach( &oVerBag, &oMet2 ));
    OH_ASSERT( octAttach( &oVerBag, &oMet1 ));
    OH_ASSERT( octAttach( &oVerBag, &oPoly ));
    OH_ASSERT( octAttach( &oVerBag, &oNDif ));
    OH_ASSERT( octAttach( &oVerBag, &oPDif ));
}
newIntProp( oContainer, name, value )
octObject *oContainer;
char *name;
int value;
{
    octObject oProp;

     /* a property to make connections maximum width		*/
    oProp.type = OCT_PROP;
    oProp.contents.prop.name = name;
    oProp.contents.prop.type = OCT_INTEGER;
    oProp.contents.prop.value.integer = value;
    OH_ASSERT( octCreate( oContainer, &oProp ));
}
