#include "copyright.h"
#include "port.h"
#include "anchor.h"

extern int		GivenRows, GivenAndCols, GivenOrCols;
extern char		**GivenCore;
extern s_input		**GivenInputs;
extern s_output		**GivenOutputs;

extern int		Rows, AndCols, OrCols, OddEvenBreak;
extern char		**Core;
extern s_input		**Inputs;
extern s_output		**Outputs;



printTrue()
{
    int		i, j;
    s_input	*tIn;
    s_output	*tOut;

    printf("True PLA: %d rows, %d andCs, %d orCs, OEB=%d\n", Rows, AndCols,
					OrCols, OddEvenBreak);
    for (i = Rows - 1; i >= 0; --i) {
	for(j = 0; j < AndCols + OrCols; ++j) {
	    printf("%c", Core[i][j]);
	}
	printf("\n");
    }

    for (i = 0; i < AndCols; ++i) {
	tIn = Inputs[i];
	while( tIn != NIL( s_input )) {
	    printf("in: col %d, \"%s\" bottom %d top %d, phase=%s\n", tIn->col,
		tIn->name, tIn->bottom, tIn->top,
		(tIn->phase==POS)?"POS":"NEG");
	    tIn = tIn->next;
	}
    }


    for (i = 0; i < OrCols; ++i) {
	tOut = Outputs[i];
	while( tOut != NIL( s_output )) {
	    printf("out: col %d, \"%s\" bottom %d top %d\n", tOut->col,
			tOut->name, tOut->bottom, tOut->top);
	    tOut = tOut->next;
	}
    }
}


printIn()
{
    int		i, j;
    s_input	*tIn;
    s_output	*tOut;

    printf("Given PLA: %d rows, %d andCs, %d orCs\n", GivenRows, GivenAndCols,
					GivenOrCols);
    for (i = 0; i < GivenRows; ++i) {
	for(j = 0; j < GivenAndCols + GivenOrCols; ++j) {
	    printf("%c", GivenCore[i][j]);
	}
	printf("\n");
    }

    for (i = 0; i < GivenAndCols; ++i) {
	tIn = GivenInputs[i];
	while( tIn != NIL( s_input )) {
	    printf("in: col %d, \"%s\" from %d to %d", tIn->col, tIn->name,
				tIn->top, tIn->bottom);
	    if ( tIn->comp == NIL( s_input )) {
		printf("\n");
	    } else {
		printf(", [comp is \"%s\"]\n",tIn->comp->name);
	    }
	    tIn = tIn->next;
	}
    }


    for (i = 0; i < GivenOrCols; ++i) {
	tOut = GivenOutputs[i];
	while( tOut != NIL( s_output )) {
	    printf("out: col %d, \"%s\" from %d to %d\n", tOut->col, tOut->name,
				tOut->top, tOut->bottom);
	    tOut = tOut->next;
	}
    }
}
