/*
Copyright (C) 1986 University of California (Berkeley). All rights reserved.

CDSPInit.c

Preinitialize data. Test data.

Author(s):		Mitsuru Igusa
Revision history:	$Log:	CDSPInit.c,v $
 * Revision 1.1  90/02/07  16:12:25  octtools
 * Checkin for 3.5 distribution
 * 
 * Revision 1.1  89/01/27  22:36:53  octtools
 * Initial revision
 * 
 * Revision 1.1  88/03/31  11:39:16  mitch
 * Initial revision
 * 
----------------------------------------------------------------------------*/
#include "copyright.h"
#include "port.h"
#include "miutil.h"
#include "CDSInc.h"

/* Pre initialize channel definition program from a file (skipping oct).
----------------------------------------------------------------------------*/
CDSPreInit(testFileName)

String		testFileName;
{
    FILE		*f;
    char		type[256];

    int		numObj = 0;
    int		objNum = 0;
    int		numBdy;
    int		bdyNum;
    CDSObjDef	*obj = NULL;

    MI_MOD_START("CDSPreInit");

    f = MIfopen(testFileName, "r", "input test file");
    if (!f) goto CDSEndPreInit;

    while(fscanf(f, "%s", type)!=EOF) {
	MSG(1, ("Record type <%s>\n", type));

	if (!strcmp(type, "	/*"))		/* Skip comment line */
	  while(fscanf(f, "%s", type)!=EOF) {
	      if (!strcmp(type, "*/")) break;
	  }

	else if (!strcmp(type, "NumObj")) { /* Read in header stuff */
	    (void) fscanf(f, " %*s %d ", &numObj);
	    DRANGE(2, numObj, 1000);
	    CDSHead.numObj = numObj;
	    CDSObj = ALLOC_ARRAY(CDSHead.numObj, CDSObjDef);
	}

	else if (!strcmp(type, "Obj")) { /* Read in obj header */
	    (void) fscanf(f, " %*d%*c %*7s%d ", &numBdy);
	    DRANGE(4, numBdy, 20);
	    DASSERT(CDSObj);
	    if (objNum>=CDSHead.numObj-1) {
		MIerror("Read of test file %s terminated prematurely\n",
			testFileName);
		break;
	    }
	    obj = &CDSObj[objNum++];
	    obj->numBdy = numBdy;
	    obj->bdy    = ALLOC_ARRAY(obj->numBdy, CDSLocDef);
	}

	else if (!strcmp(type, "Bdy")) { /* Read in boundary */
	    (void) fscanf(f, " %d", &bdyNum);
	    DASSERT(obj);
	    DRANGE(0,bdyNum,obj->numBdy);
	    (void) fscanf(f, "%*c %*c%d %d%*c",
			  &obj->bdy[bdyNum][CDS_X], &obj->bdy[bdyNum][CDS_Y]);
	}
    }

    DASSERT(objNum==CDSHead.numObj-1);
    (void) fclose(f);

 CDSEndPreInit:
    MI_MOD_END();
}				/* ............................. End of procedure CDSPreInit */
