#include "electra.h"
/*
 * accMove
 *
 * accept a move
 */
accMove( net )
s_net *net;
{
    s_network *network;
    octPoint termloc;
    int row, col;

    if( Move == INVALID ) return;
    termloc = net->termloc;
    if( Move == RESIZE ){

	row = net->signal->row;
	if( net->signal->numTerms > 0 ){
	    if(( net->edge&L_EDGE ) == 0 ){
		for( col = NewLeft; col < net->signal->left; col++ ){
		    Matrix[row][col].metal2Mask++;
		}
		for( col = net->signal->left; col < NewLeft; col++ ){
		    Matrix[row][col].metal2Mask--;
		}
	    }
	    if(( net->edge&R_EDGE ) == 0 ){
		for( col = NewRight + 1; col <= net->signal->right; col++ ){
		    Matrix[row][col].metal2Mask--;
		}
		for( col = net->signal->right + 1; col <= NewRight; col++ ){
		     Matrix[row][col].metal2Mask++;
		}
	    }
	} else if( net->edge&L_EDGE ){
	    for( col = termloc.x + 1; col <= NewTermloc.x; col++ ){
		Matrix[row][col].metal2Mask++;
	    }
	    for( col = NewTermloc.x + 1; col <= termloc.x; col++ ){
		Matrix[row][col].metal2Mask--;
	    }
	} else if( net->edge&R_EDGE ){
	    for( col = termloc.x; col < NewTermloc.x; col++ ){
		Matrix[row][col].metal2Mask--;
	    }
	    for( col = NewTermloc.x; col < termloc.x; col++ ){
		Matrix[row][col].metal2Mask++;
	    }
	}
	if( termloc.x != NewTermloc.x ){
	    if((( net->network == NIL( s_network ))||
		( termloc.x != net->network->col ))&&
	       (( net->edge&TB_EDGE )||
		( IS_TRAN( termloc.y, termloc.x ) == FALSE ))){
	       Matrix[ termloc.y ][ termloc.x ].metal1Mask--;
	    }
	    if((( net->network == NIL( s_network ))||
		( NewTermloc.x != net->network->col ))&&
	       (( net->edge&TB_EDGE )||
		( IS_TRAN( termloc.y, NewTermloc.x ) == FALSE ))){
	       Matrix[ termloc.y ][ NewTermloc.x ].metal1Mask++;
	    }
	}
	net->termloc.x = NewTermloc.x;
	net->signal->left = NewLeft;
	net->signal->right = NewRight;
    } else if(( net->edge == NewEdge )&&
	      ( termloc.x == NewTermloc.x )&&
	      ( termloc.y == NewTermloc.y )){
	return ;
    } else {
	/* updating the metal masks					*/
	if( net->edge != 0 ){
	    switch( net->edge ){
		case T_EDGE:
		    col = termloc.x;
		    for( row = termloc.y + 1; row < NumRows; row++ ){
			Matrix[row][col].metal1Mask--;
		    }
		    break;
		case B_EDGE:
		    col = termloc.x;
		    for( row = termloc.y - 1; row >= 0; row-- ){
			Matrix[row][col].metal1Mask--;
		    }
		    break;
		case L_EDGE:
		    row = termloc.y;
		    for( col = termloc.x - 1; col >= 0; col-- ){
			Matrix[row][col].metal2Mask--;
		    }
		    break;
		case R_EDGE:
		    row = termloc.y;
		    for( col = termloc.x + 1; col < NumCols; col++ ){
			Matrix[row][col].metal2Mask--;
		    }
		    break;
	    }
	    /* setting the metal1mask for the terminal		*/
	    if((( net->network == NIL( s_network ))||
		( termloc.x != net->network->col ))&&
	       (( net->edge&TB_EDGE )||
		( IS_TRAN( termloc.y, termloc.x ) == FALSE ))){
	       Matrix[ termloc.y ][ termloc.x ].metal1Mask--;
	    }
	    if(( net->edge&LR_EDGE )&&( net->signal->numTerms == 0 )){
		Matrix[ termloc.y ][ termloc.x ].metal2Mask--;
	    }
	}
	switch( NewEdge ){
	case T_EDGE:
		col = NewTermloc.x;
		for( row = NewTermloc.y + 1; row < NumRows; row++ ){
		    Matrix[row][col].metal1Mask++;
		}
		break;
	    case B_EDGE:
	    col = NewTermloc.x;
		for( row = NewTermloc.y - 1; row >= 0; row-- ){
		    Matrix[row][col].metal1Mask++;
		}
		break;
	    case L_EDGE:
		row = NewTermloc.y;
		for( col = NewTermloc.x - 1; col >= 0; col-- ){
		    Matrix[row][col].metal2Mask++;
		}
		break;
	    case R_EDGE:
		row = NewTermloc.y;
		for( col = NewTermloc.x + 1; col < NumCols; col++ ){
		    Matrix[row][col].metal2Mask++;
		}
		break;
	}
	/* setting the metal1mask for the terminal		*/
	if((( net->network == NIL( s_network ))||
	    ( NewTermloc.x != net->network->col ))&&
	   (( NewEdge&TB_EDGE )||
	    ( IS_TRAN( NewTermloc.y, NewTermloc.x ) == FALSE ))){
	   Matrix[ NewTermloc.y ][ NewTermloc.x ].metal1Mask++;
	}
	if(( NewEdge&LR_EDGE )&&( net->signal->numTerms == 0 )){
	    Matrix[ NewTermloc.y ][ NewTermloc.x ].metal2Mask++;
	}
    }
    if( net->edge != 0 ){
	network = Matrix[ termloc.y ][ termloc.x ].network;
	if(( network != NIL( s_network ))&&
	   ( network != net->network )&&
	   ((( termloc.y <= network->lastTran )&&
	     ( termloc.y >= network->firstTran ))||
	    (( termloc.y >= network->lastTran )&&
	     ( termloc.y <= network->firstTran )))&&
	   ( IS_TRAN( termloc.y, termloc.x ))){
	    network->numBadTerms--;
	    if( network->numBadTerms == 0 )NetworksWithBadTerms--;
	}
    }
    network = Matrix[ NewTermloc.y ][ NewTermloc.x ].network;
    if(( network != NIL( s_network ))&&
       ( network != net->network )&&
       ((( NewTermloc.y <= network->lastTran )&&
         ( NewTermloc.y >= network->firstTran ))||
        (( NewTermloc.y >= network->lastTran )&&
         ( NewTermloc.y <= network->firstTran )))&&
       ( IS_TRAN( NewTermloc.y, NewTermloc.x ))){
	network->numBadTerms++;
	if( network->numBadTerms == 1 )NetworksWithBadTerms++;
    }


    /* updating the net->edge and net->termloc fields			*/
    net->edge = NewEdge;
    net->termloc = NewTermloc;
}
