#include "electra.h"
/*
 * alloc.c
 *
 * procedures to allocate misc datatypes
 */
s_signal *
allocSignal( row )
int row;
{
    s_signal *signal;
    s_signal *sigptr;
    int index;

    if (SignalArray == NIL(s_signal *)){
	SignalArray = ALLOC(s_signal *, NumRows);
	for( index = NumRows - 1; index >= 0; index-- ){
	    SignalArray[index] = NIL(s_signal);
	}
    }

    signal = ALLOC( s_signal, 1 );
    signal->row = 0;
    signal->left = 0;
    signal->right = 0;
    signal->maxLeft = 0;
    signal->minRight = 0;
    signal->net = NIL(s_net);
    signal->numRuns = 0;
    signal->polyrun = NIL( s_polyrun );
    signal->numTerms = 0;
    signal->numTrans = 0;
    signal->next = NIL( s_signal );
    signal->term = NIL( s_termList );

    if(( sigptr = SignalArray[row] ) == NIL(s_signal)){
	SignalArray[ row ] = signal;
	signal->prev = NIL( s_signal );
    } else {
	while( sigptr->next != NIL(s_signal )) sigptr = sigptr->next;
	sigptr->next = signal;
	signal->prev = sigptr;
    }

    return (signal);
}
s_network *
allocNetwork( col )
int col;
{
    s_network *network;
    int index;

    if (NetworkArray == NIL( s_network * )){
	NetworkArray = ALLOC( s_network *, NumCols);
	for( index = NumCols - 1; index >= 0; index-- ){
	    NetworkArray[ index ] = NIL( s_network );
	}
    }

    network = ALLOC( s_network, 1 );

    network->type = UNDEFINED;
    network->top = UNDEFINED;
    network->bottom = UNDEFINED;
    network->firstTran = UNDEFINED;
    network->lastTran = UNDEFINED;
    network->numBadTerms = 0;
    network->next = NetworkArray[col];
    if( network->next != NIL(s_network )) network->next->prev = network;
    network->prev = NIL( s_network );
    NetworkArray[col] = network;
    return (network);
}
s_net *
allocNet()
{
    s_net *net;
    char *alloc();

    net = ALLOC( s_net, 1 );
    net->next = Netlist;
    Netlist = net;

    net->name = NIL( char );
    net->termName = NIL( char );
    net->status = 0;
    net->edge = 0;
    net->bestloc = 0;
    net->termloc.x = net->termloc.y = 0;
    net->netId = oct_null_id;
    net->network = NIL( s_network );
    net->signal = NIL(s_signal );

    return (net);
}
