#include "electra.h"
/*
 * The signals are checked for consistancy
 * These are the error conditions:
 *      more than one TERM per signal
 */
checkSignals()
{
  s_signal *signal;
  int row, col;
  int numTerms;
  for ( row = 0; row < NumRows; row++ ){
     for ( signal = SignalArray[ row ]; signal != NULL ; 
	   signal = signal->next ){
      numTerms = 0;
      for( col = signal->left; col <= signal->right; col++ ){
	if(Matrix[row][col].type == TERM) numTerms++;
      }
      if ( numTerms > 1 ) signalError( signal );
    }
  }
}
/*
 * checkNetworks
 *
 * The networks are checked for consistancey
 * These are the error conditions:
 *    more than one TERM in a network
 *    no TRANs in a network
 */
checkNetworks()
{
    s_network *network;
    int row, col;
    int numTrans, numTerms;
    for ( col = 0; col < NumCols; col++ ){
	for ( network = NetworkArray[ col ]; network != NULL ;
	      network = network->next ){
	    numTerms = numTrans = 0;
	    for( row = network->top; row >= network->bottom; row-- ){
		switch(Matrix[row][col].type){
		    case TERM:
			numTerms++;
			break;
		    case TRAN:
			numTrans++;
			break;
		}
	    }
	    if (( numTerms > 1 )||( numTrans < 1 )) networkError( network );
	}
    }
}
