/*LINTLIBRARY*/
#include "electra.h"
/*
 * error.c
 *
 * This module prints and handles error messages
 */

parseError(errstring)
char errstring[];
{
  fprintf( stderr, "Error in parsing input file - %s\n", errstring);
  exit(1);
}

internalError( string)
char *string;
{
  fprintf(stderr,"Fatal internal error - %s\n", string);
  exit(1);
}

networkError(network)
s_network *network;
{
  fprintf(stderr,
	  "Error in parsing network between rows %d and %d on column %d.\n",
	  network->top, network->bottom, network->col);
  exit(1);
}

signalError(signal)
s_signal *signal;
{
  fprintf(stderr,
	  "Error in parsing signal between columns %d and %d on row %d.\n",
	  signal->left, signal->right, signal->row);
  exit(1);
}

charTableError( letter )
char letter;
{
    fprintf(stderr,"%s %c %s %s\n",
	    "Error while creating instances - letter", letter,
	    "in the personality matrix does not map to a transistor",
	    "in the tech file\n");
    exit(1);
}
#ifdef notdef
/*
 * halt
 * 
 * if Debug is FALSE - exit( -1 )
 * if Debug is TRUE - prompt for continue , abort, or stop
 */
halt()
{
    FILE *promptfile;
    if ( Debug < 2 ){
	exit ( -1 );
    } else if( Debug == 2 ){
	promptfile = stdin;
	(void)fseek( promptfile, (long)0, 2 );
	fprintf( stderr , 
		"Should this process continue (c), stop (s), or abort(a)?\n");
	while ( 1 ){
	    switch ( getc( promptfile )){
		case 'C':
		case 'c': return;
		case EOF:
		case 'S':
		case 's': exit( -1 );
		case 'A':
		case 'a': abort();
		default : fprintf( stderr,"%c is not a valid reply.\n");
			  fprintf( stderr, 
			       "Either continue (c), stop (s), or abort(a)\n");
	    }
	}
    } else {
	return;
    }
}
#endif
