#include "electra.h"
/*
 * freeAll
 *
 * Frees everything allocated in electra and calls mkCloseArray() to 
 * free everything allocated in mkarray.  This is useful for debugging
 * electra and mkarray - it guarantees no core leaks in libmkarray.a
 * and any pointer which has been corrupted will show up when it is
 * freed.
 */
freeAll()
{

    int row, col;
    s_network *network, *next;
    s_signal *signal, *nextsig;
    s_net *net, *nextnet;

    for( row = NumRows - 1; row >= 0; row-- ){
	FREE( Matrix[row] );
	for( signal = SignalArray[row]; signal != NIL( s_signal );
	     signal = nextsig ){
	    nextsig = signal->next;
	    FREE( signal );
	}
    }
    FREE( SignalArray );
    for( col = NumCols - 1; col >= 0; col-- ){
	for( network = NetworkArray[col]; network != NIL( s_network );
	     network = next ){
	    next = network->next;
	    FREE( network );
	}
    }
    FREE( NetworkArray );
    for( net = Netlist; net != NIL( s_net ); net = nextnet ){
	nextnet = net->next;
	FREE( net );
    }
    mkFreeArray( FullArray );
}
