#include "electra.h"
/*
 * genNewEdge
 *
 */
genNewEdge( net )
s_net *net;
{

    Move = NEWEDGE;;
    NewLeft = net->signal->left;
    NewRight = net->signal->right;
    switch ( randomInt( 0, 3 )){
	case 0:
	    NewEdge = T_EDGE;
	    NewTermloc.x = randomInt( net->signal->left, 
				      net->signal->right );
	    if(( net->network != NIL(s_network ))&&
	       ( NewTermloc.x == net->network->col )){
		NewTermloc.y = net->network->top;
	    } else {
		NewTermloc.y = net->signal->row;
	    }
	    break;
	case 1:
	    NewEdge = B_EDGE;
	    NewTermloc.x = randomInt( net->signal->left, 
				      net->signal->right );
	    if(( net->network != NIL(s_network ))&&
	       ( NewTermloc.x == net->network->col )){
		NewTermloc.y = net->network->bottom;
	    } else {
		NewTermloc.y = net->signal->row;
	    }
	    break;
	case 2:
	    NewEdge = L_EDGE;
	    if( net->network == NIL( s_network )){
		NewTermloc.x = net->signal->left;
		NewTermloc.y = net->signal->row;
	    } else {
		NewTermloc.y = randomInt( net->network->bottom, 
					  net->network->top );
		if( NewTermloc.y == net->signal->row ){
		    NewTermloc.x = net->signal->left;
		} else {
		    NewTermloc.x = net->network->col;
		}
	    }
	    break;
	case 3:
	    NewEdge = R_EDGE;
	    if( net->network == NIL( s_network )){
		NewTermloc.x = net->signal->right;
		NewTermloc.y = net->signal->row;
	    } else {
		NewTermloc.y = randomInt( net->network->bottom, 
					  net->network->top );
		if( NewTermloc.y == net->signal->row ){
		    NewTermloc.x = net->signal->right;
		} else {
		    NewTermloc.x = net->network->col;
		}
	    }
	    break;
    }
}
/*
 * genNewTermloc
 *
 */
genNewTermloc( net )
s_net *net;
{
    Move = NEWTERMLOC;
    NewEdge = net->edge;
    NewLeft = net->signal->left;
    NewRight = net->signal->right;

    switch( NewEdge ){
	case T_EDGE:
	    NewTermloc.x = randomInt( net->signal->left, 
				      net->signal->right );
	    if(( net->network != NIL( s_network ))&&
	       ( NewTermloc.x == net->network->col )){
		NewTermloc.y = net->network->top;
	    } else {
		NewTermloc.y = net->signal->row;
	    }
	    break;
	case B_EDGE:
	    NewTermloc.x = randomInt( net->signal->left, 
				      net->signal->right );
	    if(( net->network != NIL( s_network ))&&
	       ( NewTermloc.x == net->network->col )){
		NewTermloc.y = net->network->bottom;
	    } else {
		NewTermloc.y = net->signal->row;
	    }
	    break;
	case L_EDGE:
	    if( net->network == NIL( s_network )){
		NewTermloc.y = net->signal->row;
		NewTermloc.x = net->signal->left;
	    } else {
		NewTermloc.y = randomInt( net->network->bottom, 
					  net->network->top );
		if( NewTermloc.y == net->signal->row ){
		    NewTermloc.x = randomInt( net->signal->left, 
			     		      net->signal->right );
		} else {
		    NewTermloc.x = net->network->col;
		}
	    } 
	    break;
	case R_EDGE:
	    if( net->network == NIL( s_network )){
		NewTermloc.y = net->signal->row;
		NewTermloc.x = net->signal->right;
	    } else {
		NewTermloc.y = randomInt( net->network->bottom, 
					  net->network->top );
		if( NewTermloc.y == net->signal->row ){
		    NewTermloc.x = randomInt( net->signal->left, 
			     		      net->signal->right );
		} else {
		    NewTermloc.x = net->network->col;
		}
	    } 
	    break;
    }
}

resizeNet( net )
s_net *net;
{
    int minX, maxX;

    NewEdge = net->edge;
    NewTermloc = net->termloc;


    if( net->signal->numTrans == 0 ){
	Move = INVALID;
	return;
    } 

    if( net->signal->prev == NIL( s_signal )){
	minX = net->signal->left;
	if( minX > 0 )minX--;
    } else {
	minX = net->signal->left - 1;
	if( minX <= net->signal->prev->right )minX++;
    }
    if( net->edge&TB_EDGE ){
	maxX = MIN( net->signal->maxLeft, net->termloc.x );
    } else {
	maxX = net->signal->maxLeft;
    }
    NewLeft = randomInt( minX, maxX );

    if( net->edge&TB_EDGE ){
	minX = MAX( net->signal->minRight, net->termloc.x );
    } else {
	minX = net->signal->minRight;
    }
    if( net->signal->next == NIL( s_signal )){
	maxX = net->signal->right;
	if( maxX < NumCols - 1 )maxX++;
    } else {
	maxX = net->signal->right + 1;
	if( maxX >= net->signal->next->left )maxX--;
    }
    NewRight = randomInt( minX, maxX );

    if( net->termloc.y != net->signal->row )NewTermloc.x = net->termloc.x;
    else if( net->edge&L_EDGE )NewTermloc.x = NewLeft;
    else if( net->edge&R_EDGE )NewTermloc.x = NewRight;
    else NewTermloc.x = net->termloc.x;
    NewTermloc.y = net->termloc.y;
    NewEdge = net->edge&ANY_EDGE;

    /* see if the resize did anything					*/
    if(( NewLeft == net->signal->left )&&( NewRight == net->signal->right )){
	Move = INVALID;
    } else {
	Move = RESIZE;
    }
}
