#include "electra.h"
#include "st.h"
/*
 * hashNet.c
 *
 * routines to hash and get nets
 */
/*
 * the hash tables
 */
st_table *Nettbl = NIL(st_table);
st_table *st_init_table();	
/*
 * hashNet
 *
 * Insert a net into Nettbl by name.  Initialize Nettbl if necessary.
 */
hashNet( net )
s_net *net;
{
    /*
     * initialize the Nettbl if it is NIL
     */
    if ( Nettbl == NIL(st_table)) {
	Nettbl = st_init_table( strcmp, st_strhash );
    }
    if( st_insert( Nettbl, net->name, (char *)net) == 1 ){
	internalError( "hashNet - st_insert returned 1\n");
    }
}
/*
 * getNet
 *
 * return an element in Nettbl with the correct name
 */
s_net *
getNet( name )
char *name;
{
    s_net *net = NIL( s_net );
    if ( Nettbl == NIL( st_table ) ) {
	return( NIL( s_net ) );
    }
    if ( st_lookup( Nettbl, name, (char **)(&net)) == 0) return ( NIL(s_net) );
    return ( net );
}
