#include "electra.h" /*
 * netlist
 *
 * The transistors in the series and parallel networks have been 
 * allocated but still need to be connected.  
 */
netlist()
{
    s_signal *signal;
    s_network *network;
    char *newNetName();
    s_net *allocNet();
    int row, col;

    for ( row = 0 ; row < NumRows ; row ++ ){
	for ( signal = SignalArray[ row ]; signal != NULL; 
	      signal = signal->next){

	    if (signal->net == NULL ) signal->net = allocNet();
	    signal->net->signal = signal;
	    hashNet( signal->net );
	}
    }

    for ( col = 0; col < NumCols; col++ ){
	for ( network = NetworkArray[col]; network != NULL; 
	      network = network->next ){
	    for( row = network->top; row >= network->bottom; row-- ){
		if ( IS_TERM( row, col )){
		    network->net = Matrix[row][col].signal->net;
		    network->net->network = network;
		    break;
		}
	    }
	}
    }
}
