#include "electra.h"
/*
 * networkTerms
 *
 * wire a network to the edge of the array
 */
networkTerms()
{

    octObject *oTerm;
    octObject *newTerm();
    octBox area;
    octPoint termloc;
    int row, col, index;
    s_network *network;
    s_net *net;

    for( col = 0; col < NumCols; col++ ){
	for( network = NetworkArray[ col ]; network != NIL( s_network ); 
	     network = network->next ){

	    net = network->net;
	    termloc = net->termloc;

	    if((( net->edge&ANY_EDGE ) == 0 )||
		( termloc.x != network->col ))continue;

	    if( net->edge&TB_EDGE ){
		oTerm = newTerm( M1FTERM );

		if( net->edge & T_EDGE ) {
		    while( network->top < NumRows - 1 ){
			network->top++;
			if( Matrix[ network->top ][ col ].network == 
			    NIL(s_network )){
			    Matrix[ network->top ][ col].network = network;
			} else {
			    fprintf(stderr,"WARNING - 2 networks collide\n");
			}
		    }
		    TEdgeMask[ termloc.x ] |= CENTER;
		    area.lowerLeft.y = area.upperRight.y = TotalRows - 1;
		    constrainTerm( T_EDGE, oTerm );
		} else if( net->edge & B_EDGE ) {
		    while( network->bottom > 0 ){
			network->bottom--;
			if( Matrix[ network->bottom ][ col ].network == 
			    NIL( s_network )){
			    Matrix[ network->bottom ][ col ].network = network;
			} else {
			    fprintf(stderr,"WARNING - 2 networks collide\n");
			}
		    }
		    BEdgeMask[ termloc.x ] |= CENTER;
		    area.lowerLeft.y = area.upperRight.y = 0;
		    constrainTerm( B_EDGE, oTerm );
		}
		area.lowerLeft.x = area.upperRight.x = network->col;
		newFterm( net, oTerm );
		if( network->type == NAND ){
		    mkAttach( NandOutput, &area, oTerm );
		} else {
		    mkAttach( NorOutput, &area, oTerm );
		}
	    } else {
		row = termloc.y;
		if( termloc.y == net->signal->row ){
		} else if( net->edge&L_EDGE ){
		    for( index = network->col; index >= 0; index-- ){
			if( Matrix[ row ][index].metal2Mask&LOWER ){
			    net->edge |= UPPER;
			    break;
			} else if( Matrix[ row ][index].metal2Mask&UPPER){
			    net->edge |= LOWER;
			    break;
			}
		    }
		} else {
		    for( index = network->col; index < NumCols; index++ ){
			if( Matrix[ row ][index].metal2Mask&LOWER ){
			    net->edge |= UPPER;
			    break;
			} else if( Matrix[ row ][index].metal2Mask&UPPER){
			    net->edge |= LOWER;
			    break;
			}
		    }
		}

		area.lowerLeft.x = area.upperRight.x = network->col;
		oTerm = newTerm( M1M2TERM );
		
		if( net->edge&UPPER ){
		    area.lowerLeft.y = area.upperRight.y = 3 * termloc.y + 4;
		} else {
		    area.lowerLeft.y = area.upperRight.y = 3 * termloc.y + 2;
		}

		if( network->type == NAND ){
		    mkAttach( NandOutput, &area, oTerm );
		} else {
		    mkAttach( NorOutput, &area, oTerm );
		}
		if( net->edge&L_EDGE ){
		    wireToLeftEdge( net, oTerm, termloc.y, termloc.x );
		} else {
		    wireToRightEdge( net, oTerm, termloc.y, termloc.x );
		}
	    }
	}
    }
}
