#include "electra.h"

/*
 * parseTech
 *
 * The path to the cell library must be on the first line of the tech file
 * This line must begin with the keyword "path.
 * If the keyword "path", the directory defaults to the home directory
 *
 * The mapping between charactors in the personality matrix and the
 * actual instances is given in the technology file.  The format 
 * of the entrys in this file are:
 *
 * #TRANS
 * char pmosName nmosName
 *
 */
enum modeType { TRANS, OPTIONS };
parseTech()
{
    char nameBuffer[512];
    int numread;
    int linecount = 0;
    FILE *fopen(), *techfile;
    enum modeType mode;
    char line[512];
    char arg1[128], arg2[128], arg3[128];

    (void) sprintf(nameBuffer,"./%s", TechFileName );
    if (( techfile = fopen( nameBuffer , "r"))== NULL ){
	fprintf(stderr, "Could not open technology file %s\n", nameBuffer );
	(void) sprintf(nameBuffer,"%s/%s", Celllib, TechFileName );
	if (( techfile = fopen( nameBuffer , "r"))== NULL ){
	    fprintf(stderr, "Could not open technology file %s - exiting\n", 
	            nameBuffer );
	    exit( -1 );
	}
    }
    mode = TRANS;
    while( fgets(line, 512, techfile) != NULL ){
	line[strlen(line) - 1] = '\0';
	linecount++;
	numread = sscanf( line,"%s %s %s", arg1, arg2, arg3 );
	if( strcmp( arg1, "#TRANS" ) == 0 ){
	    mode = TRANS;
	} else if ( strncmp( arg1, "#", 1 ) == 0 ){
	    /* a comment						*/
	    continue;
	} else if( mode == TRANS ){
	    if ( numread != 3 )goto usage;
	    if ( *arg1 == '.' || *arg1 == 'p' || *arg1 == 's' ){
		fprintf(stderr, "%c is a reserved charactor\n", *arg1 );
		goto usage;
	    } else {
		charTable[(int)*arg1].set = TRUE;
		charTable[(int)*arg1].pmos = util_strsav( arg2 );
		charTable[(int)*arg1].nmos = util_strsav( arg3 );
	    }
	}
    }
    return;
usage:
    fprintf(stderr,"Error parsing technology file on line %d\n", linecount);
    fprintf(stderr,"The form of the technology file is:\n");
    fprintf(stderr,"#TRANS\nchar pmosname nmosname\n");
    fprintf(stderr,"char should not be in {.ps}\n");
    fprintf(stderr,"#OPTIONS\noption value\n");
    exit( -1 );
}
