#include "electra.h"

/*
 * createPolyM2Term
 *
 * instanciates a term, places it in the array, and returns its objectId
 */
octId
createPolyM2Term( row, col, upper )
int row;
int col;
unsigned upper; 	/* if UPPER, the term must be rotated		*/
{
    octObject *oTerm;
    octObject *newTerm();
    octBox area;
    s_network *network;

    oTerm = newTerm( POLYM2TERM );
    if( upper == UPPER ){
	oTerm->contents.instance.transform.transformType = OCT_MIRROR_Y;
	octModify( oTerm );
    }

    /* place the terminal in the array				*/
    if( upper == UPPER ){
	area.lowerLeft.y = 3 * row + 3; 
    } else {
	area.lowerLeft.y = 3 * row + 2; 
    }
    area.upperRight.y = area.lowerLeft.y + 1;
    area.lowerLeft.x = area.upperRight.x = col;

    network = Matrix[ row ][ col ].network;
    if(( network == NIL( s_network ))||
       ((( row > network->firstTran )&&
	( row > network->lastTran ))||
       (( row < network->firstTran )&&
	( row < network->lastTran )))){

	/* place it in the right transistor column			*/
	area.upperRight.x = area.lowerLeft.x  = 5 * col + 5;
	mkAttach( FullArray, &area, oTerm );

    } else if ( IS_TRAN( row, col ) == FALSE ){

	/* place it in the parallel column			*/
	if( network->type == NAND ){
	    mkAttach( PTrans, &area, oTerm );
	} else {
	    mkAttach( NTrans, &area, oTerm );
	}

    } else {

	/* place it in the other type output column		*/
	if( network->type == NAND ){
	    mkAttach( NorOutput, &area, oTerm );
	} else {
	    mkAttach( NandOutput, &area, oTerm );
	}
    }
    return( oTerm->objectId );
}


newPolyM2Term( signal, col, instanciate )
s_signal *signal;
int col;
int instanciate;
{
    int index;

    /* update the signal->term array				*/

    if( signal->numTerms++ == 0 ){
	signal->term = ALLOC( s_termList, 1 );
	index = 0;
    } else {
	signal->term = REALLOC( s_termList, signal->term, signal->numTerms );
	for( index =  signal->numTerms - 1; index >= 0; index-- ){
	    if( signal->term[ index - 1 ].col > col ){
		signal->term[ index ] = signal->term[ index - 1 ];
	    } else {
		break;
	    }
	}
    }
    if( instanciate ){
	signal->term[ index ].objectId = 
	    createPolyM2Term( signal->row, col, signal->net->edge&UPPER);
    } else {
	signal->term[ index ].objectId = oct_null_id;
    }
    signal->term[ index ].col = col;
}
