#include "electra.h"
/*
 * routeTerms
 *
 */
routeTerms()
{
    int index;
    s_signal *signal;
    s_net *net;
    /* do the "free" runs in POLY first if this is allowed		*/
    if( PolyTerms ){
	for( index = 0; index < NumRows; index++ ){

	    signal = SignalArray[index];
	    if( signal == NIL( s_signal )) continue;

	    /* route signals to the left edge				*/
	    net = signal->net;
	    if(( net->status&EXTERNAL )&&
	       (( net->status&ROUTED ) != ROUTED )&&
	       (( net->status&L_EDGE )||
		((( net->status&( T_EDGE|B_EDGE|R_EDGE )) == 0)))){
		routePolyLeft( signal );
	    }

	    if( signal->next == NIL(s_signal)) continue;
	    while( signal->next != NIL( s_signal )) signal = signal->next;

	    /* route signals to the right edge				*/
	    net = signal->net;
	    if(( net->status&EXTERNAL )&&
	       (( net->status&ROUTED ) != ROUTED )&&
	       (( net->status&R_EDGE )||
		((( net->status&( T_EDGE|B_EDGE|L_EDGE )) == 0)))){
		routePolyRight( signal );
	    }
	}
    }
    /* now set up a simulated annealing problem to route the remaining	*/
    /* nets.  NetArray[], an array of nets to be routed is created so	*/
    /* the nets can be randomly accessed.  The inital cost is computed	*/
    /* and anneal is called.  Finally, the nets are routed		*/
    NumToRoute = 0;
    for( net = Netlist; net != NIL( s_net ); net = net->next ){
	if(( net->status&EXTERNAL )&&(( net->status&ROUTED ) != ROUTED )){
	   NumToRoute++;
	}
    }
    NetsToRoute = ALLOC( s_net *, NumToRoute );
    NumToRoute = 0;
    for( net = Netlist; net != NIL( s_net ); net = net->next ){
	net->signal->maxLeft = net->signal->left;
	net->signal->minRight = net->signal->right;
	if(( net->status&EXTERNAL )&&(( net->status&ROUTED ) != ROUTED )){
	    NetsToRoute[ NumToRoute++ ] = net;
	    if( net->signal != NIL(s_signal)){
	    }
	    genNewEdge( net );
	    accMove( net );
	}
    }

    /* these masks tell what terminal postitions have been used on the edges */
    TEdgeMask = ALLOC( unsigned, NumCols );
    BEdgeMask = ALLOC( unsigned, NumCols );
    for( index = NumCols - 1; index >= 0; index-- ){
	TEdgeMask[ index ] = 0;
	BEdgeMask[ index ] = 0;
    }

    if( Debug > 0 ) anneal(1);
    else anneal(0);
}
