#include "electra.h"
/*
 * specArch
 */
specArch()
{
    int col;
    octBox area, subarea;

    mkOpenArray( &FullArray, &oFacet );
    mkSetDebug( FullArray, Debug );
    if( PrintGraph )mkSetPrintGraph( FullArray, TRUE );

    /* total array has 5 * NumCols + 3 columns				*/
    /* 2 cols for terms - 1 col for the extra power col			*/
    /* total array has 3 * NumRows + 4 rows				*/
    /* 2 rows for terms - 2 rows for power				*/

    TotalCols =  5 * NumCols + 3;
    TotalRows =  3 * NumRows + 4;
    area.lowerLeft.x = area.lowerLeft.y = 0;
    area.upperRight.x = TotalCols - 1;
    area.upperRight.y = TotalRows - 1;
    mkAddArrayArea( FullArray, &area );

    /* creating the subarrays						*/
    subarea.lowerLeft.x = subarea.lowerLeft.y = 0;
    subarea.upperRight.x = NumCols - 1;
    subarea.upperRight.y = TotalRows - 1;

    mkOpenSubarray( &NTrans, FullArray );
    mkAddArrayArea( NTrans, &subarea );

    mkOpenSubarray( &PTrans, FullArray );
    mkAddArrayArea( PTrans, &subarea );

    mkOpenSubarray( &VddArray, FullArray );
    mkAddArrayArea( VddArray, &subarea );

    mkOpenSubarray( &VssArray, FullArray );
    mkAddArrayArea( VssArray, &subarea );

    mkOpenSubarray( &NandOutput, FullArray );
    mkAddArrayArea( NandOutput, &subarea );

    mkOpenSubarray( &NorOutput, FullArray );
    mkAddArrayArea( NorOutput, &subarea );

    /* middle cols split between NTrans, PTrans, VddArray, and VssArray */

    area.lowerLeft.y = 0;
    area.upperRight.y = TotalRows - 1;
    subarea.lowerLeft.y = 0;
    subarea.upperRight.y = TotalRows - 1;

    area.lowerLeft.x = area.upperRight.x = 1;
    for( col = 0; col < NumCols; col++ ){ 

	subarea.lowerLeft.x = subarea.upperRight.x = col;
	if( col%2 == 0 ){

	    mkLinkSubarray( VssArray, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( NTrans, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( NorOutput, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( NandOutput, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( PTrans, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( VddArray, &subarea, &area );

	} else {

	    mkLinkSubarray( VddArray, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( PTrans, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( NandOutput, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( NorOutput, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( NTrans, &subarea, &area );
	    area.lowerLeft.x = ++area.upperRight.x;
	    mkLinkSubarray( VssArray, &subarea, &area );

	}
    }
}
