#include "electra.h"
#define MAXGATESIZE 5
/*
 * printStats
 *
 * prints the number of gates and transistors in the module
 */
printStats()
{
    s_network *network;
    int row, col;
    int nandCount[MAXGATESIZE + 1];
    int norCount[MAXGATESIZE + 1];
    int totalTrans = 0;
    int numTrans;

    for( col = 0; col <= MAXGATESIZE; col++ ){
	nandCount[ col ] = norCount[ col ] = 0;
    }
    for( col = 0; col < NumCols; col++ ){
	for( network = NetworkArray[ col ]; network != NIL( s_network );
	     network = network->next ){
	    numTrans = 0;
	    for( row = network->top; row >= network->bottom; row-- ){
		if( IS_TRAN( row, col ))numTrans++;
	    }
	    totalTrans += numTrans;
	    if( network->type == NAND )nandCount[ numTrans ]++;
	    else                       norCount[ numTrans ]++;
	}
    }
    for( col = 0; col <= MAXGATESIZE; col++ ){
	if( nandCount[ col ] > 0 )
	    fprintf(stdout,"%d %d input nand gates\n", nandCount[ col ], col);
    }
    for( col = 0; col <= MAXGATESIZE; col++ ){
	if( norCount[ col ] > 0 )
	    fprintf(stdout,"%d %d input nor gates\n", norCount[ col ], col);
    }
    fprintf(stdout,"%d literals\n", totalTrans);
}
