#include "electra.h"
/*
 * wireToLeftEdge
 *
 * wire a term to the the left edge of the array
 */
wireToLeftEdge( net, oTerm, row, col )
s_net  *net;
octObject *oTerm;
int col;
{
    octObject oTerm1;
    octObject oTerm2;
    octObject *newTerm();
    octBox area;
    unsigned track;

    if( net->edge&UPPER ){
	area.lowerLeft.y = area.upperRight.y = 3 * row + 4;
	track = UPPER;
    } else {
	area.lowerLeft.y = area.upperRight.y = 3 * row + 2;
	track = LOWER;
    }
    Matrix[row][col].metal2Mask |= track;
    oTerm1 = *oTerm;
    while( --col >= 0 ){
	if( Matrix[row][col].metal2Mask&track ){
	    oTerm2 = *newTerm( M2TERM );
	    area.lowerLeft.x = area.upperRight.x = 5 * col + 6;
	    mkAttach( FullArray, &area, &oTerm2 );
	    mkNewSegment( FullArray, &oTerm1, &oTerm2, NIL( char ),
				     MK_MIN_WIDTH, MK_DC_SEG );
	    if( track == UPPER ){
		area.lowerLeft.y = area.upperRight.y = 3 * row + 2;
		track = LOWER;
	    } else {
		area.lowerLeft.y = area.upperRight.y = 3 * row + 4;
		track = UPPER;
	    }
	    oTerm1 = *newTerm( M2TERM );
	    mkAttach( FullArray, &area, &oTerm1 );
	    mkNewSegment( FullArray, &oTerm1, &oTerm2, NIL( char ),
			  MK_MIN_WIDTH, MK_VER_SEG );
	} 
	Matrix[row][col].metal2Mask |= track;
    }
    oTerm2 = *newTerm( M2FTERM );
    newFterm( net, &oTerm2 );
    area.lowerLeft.x = area.upperRight.x = 0;
    mkAttach( FullArray, &area, &oTerm2 );
    mkNewSegment( FullArray, &oTerm1, &oTerm2, NIL( char ),
		  MK_MIN_WIDTH, MK_DC_SEG );
    constrainTerm(L_EDGE, &oTerm2 );
}

/*
 * wireToRightEdge
 *
 * wire a term to the the right edge of the array
 */
wireToRightEdge( net, oTerm, row, col )
s_net *net;
octObject *oTerm;
int row;
int col;
{
    octObject oTerm1;
    octObject oTerm2;
    octObject *newTerm();
    octBox area;
    unsigned track;

    if( net->edge&UPPER ){
	area.lowerLeft.y = area.upperRight.y = 3 * row + 4;
	track = UPPER;
    } else {
	area.lowerLeft.y = area.upperRight.y = 3 * row + 2;
	track = LOWER;
    }
    Matrix[row][col].metal2Mask |= track;
    oTerm1 = *oTerm;
    while( ++col < NumCols ){
	if( Matrix[row][col].metal2Mask&track ){
	    oTerm2 = *newTerm( M2TERM );
	    area.lowerLeft.x = area.upperRight.x = 5 * col + 1;
	    mkAttach( FullArray, &area, &oTerm2 );
	    mkNewSegment( FullArray, &oTerm1, &oTerm2, NIL( char ),
			  MK_MIN_WIDTH, MK_DC_SEG );
	    if( track == UPPER ){
		area.lowerLeft.y = area.upperRight.y = 3 * row + 2;
		track = LOWER;
	    } else {
		area.lowerLeft.y = area.upperRight.y = 3 * row + 4;
		track = UPPER;
	    }
	    oTerm1 = *newTerm( M2TERM );
	    mkAttach( FullArray, &area, &oTerm1 );
	    mkNewSegment( FullArray, &oTerm1, &oTerm2, NIL( char ),
			  MK_MIN_WIDTH, MK_VER_SEG );
	} 
	Matrix[row][col].metal2Mask |= track;
    }
    oTerm2 = *newTerm( M2FTERM );
    newFterm( net, &oTerm2 );
    area.lowerLeft.x = area.upperRight.x = TotalCols - 1;
    mkAttach( FullArray, &area, &oTerm2 );
    mkNewSegment( FullArray, &oTerm1, &oTerm2, NIL( char ),
		  MK_MIN_WIDTH, MK_DC_SEG );
    constrainTerm(R_EDGE, &oTerm2 );
}
