#include "electra.h"
/*
 * wireNetworks()
 *
 * Specifies the rules and wiring areas for the networks
 */
wireNetworks()
{
    mkId outputArray;
    char *ruleName;
    int col;
    s_network *network;
    octBox area;

    /* network output column 						*/
    for( col = 0; col < NumCols; col++ ){ 
	for( network = NetworkArray[col]; network != NIL(s_network);
	     network = network->next ){

	    if( network->type == NAND ){
		ruleName = NAND_RULE_NAME;
		outputArray = NandOutput;
	    } else {
		ruleName = NOR_RULE_NAME;
		outputArray = NorOutput;
	    }

	    /* wiring the transistors					*/
	    area.lowerLeft.x = 5 * network->col + 2;
	    area.upperRight.x = area.lowerLeft.x + 3;
	    if( col%2 == 0 ){
		area.lowerLeft.y = 3 * network->lastTran + 2;
		area.upperRight.y = 3 * network->firstTran + 4;
	    } else {
		area.lowerLeft.y = 3 * network->lastTran + 4;
		area.upperRight.y = 3 * network->firstTran + 2;
	    }
	    mkWireArea( FullArray, &area, ruleName );

	    area.lowerLeft.y = 3 * network->firstTran + 2;
	    area.upperRight.y =  area.lowerLeft.y + 2;
	    mkWireArea( FullArray, &area, FIRSTTRAN_RULE_NAME );

	    /* wiring the output column					*/
	    area.lowerLeft.x = area.upperRight.x = network->col;
	    if( network->bottom == 0 ){
		area.lowerLeft.y = 0;
	    } else {
		area.lowerLeft.y = 3 * network->bottom + 2;
	    }
	    if( network->top == NumRows - 1 ){
		area.upperRight.y = TotalRows - 1;
	    } else {
		area.upperRight.y = 3 * network->top + 4;
	    }
	    mkWireArea( outputArray, &area, OUTPUT_RULE_NAME );
	}
    }

    /* VSS columns							*/
    area.lowerLeft.y = 1;
    area.upperRight.y = TotalRows - 3;
    for( col = 1; col < TotalCols; col += 10 ){ 
	area.lowerLeft.x = area.upperRight.x = col;
	mkWireArea( FullArray, &area, POWERTRACK_RULE_NAME );
	if( col == 0 ){
	    area.lowerLeft.x = col;
	} else {
	    area.lowerLeft.x =  col - 1;
	}
	area.upperRight.x = col + 1;
	mkWireArea( FullArray, &area, POWER_RULE_NAME );
    }

    /* VDD columns							*/
    area.lowerLeft.y = 2;
    area.upperRight.y = TotalRows - 2;
    for( col = 6; col < TotalCols; col += 10 ){ 
	area.lowerLeft.x = area.upperRight.x = col;
	mkWireArea( FullArray, &area, POWERTRACK_RULE_NAME );
	area.lowerLeft.x = col - 1;
	if( col == TotalCols - 2 ){
	    area.upperRight.x = col;
	} else {
	    area.upperRight.x = col + 1;
	}
	mkWireArea( FullArray, &area, POWER_RULE_NAME );
    }

    /* VDD and VSS rows							*/
    area.lowerLeft.x = 1;
    area.upperRight.x = TotalCols - 2;
    area.lowerLeft.y = area.upperRight.y = 1;
    mkWireArea( FullArray, &area, POWERTRACK_RULE_NAME );
    area.lowerLeft.y = area.upperRight.y = TotalRows - 2;
    mkWireArea( FullArray, &area, POWERTRACK_RULE_NAME );
}
