#include "copyright.h"
#include "genie.h"


/**************************************************************************/
/*    This program inputs a  multi-level personality matrix 	*/
/*         and finds the optimum placement of cells     	*/
/*      reducing the number of rows and columns using 		*/
/*                 simulated annealing.  	                */
/*           Copyright: SRINIVAS DEVADAS  1985   	        */
/**************************************************************************/



int32 new_cost;
int RANGE_SMALL;
double NEW_STATES_PER_UNIT;


simulated_anneal()
{

 int c1,c2,c3,c4,max_gen,cur_gen,temp_points;
 int32 try;
 double update_temp(),TEMP,STOP_TEMP;

   ALPHA  = 0.90;                 /* make it a function later */
   STOP_TEMP = 1;
   RATIO_NET_DISP = 5;
   RATIO_CELL_DISP = 5;
   RATIO_NET_CELL = 100;
   OVERLAP_OFFSET = 3;
   NEW_STATES_PER_UNIT = STATES_BEGIN;
   TEMP = START_TEMP; 
   RANGE_SMALL = FALSE;
   c1 = init_cost + 10;c2 = c1 + 10;c3 = init_cost;
   c4 = c2 + 10;
   max_cost = init_cost;
   cur_gen = 0;temp_points = 0;
#ifndef dist
   (void) fprintf(stdout,"Initial cost is %d\n",init_cost);
   (void) fprintf(stdout,"Initial net overlap is %d\n",net_overlap);
   (void) fflush(stdout);
#endif
   while (stopping_criterion(c1,c2,c3,c4,STOP_TEMP,TEMP) is FALSE) {
     max_gen = NEW_STATES_PER_UNIT* cell_num;
     cur_gen = 0;temp_points++ ;
     while (inner_loop_criterion(max_gen,cur_gen) is FALSE) {
       try = generate_new_state();
       cur_gen++ ;
       if (try is FALSE) {
         if (debug)
           (void) fprintf(stdout,"not trying - range problems\n");
         continue;
       }
       if (should_accept(TEMP) is  TRUE ) {
         if (debug)
           (void) fprintf(stdout,"accepting new state\n");
         accept_new_state();
       }
       else {
        if (debug)
          (void) fprintf(stdout,"rejecting new state\n");
       }
     }
     c1 = c2;
     c2 = c3;
     c3 = c4;
     c4 = init_cost;
     TEMP = update_temp(TEMP);
   /*  if (debug) */
#ifndef dist
     (void) fprintf(stdout,"\nChanging TEMP to %.2g after %d states\n",TEMP,cur_gen);
     (void) fprintf(stdout,"Cost is %d\n",init_cost);
     (void) fflush(stdout);
#endif
   }
#ifndef dist
   (void) fprintf(stdout,"Starting temperature was %.4g\n",START_TEMP);
   (void) fprintf(stdout,"Maximum cost was %d\n",max_cost);
   (void) fprintf(stdout,"Final cost is %d Stagger %d  Overlap %d\n",init_cost,
                                                          stag_cost,over_cost);
   (void) fprintf(stdout,"Temperature points %d\n",temp_points);
   (void) fprintf(stdout,"Stopping temperature %.4g\n",TEMP);
   (void) fflush(stdout);
#endif

 return;

} /* end of simulated_anneal */


should_accept(temp)
double temp;
{

 double change_in_cost,R,Y,RANDOM();
 int olds,type;


  olds = stag_cost;
  if (shift_net1 isnt NIL(struct net)) {
    if (threed is TRUE && new_layer isnt 0)
      type = DISPLAYER;
    else {
      if (shift_net1->hor is TRUE)
        type = INTHORNET;
      else 
        type = INTVERTNET;
    }
  }
  else {
    type = INTPAD;
  }
  olds = stag_cost;
  new_cost = find_cost(FALSE,type);
  new_stag = stag_cost;
  stag_cost = olds;
  change_in_cost = new_cost - init_cost ;
  if (debug)
    (void) fprintf(stdout,"newc %d news %d newo %d oldc %d olds %d oldo %d temp %.2g\n"
     , new_cost,new_stag,new_net_overlap,init_cost,stag_cost,net_overlap,temp);
  if (change_in_cost < 0)
    return(TRUE);
  else {
    Y = exp(-change_in_cost/temp);
    R = RANDOM(0,1);
    if (R < Y) 
      return(TRUE);
    else
      return(FALSE);
  }

} /* end of should_accept */


double
update_temp(temp)
double temp;
{

  double new_temp,factor,new_states;

  /*
  if (sqrt(START_TEMP) < temp )
     new_temp = temp*ALPHA*ALPHA ;
  else
  */
     new_temp = ALPHA * temp;
  if (temp >= 1.0 && new_temp >= 1.0)
    factor = log(new_temp)/log(temp) ;
  else
    factor = 1;
  horizontal_span = horizontal_span*factor;
  vertical_span = vertical_span*factor;
  vertical_span =MAX(vertical_span,2.0);
  horizontal_span =MAX(horizontal_span,2.0);
  if (horizontal_span < 4 || vertical_span < 4 )
    RANGE_SMALL = TRUE;
  if (new_temp >= 1.0 ) 
     factor =  log(new_temp)/log(START_TEMP);
  else
     factor = 0;
  new_states = (double)STATES_END - (double)(STATES_END - STATES_BEGIN)*factor;
  NEW_STATES_PER_UNIT = new_states;

  return(new_temp);

} /* end of update_temp */
  

accept_new_state()
{

  int minx,miny,maxx,maxy,i;
  int temp_x,temp_y,n_cells;
  int type;
#ifdef THREED
  int layer;
#endif
  NET hornet1;
  char tempBuf;
  CELL_PTR cptr;
  CELL cell;
  NET_PTR nptr;

   stag_cost = new_stag;
   overlap_penalty = new_penalty;
   net_overlap = new_net_overlap;
   init_cost = new_cost;
   max_cost = MAX(max_cost,init_cost);
#ifdef THREED
   if (shift_net1 isnt NIL(struct net))
     layer = shift_net1->layer;
#endif
   if (shift_net1 isnt NIL(struct net)) {
     if (threed is TRUE && new_layer isnt 0) 
         type = DISPLAYER;
     else {
       if (shift_net1->hor is TRUE)
         type = INTHORNET;
       else
         type = INTVERTNET;
     }
   }
   else
     type = INTPAD;
   if (type is INTHORNET) {
/*
* net interchange or displacement.
*/
     if (shift_net2 is NIL(struct net)) {

       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                                        cptr=cptr->nextPtr) {
         if (cptr->clink->type >= PADLEFT) continue;
         cell = cptr->clink;
         for(nptr=cell->net_list;nptr!=NIL(struct net_ptr);nptr=nptr->nextPtr)
           nptr->nlink->num_cols = nptr->nlink->nnum_cols;
       }

       if (statcmos is TRUE) {
         if (shift_net1->type is PCHANNEL ) {
           if (new_row > middle_row + OFFSET ||
                             shift_net1->row > middle_row + OFFSET)
             error("p channel net in n region");
         }
         if (shift_net1->type is NCHANNEL ) {
           if (new_row <= middle_row + OFFSET ||
                          shift_net1->row <= middle_row + OFFSET)
             error("n channel net in p region");
         }
       }
       n_cells = 0;
       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                                        cptr=cptr->nextPtr) {
         if (cptr->clink->type < PADLEFT)
           n_cells++;
       }
       Row[new_row-OFFSET] += n_cells;
       Row[shift_net1->row-OFFSET] -= n_cells;
       find_net_limits(shift_net1,&minx,&maxx,&miny,&maxy,1);
#ifndef THREED
       for(i=minx;i<=maxx;i++)
         net_matrix[i][shift_net1->row].hor -= 1;
       for(i=minx;i<=maxx;i++)
         net_matrix[i][new_row].hor += 1;
#else
       for(i=minx;i<=maxx;i++)
         net_matrix[layer][i][shift_net1->row].hor -= 1;
       for(i=minx;i<=maxx;i++)
         net_matrix[layer][i][new_row].hor += 1;
#endif
       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                             cptr=cptr->nextPtr) {
#ifdef THREED
         t_matrix[layer][cptr->clink->rect.x][shift_net1->row] -= 1;
         t_matrix[layer][cptr->clink->rect.x][new_row] += 1;
#endif
         matrix[cptr->clink->rect.x][shift_net1->row] -= 1;
         matrix[cptr->clink->rect.x][new_row] += 1;
         cptr->clink->rect.y = new_row;
       }
       shift_net1->row = new_row;
     } 
     else {

       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                                        cptr=cptr->nextPtr) {
         if (cptr->clink->type >= PADLEFT) continue;
         cell = cptr->clink;
         for(nptr=cell->net_list;nptr!=NIL(struct net_ptr);nptr=nptr->nextPtr)
           nptr->nlink->num_cols = nptr->nlink->nnum_cols;
       }
       for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                                        cptr=cptr->nextPtr) {
         if (cptr->clink->type >= PADLEFT) continue;
         cell = cptr->clink;
         for(nptr=cell->net_list;nptr!=NIL(struct net_ptr);nptr=nptr->nextPtr)
           nptr->nlink->num_cols = nptr->nlink->nnum_cols;
       }

       if (statcmos is TRUE) {
         if ( (shift_net1->type is NCHANNEL && shift_net2->type is PCHANNEL) ||
              (shift_net1->type is PCHANNEL && shift_net2->type is NCHANNEL) )
            error("p and n nets being interchanged");
         if (shift_net1->type is PCHANNEL) {
           if (shift_net1->row > middle_row + OFFSET )
             error("p net in n region");
         }
         if (shift_net1->type is NCHANNEL) {
           if (shift_net1->row <= middle_row + OFFSET )
             error("n net in p region");
         }
         if (shift_net2->type is PCHANNEL) {
           if (shift_net2->row > middle_row + OFFSET )
             error("p net in n region");
         }
         if (shift_net2->type is NCHANNEL) {
           if (shift_net2->row <= middle_row + OFFSET )
             error("n net in p region");
         }
       }
       n_cells = 0;
       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                        cptr=cptr->nextPtr) {
         if (cptr->clink->type < PADLEFT)
           n_cells++;
       }
       Row[shift_net2->row-OFFSET] += n_cells;
       Row[shift_net1->row-OFFSET] -= n_cells;
       n_cells = 0;
       for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                        cptr=cptr->nextPtr) {
         if (cptr->clink->type < PADLEFT)
           n_cells++;
       }
       Row[shift_net1->row-OFFSET] += n_cells;
       Row[shift_net2->row-OFFSET] -= n_cells;
       find_net_limits(shift_net1,&minx,&maxx,&miny,&maxy,1);
#ifndef THREED
       for(i=minx;i<=maxx;i++)
         net_matrix[i][shift_net1->row].hor -= 1;
       for(i=minx;i<=maxx;i++)
         net_matrix[i][shift_net2->row].hor += 1;
#else
       for(i=minx;i<=maxx;i++)
         net_matrix[layer][i][shift_net1->row].hor -= 1;
       for(i=minx;i<=maxx;i++)
         net_matrix[layer][i][shift_net2->row].hor += 1;
#endif
       find_net_limits(shift_net2,&minx,&maxx,&miny,&maxy,1);
#ifndef THREED
       for(i=minx;i<=maxx;i++)
         net_matrix[i][shift_net2->row].hor -= 1;
       for(i=minx;i<=maxx;i++)
         net_matrix[i][shift_net1->row].hor += 1;
#else
       for(i=minx;i<=maxx;i++)
         net_matrix[layer][i][shift_net2->row].hor -= 1;
       for(i=minx;i<=maxx;i++)
         net_matrix[layer][i][shift_net1->row].hor += 1;
#endif
       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                             cptr=cptr->nextPtr) {
         matrix[cptr->clink->rect.x][shift_net1->row] -= 1;
         matrix[cptr->clink->rect.x][shift_net2->row] += 1;
         cptr->clink->rect.y = shift_net2->row;
       }
       for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                             cptr=cptr->nextPtr) {
         matrix[cptr->clink->rect.x][shift_net2->row] -= 1;
         matrix[cptr->clink->rect.x][shift_net1->row] += 1;
         cptr->clink->rect.y = shift_net1->row;
       }
       temp_y = shift_net1->row;
       shift_net1->row = shift_net2->row;
       shift_net2->row = temp_y;
     }
   }
   if (type is INTVERTNET) {
/*
* net interchange or displacement.
*/
     if (shift_net2 is NIL(struct net)) {
       n_cells = 0;
       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                        cptr=cptr->nextPtr) {
         if (cptr->clink->type < PADLEFT)
           n_cells++;
       }
       Col[new_col-OFFSET] += n_cells;
       Col[shift_net1->col-OFFSET] -= n_cells;
       find_net_limits(shift_net1,&minx,&maxx,&miny,&maxy,1);
#ifndef THREED
       for(i=miny;i<=maxy;i++)
         net_matrix[shift_net1->col][i].ver -= 1;
       for(i=miny;i<=maxy;i++)
         net_matrix[new_col][i].ver += 1;
#else
       for(i=miny;i<=maxy;i++)
         net_matrix[layer][shift_net1->col][i].ver -= 1;
       for(i=miny;i<=maxy;i++)
         net_matrix[layer][new_col][i].ver += 1;
#endif
       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                             cptr=cptr->nextPtr) {
         matrix[shift_net1->col][cptr->clink->rect.y] -= 1;
         matrix[new_col][cptr->clink->rect.y] += 1;
         cptr->clink->rect.x = new_col;
       }
       shift_net1->col = new_col;
     } 
     else {
       n_cells = 0;
       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                        cptr=cptr->nextPtr) {
         if (cptr->clink->type < PADLEFT)
           n_cells++;
       }
       Col[shift_net2->col-OFFSET] += n_cells;
       Col[shift_net1->col-OFFSET] -= n_cells;
       n_cells = 0;
       for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                        cptr=cptr->nextPtr) {
         if (cptr->clink->type < PADLEFT)
           n_cells++;
       }
       Col[shift_net1->col-OFFSET] += n_cells;
       Col[shift_net2->col-OFFSET] -= n_cells;
       find_net_limits(shift_net1,&minx,&maxx,&miny,&maxy,1);
#ifndef THREED
       for(i=miny;i<=maxy;i++)
         net_matrix[shift_net1->col][i].ver -= 1;
       for(i=miny;i<=maxy;i++)
         net_matrix[shift_net2->col][i].ver += 1;
#else
       for(i=miny;i<=maxy;i++)
         net_matrix[layer][shift_net1->col][i].ver -= 1;
       for(i=miny;i<=maxy;i++)
         net_matrix[layer][shift_net2->col][i].ver += 1;
#endif
       find_net_limits(shift_net2,&minx,&maxx,&miny,&maxy,1);
#ifndef THREED
       for(i=miny;i<=maxy;i++)
         net_matrix[shift_net2->col][i].ver -= 1;
       for(i=miny;i<=maxy;i++)
         net_matrix[shift_net1->col][i].ver += 1;
#else
       for(i=miny;i<=maxy;i++)
         net_matrix[layer][shift_net2->col][i].ver -= 1;
       for(i=miny;i<=maxy;i++)
         net_matrix[layer][shift_net1->col][i].ver += 1;
#endif
       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                             cptr=cptr->nextPtr) {
         matrix[shift_net1->col][cptr->clink->rect.y] -= 1;
         matrix[shift_net2->col][cptr->clink->rect.y] += 1;
         cptr->clink->rect.x = shift_net2->col;
       }
       for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                             cptr=cptr->nextPtr) {
         matrix[shift_net2->col][cptr->clink->rect.y] -= 1;
         matrix[shift_net1->col][cptr->clink->rect.y] += 1;
         cptr->clink->rect.x = shift_net1->col;
       }
       if (domino is TRUE) {
/*
*  check if buffers have to be interchanged.
*/
         if (shift_net1->tilda is TRUE && shift_net2->tilda is TRUE) {
           if ( (shift_net1->buffer isnt '.' && shift_net1->col < 
                 shift_net2->col) || (shift_net2->buffer isnt '.' &&
                         shift_net2->col < shift_net1->col)) {
             if (shift_net1->gate isnt shift_net2->gate)
               error("just interchanged columns of different gates");
             tempBuf = shift_net1->buffer;
             shift_net1->buffer = shift_net2->buffer;
             shift_net2->buffer = tempBuf;
           }
         }
       }
       temp_x = shift_net1->col;
       shift_net1->col = shift_net2->col;
       shift_net2->col = temp_x;
     }
   }
#ifdef THREED
   if (type is DISPLAYER) {
     layer = shift_net1->layer;
     find_net_limits(shift_net1,&minx,&maxx,&miny,&maxy,1);
     for(i=minx;i<=maxx;i++) {
       net_matrix[layer][i][shift_net1->row].hor -= 1;
       net_matrix[new_layer][i][shift_net1->row].hor += 1;
     }
     for(cptr=shift_net1->cell_list;cptr != NIL(struct cell_ptr); 
                                                       cptr=cptr->nextPtr) {
       t_matrix[layer][cptr->clink->rect.x][cptr->clink->rect.y] -= 1;
       t_matrix[new_layer][cptr->clink->rect.x][cptr->clink->rect.y] += 1;
     }
     shift_net1->layer = new_layer;
   }
#endif
   else if (type is INTPAD) {
     matrix[newloc_x][shift_cell1->rect.y] += 1 ;
     matrix[shift_cell1->rect.x][shift_cell1->rect.y] -= 1;  
     if (shift_cell1->net_list->nlink->hor is TRUE)
       hornet1 = shift_cell1->net_list->nlink;
     else
       hornet1 = shift_cell1->net_list->nextPtr->nlink;
#ifdef THREED
     layer = hornet1->layer;
#endif
     find_net_limits(hornet1,&minx,&maxx,&miny,&maxy,1);
#ifndef THREED
     for(i=minx;i<=maxx;i++)
       net_matrix[i][shift_cell1->rect.y].hor -= 1;
#else
     for(i=minx;i<=maxx;i++)
       net_matrix[layer][i][shift_cell1->rect.y].hor -= 1;
#endif
     find_net_limits(hornet1,&minx,&maxx,&miny,&maxy,2);
#ifndef THREED
     for(i=minx;i<=maxx;i++)
       net_matrix[i][shift_cell1->rect.y].hor += 1;
#else
     for(i=minx;i<=maxx;i++)
       net_matrix[layer][i][shift_cell1->rect.y].hor += 1;
#endif
     shift_cell1->rect.x = newloc_x;
   }
  return;

} /* end of accept_new_state */


double
RANDOM(left,right)
int left,right;
{

 long divide,random(),random_num;
 double number;

   random_num = random();
   divide = 2147483647;
   number = ((double)random_num)/divide;
   number = number*abs(right - left) + left ;

 return(number);

} /* end of RANDOM */

