#include "copyright.h"
#include "genie.h"
#include "oct.h"
#include "oh.h"

/*
 * dump the oct logic view as it is
 */


FILE *Genie;

#define FUN_LENGTH 500
#define NAME_LENGTH 100
#define is ==
#define FALSE 0
#define TRUE 1

typedef struct pipo {

   char *name;
   struct pipo *nextPtr;

} *PIPO;


oct_read(cell_name)
char *cell_name;
{
    octObject cell, instance, bag;
    octGenerator gen;
    char *function, *getFunction(), *getExtNetName(), *outName();
    int i, length;
    int next_comp, temp;
    char *netName, my_func[FUN_LENGTH];
    char token[NAME_LENGTH];
    PIPO io,pi_list, po_list;
    int num_on_line;

    /* open the file */
    if ( (Genie = fopen("genie.log","w")) is NULL) {
      error("couldnt open genie.log");
    }

    /* open the cell */
    if (ohOpenFacet(&cell, cell_name, "optlogic", "contents", "r") < OCT_OK) {
	(void) fprintf( stderr, "Unable to open cell %s:%s:%s: %s\n", 
		 cell.contents.facet.cell, cell.contents.facet.view,
		 cell.contents.facet.facet, octErrorString() );
	exit (-1);
    }
    /* open the cell - interface*/
/*
    if (ohOpenFacet(&interface, cell_name, "optlogic", "interface", "r") < OCT_OK) {
	(void) fprintf( stderr, "Unable to open cell %s:%s:%s: %s\n", 
		 interface.contents.facet.cell, interface.contents.facet.view,
		 interface.contents.facet.facet, octErrorString() );
	exit (-1);
    }
*/
    pi_list = po_list = NIL(struct pipo);
/*
    find_pi_po(&interface,pi_list,po_list);
*/

    /* create all gates */
    OH_ASSERT(ohGetByBagName(&cell, &bag, "INSTANCES"));
    OH_ASSERT(octInitGenContents(&bag, OCT_INSTANCE_MASK, &gen));
    while ( octGenerate(&gen, &instance) is OCT_OK) {
	function = getFunction(&instance);
        netName = getExtNetName(&instance, outName(&instance));

        /*printf("net:%s,    func:%s\n", netName, function); */

         /* parse the function */
        length = strlen(function);
        (void) sprintf(my_func,"(o %s ", netName);
        if (inverter(function) is TRUE) {
          i = 0;
          while ( i < length ) {
 
            if (function[i] <= ' ' )
              i++;
            else if (function[i] is '!' ) {
              (void) strcat(my_func,"s ");
              i++;
            }
            else if (function[i] is '(' ) {
              (void) strcat(my_func,"(");
              i++;
            }
            else if (function[i] is ')' ) {
              (void) strcat(my_func,")");
              i++;
            }
            else {
              grab_token(function,&i,token);
              netName = getExtNetName(&instance,token);

              (void) strcat(my_func,netName);
              (void) strcat(my_func," ");
            }
          }
          (void) strcat(my_func,");");
        }
        else {
          i = 0;
          next_comp = FALSE;
          while( i < length ) {
            if (function[i] <= ' ' )
              i++;
            else if (function[i] is '!') {
              i++;
            }
            else if (function[i] is '(' ) {
              temp = i+1;
              while (function[i] <= ' ') temp++;
              if (function[temp] is '!') {
                 next_comp = TRUE;
                 i = temp + 1;
              }
              else {
                 (void) strcat(my_func,"(");
                 i++;
              }
            }
            else if (function[i] is '*' ) {
              i++;
              (void) strcat(my_func,"s ");
            }
            else if (function[i] is '+' ) {
              i++;
              (void) strcat(my_func,"p ");
            }
            else if (function[i] is ')' ) {
              if (next_comp is TRUE)
                next_comp = FALSE;
              else
               (void) strcat(my_func,")");
              i++;
            }
            else {
              grab_token(function,&i,token);
              netName = getExtNetName(&instance,token);

              (void) strcat(my_func,netName);
              (void) strcat(my_func," ");
            }
          }
          (void) strcat(my_func,");");
        }

        (void) fprintf(Genie,"%s\n",my_func);
    }
/*
* Get constraints of left and right edge signals
*/
/*
    get_constraints(Genie, &interface, &cell);
*/
/*
* find the primary inputs and outputs of this module
*/
    if (pi_list != NIL(struct pipo)) {
      (void) fprintf(Genie,"input ");
      num_on_line = 0;
      for(io=pi_list;io!=NIL(struct pipo);io=io->nextPtr) {
        num_on_line++;
        if (num_on_line > 10) {
          num_on_line = 0;
          (void) fprintf(Genie,";\ninput ");
        }
        (void) fprintf(Genie,"%s ",io->name);
      }
      (void) fprintf(Genie,";\n");
    }
    if (po_list != NIL(struct pipo)) {
      (void) fprintf(Genie,"output ");
      num_on_line = 0;
      for(io=po_list;io!=NIL(struct pipo);io=io->nextPtr) {
        num_on_line++;
        if (num_on_line > 10) {
          num_on_line = 0;
          (void) fprintf(Genie,";\noutput ");
        }
        (void) fprintf(Genie,"%s ",io->name);
      }
      (void) fprintf(Genie,";\n");
    }
    (void) fclose(Genie);

  return;

} /* end of oct_read */


/* ASSUME: there is only one terminal with property LOGICFUNCTION */
char *
getFunction(inst)
octObject *inst;
{
    octObject master, prop, fterm, aterm, net;
    octGenerator gen;

    /* look for logic function in the instance */
    OH_ASSERT(octInitGenContents(inst, OCT_TERM_MASK, &gen));
    while (octGenerate(&gen, &aterm) == OCT_OK) {
	if (ohGetByPropName(&aterm, &prop, "LOGICFUNCTION") == OCT_OK) {
	    return util_strsav(prop.contents.prop.value.string);
	}
    }

    /* goto the master */
    if (ohOpenMaster(&master, inst, "interface", "r") < OCT_OK) {
	(void) fprintf(stderr, "can't open master of %s:%s\n", 
		         inst->contents.instance.name, octErrorString());
	exit(-1);
    }

    /* loop over all terminals for the logic function */ 
    OH_ASSERT(octInitGenContents(&master, OCT_TERM_MASK, &gen));
    while (octGenerate(&gen, &fterm) == OCT_OK) {
	if (ohGetByPropName(&fterm, &prop, "LOGICFUNCTION") == OCT_OK) {
	    if( ohGetByTermName(inst, &aterm, fterm.contents.term.name) < OCT_OK ){
		(void) fprintf( stderr, 
			"Error matching formal and actual term %s of %s:%s\n",
			 fterm.contents.term.name,
			 master.contents.facet.cell,
			 master.contents.facet.view );
		exit(-1);
	    }
	    if( octGenFirstContainer( &aterm, OCT_NET_MASK, &net ) == OCT_OK ){
		return util_strsav(prop.contents.prop.value.string);
	    }
	}
    }

    (void) fprintf(stderr, "Can't find LOGICFUNCTION in cell");
    (void) fprintf(stderr, "%s\n", master.contents.facet.cell);
    exit(-1);
    /*NOTREACHED*/
}


char *
getExtNetName(inst,name)
octObject *inst;
char *name;
{
   octGenerator gen;
   octObject term, net;

   OH_ASSERT(ohGetByTermName(inst, &term, name));
   OH_ASSERT(octInitGenContainers(&term, OCT_NET_MASK, &gen));
   OH_ASSERT(octGenerate(&gen, &net));

   return util_strsav(net.contents.net.name);
}


char *
outName(inst)
octObject *inst;
{
    octObject master, prop, term, fterm, aterm, net;
    octGenerator gen;

    OH_ASSERT(octInitGenContents(inst, OCT_TERM_MASK, &gen));
    while (octGenerate(&gen, &term) is OCT_OK) {
	if (ohGetByPropName(&term, &prop, "DIRECTION") == OCT_OK) {
            if (strcmp(prop.contents.prop.value.string, "OUTPUT") == 0) {
	        return util_strsav(term.contents.term.name);
	    }
        }
    }

    /* goto the master */
    if (ohOpenMaster(&master, inst, "interface", "r") < OCT_OK) {
	(void) fprintf(stderr, "can't master %s:%s:%s: %s\n", 
			master.contents.facet.cell, master.contents.facet.view,
			master.contents.facet.facet, octErrorString());
	exit(-1);
    }

    /* loop over all terminals for the logic function */ 
    OH_ASSERT(octInitGenContents(&master, OCT_TERM_MASK, &gen));
    while (octGenerate(&gen, &fterm) == OCT_OK) {
	if (ohGetByPropName(&fterm, &prop, "LOGICFUNCTION") == OCT_OK) {
	    if( ohGetByTermName(inst, &aterm, fterm.contents.term.name) < OCT_OK ){
		(void) fprintf( stderr, 
			"Error matching formal and actual term %s of %s:%s\n",
			 fterm.contents.term.name,
			 master.contents.facet.cell,
			 master.contents.facet.view );
		exit(-1);
	    }
	    if( octGenFirstContainer( &aterm, OCT_NET_MASK, &net ) == OCT_OK ){
		return util_strsav(aterm.contents.term.name);
	    }
	}
    }
    (void) fprintf(stderr, "No output terminal for instance %s of %s:%s:%s\n", 
		    inst->contents.instance.name, master.contents.facet.cell,
		    master.contents.facet.view, master.contents.facet.facet );
    exit(-1);
    /*NOTREACHED*/
}


inverter(func)
char *func;
{

 int i;
 int length,comp,brac;

   length = strlen(func);
   comp = brac = 0;
   for(i=0;i<length;i++) {
     if (func[i] is '(') brac++;
     if (func[i] is '!') comp++;
   }
   if (comp is 1 && brac is 1) return(TRUE);
   else return(FALSE);

} /* end of inverter */


grab_token(line,ptr,token)
char *line;
int *ptr;
char *token;
{

 int j, length, i;

   length = strlen(line);
   j = 0;
   for(i= *ptr; i< length; i++) {
     if (line[i] is '!' || line[i] is '*' || line[i] is '+' ||
                 line[i] is '(' || line[i] is ')' || line[i] <= ' ') break;
     token[j++] = line[i];
   }
   token[j] = '\0';
   *ptr = i;

 return;

} /* end of grab_token */


#ifndef lint
PIPO
add_pi_po(io_list,name)
PIPO io_list;
char *name;
{

 PIPO np;

  np = ALLOC(struct pipo, 1);
  np->name = util_strsav(name);
  np->nextPtr = io_list;
  io_list = np;

 return(io_list);

} /* end of add_pi_po */

find_pi_po(interface,ilist,olist)
octObject *interface;
PIPO ilist, olist;
{
    octObject aterm, fterm, prop;
    octGenerator gen, termgen;

    OH_ASSERT(octInitGenContents(interface, OCT_TERM_MASK, &gen));
    while (octGenerate(&gen, &fterm) == OCT_OK) {
	OH_ASSERT(octInitGenContainers(&aterm, OCT_TERM_MASK, &termgen));
	if (octGenerate(&termgen, &fterm) == OCT_OK) {
	    if (ohGetByPropName(&fterm, &prop, "DIRECTION") != OCT_OK) {
(void) fprintf(stderr, "No direction on %s\n", fterm.contents.term.name);
	    }

	    if (strcmp(prop.contents.prop.value.string, "OUTPUT") == 0) {
               olist = add_pi_po(olist,aterm.contents.term.name);
	    } else if (strcmp(prop.contents.prop.value.string, "INPUT") == 0) {
               ilist = add_pi_po(ilist,aterm.contents.term.name);
	    } else {
(void) fprintf(stderr, "unknown direction> %s\n", prop.contents.prop.value.string);
	    }
	}
    }

} /* end of find_pi_po */
#endif


#ifndef lint
get_constraints(file_ptr, interface, contents)
FILE *file_ptr;
octObject *interface;
octObject *contents;
{

  octObject fterm, rterm, net;
  octObject prop;
  octGenerator gen, cgen, ngen;
  int found;

    OH_ASSERT(octInitGenContents(interface, OCT_TERM_MASK, &gen));
    while (octGenerate(&gen, &fterm) == OCT_OK) {
	if (ohGetByPropName(&fterm, &prop, "TERM_EDGE") == OCT_OK) {

            /* find fterm with same name in contents facet */
            found = FALSE;
            OH_ASSERT(octInitGenContents(contents, OCT_TERM_MASK, &cgen));
            while(octGenerate(&cgen, &rterm) == OCT_OK) {
              if (strcmp(rterm.contents.term.name, fterm.contents.term.name)
                                                               is FALSE) {
                found = TRUE;
                break;
              }
            }
            if (found is FALSE)
              crash("couldnt find terminal in contents facet");
          
	    OH_ASSERT(octInitGenContainers(&rterm, OCT_NET_MASK, &ngen));
	    OH_ASSERT(octGenerate(&ngen, &net));
	    if (strcmp(prop.contents.prop.value.string, "LEFT") == 0)
               (void) fprintf(file_ptr,"left %s ;\n", net.contents.net.name);
	    else if (strcmp(prop.contents.prop.value.string, "RIGHT") == 0)
               (void) fprintf(file_ptr,"right %s ;\n", net.contents.net.name);
	}
    }   

  return;
} /* end of get_constraints */
#endif
