#include "copyright.h"
#include "genie.h"


/**********************************************************************/
/*    This program inputs a  multi-level personality matrix  	      */
/*         and finds the optimum placement of cells      	      */
/*      reducing the number of rows and columns using 	              */
/*                 simulated annealing.      		              */
/*           Copyright: SRINIVAS DEVADAS  1985    		      */
/**********************************************************************/


#define HOR 1
#define VER 2
#define ROWH 3
#define COLV 4


int *hor_net_order,*vert_net_order;
char **fixed_loc;
int hor_num,ver_num;
int *row_type;
int *numnets_on_row;
extern int *numnets_on_col;
int errorOccured = FALSE;

route_annealed_array()
{

   int i,j,n_rows,n_cols;
   int total_length,total_width,xcoor,ycoor;
   int *maxLength,*maxWidth,minx,maxx,miny,maxy;
   int tcol;
   CELL_PTR cptr;
  
   fixed_loc = ALLOC (char *,MHsize + 30);
   for (i = 0; i < MHsize + 30; i++) 
     fixed_loc[i] = ALLOC (char,MVsize + 30);
   numnets_on_row = ALLOC(int, MVsize+10);
   shrink_matrix();
   if (rowpreferred) {
     sort_hor_nets();
     straighten_horizontal_nets();
   }
   else {
     sort_vert_nets();
     straighten_vertical_nets();
   }
   for(i=1;i<=MHsize;i++)
     for(j=1;j<=MVsize;j++)
       net_matrix[i][j].hor = net_matrix[i][j].ver = 0;
   for(i=1;i<=net_num;i++) {
     if (nets[i]->hor is TRUE && rowpreferred is TRUE) {
       minx = INFINITY;
       maxx = 0;
       if (nets[i]->cell_list) {
	 ycoor = nets[i]->cell_list->clink->rect.y;
	 for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
						    cptr=cptr->nextPtr) {
	   minx = MIN(minx,cptr->clink->rect.x);
	   maxx = MAX(maxx,cptr->clink->rect.x);
	   if (ycoor isnt cptr->clink->rect.y)
	     (void) fprintf(stdout,"NET %s NUMBER %d is not straight\n",
					nets[i]->netName, nets[i]->num);
	 }
	 for(j=minx;j<=maxx;j++)
	   net_matrix[j][ycoor].hor += 1;
       }
     }
     else if (nets[i]->hor is FALSE && rowpreferred is FALSE) {
       miny = INFINITY;
       maxy = 0;
       xcoor = nets[i]->cell_list->clink->rect.x;
       for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                  cptr=cptr->nextPtr) {
         miny = MIN(miny,cptr->clink->rect.y);
         maxy = MAX(maxy,cptr->clink->rect.y);
         if (xcoor isnt cptr->clink->rect.x)
           (void) fprintf(stdout,"NET %s NUMBER %d is not straight\n",
				      nets[i]->netName, nets[i]->num);
       }
       for(j=miny;j<=maxy;j++)
         net_matrix[xcoor][j].ver += 1;
     }
   }
/*
   for(i=1;i<=MHsize;i++) {
     for(j=1;j<=MVsize;j++) {
       if (rowpreferred is TRUE && net_matrix[i][j].hor > 1){
         (void) fprintf(stdout,"HORIZONTAL NET OVERLAP AT %d %d\n",i,j);
	 errorOccured = TRUE;
       }
       if (rowpreferred is FALSE && net_matrix[i][j].ver > 1){
         (void) fprintf(stdout,"VERTICAL NET OVERLAP AT %d %d\n",i,j);
	 errorOccured = TRUE;
       }
     }
   }
*/
   for (i = 0; i < MHsize + 30; i++) 
     for (j = 0; j < MVsize + 30; j++) 
       fixed_loc[i][j]  = FALSE ;
   if (rowpreferred is TRUE) {
     sort_vert_nets();
     straighten_vertical_nets();
   }
   else {
     sort_hor_nets();
     straighten_horizontal_nets();
   }
   for(i=0;i<=num_rows+10;i++)
     Row[i] = 0;
   for(i=0;i<=num_cols+10;i++)
     Col[i] = 0;
   for(i=1;i<=gate_num;i++) {
     Row[cells[i]->rect.y-OFFSET] += 1;
     Col[cells[i]->rect.x-OFFSET] += 1;
   }
   n_rows = n_cols = 0;
   for(i=0;i<=num_rows+10;i++)
     if (Row[i] > 0)
       n_rows++;
   for(i=0;i<=num_cols+10;i++)
     if (Col[i] > 0) 
       n_cols++;
   shrink_matrix();

/*
* check that tilda nets are not folded
*/
   for(i=1;i<=net_num;i++) {
     if (nets[i]->tilda is TRUE && nets[i]->hor is FALSE) {
       tcol = nets[i]->col;
       for(j=1;j<=net_num;j++) {
         if (nets[j]->hor is FALSE) {
           if (nets[j]->col is nets[i]->col && j isnt i) {
             (void) add_col(tcol,tcol+1);
             nets[i]->col = tcol + 1;
             for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                           cptr=cptr->nextPtr)
               cptr->clink->rect.x = tcol + 1;
           }
         }
       }
     }
   }
             
   num_rows = n_rows;num_cols = n_cols;
   maxLength =  ALLOC (int,MAX(num_rows,num_cols) + 1);
   maxWidth =  ALLOC (int,MAX(num_rows,num_cols) + 1);
   for(i=1;i<=MAX(num_rows,num_cols);i++) {
     maxWidth[i] = 0;
     maxLength[i] = 0;
   }
   for(i=1;i<=gate_num;i++) {
     maxWidth[cells[i]->rect.x-OFFSET] = 
              MAX(maxWidth[cells[i]->rect.x-OFFSET],cells[i]->stdType->w);
     maxLength[cells[i]->rect.y-OFFSET] = 
                MAX(maxLength[cells[i]->rect.y-OFFSET],cells[i]->stdType->l);
   }
   total_width = total_length = 0;
   for(i=1;i<=num_cols;i++) 
     total_width += maxWidth[i];
   for(i=1;i<=num_rows;i++)
      total_length += maxLength[i];
#ifndef dist
   (void) fprintf(stdout,"\nTOTAL WIDTH %d TOTAL LENGTH %d\n\n",total_width,
                                                          total_length);
#endif
/*
   plot_cells("plf");
*/
   for(i=1;i<=MHsize;i++)
     for(j=1;j<=MVsize;j++)
       matrix[i][j] = 0;
   for(i=1;i<=gate_num;i++)
     matrix[cells[i]->rect.x][cells[i]->rect.y] += 1;
   for(i=1;i<=MHsize;i++)
     for(j=1;j<=MVsize;j++)
       if (matrix[i][j] > 1)
         (void) fprintf(stdout,"\n\nCELL OVERLAP AT %d %d\n\n",i,j);
   for(i=1;i<=MHsize;i++)
     for(j=1;j<=MVsize;j++)
       net_matrix[i][j].hor = net_matrix[i][j].ver = 0;
   for(i=1;i<=net_num;i++) {
     if (nets[i]->hor is TRUE) {
       minx = INFINITY;
       maxx = 0;
       if (nets[i]->cell_list) ycoor = nets[i]->cell_list->clink->rect.y;
       for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                  cptr=cptr->nextPtr) {
         minx = MIN(minx,cptr->clink->rect.x);
         maxx = MAX(maxx,cptr->clink->rect.x);
         if (ycoor isnt cptr->clink->rect.y)
           (void) fprintf(stdout,"NET %s NUMBER %d is not straight\n",
				      nets[i]->netName, nets[i]->num);
       }
       for(j=minx;j<=maxx;j++)
         net_matrix[j][ycoor].hor += 1;
     }
     else {
       miny = INFINITY;
       maxy = 0;
       if (nets[i]->cell_list) xcoor = nets[i]->cell_list->clink->rect.x;
       for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                  cptr=cptr->nextPtr) {
         miny = MIN(miny,cptr->clink->rect.y);
         maxy = MAX(maxy,cptr->clink->rect.y);
         if (xcoor isnt cptr->clink->rect.x)
           (void) fprintf(stdout,"NET %s NUMBER %d is not straight\n",
				      nets[i]->netName, nets[i]->num);
       }
       for(j=miny;j<=maxy;j++)
         net_matrix[xcoor][j].ver += 1;
     }
   }
   for(i=1;i<=MHsize;i++) {
     for(j=1;j<=MVsize;j++) {
       if (net_matrix[i][j].hor > 1){
         (void) fprintf(stdout,"HORIZONTAL NET OVERLAP AT %d %d\n",i,j);
	 errorOccured = TRUE;
       }
       if (net_matrix[i][j].ver > 1){
         (void) fprintf(stdout,"VERTICAL NET OVERLAP AT %d %d\n",i,j);
	 errorOccured = TRUE;
       }
     }
   }
   if( errorOccured ){
	(void) fprintf(stderr,"Serious errors occured, exiting\n");
	exit(-1);
  }
  return;

} /* end of route_annealed_array  */ 


sort_hor_nets()
{
/*
* sort nets according to increasing average y for horizontal nets.
*/

int i,p;
int minx,maxx;
NET net;
CELL_PTR cptr;

 
 hor_net_order = ALLOC(int,net_num + 5);
 for(i=1;i<=net_num;i++) {
   net = nets[i];
   minx = INFINITY;
   maxx = 0;
   for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
     minx = MIN(cptr->clink->rect.x,minx);
     maxx = MAX(cptr->clink->rect.x,maxx);
   }
   net->stagger = maxx - minx;     /* using stagger as length */
 }
 p = 0;
 for(i=1;i<=net_num;i++) {
   if (nets[i]->hor is TRUE) {
     hor_net_order[p] =  i;
     p++;
   }
 }
 hor_num = p;
 sort_hor_or_vert_nets(hor_net_order,hor_num,HOR);

return;

} /* end of sort_hor_nets */


sort_vert_nets()
{
/*
* sort vertical nets according to increasing stagger.
*/

int i,q;
int miny,maxy;
NET net;
CELL_PTR cptr;

 
 vert_net_order = ALLOC(int,net_num + 5);
 for(i=1;i<=net_num;i++) {
   net = nets[i];
   miny = INFINITY;
   maxy = 0;
   for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
     miny = MIN(cptr->clink->rect.y,miny);
     maxy = MAX(cptr->clink->rect.y,maxy);
   }
   net->stagger = maxy - miny;
 }
 q = 0;
 for(i=1;i<=net_num;i++) {
   if (nets[i]->hor is FALSE) {
     vert_net_order[q] = i;
     q++;
   }
 }
 ver_num = q;
 sort_hor_or_vert_nets(vert_net_order,ver_num,VER);

return;

} /* end of sort_vert_nets */



shrink_matrix()
{
/*
* shrink the matrix into mimimum possible dimensions.Place pads on closest
* possible rows on left and right.
*/
  int i,j,p;
  int ptr1,ptr2;

/*
* shrink matrix in vertical direction
*/
  p = 0;
  for(i=1;i<=num_rows;i++)
    if (Row[i] is 0)
      p++;
  ptr1=1;ptr2=1;
  while(ptr2 <= num_rows) {
    while(Row[ptr2] is 0 && ptr2 <= num_rows) 
      ptr2++;
    if (ptr2 > num_rows)
      continue;
    if (ptr1 is ptr2) {
      ptr1++;ptr2++;
      continue;
    }
    if (ptr2 > ptr1) {
      for(i=1;i<=cell_num;i++) {
        if (cells[i]->rect.y-OFFSET is ptr2)
          cells[i]->rect.y = ptr1 + OFFSET;
      }
      Row[ptr2] = 0;
      ptr1++;
    }
  }
  num_rows -= p;

  p = 0;
  for(i=1;i<=num_cols;i++)
    if (Col[i] is 0)
      p++;
/*
* shrink matrix in horizontal direction
*/
  ptr1=1;ptr2=1;
  while(ptr2 <= num_cols) {
    while(Col[ptr2] is 0 && ptr2 <= num_cols) 
      ptr2++;
    if (ptr2 > num_cols)
      continue;
    if (ptr1 is ptr2) {
      ptr1++;ptr2++;
      continue;
    }
    if (ptr2 > ptr1) {
      for(i=1;i<=cell_num;i++) {
        if (cells[i]->rect.x-OFFSET is ptr2)
          cells[i]->rect.x = ptr1 + OFFSET;
      }
      Col[ptr2] = 0;
      ptr1++;
    }
  }
  num_cols -= p;

  for(i=0;i<=MHsize;i++)
    for(j=0;j<=MVsize;j++)
      matrix[i][j] = 0;
  for(i=1;i<=gate_num;i++)
    matrix[cells[i]->rect.x][cells[i]->rect.y] += 1;
  for(i=gate_num+1;i<=cell_num;i++) {
    if (cells[i]->rect.x < OFFSET )
      cells[i]->rect.x = OFFSET;
    else if (cells[i]->rect.x > OFFSET + num_cols )
      cells[i]->rect.x = OFFSET + num_cols + 1;
    matrix[cells[i]->rect.x][cells[i]->rect.y] += 1;
  }
  for(i=1;i<=net_num;i++) {
    if (nets[i]->cell_list is NIL(struct cell_ptr)) continue;
    if (nets[i]->hor is TRUE)
      nets[i]->row = nets[i]->cell_list->clink->rect.y;
    else
      nets[i]->col = nets[i]->cell_list->clink->rect.x;
  }
 return;

} /* end of shrink_matrix */
  

sort_hor_or_vert_nets(v,n,type)
int v[];
int n,type;
{
  int gap,i,j;
  int temp,one,two,three;

  for(gap=n/2;gap > 0;gap /= 2) {
    for(i=gap;i < n ; i++) {
      for(j = i-gap;j >= 0 ;j -= gap) {
        one = two = three = FALSE;
        if ( (type is HOR || type is VER)  &&
             (nets[v[j]]->stagger < nets[v[j+gap]]->stagger))
          one = TRUE;
        if ( (type is COLV)  && ( (nets[v[j]]->col > nets[v[j+gap]]->col ) ||
               ( nets[v[j]]->col is nets[v[j+gap]]->col && nets[v[j]]->row > nets[v[j+gap]]->row) ) )
          two = TRUE;
        if ( (type is ROWH)  && ( (nets[v[j]]->row > nets[v[j+gap]]->row ) ||
               ( nets[v[j]]->row is nets[v[j+gap]]->row && nets[v[j]]->col > nets[v[j+gap]]->col) ) )
          three = TRUE;
        if (one is TRUE || two is TRUE || three is TRUE) {
          temp = v[j];
          v[j] = v[j + gap];
          v[j + gap] = temp;
        }
      }
    }
  }
   
 return;

} /* end of sort_hor_or_vert_nets */


straighten_horizontal_nets()
{
/*
*  all the horizontal nets' stagger is removed.After this vertical nets will
*  still have stagger.
*/
   int i;
   NET net;

   if (statcmos is TRUE || pla is TRUE) {
     row_type =  ALLOC (int,MAX(MHsize,MVsize) + 1);
     for(i=0;i< MVsize;i++)
       row_type[i] = EITHER;
     for(i=1;i<=gate_num;i++) {
       net = cells[i]->net_list->nextPtr->nlink;
       if (net->hor is FALSE)
         error("couldnt find horizontal net");
       if (row_type[cells[i]->rect.y] is EITHER)
         row_type[cells[i]->rect.y] = net->type;
       else if (row_type[cells[i]->rect.y] isnt net->type &&
                                             net->type isnt EITHER) 
         error("before straightening p and n cells on same row");
     }
   }
   for(i=0;i<hor_num;i++) {
     net = nets[hor_net_order[i]];
     if (net->cell_list isnt NIL(struct cell_ptr))
       if (rowpreferred is TRUE)
         strgtn_hor_net(net);
       else
         strgtn_hor(net);
   }
  return;

} /* end of straighten_horizontal_nets */


strgtn_hor_net(net)
NET net;
{

  int i,j,minx,maxx,*poss_row,*yes,diff;
  int n_row,row,row_exist,not_this_row,psize;
  int overlap_exist,num_cells,*occupied,end_loc_x;
  CELL_PTR cptr;
  NET chornet;


  minx = INFINITY;
  maxx = 0;
  row = net->row = net->cell_list->clink->rect.y;

  occupied =  ALLOC (int,MVsize + 10);
  poss_row =  ALLOC (int,MVsize + 10);
  yes =  ALLOC (int,MVsize + 10);

  for(i=0;i< MVsize;i++)
    yes[i] = poss_row[i] = FALSE;
  num_cells = 0;
  for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
    minx = MIN(minx,cptr->clink->rect.x);
    maxx = MAX(maxx,cptr->clink->rect.x);
    num_cells += 1;
    if (row isnt cptr->clink->rect.y)
      error("horizontal net isnt straight");
  }
  if (maxx - minx + 1 < num_cells) {
    overlap_exist = TRUE;
    end_loc_x = maxx + 1;
    maxx = minx + num_cells - 1;
  }
  else
    overlap_exist = FALSE;
  if (minx > maxx)
    error("error in strgn_hor_net");
/*
*  find out if net can be placed on the present row.
*/
  not_this_row = FALSE;
  for(i=minx;i<=maxx;i++) {
    if (fixed_loc[i][row] is TRUE ) {
      not_this_row = TRUE;
      break;
    }
  }
  if (simplerow is TRUE) {
    if (numnets_on_row[row] > 1 )
      not_this_row = TRUE;
  }
  if (statcmos is TRUE || pla is TRUE) {
    if (row_type[row] isnt EITHER && net->type isnt EITHER &&
         row_type[row] isnt net->type)
      not_this_row = TRUE;
  }
  if (pla is TRUE) {
    if (net->gate isnt 0 && nets[net->gate]->straightened is TRUE) {
       if (abs(row-nets[net->gate]->row) > 1 || row is nets[net->gate]->row)
         not_this_row = TRUE;
    }
  }
  if (not_this_row is FALSE) {
/*
*  can place net on this row,so do so.
*/
    if (simplerow is TRUE)
      numnets_on_row[row] += 1;

    for(i=minx;i<=maxx;i++) 
      fixed_loc[i][row] = TRUE;
    for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
      cptr->clink->yfix = TRUE;
    }
    if (overlap_exist is TRUE) {
      for(i=minx;i<=maxx;i++)
        occupied[i] = FALSE;
      for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
        if (occupied[cptr->clink->rect.x] is FALSE) 
           occupied[cptr->clink->rect.x] = TRUE;
        else {
           occupied[end_loc_x] = TRUE;
           cptr->clink->rect.x = end_loc_x;
           end_loc_x += 1;
        }
      }
    }
    net->straightened = TRUE;
  }
  else {
/*
*  have to find a row to place it on ,else add a row.If more than one
*  row has a vacant space choose row whose size is closest to the present row.
*  if worried about static CMOS structure need to place P net on a P row
*  and a N net on a N row. Simple folding also constrains where you
*  place the net.
*/
    for(i=1;i<=cell_num;i++)
      poss_row[cells[i]->rect.y] = TRUE;
    row_exist = FALSE;
    for(i=1;i<=MVsize;i++) {
      if (poss_row[i] is FALSE) continue;
      not_this_row = FALSE;
      for(j=minx;j<=maxx;j++) {
        if (fixed_loc[j][i] is TRUE) {
          not_this_row = TRUE;
          break;
        }
      }
      if (pla is TRUE) {
        if (net->gate isnt 0 && nets[net->gate]->straightened is TRUE) {
           if (abs(i-nets[net->gate]->row) > 1 || i is nets[net->gate]->row)
              not_this_row = TRUE;
        }
      }
      if (simplerow is TRUE) {
        if ( numnets_on_row[i] > 1 )
          not_this_row = TRUE;
      } 
      if (statcmos is TRUE || pla is TRUE) {
        if (row_type[i] isnt net->type && row_type[i] isnt EITHER
                                                 && net->type isnt EITHER)
          not_this_row = TRUE;
      }
      if (not_this_row is FALSE) {
        row_exist = TRUE;
        yes[i] = TRUE;
      }
    }
    if (row_exist is TRUE) {
/*
*  there exist one or more rows this net can be placed on.Find the best.
*/
      diff = INFINITY;
      for(i=1;i<=MVsize;i++) {
        if (yes[i] is FALSE) continue;
        if (varwidth is TRUE) {
          psize = 0;
          for(j=1;j<=net_num;j++) {
            if (nets[j]->hor is FALSE) continue;
            if (nets[j]->cell_list->clink->rect.y is i && nets[j] isnt net)
               psize = MAX(psize,nets[j]->size);
          }
          if (diff > abs(psize - net->size)) {
            n_row = i;
            diff = abs(psize-net->size);
          }
        }
        else {
          if (diff > abs(i-row)) {
            n_row = i;
            diff = abs(i -row);
          }
        }
      }
      for(i=minx;i<=maxx;i++) 
        fixed_loc[i][n_row] = TRUE;

      if ( simplerow is TRUE )
        numnets_on_row[n_row] += 1;

      for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
        cptr->clink->yfix = TRUE;
        cptr->clink->rect.y = n_row;
      }
      net->row = n_row;
      if (overlap_exist is TRUE) {
        for(i=minx;i<=maxx;i++)
          occupied[i] = FALSE;
        for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
          if (occupied[cptr->clink->rect.x] is FALSE) 
            occupied[cptr->clink->rect.x] = TRUE;
          else {
            occupied[end_loc_x] = TRUE;
            cptr->clink->rect.x = end_loc_x;
            end_loc_x += 1;
          }
        }
      }
      net->straightened = TRUE;
    }
    else {
/*
*  need to add a row and place net on it.
*/
      if (pla is TRUE && net->gate isnt 0) {
        if (! adj_vio(nets[net->gate]->row,nets[net->gate]->row+1,net) ) {
          n_row = add_row(nets[net->gate]->row,nets[net->gate]->row+1);
        }
        else if ( ! adj_vio(nets[net->gate]->row-1,nets[net->gate]->row,net) ) {
          n_row = add_row(nets[net->gate]->row-1,nets[net->gate]->row);
        }
        else {
          (void) fprintf(stderr,"need to sanitize PLA\n");
          n_row = add_row(nets[net->gate]->row-1,nets[net->gate]->row);
        }
      }
      else
        n_row = add_row(row,row+1);
      if (simplerow is TRUE)
        numnets_on_row[n_row] += 1;
      for(i=minx;i<=maxx;i++)
        fixed_loc[i][n_row] = TRUE;
      for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
        cptr->clink->yfix = TRUE;
        cptr->clink->rect.y = n_row;
      }
      net->row = n_row;
      if (overlap_exist is TRUE) {
        for(i=minx;i<=maxx;i++)
          occupied[i] = FALSE;
        for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
          if (occupied[cptr->clink->rect.x] is FALSE) 
            occupied[cptr->clink->rect.x] = TRUE;
          else {
            occupied[end_loc_x] = TRUE;
            cptr->clink->rect.x = end_loc_x;
            end_loc_x += 1;
          }
        }
      }
      net->straightened = TRUE;
    }
  }
/*
*  update row_type
*/
  if (statcmos is TRUE || pla is TRUE) {
    for(i=0;i< MVsize;i++)
      row_type[i] = EITHER;
    for(i=1;i<=gate_num;i++) {
      chornet = cells[i]->net_list->nextPtr->nlink;
      if (chornet->hor is FALSE)
        error("couldnt find horizontal net");
      if (row_type[cells[i]->rect.y] is EITHER)
        row_type[cells[i]->rect.y] = chornet->type;
      else if (row_type[cells[i]->rect.y] isnt chornet->type &&
                                          chornet->type isnt EITHER)
        error("while straightening p and n cells on same row");
    }
  }
 FREE(yes);FREE(poss_row);
 FREE(occupied);
 return;

} /* end of strgtn_hor_net */


add_col(one,two)
{
  int i,saved,column,j;
  int *save,temp;

  save =  ALLOC (int,M_SIZE + 1);
  if (two - OFFSET > num_cols ) {
    num_cols++;
  }
  else {
    for(i=1;i<=MHsize ;i++)
      for(j=1;j<=MVsize ;j++)
        matrix[i][j] = 0;
    for(i=1;i<=cell_num;i++) {
      if (cells[i]->rect.x > one)
        cells[i]->rect.x += 1;
       matrix[cells[i]->rect.x][cells[i]->rect.y] +=1;
    }
    for(i=1;i<=net_num;i++) {
      if (nets[i]->hor is FALSE && nets[i]->col > one)
        nets[i]->col += 1;
    } 
    num_cols++;
    for(i=1;i<=MVsize-1;i++)
      save[i] = 0;
    for(column=one;column<num_cols+OFFSET;column++) {
      for(i=1;i<=MVsize-1;i++) {
        saved = fixed_loc[column+1][i];
        fixed_loc[column+1][i] = save[i];
        save[i] = saved;
      }
    }
  }
  if (simplecol is TRUE) {
    temp = 0;
    for(column=two; column < num_cols+OFFSET;column++) {
      saved = numnets_on_col[column];
      numnets_on_col[column] = temp;
      temp = saved;
    }
  }
  FREE(save);
 return(two);

} /* end of add_col */


int 
add_row(one,two)
{
  int i,saved,row,j;
  int *save,temp;

  save =  ALLOC (int,M_SIZE + 1);
  if (two - OFFSET > num_rows) {
    num_rows++;
  }
  else {
    for(i=1;i<=MHsize ;i++)
      for(j=1;j<=MVsize;j++)
        matrix[i][j] = 0;
    for(i=1;i<=cell_num;i++) {
      if (cells[i]->rect.y > one)
        cells[i]->rect.y += 1;
       matrix[cells[i]->rect.x][cells[i]->rect.y] += 1;
    }
    for(i=1;i<=net_num;i++) {
      if (nets[i]->hor is TRUE && nets[i]->row > one)
        nets[i]->row += 1;
    } 
    num_rows++;
    for(i=1;i<=MHsize-2;i++)
      save[i] = 0;
    for(row=one;row<num_rows+OFFSET;row++) {
      for(i=1;i<=MHsize-2;i++) {
        saved = fixed_loc[i][row+1];
        fixed_loc[i][row+1] = save[i];
        save[i] = saved;
      }
    }
  }
  if (simplerow is TRUE) {
    temp = 0;
    for(row=two; row <= num_rows+OFFSET;row++) {
      saved = numnets_on_row[row];
      numnets_on_row[row] = temp;
      temp = saved;
    }
  }
  FREE(save);
 return(two);

} /* end of add_row */


#ifndef lint
print_cells(nettype)
int nettype;
{

  NET net;
  int i;
  CELL_PTR cptr;

   (void) fprintf(stdout,"num_rows = %d\n",num_rows);
   (void) fprintf(stdout,"num_cols = %d\n",num_cols);
   for(i=1;i<= net_num;i++) {
     net = nets[i];
     if (net->hor is TRUE && nettype isnt HOR) continue;
     if (net->hor is FALSE && nettype isnt VER) continue;
     (void) fprintf(stdout,"%s  ",net->netName);
     for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
       (void) fprintf(stdout,"( %d %d ) ",cptr->clink->rect.x,cptr->clink->rect.y);
     }
     (void) fprintf(stdout,"\n");
   }
  return;

} /* end of print_cells */
#endif

strgtn_ver(net)
NET net;
{

  int i,j,miny,maxy,*poss_col,*yes,diff;
  int n_col,col,col_exist,not_this_col,psize;
  int overlap_exist,num_cells,*occupied,end_loc_y;
  CELL_PTR cptr;


  miny = INFINITY;
  maxy = 0;
  col = net->cell_list->clink->rect.x;
  occupied =  ALLOC (int,MHsize + 10);
  poss_col =  ALLOC (int,MHsize + 10);
  yes = ALLOC (int,MHsize + 10);
  for(i=0;i< MHsize;i++)
    yes[i] = poss_col[i] = FALSE;
  num_cells = 0;
  for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
    miny = MIN(miny,cptr->clink->rect.y);
    maxy = MAX(maxy,cptr->clink->rect.y);
    num_cells += 1;
    if (col isnt cptr->clink->rect.x)
      error("vertical net isnt straight");
  }
  if (maxy - miny + 1 < num_cells) {
    overlap_exist = TRUE;
    end_loc_y = maxy + 1;
    maxy = miny + num_cells - 1;
  }
  else
    overlap_exist = FALSE;
  if (miny > maxy)
    error("error in strgn_ver");
/*
*  find out if net can be placed on the present column.
*/
  not_this_col = FALSE;
  for(i=miny;i<=maxy;i++) {
    if (fixed_loc[col][i] is TRUE ) {
      not_this_col = TRUE;
      break;
    }
  }
  if (not_this_col is FALSE) {
/*
*  can place net on this column,so do so.
*/
    for(i=miny;i<=maxy;i++) 
      fixed_loc[col][i] = TRUE;
    for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
      cptr->clink->xfix = TRUE;
    }
    if (overlap_exist is TRUE) {
      for(i=miny;i<=maxy;i++)
        occupied[i] = FALSE;
      for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
        if (occupied[cptr->clink->rect.y] is FALSE) 
           occupied[cptr->clink->rect.y] = TRUE;
        else {
           occupied[end_loc_y] = TRUE;
           cptr->clink->rect.y = end_loc_y;
           end_loc_y += 1;
        }
      }
    }
    net->straightened = TRUE;
  }
  else {
/*
*  have to find a column to place it on ,else add a column.If more than one
*  column has a vacant space choose column closest to the present column.
*/
    for(i=1;i<=cell_num;i++)
      poss_col[cells[i]->rect.x] = TRUE;
    col_exist = FALSE;
    for(i=1;i<=MHsize;i++) {
      if (poss_col[i] is FALSE) continue;
      not_this_col = FALSE;
      for(j=miny;j<=maxy;j++) {
        if (fixed_loc[i][j] is TRUE) {
          not_this_col = TRUE;
          break;
        }
      }
      if (not_this_col is FALSE) {
        col_exist = TRUE;
        yes[i] = TRUE;
      }
    }
    if (col_exist is TRUE) {
/*
*  there exist one or more columns this net can be placed on.Find the best.
*/
      diff = INFINITY;
      for(i=1;i<=MHsize;i++) {
        if (yes[i] is FALSE) continue;
        if (varwidth is TRUE) {
          psize = 0;
          for(j=1;j<=net_num;j++) {
            if (nets[j]->hor is TRUE) continue;
            if (nets[j]->cell_list->clink->rect.x is i && nets[j] isnt net)
               psize = MAX(psize,nets[j]->size);
          }
          if (diff > abs(psize - net->size)) {
            n_col = i;
            diff = abs(psize - net->size);
          }
        }
        else {
          if (diff > abs(i-col)) {
            n_col = i;
            diff = abs(i -col);
          }
        }
      }
      for(i=miny;i<=maxy;i++) 
        fixed_loc[n_col][i] = TRUE;
      for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
        cptr->clink->xfix = TRUE;
        cptr->clink->rect.x = n_col;
      }
      if (overlap_exist is TRUE) {
        for(i=miny;i<=maxy;i++)
          occupied[i] = FALSE;
        for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
          if (occupied[cptr->clink->rect.y] is FALSE) 
            occupied[cptr->clink->rect.y] = TRUE;
          else {
            occupied[end_loc_y] = TRUE;
            cptr->clink->rect.y = end_loc_y;
            end_loc_y += 1;
          }
        }
      }
      net->straightened = TRUE;
    }
    else {
/*
*  need to add a column and place net on it.
*/
      n_col = add_col(col,col+1);
      for(i=miny;i<=maxy;i++)
        fixed_loc[n_col][i] = TRUE;
      for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
        cptr->clink->xfix = TRUE;
        cptr->clink->rect.x = n_col;
      }
      if (overlap_exist is TRUE) {
        for(i=miny;i<=maxy;i++)
          occupied[i] = FALSE;
        for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
          if (occupied[cptr->clink->rect.y] is FALSE) 
            occupied[cptr->clink->rect.y] = TRUE;
          else {
            occupied[end_loc_y] = TRUE;
            cptr->clink->rect.y = end_loc_y;
            end_loc_y += 1;
          }
        }
      }
      net->straightened = TRUE;
    }
  }
 FREE(occupied);
 FREE(yes);FREE(poss_col);
 return;

} /* end of strgtn_ver */



adj_vio(one,two,net)
int one,two;
NET net;
{
/*
* check if making a row between one and two will violate
* adjacency constraints or not.
*/

 int i;

  for(i=1;i<=net_num;i++) {

    if (i is net->num || i is net->gate) continue;
    if (nets[i]->straightened is FALSE ) continue;

    if (nets[i]->hor is TRUE && nets[i]->type is PCHANNEL) {
      if (nets[i]->row is one && nets[i]->gate isnt 0) {
        if (nets[nets[i]->gate]->straightened is TRUE && 
                                       nets[nets[i]->gate]->row is two)
            return(TRUE);
      }
    }
  }

 return(FALSE);

} /* end of adj_vio */
