#include "copyright.h"
#include "genie.h"


/**************************************************************************/
/*    This program inputs a  multi-level personality matrix 	*/
/*         and finds the optimum placement of cells     	*/
/*      reducing the number of rows and columns using 		*/
/*                 simulated annealing.  	                */
/*           Copyright: SRINIVAS DEVADAS  1985   	        */
/**************************************************************************/

extern CELL findCell();

/*
*   structure for representation of folded array.
*/


#ifndef lint
print_lists()
{
 int i,j;
 CELL cl;
 NET nt;
 NET_PTR nptr;
 CELL_PTR cptr;


  for(i=1;i<=cell_num;i++) {
    cl = cells[i];
    if (cl->type is PADLEFT )
      (void) fprintf(stdout,"PADLEFT %2d",i);
    else if (cl->type is PADRIGHT)
      (void) fprintf(stdout,"PADRIGHT %2d",i);
   else if (cl->type is PADLR)
      (void) fprintf(stdout,"PADLR %2d",i);
    else
      (void) fprintf(stdout,"CELL %2d",i);
    j= 0;
    for(nptr=cl->net_list;nptr!=NIL(struct net_ptr);nptr=nptr->nextPtr) {
      j++ ;
      (void) fprintf(stdout," %s ",nptr->nlink->netName);
      if (j > 6) {
        (void) fprintf(stdout,"\n");
        j = 0;
      }
    }
    (void) fprintf(stdout,"\n");
  }
  for(i=1;i<=net_num;i++) {
    nt = nets[i];
    (void) fprintf(stdout,"NET %s",nt->netName);
    j = 0;
    for(cptr=nt->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr)  {
      j++ ;
      (void) fprintf(stdout," %3d ",cptr->clink->num);
      if (j > 11) {
        (void) fprintf(stdout,"\n");
        j = 0;
      }
    }
    (void) fprintf(stdout,"\n");
  }

 return;

} /* end of print_lists  */
#endif


add_pads()
/*
*  add the pads to the cell array.Gate_num is the number of gates,pad_num
*  the number of pads.Cell_num is the total number of cells.
*/
{

  int i;
  CELL pad,findCell();
  char padName[ID_LENGTH];
  
  gate_num = cell_num ; pad_left_num = 0;pad_right_num = 0;pad_num = 0;
  for(i=1;i<=net_num;i++) {
    if (nets[i]->left is TRUE ) {
/*  || (octread is TRUE && nets[i]->input is TRUE)) { }*/
       pad_num++ ;
       get_pad_name(padName,pad_num);
       pad = findCell(padName);
       pad_left_num++ ;
       pad->type = PADLEFT;
       add_net_cell(pad,nets[i]);
    }
    if (nets[i]->right is TRUE ) {
/* || (octread is TRUE && nets[i]->output is TRUE)) { }*/
       pad_num++ ;
       get_pad_name(padName,pad_num);
       pad = findCell(padName);
       pad_right_num++ ;
       pad->type = PADRIGHT;
       add_net_cell(pad,nets[i]);
    }
    if (nopads is FALSE) {
      if (nets[i]->hor is TRUE) {
        pad_num++ ;
        get_pad_name(padName,pad_num);
        pad = findCell(padName);
        pad->type = PADLR;
        add_net_cell(pad,nets[i]);
      }
    }
  }
 return;

} /* end of  add_pads */


place_pads()
{
/*
*  initially place pads according to constraints.Cells are already placed,
*  in grid locations.
*/
 int i;
 CELL cell;

  for(i=gate_num+1;i<=cell_num;i++) {
    cell = cells[i];
    if (cell->type >= PADLEFT ) {
      cell->rect.y = cell->net_list->nlink->num ;
    }
  }
     
 return;

} /* end of place_pads */


make_cells()
{

  int i,j,offset,num_gate;
  CELL cl,findCell();
  NET nt,findNet();
  char cellName[ID_LENGTH],netName[ID_LENGTH];

/*
* first subscript is column number.second is row number.
*/

  for(j=1;j<=num_rows;j++) {
    nt = nets[j];
    for(i=1;i<=num_cols;i++) {
      if (inp_matrix[i][j] is 's' || inp_matrix[i][j] is 'S') {
        get_cell_name(cellName,i,j);
        cl = findCell(cellName);
        cl->type = SERIES;
        cl->rect.x = i;
        cl->rect.y = j;
        cl->ch = inp_matrix[i][j];
        if (inp_matrix[i][j] is 'S')
          cl->special = TRUE;
        nt->output = FALSE;
        add_net_cell(cl,nt);
      }
      else if (inp_matrix[i][j] is 'p' || inp_matrix[i][j] is 'P') {
        get_cell_name(cellName,i,j);
        cl = findCell(cellName);
        cl->type = PARALLEL;
        cl->rect.x = i;
        cl->rect.y = j;
        cl->ch = inp_matrix[i][j];
        if (inp_matrix[i][j] is 'S')
          cl->special = TRUE;
        nt->output = FALSE;
        add_net_cell(cl,nt);
      }
      else if (inp_matrix[i][j] is 'o') {
        get_cell_name(cellName,i,j);
        cl = findCell(cellName);
        cl->type = LOAD;
        cl->rect.x = i;
        cl->rect.y = j;
        cl->ch = inp_matrix[i][j];
        nt->input = FALSE;
        add_net_cell(cl,nt);
      }
      else if (inp_matrix[i][j] is '~') {
        get_cell_name(cellName,i,j);
        cl = findCell(cellName);
        cl->type = CONNECT;
        cl->rect.x = i;
        cl->rect.y = j;
        cl->ch = inp_matrix[i][j];
        nt->input = FALSE;
        add_net_cell(cl,nt);
      }
      else if (inp_matrix[i][j] isnt '.') {
        get_cell_name(cellName,i,j);
        cl = findCell(cellName);
        cl->type = SERIES;
        cl->rect.x = i;
        cl->rect.y = j;
        cl->ch = inp_matrix[i][j];
        nt->output = FALSE;
        add_net_cell(cl,nt);
      }
    }
  }
  offset = 2*MIN(MAX(num_rows,num_cols),10);
  for(i=0;i<=offset;i++)
    tilda_column[i] = FALSE;
  num_gate = 1;
  for(i=1;i<=num_cols;i++) {
    get_net_name(netName,i);
    nt = findNet(netName);
    nt->input = nt->output = FALSE;
    nt->vert = TRUE;
    nt->col = i;
    nt->tilda = FALSE ;
    tilda_column[i+offset] = FALSE ;
    if (domino is TRUE) {
      nt->gate = num_gate;
      nt->buffer = pbuffer[1][i+offset];
      if (pbuffer[1][i+offset] is '.' || pbuffer[1][i+1+offset] is '.') {
/*
*  two level gate column. Don't fold so TINKER compatible.
*/
        nt->tilda = TRUE;
        tilda_column[i+offset] = TRUE;
      }
      if (pbuffer[1][i+1+offset] isnt '.')
        num_gate++;
    }
      
    for(j=1;j<=num_rows;j++) {
      if (inp_matrix[i][j] isnt '.') {
        get_cell_name(cellName,i,j);
        cl = findCell(cellName);
        add_net_cell(cl,nt);
      }
    }
  }
  if (statcmos is TRUE) {
    for(i=1;i<=hor_net_num;i++)
      if (nets[i]->output is TRUE)
        nets[i]->type = EITHER;
  }
  
 return;

} /* end of make_cells  */



typedef struct fold {
  int *net;
  int *point;

} *FOLD ;


print_array(outFile)
STRING outFile;
{
 s_clist *clist;
 
 FILE *Output;
 int i,j,p,minx,maxx,miny,maxy;
 CELL cell;
 FOLD rofold,cofold;
  

#ifdef dist
  Output = stdout;
#else
  if ((Output = fopen(outFile,"w")) is NULL)
    crash("couldn't open output file");
#endif

  for(i=1;i<=MHsize;i++) 
    for(j=1;j<=MVsize;j++) 
      inp_matrix[i][j] = '.';

  miny = minx = INFINITY;
  maxy = maxx = 0;
  for(i=1;i<=gate_num;i++) {
    cell = cells[i];
    inp_matrix[cell->rect.x][cell->rect.y] = cell->ch;
    minx = MIN(minx,cell->rect.x);
    maxx = MAX(maxx,cell->rect.x);
    miny = MIN(miny,cell->rect.y);
    maxy = MAX(maxy,cell->rect.y);
  }
/*
* the folded array compatible with TINKER format.
*/
  rofold = ALLOC (struct fold,M_SIZE + 1);
  cofold = ALLOC (struct fold,M_SIZE + 1);
  for(i=0;i< M_SIZE+1;i++) {
    rofold[i].net  = ALLOC (int,30 + 1);
    cofold[i].net  = ALLOC (int,30 + 1);
    rofold[i].point  = ALLOC (int,30 + 1);
    cofold[i].point  = ALLOC(int,30 + 1);
  }

  get_folds(rofold,cofold);
  (void) fprintf(Output,"new %d %d\n",maxy-miny+1,maxx-minx+1);
/*
* get terminals
*/

  (void) fprintf(Output,"\n");
  for(j=miny;j<=maxy;j++) {
    for(i=minx;i<=maxx;i++) {
      (void) fprintf(Output,"%c",inp_matrix[i][j]);
    }
    (void) fprintf(Output,"\n");
  }
  (void) fprintf(Output,"\n");

  for(i=miny;i<=maxy;i++) {
    (void) fprintf(Output,"( row %d ",i-miny);
    p = 1;
    while (rofold[i].net[p] isnt END) {
      if (p is 1) {
        if (is_output(nets[rofold[i].net[p]]->netName) is TRUE) 
          (void) fprintf(Output,"\"\" 0 ");
        else
          (void) fprintf(Output,"%s 0 ",nets[rofold[i].net[p]]->netName);
      }
      else {
        if (is_output(nets[rofold[i].net[p]]->netName) is TRUE)
          (void) fprintf(Output,"\"\" %d ",rofold[i].point[p] - minx);
        else
          (void) fprintf(Output,"%s %d ",nets[rofold[i].net[p]]->netName,
						rofold[i].point[p] - minx );
      }
      p++;
    }
    (void) fprintf(Output,")\n");
  }

  for(i=minx;i<=maxx;i++) {
    (void) fprintf(Output,"( column %d ",i - minx);
    p = 1;
    while (cofold[i].net[p] isnt END) {
      if (no_output is TRUE) {
        if (p is 1)
          (void) fprintf(Output,"%s 0 ", nets[cofold[i].net[p]]->netName);
        else
          (void) fprintf(Output,"%s %d ", nets[cofold[i].net[p]]->netName,
                                               cofold[i].point[p] - miny);
      }
      else {
        if (p is 1)
          (void) fprintf(Output,"0 ");
        else
          (void) fprintf(Output,"%d ", cofold[i].point[p] - miny);
      }
      p++;
    }
    (void) fprintf(Output,")\n");
  }

  if (mgread is TRUE) {
    for(i=1;i<=net_num;i++) {
      if (nets[i]->input is TRUE) {
        (void) fprintf(Output,"( input %s )\n",nets[i]->netName);
      }
      else if (nets[i]->output is TRUE) {
        (void) fprintf(Output,"( output %s )\n",nets[i]->netName);
      }
    }
  }
  if( pla == TRUE ){
    for( clist = CompList; clist != NIL( s_clist ); clist = clist->next ){
	(void) fprintf( Output, "( complement %s %s )\n", clist->pos, clist->neg );
    }
  }

  FREE(rofold);FREE(cofold);
 (void) fclose(Output);
 return;

} /* end of print_array */


ready_for_anneal()
{

 int i;
  
  OFFSET = MIN(MAX(num_rows,num_cols),10);
  MHsize = 2*OFFSET + num_cols;
  MVsize = 2*OFFSET + num_rows;
  horizontal_span = 2*num_cols;
  vertical_span = 2*num_rows;
  p_cols = num_cols;
  p_rows = num_rows;
  min_xcoor = OFFSET + 1;
  min_ycoor = OFFSET + 1 ;
  max_xcoor = OFFSET + num_cols;
  max_ycoor = OFFSET + num_rows;

  for(i=1;i<=gate_num;i++) {
    cells[i]->rect.x += OFFSET;
    cells[i]->rect.y += OFFSET;
  }
  for(i=gate_num+1;i<=cell_num;i++) {
    if (cells[i]->type is PADLEFT || cells[i]->type is PADLR) {
      cells[i]->rect.x = 2;
      cells[i]->rect.y +=  OFFSET;
    }
    else if (cells[i]->type is PADRIGHT) {
      cells[i]->rect.x = MHsize - 2;
      cells[i]->rect.y += OFFSET;
    }
  }
  for(i=1;i<=net_num;i++) {
    if (nets[i]->hor is TRUE)
      nets[i]->row += OFFSET;
    else
      nets[i]->col += OFFSET;
    nets[i]->layer = 1;
  }
 return;

} /* end of ready_for_anneal */


add_connects()
{
/*
*  if matrix is a PLA personality matrix,we should add the connecting nets
*  to see that the input and its complement stay together.
*/
    s_clist *clist;
  CELL cell1,cell2,findCell();
  NET findNet(),net;
  int i,num_connects,p_netnum;
  char tempName[ID_LENGTH],netName[ID_LENGTH],cellName[ID_LENGTH];


  p_netnum = net_num;
  num_connects = 0;
  i = 1;		/* XXX was 0, fix by RLS */
  while(i< p_netnum) {
    if ( nets[i]->type is PCHANNEL && nets[i]->hor is TRUE) {
      (void) sprintf(tempName,"%s*",nets[i]->netName);
      if (strcmp(tempName,nets[i+1]->netName) is FALSE) {
/*
* need to add a connecting vertical net and two connecting cells.
*/
        nets[i]->gate = i+1;
        nets[i+1]->gate = i;
        num_connects++ ;
        num_cols++;
        (void) sprintf(netName,"con_%d",num_connects);
        net = findNet(netName);
        net->col = num_cols;
        net->input = FALSE;
        net->output = FALSE;
        net->hor = FALSE;
        net->vert = TRUE;
        net->type = CONNECT;
        (void) sprintf(cellName,"cell_%d_%d",num_cols,i);
        cell1 = findCell(cellName);
        cell1->type = CONNECT ;
        (void) sprintf(cellName,"cell_%d_%d",num_cols,i+1);
        cell2 = findCell(cellName);
        cell2->type = CONNECT ;
        cell1->ch = cell2->ch = 'c';
        add_net_cell(cell1,nets[i]);
        add_net_cell(cell2,nets[i+1]);
        add_net_cell(cell1,net);
        add_net_cell(cell2,net);
        cell1->rect.x = num_cols ;
        cell2->rect.x = num_cols ;
        cell1->rect.y = i;
        cell2->rect.y = i + 1;
	/*
	 * added by Chuck Kring to add the complement statement to the 
	 * pla output
	 */
	clist = ALLOC(s_clist, 1);
	clist->next = CompList;
	CompList = clist;
	CompList->pos = nets[ i ]->netName;
	CompList->neg = nets[ i+1 ]->netName;

        i += 2;
      }
      else 
        i += 1;
    }
    else 
      i += 1;
  }
 return;

} /* end of add_connects */
  


dogleg_nets()
{
/*
* This routine doglegs nets i.e. splits nets with too many cells
* on them.
*/
 int i,total_cnt,cnt,average,ncnt;
 int newnet,makenew,threshold,old_net_num;
 NET nnet,net,findNet();
 char nnetName[ID_LENGTH];
 CELL_PTR cptr;

  total_cnt = 0;
  for(i=1;i<=net_num;i++) {
    if (nets[i]->hor is FALSE) continue;
    cnt = 0;
    for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr)
      cnt++;
    nets[i]->cnt = cnt;
    total_cnt += cnt;
  }
  average = total_cnt/net_num + 1;
  (void) fprintf(stderr,"Average %d what's threshold?:",average);
  (void) fscanf(stdin,"%d",&threshold);
  old_net_num = net_num;
  for(i=1;i<=old_net_num;i++) {
    net = nets[i];
    if (net->hor is FALSE) continue;
    if (net->cnt < threshold + 3) continue;
     ncnt = 0;newnet = 0;makenew = FALSE;
    for(cptr=net->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
      ncnt++;
      if (ncnt > threshold) {
        newnet++;
        (void) fprintf(stdout,"Splitting net %s for the %d time\n",net->netName,
                                                                 newnet);
        (void) sprintf(nnetName,"%s_%d",net->netName,newnet);
        nnet = findNet(nnetName);
        if (net->vert is TRUE) {
          nnet->col = ++num_cols;
          nnet->input = FALSE;
          nnet->output = FALSE;
          nnet->hor = FALSE;
          nnet->vert = TRUE;
        }
        else if (net->hor is TRUE) {
          num_rows++;
          nnet->row = num_rows;
          nnet->input = FALSE;
          nnet->output = FALSE;
          nnet->hor = TRUE;
          nnet->vert = FALSE;
        }
        ncnt = 0; makenew = TRUE;
      }
      if (makenew is TRUE) {
        add_net_cell(cptr->clink,nnet);
        if (net->hor is TRUE) 
          cptr->clink->rect.y = nnet->row;
        else if (net->vert is TRUE)
          cptr->clink->rect.x = nnet->col;
        delete_net_cell(cptr->clink,net);
      }
    }
  }
  for(i=1;i<=net_num;i++) {
    cnt = 0;
    for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr)
      cnt++;
    nets[i]->cnt = cnt;
  }
 return;

} /* end of dogleg_nets */
 


get_folds(rowf,colf)
FOLD rowf,colf;
{
  
 int *cell_array;
 int i,j,p,lastx,lasty;
 NET lastnet,hornet,vertnet;
 CELL cell;


  for(i=1;i<=M_SIZE-1;i++) {
    for(j=1;j<=29;j++) {
      rowf[i].net[j] = rowf[i].point[j] = END ;
      colf[i].net[j] = colf[i].point[j] = END ;
    }
    rowf[i].point[1] = 1; colf[i].point[1] = 1;
  }
  cell_array = ALLOC (int,cell_num + 1);
  for(i=0;i<gate_num;i++) 
    cell_array[i] = i+1;
/*
* sort with increasing y,increasing x.
*/
  sort_cells(cell_array,gate_num,1);
  lastnet = NIL(struct net);
  lasty = 0;p = 0;
  for(i=0;i<gate_num;i++) {
    cell = cells[cell_array[i]];
    if (cell->net_list->nlink->hor is TRUE)
      hornet = cell->net_list->nlink;
    else
      hornet = cell->net_list->nextPtr->nlink;
    if (cell->rect.y isnt lasty)
      p = 0;
    lasty = cell->rect.y;
    if (lastnet is hornet) continue;
    p++;
    rowf[cell->rect.y].net[p] = hornet->num;
    rowf[cell->rect.y].point[p] = cell->rect.x;
    lastnet = hornet;
  }
/*
* sort with increasing x,increasing y.
*/
  sort_cells(cell_array,gate_num,2);
  lastnet = NIL(struct net);
  lastx = 0;p = 0;
  for(i=0;i<gate_num;i++) {
    cell = cells[cell_array[i]];
    if (cell->net_list->nlink->hor is FALSE)
      vertnet = cell->net_list->nlink;
    else
      vertnet = cell->net_list->nextPtr->nlink;
    if (cell->rect.x isnt lastx)
      p = 0;
    lastx = cell->rect.x;
    if (lastnet is vertnet) continue;
    p++;
    colf[cell->rect.x].net[p] = vertnet->num;
    colf[cell->rect.x].point[p] = cell->rect.y;
    lastnet = vertnet;
  }
  FREE(cell_array);
 return;

} /* end of get_folds */



sort_cells(v,n,type)
int v[];
int n,type;
{
  int gap,i,j;
  int temp,one,two;

  for(gap=n/2;gap > 0;gap /= 2) {
    for(i=gap;i < n ; i++) {
      for(j = i-gap;j >= 0 ;j -= gap) {
         if (type is 2 && (cells[v[j]]->rect.x > cells[v[j+gap]]->rect.x 
             || (cells[v[j]]->rect.x is cells[v[j+gap]]->rect.x &&
                 cells[v[j]]->rect.y > cells[v[j+gap]]->rect.y)))
            one = TRUE;
         else
            one = FALSE;
         if (type is 1 && (cells[v[j]]->rect.y > cells[v[j+gap]]->rect.y 
             || (cells[v[j]]->rect.y is cells[v[j+gap]]->rect.y &&
                 cells[v[j]]->rect.x > cells[v[j+gap]]->rect.x))) 
           two = TRUE;
         else
           two = FALSE;
         if (one is TRUE || two is TRUE)
          {
            temp = v[j];
            v[j] = v[j + gap];
            v[j + gap] = temp;
          }
      }
    }
  }
   
 return;

} /* end of sort_cells */


#ifndef lint
construct_acceptable_order()
{
/*
* construct an acceptable order satisfying the initial constraints.
*/

 int i,temp,rownum;
 CELL_PTR cptr;

  rownum = 0;
  for(i=1;i<=net_num;i++) {
    if (nets[i]->hor is TRUE) {
      if (nets[i]->left is TRUE && nets[i]->ordernum isnt 0) {
        rownum++;
        nets[i]->row = nets[i]->ordernum;
      }
    }
  }

  temp = rownum;
  for(i=1;i<=net_num;i++) {
    if (nets[i]->hor is TRUE) {
      if (nets[i]->right is TRUE && nets[i]->ordernum isnt 0) {
        rownum++;
        nets[i]->row = temp + nets[i]->ordernum;
      }
    }
  }

  for(i=1;i<=net_num;i++) {
    if (nets[i]->hor is TRUE) {
      if (nets[i]->left is FALSE || nets[i]->right is FALSE ||
                                                 nets[i]->ordernum is 0) {
        rownum++;
        nets[i]->row = rownum;
      }
    }
  }

  for(i=1;i<=net_num;i++) {
    if (nets[i]->hor is TRUE) {
      for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                      cptr=cptr->nextPtr)
        cptr->clink->rect.y = nets[i]->row;
    }
  }

 return;

} /* end of construct_acceptable_order */
#endif



pla_to_genie(inFile)
char *inFile;
{ 

 int num_inp,num_out,num_prod = -1;
 int i,j,nr,nc,ilb,ob;
 char line[MAXLINE];
 int blank, num_tot_inp, num_tot_out;
 char inp_vector[400][300],out_vector[400][300];
 STRING inputs[300], outputs[300];
 char matrix[400][300],netname[ID_LENGTH];
 int present_inum, present_onum;
 FILE *input;

  if ( (input = fopen(inFile,"r")) is NULL) {
    crash("couldn't open pla input file");
  }
  NextLine = 0; nr = nc = 0;
  ilb = ob = FALSE; present_inum = 0; present_onum = 0;
  while(fgets(line,MAXLINE,input) isnt NULL) {
    NextLine++;
    parse_line(line);
    if (targv[0] is NULL || targv[0][0] is '#') continue;
    if (targv[0][0] is '.') {
      if (strcmp(targv[0],".i") is FALSE) 
        num_inp = atoi(targv[1]);
      else if (strcmp(targv[0],".o") is FALSE) 
        num_out = atoi(targv[1]);
      else if (strcmp(targv[0],".p") is FALSE)
        num_prod = atoi(targv[1]);
      else if (strcmp(targv[0],".ilb") is FALSE) {
        for(i=1;i<targc;i++) {
          present_inum++;
          inputs[present_inum] = ALLOC(char,ID_LENGTH+1);
          (void) strcpy(inputs[present_inum],targv[i]);
        }
        ilb = TRUE;
      }
      else if (strcmp(targv[0],".ob") is FALSE) {
        for(i=1;i<targc;i++) {
          present_onum++;
          outputs[present_onum] = ALLOC(char,ID_LENGTH+1);
          (void) strcpy(outputs[present_onum],targv[i]);
        }
        ob = TRUE;
      }
    }
    else {
      nc = 0; nr++;
      for(i=0;i< targc;i++) {
        j = 0;
        while(targv[i][j] isnt '\0') {
          nc++;
          if (nc <= num_inp)
            inp_vector[nr][nc] = targv[i][j];
          else if (nc > num_inp+num_out)
            crash("more inputs/outputs than specified");
          else if (nc > num_inp)
            out_vector[nr][nc-num_inp] = targv[i][j];
          j++;
        }
      }
      if (nc < num_inp + num_out) error("not enough inputs/outputs");
    }
  }
  if (num_prod == -1)
    num_prod = nr; /* no .p was given */
  if (nr isnt num_prod) crash("not enough product terms");
  for(i=1;i<=num_prod;i++)
    for(j=1;j<=2*num_inp+num_out;j++)
      matrix[i][j] = '.' ;
  for(j=1;j<=num_inp;j++) {
    for(i=1;i<=num_prod;i++) {
      if (inp_vector[i][j] is '1') 
        matrix[i][2*j-1] = 's';
      else if (inp_vector[i][j] is '0')
        matrix[i][2*j] = 's';
    }
  }
  for(i=1;i<=num_prod;i++) {
    for(j=1;j<=num_out;j++) {
      if (out_vector[i][j] is '1') 
        matrix[i][2*num_inp+j] = 'p';
    }
  }
  (void) fprintf(stdout,"# translated from .pla format\n");
  num_tot_inp = 0;
  for(j=1;j<=2*num_inp;j++) {
/*
* dont drop blank pla input rows.
*/
    blank = TRUE;
    blank = FALSE;
    for(i=1;i<=num_prod;i++) {
      if (matrix[i][j] isnt '.') {
        blank = FALSE;
        break;
      }
    }
    if (blank is FALSE)
       num_tot_inp++;
  }
  num_tot_out = 0;
  for(j=1;j<=num_out;j++) {
    blank = TRUE;
    for(i=1;i<=num_prod;i++) {
      if (matrix[i][2*num_inp+j] isnt '.') {
        blank = FALSE;
        break;
      }
    }
    if (blank is FALSE)
       num_tot_out++;
  }
  (void) fprintf(stdout,"new %d %d %d\n\n",
                         num_tot_inp+num_tot_out,num_prod,num_tot_inp);
  for(j=1;j<=2*num_inp+num_out;j++) {
    if (j<=2*num_inp) {

/*
* dont drop blank input rows
*/
      blank = TRUE;
      blank = FALSE;
      for(i=1;i<=num_prod;i++) {
        if (matrix[i][j] isnt '.') {
          blank = FALSE;
          break;
        }
      }
      if (blank is TRUE) continue;

      if (ilb is FALSE) {
        if (j % 2 is 1) 
          (void) sprintf(netname,"inp_%d",(j+1)/2);
        else
          (void) sprintf(netname,"inp_%d*",j/2);
      }
      else {
        if (j % 2 is 1) 
          (void) sprintf(netname,"%s",inputs[(j+1)/2]);
        else
          (void) sprintf(netname,"%s*",inputs[j/2]);
      }
    }
    else {
      blank = TRUE;
      for(i=1;i<=num_prod;i++) {
        if (matrix[i][j] isnt '.') {
          blank = FALSE;
          break;
        }
      }
      if (blank is TRUE) {
        (void) fprintf(stderr,"warning: dropping empty output %d\n",j-2*num_inp);
        continue;
      }
      if (ob is FALSE) 
        (void) sprintf(netname,"out_%d",j-2*num_inp);
      else
        (void) sprintf(netname,"%s",outputs[j-2*num_inp]);
    }
    (void) fprintf(stdout," %10s  ",netname);
    for(i=1;i<=num_prod;i++) {
      (void) fprintf(stdout,"%c",matrix[i][j]);
    }
    (void) fprintf(stdout,"\n");
  }
  if (ilb is TRUE)
    if (present_inum isnt num_inp)
      error("not all inputs named");
  if (ob is TRUE)
    if (present_onum isnt num_out)
      error("not all inputs named");
 return;

} /* end of pla_to_genie */


#ifndef lint
simple_folding_pads()
{
/*
* place pads arbitrarily and left and right on the horizontal nets
* for simple folding.
*/
 int i,odd;
 CELL pad;
 char padName[ID_LENGTH];

  odd = TRUE;
  for(i=1;i<=net_num;i++) {
    if (nets[i]->hor is TRUE) {
      if (odd is TRUE) {
        pad_num++;
        get_pad_name(padName,pad_num);
        pad = findCell(padName);
        pad_left_num++ ;
        pad->type = PADLEFT;
        add_net_cell(pad,nets[i]);
        odd = FALSE;
      }
      else {
        pad_num++;
        get_pad_name(padName,pad_num);
        pad = findCell(padName);
        pad_right_num++ ;
        pad->type = PADRIGHT;
        add_net_cell(pad,nets[i]);
        odd = TRUE;
      }
    }
  }

 return;

} /* end of simple_folding_pads */
#endif
