#include "copyright.h"
#include "genie.h"


/**************************************************************************/
/*    This program inputs a  multi-level personality matrix 	*/
/*         and finds the optimum placement of cells     	*/
/*      reducing the number of rows and columns using 		*/
/*                 simulated annealing.  	                */
/*           Copyright: SRINIVAS DEVADAS  1985   	        */
/**************************************************************************/



int32
find_cost(first,type)
int first,type;
{

 int32 cost;
 int i,j,k,l,minx,miny,maxx,maxy;
 int col_penalty,row_penalty,t_over,n_cells;
 int rohe,cowi,rh[100],cw[100];   /* for varwidth */
 CELL cell;
 CELL_PTR cptr;
 NET_PTR nptr;
 NET hornet,vertnet,net;
 int pre_over,fin_over,delta_cols;
 int minx1,minx2,maxx1,maxx2;
 int miny1,miny2,maxy1,maxy2;
 

   cost = 0;
/*
*  compute the cost due to the net length first
*/
   if (first is TRUE) {
     shift_cell1 = shift_cell2 = NIL(struct cell);
     shift_net1 = shift_net2 = NIL(struct net);
     for(i=1;i<=MHsize;i++) {
       for(j=1;j<=MVsize;j++) {
         matrix[i][j] = net_matrix[i][j].hor = net_matrix[i][j].ver  = 0;
       }
     }
   }

   if (type is INTHORNET || type is DISPLAYER || first is TRUE) {
     for(i=1;i<=net_num;i++) {
       if (nets[i]->cell_list is NIL(struct cell_ptr)) continue;
       if (nets[i]->hor is FALSE) {
         miny = INFINITY;
         maxy = 0;
         for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                    cptr=cptr->nextPtr) {
           if (cptr->clink->net_list->nlink->hor is TRUE)
             hornet = cptr->clink->net_list->nlink;
           else
             hornet = cptr->clink->net_list->nextPtr->nlink;
           if (hornet is shift_net1 && shift_net2 is NIL(struct net)) {
             miny = MIN(miny,new_row);
             maxy = MAX(maxy,new_row);
           }
           else if (hornet is shift_net1 && shift_net2 isnt NIL(struct net)) {
             miny = MIN(miny,shift_net2->row);
             maxy = MAX(maxy,shift_net2->row);
           }
           else if (hornet is shift_net2 && shift_net1 isnt NIL(struct net)) {
             miny = MIN(miny,shift_net1->row);
             maxy = MAX(maxy,shift_net1->row);
           }
           else {
             miny = MIN(miny,cptr->clink->rect.y);
             maxy = MAX(maxy,cptr->clink->rect.y);
           }
         }
         if (maxy < miny && nets[i]->cell_list isnt NIL(struct cell_ptr))
           crash("error in interchanging nets");
         miny = MAX(miny,OFFSET);
         maxy = MIN(maxy,num_rows+1+OFFSET);
         cost += (maxy - miny) * NET_LENGTH_PARAM;
       }
       else {
         minx = INFINITY;
         maxx = 0;
         for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                    cptr=cptr->nextPtr) {
           minx = MIN(minx,cptr->clink->rect.x);
           maxx = MAX(maxx,cptr->clink->rect.x);
         }
         if (maxx < minx && nets[i]->cell_list isnt NIL(struct cell_ptr))
          crash("maxx less than minx");
         cost += (maxx - minx) * NET_LENGTH_PARAM ;
         if (first is TRUE) {
           for(j=minx;j<=maxx;j++)
             net_matrix[j][nets[i]->row].hor += 1;
         }
       }
     }
   }
   else if (type is INTVERTNET || first is TRUE) {
     for(i=1;i<=net_num;i++) {
       if (nets[i]->cell_list is NIL(struct cell_ptr)) continue;
       if (nets[i]->hor is TRUE) {
         minx = INFINITY;
         maxx = 0;
         for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                    cptr=cptr->nextPtr) {
           vertnet = NIL(struct net);
           if (cptr->clink->net_list->nlink->hor is FALSE)
             vertnet = cptr->clink->net_list->nlink;
           else if (cptr->clink->type <= PADLEFT) 
             vertnet = cptr->clink->net_list->nextPtr->nlink;
           if (vertnet is shift_net1 && shift_net2 is NIL(struct net)) {
             minx = MIN(minx,new_col);
             maxx = MAX(maxx,new_col);
           }
           else if (vertnet is shift_net1 && shift_net2 isnt NIL(struct net)) {
             minx = MIN(minx,shift_net2->col);
             maxx = MAX(maxx,shift_net2->col);
           }
           else if (vertnet is shift_net2 && shift_net1 isnt NIL(struct net)) {
             minx = MIN(minx,shift_net1->col);
             maxx = MAX(maxx,shift_net1->col);
           }
           else {
             minx = MIN(minx,cptr->clink->rect.x);
             maxx = MAX(maxx,cptr->clink->rect.x);
           }
         }
         if (maxx < minx && nets[i]->cell_list isnt NIL(struct cell_ptr))
           crash("error in interchanging nets");
         minx = MAX(minx,OFFSET);
         maxx = MIN(maxx,num_cols+1+OFFSET);
         cost += (maxx - minx) * NET_LENGTH_PARAM;
       }
       else {
         miny = INFINITY;
         maxy = 0;
         for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                    cptr=cptr->nextPtr) {
           miny = MIN(miny,cptr->clink->rect.y);
           maxy = MAX(maxy,cptr->clink->rect.y);
         }
         if (maxy < miny && nets[i]->cell_list isnt NIL(struct cell_ptr))
          crash("maxy less than miny in find_cost");
         if (nets[i]->type is CONNECT && pla is TRUE)
           cost += (maxy - miny)*3 * NET_LENGTH_PARAM;
         else
           cost += (maxy - miny) * NET_LENGTH_PARAM ;
         if (first is TRUE) {
           for(j=miny;j<=maxy;j++)
             net_matrix[nets[i]->col][j].ver += 1;
         }
       }
     }
   }
   else if (type is INTPAD && first isnt TRUE) {
     hornet = shift_cell1->net_list->nlink;
     for(i=1;i<=net_num;i++) {
       if (nets[i]->cell_list is NIL(struct cell_ptr)) continue;
       if (nets[i]->hor is TRUE) {
         minx = INFINITY;
         maxx = 0;
         if (nets[i] isnt hornet) {
           for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                     cptr=cptr->nextPtr) {
             minx = MIN(minx,cptr->clink->rect.x);
             maxx = MAX(maxx,cptr->clink->rect.x);
           }
         }
         else {
           for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                     cptr=cptr->nextPtr) {
             if (cptr->clink isnt shift_cell1) {
               minx = MIN(minx,cptr->clink->rect.x);
               maxx = MAX(maxx,cptr->clink->rect.x);
             }
             else {
               minx = MIN(minx,newloc_x);
               maxx = MAX(maxx,newloc_x);
             }
           }
         }
         if (maxx < minx && nets[i]->cell_list isnt NIL(struct cell_ptr))
           crash("maxx less than minx");
         maxx = MIN(maxx,num_cols+1);
         minx = MAX(minx,OFFSET);
         cost += (maxx - minx) * NET_LENGTH_PARAM;
       }
       else {
         miny = INFINITY;
         maxy = 0;
         for(cptr=nets[i]->cell_list;cptr!=NIL(struct cell_ptr);
                                                     cptr=cptr->nextPtr) {
           miny = MIN(miny,cptr->clink->rect.y);
           maxy = MAX(maxy,cptr->clink->rect.y);
         }
         if (maxy < miny && nets[i]->cell_list isnt NIL(struct cell_ptr))
           crash("maxy less than miny");
         maxy = MIN(maxy,num_rows+1);
         miny = MAX(miny,OFFSET);
         cost += (maxy - miny) * NET_LENGTH_PARAM;
       }
     }
   }
/*
*  Initial computation of net overlap
*/
   if (first is TRUE) {
     net_overlap = 0;
     for(i=1;i<=MHsize;i++) {
       for(j=1;j<=MVsize;j++) {
         if (net_matrix[i][j].hor  > 1)
           net_overlap += net_matrix[i][j].hor  - 1;
         if (net_matrix[i][j].ver  > 1)
           net_overlap += net_matrix[i][j].ver  - 1;
       }
     }
   }
/*
*  incremental calculation of net overlap for next states
*/
    else {
      if (type is INTHORNET) {
        new_net_overlap = net_overlap;
        if (shift_net2 is NIL(struct net)) {
          if (new_row isnt shift_net1->row) {
            find_net_limits(shift_net1,&minx1,&maxx1,&miny1,&maxy1,1);
            for(k=minx1;k<=maxx1;k++) {
              if (net_matrix[k][shift_net1->row].hor > 1)
                new_net_overlap--;
            }
            for(k=minx1;k<=maxx1;k++) {
              if (net_matrix[k][new_row].hor > 0)
                new_net_overlap++;
            }
          }
        }
        else {
          find_net_limits(shift_net1,&minx1,&maxx1,&miny1,&maxy1,1);
          find_net_limits(shift_net2,&minx2,&maxx2,&miny2,&maxy2,1);
          for(k=minx1;k<=maxx1;k++) {
            if (net_matrix[k][shift_net1->row].hor > 1)
              new_net_overlap--;
          }
          for(k=minx2;k<=maxx2;k++) {
            if (net_matrix[k][shift_net2->row].hor > 1)
              new_net_overlap--;
          }
          for(k=minx1;k<=maxx1;k++) {
            if (net_matrix[k][shift_net2->row].hor > 1 || ((k < minx2 ||
                k > maxx2) && net_matrix[k][shift_net2->row].hor > 0) )
              new_net_overlap++;
          }
          for(k=minx2;k<=maxx2;k++) {
            if (net_matrix[k][shift_net1->row].hor > 1 || ((k < minx1 ||
               k > maxx1) && net_matrix[k][shift_net1->row].hor > 0) )
              new_net_overlap++;
          }
        }
      }
      if (type is INTVERTNET) {
        new_net_overlap = net_overlap;
        if (shift_net2 is NIL(struct net)) {
          if (new_col isnt shift_net1->col) {
            find_net_limits(shift_net1,&minx1,&maxx1,&miny1,&maxy1,1);
            for(k=miny1;k<=maxy1;k++) {
              if (net_matrix[shift_net1->col][k].ver > 1)
                new_net_overlap--;
            }
            for(k=miny1;k<=maxy1;k++) {
              if (net_matrix[new_col][k].ver > 0)
                new_net_overlap++;
            }
          }
        }
        else {
          find_net_limits(shift_net1,&minx1,&maxx1,&miny1,&maxy1,1);
          find_net_limits(shift_net2,&minx2,&maxx2,&miny2,&maxy2,1);
          for(k=miny1;k<=maxy1;k++) {
            if (net_matrix[shift_net1->col][k].ver > 1)
              new_net_overlap--;
          }
          for(k=miny2;k<=maxy2;k++) {
            if (net_matrix[shift_net2->col][k].ver > 1)
              new_net_overlap--;
          }
          for(k=miny1;k<=maxy1;k++) {
            if (net_matrix[shift_net2->col][k].ver > 1 || ((k < miny2 ||
                k > maxy2) && net_matrix[shift_net2->col][k].ver > 0) )
              new_net_overlap++;
          }
          for(k=miny2;k<=maxy2;k++) {
            if (net_matrix[shift_net1->col][k].ver > 1 || ((k < miny1 ||
               k > maxy1) && net_matrix[shift_net1->col][k].ver > 0) )
              new_net_overlap++;
          }
        }
      }
      else if (type is INTPAD) {
        hornet = shift_cell1->net_list->nlink;
        find_net_limits(hornet,&minx1,&maxx1,&miny1,&maxy1,1);
        find_net_limits(hornet,&minx2,&maxx2,&miny2,&maxy2,2);
        for(k=minx1;k<=maxx1;k++) {
          if (net_matrix[k][hornet->row].hor > 1)
            new_net_overlap--;
        }
        for(k=minx2;k<=maxx2;k++) {
          if ( (net_matrix[k][hornet->row].hor > 0 && (k < minx1 || k > maxx1))
              || (net_matrix[k][hornet->row].hor > 1))
            new_net_overlap++;
        }
      }
    }
/*
*  add the net overlap to the total cost
*/
    if (first is TRUE)
      cost += MAX(net_overlap,0)*NET_OVERLAP_PARAM;
    else
      cost += MAX(new_net_overlap,0)*NET_OVERLAP_PARAM;
      
/*
*  compute the penalty function ,all the cell overlaps
*/
   t_over = overlap_penalty;
   if (first is TRUE ) {
     overlap_penalty = 0;
     for(i=1;i<=cell_num;i++) {
       cell = cells[i];
       matrix[cell->rect.x][cell->rect.y] += 1;
     }
     for(k=1;k<= MHsize;k++) {
       for(l=1;l<= MVsize;l++) {
         if (matrix[k][l] > 1)
            overlap_penalty += matrix[k][l] - 1;
       }
     }
   }
   else {
     if (type is INTHORNET) {
       if (shift_net2 is NIL(struct net)) {
         find_net_limits(shift_net1,&minx,&maxx,&miny,&maxy,1);
         pre_over = 0;
         for(k=minx;k<=maxx;k++) {
           if (matrix[k][new_row] > 1)
             pre_over += matrix[k][new_row] - 1;	
         }
         for(k=minx;k<=maxx;k++) {
           if (matrix[k][shift_net1->row] > 1)
             pre_over += matrix[k][shift_net1->row] - 1;	
         }
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
             matrix[cptr->clink->rect.x][new_row] += 1;
             matrix[cptr->clink->rect.x][shift_net1->row] -= 1;
         }
         fin_over = 0;
         for(k=minx;k<=maxx;k++) {
           if (matrix[k][new_row] > 1)
             fin_over += matrix[k][new_row] - 1;	
         }
         for(k=minx;k<=maxx;k++) {
           if (matrix[k][shift_net1->row] > 1)
             fin_over += matrix[k][shift_net1->row] - 1;	
         }
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
             matrix[cptr->clink->rect.x][new_row] -= 1;
             matrix[cptr->clink->rect.x][shift_net1->row] += 1;
         }
         overlap_penalty += fin_over - pre_over;
       }
       else {
         find_net_limits(shift_net1,&minx1,&maxx1,&miny1,&maxy1,1);
         find_net_limits(shift_net2,&minx2,&maxx2,&miny2,&maxy2,1);
         minx = MIN(minx1,minx2);
         maxx = MAX(maxx1,maxx2);
         pre_over = 0;
         for(k=minx;k<=maxx;k++) {
           if (matrix[k][shift_net1->row] > 1)
             pre_over += matrix[k][shift_net1->row] - 1;	
         }
         for(k=minx;k<=maxx;k++) {
           if (matrix[k][shift_net2->row] > 1)
             pre_over += matrix[k][shift_net2->row] - 1;	
         }
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
           matrix[cptr->clink->rect.x][shift_net1->row] -= 1;
           matrix[cptr->clink->rect.x][shift_net2->row] += 1;
         }
         for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
           matrix[cptr->clink->rect.x][shift_net2->row] -= 1;
           matrix[cptr->clink->rect.x][shift_net1->row] += 1;
         }
         fin_over = 0;
         for(k=minx;k<=maxx;k++) {
           if (matrix[k][shift_net1->row] > 1)
             fin_over += matrix[k][shift_net1->row] - 1;	
         }
         for(k=minx;k<=maxx;k++) {
           if (matrix[k][shift_net2->row] > 1)
             fin_over += matrix[k][shift_net2->row] - 1;	
         }
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
           matrix[cptr->clink->rect.x][shift_net1->row] += 1;
           matrix[cptr->clink->rect.x][shift_net2->row] -= 1;
         }
         for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
           matrix[cptr->clink->rect.x][shift_net2->row] += 1;
           matrix[cptr->clink->rect.x][shift_net1->row] -= 1;
         }
         overlap_penalty += fin_over - pre_over;
       }
     }
     if (type is INTVERTNET) {
       if (shift_net2 is NIL(struct net)) {
         find_net_limits(shift_net1,&minx,&maxx,&miny,&maxy,1);
         pre_over = 0;
         for(k=miny;k<=maxy;k++) {
           if (matrix[new_col][k] > 1)
             pre_over += matrix[new_col][k] - 1;	
         }
         for(k=miny;k<=maxy;k++) {
           if (matrix[shift_net1->col][k] > 1)
             pre_over += matrix[shift_net1->col][k] - 1;	
         }
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
             matrix[new_col][cptr->clink->rect.y] += 1;
             matrix[shift_net1->col][cptr->clink->rect.y] -= 1;
         }
         fin_over = 0;
         for(k=miny;k<=maxy;k++) {
           if (matrix[new_col][k] > 1)
             fin_over += matrix[new_col][k] - 1;	
         }
         for(k=miny;k<=maxy;k++) {
           if (matrix[shift_net1->col][k] > 1)
             fin_over += matrix[shift_net1->col][k] - 1;	
         }
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
             matrix[new_col][cptr->clink->rect.y] -= 1;
             matrix[shift_net1->col][cptr->clink->rect.y] += 1;
         }
         overlap_penalty += fin_over - pre_over;
       }
       else {
         find_net_limits(shift_net1,&minx1,&maxx1,&miny1,&maxy1,1);
         find_net_limits(shift_net2,&minx2,&maxx2,&miny2,&maxy2,1);
         miny = MIN(miny1,miny2);
         maxy = MAX(maxy1,maxy2);
         pre_over = 0;
         for(k=miny;k<=maxy;k++) {
           if (matrix[shift_net1->col][k] > 1)
             pre_over += matrix[shift_net1->col][k] - 1;	
         }
         for(k=miny;k<=maxy;k++) {
           if (matrix[shift_net2->col][k] > 1)
             pre_over += matrix[shift_net2->col][k] - 1;	
         }
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
           matrix[shift_net1->col][cptr->clink->rect.y] -= 1;
           matrix[shift_net2->col][cptr->clink->rect.y] += 1;
         }
         for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
           matrix[shift_net2->col][cptr->clink->rect.y] -= 1;
           matrix[shift_net1->col][cptr->clink->rect.y] += 1;
         }
         fin_over = 0;
         for(k=miny;k<=maxy;k++) {
           if (matrix[shift_net1->col][k] > 1)
             fin_over += matrix[shift_net1->col][k] - 1;	
         }
         for(k=miny;k<=maxy;k++) {
           if (matrix[shift_net2->col][k] > 1)
             fin_over += matrix[shift_net2->col][k] - 1;	
         }
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
           matrix[shift_net1->col][cptr->clink->rect.y] += 1;
           matrix[shift_net2->col][cptr->clink->rect.y] -= 1;
         }
         for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                               cptr=cptr->nextPtr) {
           matrix[shift_net2->col][cptr->clink->rect.y] += 1;
           matrix[shift_net1->col][cptr->clink->rect.y] -= 1;
         }
         overlap_penalty += fin_over - pre_over;
       }
     }
     else if (type is INTPAD) {
       if (matrix[shift_cell1->rect.x][shift_cell1->rect.y] > 1)
         overlap_penalty--;
       if (matrix[newloc_x][shift_cell1->rect.y] > 0)
         overlap_penalty++;
     }
   }
   if (overlap_penalty < 0)
     (void) fprintf(stdout,"OVERLAP PENALTY LESS THAN ZERO\n");
   over_cost = overlap_penalty*OVERLAP_PARAM ;
   if (overlap_penalty isnt 0)
     cost += over_cost + OVERLAP_OFFSET ;
/*
*  calculate penalty for increasing column or row size,gain for decreasing.
*/
   col_penalty = row_penalty = 0;
   if (first is TRUE) {
     for(i=1;i<M_SIZE;i++)
       Row[i] = Col[i] = 0;
     for(i=1;i<=gate_num;i++) {
       Row[cells[i]->rect.y-OFFSET] += 1;
       Col[cells[i]->rect.x-OFFSET] += 1;
     }
   }
   else {
     if (type is INTHORNET) {
       if (shift_net2 is NIL(struct net)) {
         n_cells = 0;
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                              cptr=cptr->nextPtr) {
           if (cptr->clink->type < PADLEFT) 
             n_cells++;
         }
         if (new_row isnt shift_net1->row) {
           if (Row[new_row-OFFSET] is 0)
             row_penalty++ ;
           if (Row[shift_net1->row-OFFSET] is n_cells)
             row_penalty--;
           if (Row[shift_net1->row-OFFSET] < n_cells)
             crash("something wrong in Row calculations");
         }
       }
     }
     if (type is INTVERTNET) {
       if (shift_net2 is NIL(struct net)) {
         n_cells = 0;
         for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                              cptr=cptr->nextPtr) {
           if (cptr->clink->type < PADLEFT) 
             n_cells++;
         }
         if (new_col isnt shift_net1->col) {
           if (Col[new_col-OFFSET] is 0)
             col_penalty++ ;
           if (Col[shift_net1->col-OFFSET] is n_cells)
             col_penalty--;
           if (Col[shift_net1->col-OFFSET] < n_cells)
             crash("something wrong in Column calculations");
         }
       }
     }
   }
   cost += col_penalty*COL_PARAM + row_penalty*ROW_PARAM;
/*
* Calculate cost of columns for a complex gate, directly related, to
* the column penalty.
*/
   if (first is TRUE && complex is TRUE) {
     complex_cols = 0;
     for(i=1;i<=net_num;i++) {
       net = nets[i];
       if (net->complex is TRUE) {
         net->num_cols = net->nnum_cols = compute_numcols(net,NULL);
         complex_cols += net->num_cols;
       }
     }
   }
   else if (shift_net1->hor is TRUE && complex is TRUE) {
     delta_cols = 0;
     for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                                    cptr=cptr->nextPtr) {
       cell = cptr->clink;
       if (cell->type >= PADLEFT) continue;
       if (cell->net_list->nlink->hor is FALSE) {
         net = cell->net_list->nlink;
       }
       else if (cell->net_list->nextPtr->nlink->hor is FALSE) {
         net = cell->net_list->nextPtr->nlink;
       }
       if (net->complex is TRUE) {
         net->nnum_cols = compute_numcols(net,INTHORNET);
         delta_cols += net->nnum_cols - net->num_cols;
         if (type is INTHORNET)
           net->proc = TRUE;
       }
     }
     if (shift_net2 isnt NIL(struct net)) {
       for(cptr=shift_net2->cell_list;cptr!=NIL(struct cell_ptr);
                                                      cptr=cptr->nextPtr) {
         cell = cptr->clink;
         if (cell->type >= PADLEFT) continue;
         if (cell->net_list->nlink->hor is FALSE) {
           net = cell->net_list->nlink;
         }
         else if (cell->net_list->nextPtr->nlink->hor is FALSE) {
           net = cell->net_list->nextPtr->nlink;
         }
         if (net->complex is TRUE && net->proc is FALSE) {
           net->nnum_cols = compute_numcols(net,INTHORNET);
           delta_cols += net->nnum_cols - net->num_cols;
         }
       }
       for(cptr=shift_net1->cell_list;cptr!=NIL(struct cell_ptr);
                                                      cptr=cptr->nextPtr) {
         cell = cptr->clink;
         for(nptr=cell->net_list;nptr!=NIL(struct net_ptr);nptr=nptr->nextPtr)
           nptr->nlink->proc = FALSE;
       }
     }
     cost += delta_cols*COMPLEX_PARAM;
   }
/*
*  Calculate cost for increasing row and column sizes for SLAS
*/
   if (varwidth is TRUE ) {
     if (first is TRUE) {
       for(i=1;i<=MVsize;i++) rh[i] = 0;
       for(i=1;i<=MHsize;i++) cw[i] = 0;
       for(i=1;i<=net_num;i++) {
         if (nets[i]->hor is TRUE)
           rh[nets[i]->row] = MAX(rh[nets[i]->row],nets[i]->size);
         else
           cw[nets[i]->col] = MAX(cw[nets[i]->col],nets[i]->size);
       }
       rohe = 0; cowi = 0;
       for(i=1;i<=MVsize;i++) rohe += rh[i];
       for(i=1;i<=MHsize;i++) cowi += cw[i];
       cost += (rohe+cowi)*WID_LEN_PARAM;
     }
     else {
       for(i=1;i<=MVsize;i++) rh[i] = 0;
       for(i=1;i<=MHsize;i++) cw[i] = 0;
       for(i=1;i<=net_num;i++) {
         if (nets[i]->hor is TRUE) {
           if (nets[i] is shift_net1 && shift_net2 isnt NIL(struct net))
             rh[shift_net2->row] = MAX(rh[shift_net2->row],nets[i]->size);
           else if (nets[i] is shift_net1 && shift_net2 is NIL(struct net))
             rh[new_row] = MAX(rh[new_row],nets[i]->size);
           else if (nets[i] is shift_net2 && shift_net1 isnt NIL(struct net))
             rh[shift_net1->row] = MAX(rh[shift_net1->row],nets[i]->size);
           else if (nets[i] is shift_net2 && shift_net1 is NIL(struct net))
              error("shiftnet1 is nil");
           else
             rh[nets[i]->row] = MAX(rh[nets[i]->row],nets[i]->size);
         }
         else {
           if (nets[i] is shift_net1 && shift_net2 isnt NIL(struct net))
             cw[shift_net2->col] = MAX(cw[shift_net2->col],nets[i]->size);
           else if (nets[i] is shift_net1 && shift_net2 is NIL(struct net))
             cw[new_col] = MAX(cw[new_col],nets[i]->size);
           else if (nets[i] is shift_net2 && shift_net1 isnt NIL(struct net))
             cw[shift_net1->col] = MAX(cw[shift_net1->col],nets[i]->size);
           else if (nets[i] is shift_net2 && shift_net1 is NIL(struct net))
              error("shiftnet1 is nil");
           else
             cw[nets[i]->col] = MAX(cw[nets[i]->col],nets[i]->size);
         }
       }
       rohe = 0; cowi = 0;
       for(i=1;i<=MVsize;i++) rohe += rh[i];
       for(i=1;i<=MHsize;i++) cowi += cw[i];
       cost += (rohe+cowi)*WID_LEN_PARAM;
     }
   }

   new_penalty = overlap_penalty;
   overlap_penalty = t_over;
 
  return(cost);

} /* end of find_cost */


void
find_starting_temp()
{

  double delta_c;
  int yes;
/*
*  Let's not accept a move which increases the initial cost by more than
*   X percent.
*/

   delta_c = 0.04 * (double)init_cost;
   START_TEMP = delta_c/log(1.25) ;
   if (specify is TRUE) {
     (void) fprintf(stderr,"STARTING TEMPERATURE IS %.4g\n",START_TEMP);
     (void) fprintf(stderr,"Want to change it (1/0)?:");
     (void) fscanf(stdin,"%d",&yes);
     if (yes is TRUE) {
       (void) fprintf(stderr,"Starting Temperature:");
       (void) fscanf(stdin,"%lf",&START_TEMP);
     }
   }
#ifndef dist
   else 
     (void) fprintf(stdout,"STARTING TEMPERATURE IS %.4g\n",START_TEMP);
#endif
  return;

} /* end of find_starting_temp */


find_net_limits(nt,minx,maxx,miny,maxy,type)
NET nt;
int *minx,*maxx,*miny,*maxy;
int type;
{

 CELL_PTR cptr;


  *minx = *miny = INFINITY;
  *maxx = *maxy = 0;

  if (nt is NIL(struct net) || nt->cell_list is NIL(struct cell_ptr)) 
    return;
  if (type is 1) {
/*
* normal limits
*/
    for(cptr=nt->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
      *miny = MIN(*miny,cptr->clink->rect.y);
      *maxy = MAX(*maxy,cptr->clink->rect.y);
      *minx = MIN(*minx,cptr->clink->rect.x);
      *maxx = MAX(*maxx,cptr->clink->rect.x);
    }
    if (*maxx < *minx || *maxy < *miny)
      crash("error in find_net_limits");
  }
  else if (type is 2) {
/* 
* means a cell displacement 
*/
    for(cptr=nt->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
      if (cptr->clink isnt shift_cell1) {
        *miny = MIN(*miny,cptr->clink->rect.y);
        *maxy = MAX(*maxy,cptr->clink->rect.y);
        *minx = MIN(*minx,cptr->clink->rect.x);
        *maxx = MAX(*maxx,cptr->clink->rect.x);
      }
      else {
        *miny = MIN(*miny,newloc_y);
        *maxy = MAX(*maxy,newloc_y);
        *minx = MIN(*minx,newloc_x);
        *maxx = MAX(*maxx,newloc_x);
      }
    }
    if (*maxx < *minx || *maxy < *miny)
      crash("error in find_net_limits");
  }
  else if (type is 3) {
/*
* means a cell interchange here.
*/
    for(cptr=nt->cell_list;cptr!=NIL(struct cell_ptr);cptr=cptr->nextPtr) {
      if (cptr->clink is shift_cell1) {
        *miny = MIN(*miny,shift_cell2->rect.y);
        *maxy = MAX(*maxy,shift_cell2->rect.y);
        *minx = MIN(*minx,shift_cell2->rect.x);
        *maxx = MAX(*maxx,shift_cell2->rect.x);
      }
      else if (cptr->clink is shift_cell2) {
        *miny = MIN(*miny,shift_cell1->rect.y);
        *maxy = MAX(*maxy,shift_cell1->rect.y);
        *minx = MIN(*minx,shift_cell1->rect.x);
        *maxx = MAX(*maxx,shift_cell1->rect.x);
      }
      else {
        *miny = MIN(*miny,cptr->clink->rect.y);
        *maxy = MAX(*maxy,cptr->clink->rect.y);
        *minx = MIN(*minx,cptr->clink->rect.x);
        *maxx = MAX(*maxx,cptr->clink->rect.x);
      }
    }
  }
 return;

} /* end of find_net_limits */

