/*
 * debug.c: Routines for dumping data structures
 */
#include "port.h"
#include "utility.h"
#include "fang.h"
#include "harpoon.h"
#include "oct.h"
#include "st.h"
#include "oh.h"
#include "fa.h"
#include "gn.h"
#include "list.h"
#include "kh.h"
#include "kahlua.h"

#ifndef lint
/*
 * dumpTerm: dump out term in human readable form.
 */
void
dumpTerm(ptr)
kh_term *ptr;
{
    int x, y;
    octId objectId;

    x = ptr->position.x; 
    y = ptr->position.y;
    objectId = ptr->termId;

    (void) fprintf(stderr, "\tterminal (%d) on (%d,%d)\n", objectId, x, y);
    return;
}


/*
 * dumpTermList: dump out term list in human readable form.
 */
/*ARGSUSED*/
dumpTermList(key, value, arg)
char *key;
lsList value;
char *arg;
{
    (void) fprintf(stderr, "On layer %s\n", key);
    lsDestroy(value, dumpTerm);
}


/*
 * dumpKhList: dump out khList in human readable form.
 */
dumpKhList(listPtr)
khList *listPtr;
{
    khList list, nextList;
    char *name;
    lsList ls;

    for (list = *listPtr; list != KH_EMPTY_LIST; list = nextList) {
	nextList = khRestOfList(list);
	name = khFirstName(list);
	ls = khFirstLs(list);
	dumpTermList(name, ls, NIL(char));
    }
}
#endif
