/*
 * kahlua.h -- basic header file
 */
#include "oct.h"

typedef struct kh_term {
    struct octPoint position;
    struct octPoint gridPosition;
    octId termId;
    struct kh_term *equiv_next;	/* Equivalent terms in a sll. */
    struct kh_term *equiv_head;	/* Equivalent terms in a sll. */
    struct kh_term *overlap;	/* Pointer to an overlapping terminal. */
} kh_term;

extern kh_term* termConstruct();

typedef struct kh_path {
    struct octPoint start;
    struct octPoint end;
    int width;
} kh_path;

#define KH_GLOBAL_CELL "#KH_GLOBAL_CELL"
#define KH_GLOBAL_VIEW "#KH_GLOBAL_VIEW"
#define BUFFER_SIZE 200
#define INDENT "    "

extern int parentOnly;			/* kahlua.c */
extern int deviceOnly;			/* kahlua.c */
extern int implicitFterm;		/* kahlua.c */
extern int explicitFterm;		/* kahlua.c */
extern int trace;			/* kahlua.c */
extern int minWidth;			/* kahlua.c */
extern int expandFactor;		/* kahlua.c */
extern int ratio;			/* kahlua.c */
extern int interactive;			/* kahlua.c */
extern char *leafView;			/* kahlua.c */
extern char *defLibDir;			/* kahlua.c */
extern char *techFile;			/* kahlua.c */
extern char *technology;		/* kahlua.c */

extern octObject globalFacet;		/* globals.c */
extern octObject masBag;		/* globals.c */
extern octObject disBag;		/* globals.c */

/* counters declarations */
extern int instanceCount;		/* counters.c */
extern int netCount;			/* counters.c */
extern int ftermCount;			/* counters.c */
extern int mosfetMasterCount;		/* counters.c */
extern int pathCount;			/* counters.c */
extern int majorNetCount;		/* counters.c */
extern int subcellCount;		/* counters.c */
extern int uniqueSubcellCount;		/* counters.c */
extern int mosfetCount;			/* counters.c */
extern int uniqueMosfetCount;		/* counters.c */
extern int contactCount;		/* counters.c */
extern int uniqueContactCount;		/* counters.c */
extern int connectorCount;		/* counters.c */
extern int uniqueConnectorCount;	/* counters.c */
extern int routeRegionCount;		/* counters.c */
extern int humanMosfetCount;		/* counters.c */
extern int humanRoutedCount;		/* counters.c */

/* simple macros */
#define mkInstanceName(s)  (void) sprintf(s, "i%d", instanceCount++);
#define mkNetName(s)       (void) sprintf(s, "n%d", netCount++);
#define mkFtermName(s)       (void) sprintf(s, "t%d", ftermCount++);

/* backwards compatibility to Dave Harrison's list package */
#define Pointer lsGeneric		/* list.h compatibility */

