#include "port.h"
#include "utility.h"
#include "list.h"
#include "kh.h"

/*
 * khFreeList: frees memory associated with listPtr
 */
khFreeList(listPtr)
khList *listPtr;
{
    khList list, nextList;

    for (list = *listPtr; list != KH_EMPTY_LIST; list = nextList) {
	nextList = khRestOfList(list);
	lsDestroy(khFirstLs(list), (void (*)()) 0);
	FREE(khFirstName(list));
	FREE(list);
    }
}

/*
 * khGetNamedLs: returns the ls that corresponds to name
 *    from the tsList
 */
lsList khGetNamedLs(name, termLsListPtr)
char *name;			/* name of desired termLs */
khList *termLsListPtr;		/* list of named termLsmetries */
{
    struct khListItem *termLsItem;	/* new item */

    while (*termLsListPtr != KH_EMPTY_LIST) {
	if (!strcmp(name, khFirstName(*termLsListPtr))) {
	    return(khFirstLs(*termLsListPtr));
	}
	termLsListPtr = &khRestOfList(*termLsListPtr);
    }
    termLsItem = ALLOC(struct khListItem, 1);
    khRestOfList(termLsItem) = *termLsListPtr;
    *termLsListPtr = termLsItem;
    khFirstName(termLsItem) = util_strsav(name);
    khFirstLs(termLsItem) = lsCreate();
    return(khFirstLs(termLsItem));
}

