#include "port.h"
#include "st.h"
#include "kahlua.h"
#include "errtrap.h"
#include "wormhole.h"


static st_table *table = 0;


void WHinit()
{
    if ( ! table ) {
	table = st_init_table( st_numcmp, st_numhash );
    }
}


void WHadd( x, y, termEntry )
    int x;
    int y;
    kh_term *termEntry;
{
    int key = (x << 16 ) + y ;
    kh_term* t = WHget( x, y );

    if ( t == 0 ) {
	st_insert( table, (char*)key, (char*)termEntry );
    } else {
	if ( t != termEntry ) {
	    errRaise( "WH",1, "entry %d,%d already filled with another term", x,y );
	} 
    }
}

kh_term* WHget( x, y )
    int x;
    int y;
{
    kh_term* term = 0;
    int key = (x << 16 ) + y ;
    st_lookup( table, (char*)key, (char**)&term );
    return term;
}

void WHclean()
{
    st_free_table( table );
    table = 0;
}
