/*
 *
 *  GLOBAL DEFINITIONS
 *
 *  Advising professor:
 *      Alberto Sangiovanni-Vincentelli
 *
 *	Andrea Casotto
 */
#include <oct.h>
#include <port.h>

#define OCT_LAMBDA 20


/*
 *   MACRO DEFINITIONS
 *
 *   Macros are distinguished by using solely capital letters in their
 *   identifiers.  This contrasts with C defined identifiers which are strickly 
 *   lower case, and program variable and procedure names which use both upper 
 *   and lower case.
 */

/* Begin macros. */

/* Boolean data type */
#define  BOOLEAN	int
#define  FALSE		0
#define  TRUE		1

#ifndef NULL
#define NULL	0
#endif

char _errBuffer[64];
#define OCT_ASSERT(fct) \
    if ((fct) < OCT_OK) {\
	(void) sprintf(_errBuffer,"An OCT assertion failed: %s line %d", \
		__FILE__, __LINE__ );\
	octError(_errBuffer);\
	exit(-1);\
    }

/* Macro commands */
/* Macro functions that return the maximun or minimum independent of type. */
#define  MAX(a,b)           ((a) > (b) ? (a) : (b))
#define  MIN(a,b)           ((a) < (b) ? (a) : (b))

/* Macro function that returns the absolute value of a floating point number. */
#define  ABS(a)             ((a) < 0.0 ? -(a) : (a))

/* Macro procedure that swaps two entities. */
#define  SWAP(type, a, b)   {type swapx; swapx = a; a = b; b = swapx;}


/* Standard Macros ... */
typedef char * PTR;
#define NIL(type)		((type *) 0)


#ifdef lint
#define MALLOC(type, num)	NIL(type)
#define CALLOC(type, num)	NIL(type)
#define REALLOC(type, obj, num) NIL(type)
#define FREE(object)		(object) = 0
#else
#define MALLOC(type,number)  (type *)malloc((unsigned)(sizeof(type)*(number)))
#define CALLOC(type,number)  (type *)calloc(sizeof(type),(unsigned)(number))
#define REALLOC(ptr,type,number)  \
           ptr = (type *)realloc((char *)ptr,(unsigned)(sizeof(type)*(number)))
#define FREE(pointer)  if ((pointer) != NULL)  \
	   { free((char *)pointer); (pointer)=NULL; }
#endif

#define strsav(s)		strcpy(MALLOC(char,strlen(s)+1), s)

