/* fiboHeap.h - data structure for Fibonacci heap and its operation
 
   Copyright (C) 1988 by Yoshihito Nishizaki.
		All rights reserved.

 */



#define MAXRANK		10
#define MAXHEAPSIZE	G_MAXNODE

typedef struct  FH_node         FH_node;
typedef struct  FH_node         *FH_header;


struct FH_node {
    int		id;		/* id of the object represented by this node */
    float	key;		/* key value of this node */
    int		rank;		/* rank of this node */
    short	counter;	/* counter for cascading cut rule */
    FH_node	*parent;	/* parent node */
    FH_node	*child;		/* first child */
    FH_node	*nextSibling;	/* next sibling */
    FH_node	*preSibling;	/* preceding sibling */
};

FH_node		*rank2tree[MAXRANK + 1];
FH_node		*id2heapNode[MAXHEAPSIZE];

FH_header	*FH_makeheap();
FH_node		*FH_findmin();
FH_node		*FH_link();



