/* intProg.h - data structure for integer programming
 
   Copyright (C) 1988 by Yoshihito Nishizaki.  All rights reserved.

 */


#define NO_REGIONTYPE	3



/* 
  array for fixed usage for each routing region in OCT units
  ----------------------------------------------------------
	1st suffix : represents the type of region
			HORIZONTAL	: non over the cell, horizontal region
			VERTICAL	: non over the cell, vertical region
			OVERCELL	: over the cell region
	2nd suffix : suffix for each region within each region category
 */
int FIX[NO_REGIONTYPE][G_MAXREGION];


/* 
  incidence matrix between a polar path and a routing region
  ----------------------------------------------------------
	1st suffix : represents the type of region
			HORIZONTAL	: horizontal polar path
			VERTICAL	: vertical polar path
	2nd suffix : suffix for each path in each direction in polar graph
	3rd suffix : serial number of region in this polar path

	Each element contains the id of region contained in the path
 */
int INC[NO_REGIONTYPE - 1][G_MAXPOLAR][G_MAXREGION];


/* 
  weight matrix of each route candidate to each routing region
  ------------------------------------------------------------
	1st suffix : represents the type of region
			HORIZONTAL	: non over the cell, horizontal region
			VERTICAL	: non over the cell, vertical region
			OVERCELL	: over the cell region
	2nd suffix : suffix for each region within each region category (H/V/O)
	3rd suffix : suffix for each candidate route of nets
 */

float *WGT[G_MAXREGION];



typedef struct critPath {
    int	pathNo;
    int	regionID[G_MAXREGION];
    int	critPathNo;
    int maxLength;
    }
    critPathType;



