/*
Copyright (C) 1988 University of California (Berkeley). All rights reserved.

hgMain.c

Main routine for channel definition slicing structure.

Author(s):		Mitsuru Igusa
Revision history:	$Log:	hgMain.c,v $
 * Revision 1.1  90/02/07  17:03:27  octtools
 * Checkin for 3.5 distribution
 * 
----------------------------------------------------------------------------*/
#ifndef lint
static char RCSId[] = "@(#) $Header: /octtools/release-3.0/src/mercuryInterface/RCS/hgMain.c,v 1.1 90/02/07 17:03:27 octtools Exp Locker: octtools $";
#endif
#include "copyright.h"
#include "port.h"
#include "oct.h"
#include "oh.h"
#include "miutil.h"
#include "CDSInc.h"
/* Main procedure for channel definition
----------------------------------------------------------------------------*/
CDSMain(cellName, inputView, outputView, mergeIoFlg, atlasMain, expandFactor, zFlag)

char		*cellName;
char		*inputView;
char		*outputView;
int		mergeIoFlg;	/* == 0 if ios should not be merged */
octObject	*atlasMain;
double		expandFactor;
int		zFlag;
{
int		rc;
int		CDSMainFromFacet();
void		CDSHgInterface();

CDSParm.mode         = "hgInter";
CDSParm.zChanFlg     = zFlag;
CDSOctMode	     = TRUE;
CDSParm.cellName     = cellName;
CDSParm.inputView    = inputView;
CDSParm.outputView   = outputView;
CDSParm.mergeIoFlg   = mergeIoFlg;
CDSParm.mergeIoOnlyFlg = FALSE;
CDSParm.rpcFlg       = FALSE;
CDSParm.seqFileName  = NULL;
CDSParm.expandFactor = 1.2;

if (expandFactor>1.0 & expandFactor<CDSParm.expandFactor) {
    printf("Changing expand factor from default %f to %f\n",
	CDSParm.expandFactor, expandFactor);
    CDSParm.expandFactor = expandFactor;
}

MIPrefix = "hgInter";
printf("%s: Mercury channel definition and ordering (Rev 1.8 compiled %s %s)\n",
    MIPrefix, __TIME__, __DATE__);
printf("Cell name = %s, input view = %s and output view = %s\n",
    CDSParm.cellName, CDSParm.inputView, CDSParm.outputView);

if (CDSOctMode) {
    octBegin();
    MIModStatStart("hgInter", "debug", TRUE);
    MI_STACK_ALLOC(10000);
    MI_QUEUE_ALLOC(10000);

    CDSOctCopyAndOpen(CDSParm.cellName, CDSParm.inputView, CDSParm.outputView,
	atlasMain);

    MI_STACK_FREE();
    MI_QUEUE_FREE();
    MIModStatEnd();
}

rc = CDSMainFromFacet(atlasMain, CDSHgInterface);

return(rc);
} /* ............................. End of main procedure */
/* Main procedure for output from mercury.
----------------------------------------------------------------------------*/
int
CDSHgOutMain(mainFacet, updateNetFlag)

octObject	*mainFacet;
int		updateNetFlag;
{

MIModStatStart("hgInter", "debug", TRUE);
MI_MOD_START("CDSHgOutMain");

MI_STACK_ALLOC(10000);
MI_QUEUE_ALLOC(10000);

if (updateNetFlag) {
    hgCreateChan(mainFacet);
    hgOutOct(mainFacet);
}
else {
    printf("WARNING: Not saving global net information\n");
    printf("Just updating the locations of the instances\n");
    hgCreateChan(mainFacet);
    CDSOctPurge(mainFacet);
}
hgUpdateLoc(mainFacet);
OH_ASSERT(octCloseFacet(mainFacet));

CDSCleanUp("CDSHg");
MI_STACK_FREE();
MI_QUEUE_FREE();

MI_MOD_END();
MIModStatEnd();
} /* ............................. End of procedure CDSHgOutMain */
