#include "mighty.h"

extern SCHED_PTR schedhead;
/********************************************************
 *  Last modified 4/9'87
 *    NULL schedhead handling in S_delschedq( )
 *
 *
 ********************************************************/

/*
 *  if possible, push a segment by one unit, and return YES
 */
int S_unitpush( dir, x, y, net )
int dir;
int x,
    y;
int net;
{
    int x1,
	y1,
	x2,
	y2;
    int blockx,
	blocky,
	newx,
	newy;
    int blocknet = 0;

    x1 = x2 = x;
    y1 = y2 = y;

    if( dir == DOWN || dir == UP )
    {
	/*
	 *  find the interval to push
	 */
	while( hlayer[y1][x1] == net || vlayer[y1][x1] == net )
	    x1--;
	x1++;
	while( hlayer[y2][x2] == net || vlayer[y2][x2] == net )
	    x2++;
	x2--;
	/*
	 *  there must not be a pin connected
	 */
	for( newx = x1; newx <= x2; newx++ )
	    if( playerh[y][newx] == net || playerv[y][newx] == net )
	        return( NO );

	/*
	 *  check if there is available space
	 */
	if( dir == DOWN )
	    newy = y + 1;
	else
	    newy = y - 1;
	for( newx = x1; newx <= x2; newx++ )
	{
	    if( hlayer[y][newx] == net &&
		hlayer[newy][newx] != 0 && hlayer[newy][newx] != net )
	    {
		if( blocknet == 0 )
		{
		    blockx = newx;
		    blocky = newy;
		    blocknet = hlayer[newy][newx];
		}
		else if( blocknet != hlayer[newy][newx] )
	    return( NO );
	    }
	    if( vlayer[y][newx] == net &&
		vlayer[newy][newx] != 0 && vlayer[newy][newx] != net )
	    {
		if( blocknet == 0 )
		{
		    blockx = newx;
		    blocky = newy;
		    blocknet = vlayer[newy][newx];
		}
		else if( blocknet != vlayer[newy][newx] )
	    return( NO );
	    }
	}
	if( blocknet > num_nets )
    return( NO );
	if(blocknet == 0 || S_unitpush( dir, blockx, blocky, blocknet ))
	{
	    S_unitmove( x1, y1, x2, y2, dir, net );
	    return( YES );
	}
	return( NO );
    }
    else /* LEFT or RIGHT */
    {
	/*
	 *  find the interval to push
	 */
	while( hlayer[y1][x1] == net || vlayer[y1][x1] == net )
	    y1--;
	y1++;
	while( hlayer[y2][x2] == net || vlayer[y2][x2] == net )
	    y2++;
	y2--;

	/*
	 *  there must not be a pin connected
	 */
	for( newy = y1; newy <= y2; newy++ )
	    if( playerh[newy][x] == net || playerv[newy][x] == net )
	        return( NO );

	/*
	 *  check if there is available space
	 */
	if( dir == RIGHT )
	    newx = x + 1;
	else
	    newx = x - 1;
	for( newy = y1; newy <= y2; newy++ )
	{
	    if( hlayer[newy][x] == net &&
		hlayer[newy][newx] != 0 && hlayer[newy][newx] != net )
	    {

		if( blocknet == 0 )
		{
		    blockx = newx;
		    blocky = newy;
		    blocknet = hlayer[newy][newx];
		}
		else if( blocknet != hlayer[newy][newx] )
	    return( NO );
	    }
	    if( vlayer[newy][x] == net &&
		vlayer[newy][newx] != 0 && vlayer[newy][newx] != net )
	    {
		if( blocknet == 0 )
		{
		    blockx = newx;
		    blocky = newy;
		    blocknet = vlayer[newy][newx];
		}
		else if( blocknet != vlayer[newy][newx] )
	    return( NO );
	    }
	}
	if( blocknet > num_nets )
    return( NO );
	if(blocknet == 0 || S_unitpush( dir, blockx, blocky, blocknet ))
	{
	    S_unitmove( x1, y1, x2, y2, dir, net );
	    return( YES );
	}
	return( NO );
    }
}

/*
 *  push one unit by rerouting
 */
void
S_unitmove( x1, y1, x2, y2, dir, net )
int x1,
    y1,
    x2,
    y2;
int dir;
int net;
{
    LINKPTR link;
    int numcomp;
    int x,
	y;
    LINKPTR S_picklink();

    /*
     *  actual move
     */
    while( (link = net_array[net].tmplist) != NULL )
    {
	net_array[net].tmplist = link->netnext;
	S_retlink( link );
    }

    if( (link = S_picklink( x1, y1, net )) == NULL ||
	(link = S_picklink( x2, y2, net )) == NULL )
    {
print_debug ("impr1", "horiz", channel->horiz_layer, num_rows, num_cols, num_nets);
print_debug ("impr1", "vert", channel->vert_layer, num_rows, num_cols, num_nets);
exit( 29 );
    }

    if( dir == DOWN || dir == UP )
    {
        if( dir == DOWN )
	    y2++;
        else
	    y2--;

	for( x = x1; x <= x2; x++ )
	{
	    while( (link = S_picklink( x, y1, net )) != NULL )
	    {
		if( link->y1 == y1 )
		{
		    if( link->y2 == y1 )
		        S_addlink( link->layer, link->x1, y2, link->x2, y2, net );
		    else if( link->x1 != link->x2 || link->y2 != y2 )
		        S_addlink( link->layer, link->x1, y2, link->x2, link->y2, net );
		}
		else  /* link->y2 == y1 */
		{
		    if( link->x1 != link->x2 || link->y1 != y2 )
		        S_addlink( link->layer, link->x1, link->y1, link->x2, y2, net );
		}
		S_writelink( link, 0 );
		S_dellink( link );
	    }
	}
    }
    else /* dir == LEFT || dir == RIGHT */
    {
        if( dir == RIGHT )
	    x2++;
        else
	    x2--;

	for( y = y1; y <= y2; y++ )
	{
	    while( (link = S_picklink( x1, y, net )) != NULL )
	    {
		if( link->x1 == x1 )
		{
		    if( link->x2 == x1 )
		        S_addlink( link->layer, x2, link->y1, x2, link->y2, net );
		    else if( link->y1 != link->y2 || link->x2 != x2 )
		        S_addlink( link->layer, x2, link->y1, link->x2, link->y2, net );
		}
		else  /* link->x2 == x1 */
		{
		    if( link->y1 != link->y2 || link->x1 != x2 )
		        S_addlink( link->layer, link->x1, link->y1, x2, link->y2, net );
		}
		S_writelink( link, 0 );
		S_dellink( link );
	    }
	}
    }
    for( link = net_array[net].path; link != NULL; link = link->netnext)
	S_writelink( link, net );

    if( S_trytmppath( net ) == NO )
    {
print_debug ("impr1", "horiz", channel->horiz_layer, num_rows, num_cols, num_nets);
print_debug ("impr1", "vert", channel->vert_layer, num_rows, num_cols, num_nets);
	S_dumppath( net );
	exit( 25 );
    }
    /*
     *  Set marked
     */
    net_array[net].marked = YES;

    /*
     *  reschedule is done in S_improve
     *  LATER check any severe cost increase
     */
    if ( (numcomp = S_findcomponents( net )) > 1 )
    {
        if( S_findpath( net, YES ) == NO )
	{
	    printf("findpath3 not possible - must reroute\n");
	}
    }
}

/*
 *  delete a job from schedule queue.
 */
S_delschedq( net )
int net;
{
    SCHED_PTR schedq = NULL;
    SCHED_PTR prevq = NULL;

    if( schedhead == NULL )
	return;

    for( schedq = schedhead; schedq != NULL; schedq = schedq->next )
    {
	if( schedq->net == net )
	    break;
	prevq = schedq;
    }
    if( schedq != NULL && schedq->net == net )
    {
	if( prevq == NULL )
	    schedhead = schedhead->next;
	else
	    prevq->next = schedq->next;
	S_retschedq( schedq );
    }
}
