
#define MAIN
#include "mighty.h"
#undef MAIN
extern SEARCHPTR *searchq;
extern int MODCOST;
extern int addguide;

/************************************************************************
 *
 * This is the main routine for mighty 
 *
 ************************************************************************/


main (argc, argv)
int argc;			/* argc and argv are used to get
				   information from the command line */
char *argv[];
{
    int num_box;
    NETPTR S_input();
    void S_markborder();
    void S_route();
    void S_rmpins();
    void S_maxmetal();
    void S_connectboundary();
    void S_printstandard();
    void print_channel ();
    void S_printsq();
    void S_printstats();
    CHANNELPTR allocate_channel ();
    LINKLISTPTR **allocate_linklayer ();
    int **allocate_hist ();
    SEARCHPTR *allocate_searchq ();


    fprintf(stderr,"MIGHTY 1.7: detailed router.\n");

    /*
     *  process command line
     */

    command_line (argc, argv);

    /*
     * See if there was a problem opening files
     */
    
    if (input_file==NULL || output_file==NULL || result_file==NULL)
    {
	fprintf(output_file,"Problem opening files!\n");
	exit(1);
    }

    /*
     *  read input
     */

    net_array = S_input ( &num_nets, &num_box, &num_rows, &num_cols,
			&num_obstacles, &num_pins );
    
    /*
     * Check for bogus input
     */
    if (num_nets==0 || num_cols==0)
    {
	fprintf(output_file,"Bogus input: No nets or no cols!\n");
	exit(1);
    }


    /*
     *  allocate memory for the channel and cost matrix
     */

    channel = allocate_channel (num_rows, num_cols);
    hlayer = channel->horiz_layer;
    vlayer = channel->vert_layer;
    playerh = channel->pin_layerh;
    playerv = channel->pin_layerv;

    /*
     *  allocate memory for the link layer
     */

    linklayer = allocate_linklayer (num_rows, num_cols);

    /*
     *  allocate memory for the seachq
     */

    searchq = allocate_searchq (MODCOST);

    /*
     *  allocate memory for the history
     */

    history = allocate_hist (num_nets);

    /*
     *  Mark obstacles before routing
     */
    S_markborder();

    /*
     *  switch box routing
     */
    S_route( net_array, channel, num_nets );

    if (maximize_metal)
    {
        if( addguide )
	    S_rmpins();
	S_maxmetal();
    }
    /*
     *  connect to the pins on the boundary
     */
    S_connectboundary();

    if (stats_only == FALSE)
    {
	S_printstandard();
	if( debug )
	    print_channel (channel, num_rows, num_cols, num_nets);
/*
	S_printsq();
*/
    }
    else
	S_printstats();

    exit( 0 );
}
