#include "mighty.h"
extern int Longch;

int bkcycle = NO;
int LIMCOLS = 70;

int STEPSIZE = 35; 	/*  can be increased in S_guidepin  */
#define DELSTEP 5

/* zzz 3/18'86
#define BIAS 10
#define VSLOPE  50
#define VCGSLOPE 500
#define HSLOPE  50000
int PREASSIGN = 500000;
*/
#define BIAS 10
#define VSLOPE   50
#define VCGSLOPE 2000
#define CYCVCGSLOPE 5000
#define HSLOPE  50000
int PREASSIGN = 500000;

#define HALFCOL 2
#define FULLCOL 4

int left_start;
int left_numtr;
int right_start;
int right_numtr;
int *bother = 0;
int *lftop = 0;
int *lfbot = 0;

/*
 *  Pseudo pins are made.
 *  This is to give guide in routing long channels
 *  or highly iregular shaped channels.
 */

extern int *S_allocatevector();
extern int *S_finddensity();
extern int **S_structure();
extern void S_resetstructure();
extern int *S_assign();

extern int **cost;

S_addguides()
/*
 *  This routine is called if num_cols > LIMCOLS
 */
{
int m, /* number of rows( crossing nets ) */
    n; /* number of cols( tracks ) */
int *cross;
int *distloc,  /* If there is less number of pins, more flexible */
    *distacc;  /* Lookup table of distances */
int *density;
int i,
    j,
    col,
    fromcol,
    tocol,
    prevcol;
int maxlevel;
int maxcol,    /* column with max density */
    starttr,   /* first available track */
    numpin;
int left_pins = 0,
    right_pins = 0;

    if( num_left > 0 )
	left_pins = YES;
    if( num_right > 0 )
	right_pins = YES;

    /*
     *  If wide channel, increase STEPSIZE
     */
    STEPSIZE = MAX(3*num_rows/2, STEPSIZE);
    LIMCOLS = MAX(LIMCOLS, 3*STEPSIZE/2);

    /*
     *  Compensate the distance according to the pin density
     *  allocate distance compensating vetor
     */
    distloc = S_allocatevector( num_cols );
    distacc = S_allocatevector( num_cols );

    for( i = 1; i <= num_cols; i++ )
    {
	/*
	 *  count number of pins on each column
	 */
	numpin = 0;
	for( j = 1; j <= num_rows; j++ )
	{
	    if( playerh[j][i] > 0 )
		numpin++;
	    if( playerv[j][i] > 0 )
		numpin++;
	}
	if( numpin == 0 )
	    distloc[i] = FULLCOL;
	else if( numpin == 1 )
	    distloc[i] = HALFCOL;
	else
	    distloc[i] = 0;
    }


    /*
     *  allocate and find density
     */
    density = S_finddensity();

    /*  set defaults  */
    maxcol = 1;
    col = 0;
    /*
     *  Main loop begins
     */
    for( ;; )
    {
	prevcol = col;

	if( col == 0 && Longch )
	{
	    maxcol = col = S_maxdencol( density, 1, num_cols );
	}
	else if( col <= maxcol && col > LIMCOLS && Longch )
	{
	    fromcol = col - STEPSIZE - DELSTEP;
	    tocol = col - STEPSIZE + DELSTEP;
	    col = S_maxdencol( density, fromcol, tocol );
	}
	else if( left_pins == YES )
	{
	    left_pins = NO;
	    col = 1;
	}
	else if( col < num_cols - LIMCOLS && maxcol + LIMCOLS < num_cols&& Longch )
	{
	    fromcol = MAX(maxcol, col) + STEPSIZE - DELSTEP;
	    tocol = fromcol + DELSTEP + DELSTEP;
	    col = S_maxdencol( density, fromcol, tocol );
	}
	else if( right_pins == YES )
	{
	    right_pins = NO;
	    col = num_cols;
	}
	else
	    break;

	/*  calculate accumulated compensated distance  */
	distacc[col] = distloc[col]/2;
	for( i = col + 1; i <= num_cols; i++ )
	    distacc[i] = distacc[i-1] + distloc[i] + 1;
	for( i = col - 1; i >= 1; i-- )
	    distacc[i] = distacc[i+1] + distloc[i] + 1;

	/*
	 *  find number m of nets crossing col, and
	 *  number n of available tracks on the column.
	 */
	if( col == 1 )
	{
            S_resetmarked();
            m = num_left;
            n = S_findtracks( 2, &starttr );
	    col = 1;
	    left_pins = NO;

	    /*  save for post processing  */
	    left_start = starttr;
	    left_numtr = n;

            for( i = 1; i <= num_left; i++ )
    	    {
		net_array[ left[i] ].marked = YES;
	    }
	}
	else if( col == num_cols )
	{
            S_resetmarked();
            m = num_right;
            n = S_findtracks( num_cols-1, &starttr );
	    col = num_cols;
	    right_pins = NO;

	    /*  save for post processing  */
	    right_start = starttr;
	    right_numtr = n;

            for( i = 1; i <= num_right; i++ )
    	    {
		net_array[ right[i] ].marked = YES;
	    }
	}
	else
	{
            m = S_findnets( col );
	    /*
	     * If more crossing nets than tracks, exit.
	     */
	    if( m > num_rows - 2 )
	    {
		printf( "ERROR: crossing nets = %d, tracks = %d\n",
		    m, num_rows );
		fprintf(output_file, "failed\n");
		exit( 88 );
	    }

            n = S_findtracks( col, &starttr );
	    /*
	     *  If non convex(n=0), or blocked area on the col, continue
	     */
	    if( m > n )
	    {
		printf("ERROR: m = %d, n = %d at col = %d\n", m, n,
		    col );
    continue;
	    }
	}

	/*
	 *  calculate level
	 */
        S_cleargraph();
        S_makegraph(1,num_cols);
        level_graph(col);
	maxlevel = S_maplevels();

	/*
	 * allocate for linear assignments
	 */
	if( cost == 0 )
            cost = S_structure(num_nets, num_rows);
	else
	    S_resetstructure(num_nets,num_rows);

	if( col == maxcol )
            S_setcosts( cost, distacc, starttr, m, n, maxlevel, 1, num_cols, col );
	else if( col < prevcol )
            S_setcosts( cost, distacc, starttr, m, n, maxlevel, 1, prevcol, col );
	else if( col > prevcol )
            S_setcosts( cost, distacc, starttr, m, n, maxlevel, MAX(prevcol, maxcol), num_cols, col );
	else exit( 85 );


	cross= S_assign( cost, m, n );
/*
S_printresults( m, n );
*/

	/*
	 *  assign i-th crossing net on track cross[i]
	 */
	if( col == 1 || col == num_cols )
	    S_addpins( cross, col, starttr, TEMP );
	else
	    S_addpins( cross, col, starttr, TEMP );

    }
}


S_findnets( col )
int col;
/*
 *  set marked for the nets crossing x = col or having a pin on x = col
 *  returns the number of such nets
 *  NOTE : Include the nets which start or stop at col.
 *         But nets with lateral distance <= 1 would be omitted.
 */
{
    PINPTR cpin;
    int i;
    int xleft,
	xright;	/* flag indicating the existence of the pin of a net
		   on the left or right side of col */
    int numcross = 0;

    S_resetmarked();

    for( i = 1; i <= num_nets; i++ )
    {
	if( (cpin = net_array[i].pin) == 0 )
    continue;

	xleft = xright = cpin->x;
	for( cpin = cpin->next; cpin != 0; cpin = cpin->next )
	{
	    xleft = MIN( xleft, cpin->x );
	    xright = MAX( xright, cpin->x );

	    /* if a pin is on the col on hlayer, add the net */
	    if( cpin->x == col && cpin->layer == HORIZ )
	    {
		/* fake */
		xleft = 1;
		xright = num_cols;
	    }
	}
	/*  See if right or left nets  */
	if( net_array[i].left == YES )
	    xleft = 1;
	if( net_array[i].right == YES )
	    xright = num_cols;

	if( xleft <= col && xright >= col && xright - xleft > 1 )
	{
		net_array[i].marked = YES;
		numcross++;
	}
    }
    return( numcross );
}


S_findtracks( col, starttrp )
int col;
int *starttrp;
/*
 *  find the number of available tracks at x = col
 *  First implementation is for CONVEX channels
 */
{
    LINKPTR bound;
    int mintr;  /* first available track */
    int j;

    mintr = 0;
    for( bound = bounding_box; bound != 0; bound = bound->netnext )
    {
	if( MIN(bound->x1, bound->x2) <= col &&
	    MAX(bound->x1, bound->x2) >= col )
	{
	    if( bound->x1 < bound->x2 )
	    {
    		/*  If non-convex routing area, no pseudo pins.  */
		if( mintr != 0 )
    		    return( 0 );
		mintr = bound->y1;
		break;
	    }
	}
    }

    while( (hlayer[mintr][col] > num_nets || vlayer[mintr][col] > num_nets) &&
	mintr < num_rows )
	mintr++;

    *starttrp = mintr;

    for( j = mintr; ; j++ )
    {
	if( hlayer[j][col] > num_nets || vlayer[j][col] > num_nets ||
	    j >= num_rows )
            break;
    }
    return( j - mintr );
}


S_addpins( cross, col, starttr, pintype )
int cross[];
int col,
    starttr;
int pintype;
{
    PINPTR newpin;
    int i;
    int index = 0;
    PINPTR S_getpin();

    /* correct track is ( cross[index] + starttr - 1 ) */
    starttr--;

    for( i = 1; i <= num_nets; i++ )
    {
	if( net_array[i].marked == NO )
    continue;
	
	index++;
	newpin = S_getpin();
	newpin->type = pintype;
	newpin->x = col;
	newpin->y = cross[index] + starttr;
	newpin->layer = HORIZ;
        newpin->next = net_array[i].pin;
	net_array[i].pin = newpin;
/*
printf("pin at %d %d for %d\n", newpin->x, newpin->y, number_to_name(i));
*/
        playerh[newpin->y][newpin->x] = i;
    }
}


int S_maplevels()
/*
 *  map levels ( 1 to maxlevel to 1 to n )
 */
{
    int fromtop;
    int frombot;
    int i;
    int maxlevel = 0;  /* max number of level */

    for( i = 1; i <= num_nets; i++ )
	maxlevel = MAX( maxlevel, net_array[i].level_from_top );

    if( lftop == 0 )
    {
        lftop = S_allocatevector( num_nets );
        lfbot = S_allocatevector( num_nets );
    }
    else
    {
	for( i = 1; i <= num_nets; i++ )
	    lftop[i] = lfbot[i] = 0;
    }

    for( i = 1; i <= num_nets; i++ )
    {
	if( net_array[i].marked == NO )
    continue;
	fromtop = net_array[i].level_from_top;
	frombot = net_array[i].level_from_bottom;
	lftop[fromtop] = 1;
	lfbot[frombot] = 1;
    }
    for( i = 2; i <= maxlevel; i++ )
    {
	lftop[i] += lftop[i-1];
	lfbot[i] += lfbot[i-1];
    }
    return( maxlevel );
}


S_setcosts( cost, distacc, starttr, m, n, maxlevel, fromcol, tocol, col )
int **cost;
int *distacc;
int starttr,
    m,
    n;
int maxlevel;
int fromcol,
    tocol,
    col;
/*
 *  fill the cost matrix
 *  try not to assign any pins on the first and last two tracks
 *  by giving high cost.
 */
{
    PINPTR cpin;
    int lateraldist,
        slope,
	track;
    int toplevel,
	botlevel;  /* top/bot most track to avoid VCV  */
    int vcgslope;
    int ideal;
    int i;
    int j = 0;
    int k;
    int tmp;
    int tmpcol,
	row;

    /*  set parameter  */
    if( bkcycle )
        vcgslope = CYCVCGSLOPE;
    else
        vcgslope = VCGSLOPE;

    /*
     *  HIGH costs due to level graph
     */
    for( i = 1; i <= num_nets; i++ )
    {
	if( net_array[i].marked == NO )
    continue;
	j++;

        toplevel = lftop[net_array[i].level_from_top];
        botlevel = lftop[net_array[i].level_from_bottom];

	if( maxlevel > 1 )
	{
	    ideal = ((n - 1) * (net_array[i].level_from_top
	        - net_array[i].level_from_bottom + maxlevel)/2
	        + maxlevel - n)/(maxlevel - 1);
	}
	else
	    ideal = n/2;
	
        /* 1 to maxlevel is mapped on 1 to n */
	if( toplevel + botlevel <= n + 1 )
	{
	    slope = 5 * vcgslope/BIAS;

	    if( ideal < toplevel )
	        ideal = toplevel;
	    if( ideal > n + 1 - botlevel )
	        ideal = n + 1 - botlevel;

	    for( k = toplevel - 1; k >= 1; k-- )
	        cost[j][k] += slope;

	    for( k = 1; k < botlevel; k++ )
	        cost[j][n-k+1] += slope;

	}

	slope = vcgslope/BIAS;
	for( k = 1; k <= n; k++ )
	{
	    cost[j][k] += ABS(ideal - k) * slope;
	}

/*
printf("fromtop %2d from bot %2d net %2d\n",
	     net_array[i].level_from_top,
	     net_array[i].level_from_bottom, i );
printf("fromtop %2d from bot %2d net %2d\n",
	     toplevel, botlevel, i );
*/

	/* Not to use the topmost and botmost tracks */
	/* add HIGHSOLPE/BIAS */
        (cost[j][2]) += slope;
        (cost[j][n-1]) += slope;
	/* add two times HIGHSOLPE/BIAS */
	slope += slope;
        (cost[j][1]) += slope;
        (cost[j][n]) += slope;
    }


    if( bother == 0 )
	bother = S_allocatevector( num_rows );
    else
	for( k = 1; k <= num_rows; k++ )
	    bother[k] = 0;

    /*
     *  penalize horizontal violation - like channel routers
     *  fromcol != 1      => check leftward
     *  tocol != num_cols => check rightward
     *  If near the edges, it may be better to check in both dir.
     */

    if( fromcol != 1 )
    {
        for( k = 1; k <= n; k++ )
        {
	    row = starttr + k - 1;
	    for( tmpcol = col-1; tmpcol >= fromcol; tmpcol-- )
	    {
	        if( (tmp = hlayer[row][tmpcol]) != 0 )
		break;
	    }
	    if( tmp == 0 )
	        tmp = playerh[row][fromcol];
	    bother[k] = tmp;
        }
    }
    else if( tocol != num_cols )
    {
        for( k = 1; k <= n; k++ )
        {
	    row = starttr + k - 1;
	    for( tmpcol = col+1; tmpcol <= tocol; tmpcol++ )
	    {
	        if( (tmp = hlayer[row][tmpcol]) != 0 )
		break;
	    }
	    if( tmp == 0 )
	        tmp = playerh[row][fromcol];
	    bother[k] = tmp;
        }
    }
    /*
    printf("col = %d\n", col );
    for( k = 1; k <= n; k ++ )
	printf("%d bother %d\n", k, bother[k]);
    */

    /*
     *  MID and LOW costs due to distance
     */
    j = 0;
    for( i = 1; i <= num_nets; i++ )
    {
	if( net_array[i].marked == NO )
    continue;
	j++;
	for( cpin = net_array[i].pin; cpin != 0; cpin = cpin->next )
	{
	    /*  consider only the pins inside proper area */
	    if( cpin->x < fromcol || cpin->x > tocol )
	continue;

	    lateraldist = distacc[cpin->x];

	    if( cpin->layer == HORIZ &&
	        starttr <= cpin->y && cpin->y <= starttr + n - 1 )
	    {
		/* intersection : high slope */
		slope = HSLOPE/( BIAS + lateraldist);
	    }
	    else
	    {
		slope = VSLOPE/( BIAS + lateraldist);
	    }
	    for( k = 1; k <= n; k++ )
	    {
	    	track = starttr + k - 1;
		cost[j][k] = cost[j][k] + slope * ABS(track - cpin->y);
	    }
	}

        /*
         *  To avoid partial overlap, add cost
         */
	slope = 5 * vcgslope/ BIAS;
        if( fromcol != 1 && net_array[i].colleft > fromcol )
	{
	  for( k = 1; k <= n; k++ )
	  {
	    if( bother[k] > num_nets )
	    	    cost[j][k] += slope;
	    else if( bother[k] > 0 && net_array[bother[k]].marked == NO &&
		net_array[i].colleft <= net_array[bother[k]].colright )
	      cost[j][k] += slope;
	  }
	}
        else if( tocol != num_cols && net_array[i].colright < tocol )
	{
	  for( k = 1; k <= n; k++ )
	  {
	    if( bother[k] > num_nets )
	    	    cost[j][k] += slope;
	    else if( bother[k] > 0 && net_array[bother[k]].marked == NO &&
		net_array[i].colright >= net_array[bother[k]].colleft )
	      cost[j][k] += slope;
	  }
        }

	/*
	 *  if there is a pin on the col on HORIZ layer,
	 *  preassign the net on the track.
	 */
	if( (cpin = net_array[i].pin) == 0 )
    continue;
	for( cpin = cpin->next; cpin != 0; cpin = cpin->next )
	{
	    if( cpin->x == col && cpin->layer == HORIZ )
	    {
		/* penalize using k-th col except net i (j)  */
	    	k = cpin->y - starttr + 1;
		for( tmp = 1; tmp < j; tmp++ )
		    cost[tmp][k] += PREASSIGN;
		for( tmp = j+1; tmp <= m; tmp++ )
		    cost[tmp][k] += PREASSIGN;
	    }
	}
    }
}


S_addedges(col)
int col;
/*
 *  insert edges to VCG to represent new constraints due to new pins
 */
{
    int lowernet;
    int uppernet;
    int row;
    /*
     *  insert graph edges caused by pins on hlayer
     */
	lowernet = 0;
	uppernet = 0;

	for( row = 1; row <= num_rows; row++ )
	{
	    /* if outside of channel, reset */
	    if( hlayer[row][col] > num_nets )
	    {
		lowernet = 0;
		uppernet = 0;
	    }
	    if( playerh[row][col] > 0 )
	    {
		if( uppernet != 0 )
		{
		    lowernet = playerh[row][col];
	            insert_edge (uppernet, lowernet, num_nets, col);
		    uppernet = lowernet;
		}
		else
		    uppernet = playerh[row][col];
	    }
	}
}


S_rmpins()
/*
 *  Before metal maximization, remove pseudo pins
 */
{
    PINPTR cpin;
    PINPTR ppin;
    int i;

    for( i = 1; i <= num_nets; i++ )
    {
    	while( (cpin = net_array[i].pin) != 0 && cpin->type == TEMP )
    	{
	    net_array[i].pin = cpin->next;

	    if( cpin->layer == HORIZ )
		playerh[cpin->y][cpin->x] = 0;
	    else
		playerv[cpin->y][cpin->x] = 0;
	    S_retpin( cpin );
	}

if( net_array[i].pin == 0 )
    printf("WARNING : i = %d net = %d has no fixed pin\n", i, number_to_name(i));
if( net_array[i].pin == 0 )
    continue;
	ppin = net_array[i].pin;

        for( cpin = ppin->next; cpin != 0;
	     cpin = cpin->next )
	{
	    if( cpin->type == TEMP )
	    {
		ppin->next = cpin->next;

	        if( cpin->layer == HORIZ )
		    playerh[cpin->y][cpin->x] = 0;
	        else
		    playerv[cpin->y][cpin->x] = 0;

    printf("tmppin rmed at (%d, %d)\n", cpin->x, cpin->y);
		S_retpin( cpin );
		cpin = ppin;
	    }
	    else
	        ppin = cpin;
	}
    }
}

S_rmsidepins(i, row, col)
int i; /* net */
/*
 *  same as S_rmpins, but for only one net
 *  rm except the one at row
 *  mark as X after removal of pins
 */
{
    PINPTR cpin;
    PINPTR ppin;

    	while( (cpin = net_array[i].pin) != 0 && cpin->type == TEMP &&
	    cpin->x == col && cpin->y != row )
    	{
	    net_array[i].pin = cpin->next;

	    if( cpin->layer == HORIZ )
		playerh[cpin->y][cpin->x] = 0;
	    else
		playerv[cpin->y][cpin->x] = 0;

	    hlayer[cpin->y][cpin->x] = num_nets+1;

	    S_retpin( cpin );
	}

if( net_array[i].pin == 0 )
    printf("WARNING : i = %d net = %d has no fixed pin\n", i, number_to_name(i));
if( net_array[i].pin == 0 )
    return;

	ppin = net_array[i].pin;

        for( cpin = ppin->next; cpin != 0;
	     cpin = cpin->next )
	{
	    if( cpin->type == TEMP && cpin->x == col && cpin->y != row )
	    {
		ppin->next = cpin->next;

	        if( cpin->layer == HORIZ )
		    playerh[cpin->y][cpin->x] = 0;
	        else
		    playerv[cpin->y][cpin->x] = 0;

	        hlayer[cpin->y][cpin->x] = num_nets+1;

		S_retpin( cpin );
		cpin = ppin;
	    }
	    else
	        ppin = cpin;
	}
}
