#include "mighty.h"
#define OUTCOST 1000

extern int HCOST1;
extern int VCOST1;

extern int HCOST2;
extern int VCOST2;
extern int SWCOST;

extern int LIMCOST;
extern int LOWLIMIT;
extern int HIGHLIMIT;
extern int LEFTLIMIT;
extern int RIGHTLIMIT;

extern int left_start;
extern int left_numtr;
extern int right_start;
extern int right_numtr;

void S_postend();

void
S_maxmetal()
/*
 *  maximize metal
 */
{
    LINKPTR tmplink;
    int i;  /* counter */
    int net,
	diff;
    int status;

    LIMCOST = 3000;

    HCOST1 = 6;
    VCOST1 = 10;

    HCOST2 = 12;
    VCOST2 = 8;
    SWCOST = 30;

    for( i = 1; i <= num_nets; i++ )
    {
        net_array[i].difficulty = 0;
	for( tmplink = net_array[i].path; tmplink != NULL; tmplink = tmplink->netnext )
            net_array[i].difficulty += tmplink->x2 - tmplink->x1 +
				tmplink->y2 - tmplink->y1;
        if( net_array[i].left == YES )
            net_array[i].difficulty += OUTCOST;
        if( net_array[i].right == YES )
            net_array[i].difficulty += OUTCOST;
    }

    for( ; ; )
    {
	diff = 0;
        for( i = 1; i <= num_nets; i++ )
        {
    	    if( diff < net_array[i].difficulty )
	    {
		net = i;
		diff = net_array[i].difficulty;
	    }
	}
	if( diff == 0 )
	    break;

	net_array[net].difficulty = 0;

	while( (tmplink = net_array[net].path) != NULL )
	{
	    S_writelink( tmplink, 0 );
	    S_dellink( tmplink );
	}
	/*
	 *  left/right pins
	 */
	if( net_array[net].left == YES )
	    S_poststart( net, LEFT );
	if( net_array[net].right == YES )
	    S_poststart( net, RIGHT );

	while( S_findcomponents( net ) > 1 )
	{
            if ( (status = S_findpath( net, YES )) == YES )
	    {
		if( net_array[net].left == YES )
	    	    S_postend( net, LEFT );
		if( net_array[net].right == YES )
	    	    S_postend( net, RIGHT );

		if( S_trytmppath( net ) == NO )
		{
S_dumppath( net );
print_debug ("routed", "horiz", channel->horiz_layer, num_rows, num_cols, num_nets);
print_debug ("routed", "vert", channel->vert_layer, num_rows, num_cols, num_nets);
		    exit( 5 );
		}
	    }
	    else if (status == NO)
	    {
		S_findpath( net, NO );
	        printf("findpath not possible - metal maximization %D\n", net);
		S_debugdumpsched();
	        exit( 10 );
	    }
	}
    }
}

S_poststart( net, side )
int net;
int side;
/*
 *  add pins on all available left/right column
 */
{
    int r;
    int c;
    PINPTR newpin;
    int start;
    int stop;
    PINPTR S_getpin();

    if( side == LEFT )
    {
	c = 1;
	start = left_start;
	stop = left_start + left_numtr - 1;
    }
    else
    {
	c = num_cols;
	start = right_start;
	stop = right_start + right_numtr - 1;
    }

    for( r = start; r <= stop; r++ )
    {
	if( hlayer[r][c] == 0 || hlayer[r][c] > num_nets )
	{
	    newpin = S_getpin();
	    newpin->type = TEMP;
	    newpin->x = c;
	    newpin->y = r;
	    newpin->layer = HORIZ;
            newpin->next = net_array[net].pin;
	    net_array[net].pin = newpin;
/*
printf("pin at %d %d for %d\n", newpin->x, newpin->y, number_to_name(i));
*/
            playerh[r][c] = net;
            hlayer[r][c] = net;
	    /*
	    if( playerh[r-1][c] == net )
	    {
		S_addlink(HORIZ, c, r-1, c, r, net);
	    }
	    else if( playerh[r+1][c] != 0 && playerh[r+1][c] <= num_nets )
	    {
		S_addlink(HORIZ, c, r, c, r, net);
	    }
	    */
	}
    }
    if( S_trytmppath(net) == NO )
	exit( 4 );
}

static void
S_postend( net, side )
int net;
int side;
{
LINKPTR tmplink;
LINKPTR plink;
int row;
int col;

    if( side == LEFT )
	col = 1;
    else
	col = num_cols;

    for( tmplink = net_array[net].tmplist; tmplink != NULL;
	tmplink = tmplink->netnext )
    {
	if( (tmplink->x1 == col && tmplink->x2 != col) ||
	    (tmplink->x2 == col && tmplink->x1 != col) )
	{
    break;
	}
    }
    if( tmplink == NULL )
	return;
    else
	row = tmplink->y1;
    
    /*
     *  rm TEMP pins
     */
    S_rmsidepins( net, row, col );
    /*
    S_dumppath(net);
    S_dumppins(net);
    */

    /*
     *  rm connection on col
     */
    for( tmplink = net_array[net].path; tmplink != NULL;
	tmplink = tmplink->netnext )
    {
SLOOP:
	if( tmplink->x1 == col && tmplink->x2 == col )
	{
	    if( tmplink == net_array[net].path )
	    {
		net_array[net].path = tmplink->netnext;
		S_retlink( tmplink );
		tmplink = net_array[net].path;
	    }
	    else
	    {
	        plink->netnext = tmplink->netnext;
	        S_retlink( tmplink );
	        tmplink = plink->netnext;
	    }
	    if( tmplink != NULL )
	        goto SLOOP;
	    else
		break;
	}
	plink = tmplink;
    }
    return;
}
