#include "mighty.h"

#define PRIORSENS 10  /* priority of sensitive nets */
int NUMGOOD = 5;
int conncount = 0;
int debcount = 2;
extern int LIMCOLS;
extern int Densityonly;
int addguide = NO;
int Longch = NO;
int num_impr = 0;
int num_power = 0;

int HCOST1 = 2;
int VCOST1 = 2;

int HCOST2 = 50;
int VCOST2 = 50;

int SWCOST = 30;

int LIMCOST = 500;  /* path length <= 2 * LIMCOST */
int MODCOST = 55;

SCHED_PTR schedhead;

/*ARGSUSED*/
void S_route( net_array, channel, num_nets )
NETPTR net_array;
CHANNELPTR channel;
int num_nets;
{
    int status; /*  YES, NO, or DONE */
    int job;    /*  net_number currently being connected  */
    int numcomp,
	numfloat; /* number of floating links */
    int i;     	/*  counter  */

    schedhead = 0;

    S_markpinlayer();

    /*
     *  If Densityonly, return modified maximum density.
     */
    if( Densityonly )
    {
	(void) S_retdensity();
	/* XXX what the hell? */
	exit( 0 );
    }

    /*
     *  if channel is too long, add pseudo pins
     *  ( later, when channel is irregular )
     */
    if( num_cols > LIMCOLS/2 && num_pins > 10 )
	Longch = YES;

    if( Longch || num_left > 0 || num_right > 0 )
    {
	addguide = YES;
	S_addguides();
        S_markpinlayer();
    }

    /*
     *  classify equivalent set of pins
     */
    for( i = 1; i <= num_nets; i++ )
        S_equivpins( i );

    for( i = 1; i <= num_nets; i++ )
    {
	if( S_findcomponents( i ) > 1 )
	{
            if ( (status = S_findpath( i, YES )) == YES )
	    {
                numfloat = S_schedpriority( i );
	        S_schedule( i, net_array[i].cost );
	    }
	    else if (status == NO)
	    {
/*
print_debug ("after preroute", "horiz", channel->horiz_layer, num_rows, num_cols, num_nets);
print_debug ("after preroute", "vert", channel->vert_layer, num_rows, num_cols, num_nets);
*/
	        printf("findpath not possible - not DONE\n");
		S_debugdumpsched();
	        exit( 8 );
	    }
	}
    }
    while( (job = S_popschedule()) != 0 )
    {
/*
print_debug ("route", "horiz", channel->horiz_layer, num_rows, num_cols, num_nets);
print_debug ("route", "vert", channel->vert_layer, num_rows, num_cols, num_nets);
printf("popsched net %d\n", job );
*/
	if( S_trytmppath( job ) )
	{
	    S_clearhistory( job );
/*
	    conncount++;
	    if( debcount == conncount )
	    {
		return;
	    }
*/
	}
	if ( (numcomp = S_findcomponents( job )) > 1 )
	{
            if( (status = S_findpath( job, YES )) == YES )
	    {
                numfloat = S_schedpriority( job );
/*
printf("job %d : numfloat = %d\n", job, numfloat);
*/
	    }
	    /*
	     *  if not near optimal, reroute other nets
	     */
	    if( status == NO || numfloat >= NUMGOOD )
	    {
	        status = S_improve( job, status );
		num_impr++;
	    }
	    if( status == YES ) /* path found */
		S_schedule( job, net_array[job].cost );
	    else
	    {
		num_power++;
		if( S_powerimprove( job ) == NO )
		{
	     	    printf("findpath2 not possible - must reroute %d\n", job);
		    S_debugdumpsched();
	            exit( 8 );
		}
	    }
	}
    }
    printf("nummod = %d    numpower = %d\n", num_impr, num_power );
}

/*
 *  schedule the jobs in the order of priority to connect them
 */
S_schedule( i, value )
int i;  /* net number */
int value; /* priority */
{
    SCHED_PTR tmpq;
    SCHED_PTR prevq = 0;
    SCHED_PTR newsched;
    SCHED_PTR S_getschedq();

    newsched = S_getschedq();
    newsched->net = i;    /* net_num */

    /* if sensitive net, give priority  */
    if( net_array[i].sens == YES )
	value = value/PRIORSENS;

    newsched->priority = value;
/*
printf("*** net %d with priority %d\n", i, newsched->priority );
*/
    if( schedhead == 0 )
    {
	newsched->next = 0;
	schedhead = newsched;
	return;
    }
    for( tmpq = schedhead; tmpq != 0; tmpq = tmpq->next )
    {
	if( newsched->priority <= tmpq->priority )
	    break;
	prevq = tmpq;
    }
    if( prevq == 0 )
    {
	/*  insert before schedhead  */
        newsched->next = schedhead;
	schedhead = newsched;
    }
    else
    {
	/*  insert after prevq  */
        newsched->next = prevq->next;
	prevq->next = newsched;
    }
}

/*
 *  returns the first netnum
 *  if 0 return 0
 */
S_popschedule()
{
    SCHED_PTR tmpq;
    int net;  /* the net_num to be returned */

    if( schedhead == 0 )
	return( 0 );
    net = schedhead->net;
    tmpq = schedhead;
    schedhead = schedhead->next;
    S_retschedq ( tmpq );
/*
printf("   popschedule %d ***\n", net );
*/
    return( net );
}


S_debugdumpsched()
{
    SCHED_PTR tmpq;
    int count = 0;

    if( schedhead == 0 )
    {
	printf("dump sched : 0\n");
	return;
    }
    while( schedhead != 0 )
    {
	printf("dump sched %d : net=%d, cost=%d\n", ++count,
		schedhead->net, schedhead->priority);
        tmpq = schedhead;
        schedhead = schedhead->next;
        S_retschedq ( tmpq );
    }
}


/*
 *  find numfloat in net.tmplist
 */
int S_schedpriority( net )
int net;
{
    LINKPTR tmplk;
    int numdiv = 0;
    int numfloat = 0;

    /*
     *  count each type of links
     */
    for( tmplk = net_array[net].tmplist; tmplk != 0; tmplk = tmplk->netnext )
    {
	if( tmplk->layer == 0 )
	    numdiv++;
	else if( playerh[tmplk->y1][tmplk->x1] != net &&
		 playerv[tmplk->y1][tmplk->x1] != net &&
	 	 playerh[tmplk->y2][tmplk->x2] != net &&
	 	 playerv[tmplk->y2][tmplk->x2] != net )
	    numfloat++;
    }
    return( numfloat );
}

S_markpinlayer()
/*
 *  Mark the location of pins on player
 */
{
    PINPTR ppin;
    int i;

    for( i = 1; i <= num_nets; i++ )
    {
	for( ppin = net_array[i].pin; ppin != 0; ppin = ppin->next )
	{
	    if( ppin->layer == HORIZ )
	    {
	        playerh[ppin->y][ppin->x] = i;
	        hlayer[ppin->y][ppin->x] = i;
	    }
	    if( ppin->layer == VERT )
	    {
	        playerv[ppin->y][ppin->x] = i;
	        vlayer[ppin->y][ppin->x] = i;
	    }
	}
    }
}

