#include "header.h"
#include "copyright.h"
#include "port.h"

/*******************************************************************/

make_buckets()
{
FREE[PART_A] = new_bucket();
LOCKED[PART_A] = new_bucket();
FREE[PART_B] = new_bucket();
LOCKED[PART_B] = new_bucket();
}

/*******************************************************************/

free_all_buckets()
{
free_bucket(FREE[PART_A]);
free_bucket(LOCKED[PART_A]);
free_bucket(FREE[PART_B]);
free_bucket(LOCKED[PART_B]);
}

/*******************************************************************/

pbucket new_bucket()
{
register pbucket bucket;
register int i;

bucket = CALLOC(1,struct bucket);
bucket->global_max = -1;
bucket->cells = CALLOC(2 * P + 1,pcell);
for(i = 0;i <= (P*2);i++)
  bucket->cells[i] = NULL;
bucket->num = 0;
return(bucket);
}

/*******************************************************************/

free_bucket(bucket)
pbucket bucket;
{
FREE_MEM(P*2 + 1,bucket->cells,pcell);
FREE_MEM(1,bucket,struct bucket);
}

/*************************************************************************/

delete_from_bucket(cell)
register pcell cell;
{
register pbucket bucket;
register int addr;

bucket = cell->bucket;
cell->bucket = NULL;

addr = cell->gain + P;
bucket->num --;;
	

if(cell->bucket_prev == NULL)
  {
    if(bucket->num > 0)
      {
	if((addr == bucket->global_max) && (bucket->cells[addr]->bucket_next == NULL))
	  {
	    do
	      {
		bucket->global_max--;
	      }
	    while(bucket->cells[bucket->global_max] == NULL);
	    if(bucket->global_max < 0)
	      printf("bucket delete error\n");
	  }
      }
    else
      bucket->global_max = 0;

    bucket->cells[addr] = cell->bucket_next;
  }
else
  cell->bucket_prev->bucket_next = cell->bucket_next;

if(cell->bucket_next != NULL)
  cell->bucket_next->bucket_prev = cell->bucket_prev;
}
   
/*************************************************************************/

insert_in_bucket(bucket,cell)
register pbucket bucket;
register pcell cell;
{
register int addr;

addr = cell->gain + P;
if(addr > bucket->global_max)
  bucket->global_max = addr;

bucket->num ++;
cell->bucket = bucket;
cell->bucket_next = bucket->cells[addr];
cell->bucket_prev = NULL;

if(cell->bucket_next != NULL)
  cell->bucket_next->bucket_prev = cell;
bucket->cells[addr] = cell;
}

/*************************************************************************/

get_cells_from_bucket(buc,cell,num)
pbucket buc;
pcell *cell;
int *num;
{
register pcell a,b;
register int a_cnt,size;

a = NULL;
a_cnt = 0;
size = buc->num;
while((b = get_max_cell(buc)) != NULL)
  {
    remove_from_bucket(b);
    b->next = a;
    a = b;
    a_cnt++;
  }
(*cell) = a;
(*num) = a_cnt;
return(size);
}

/*************************************************************************/

set_glob_max(bucket,addr)
register pbucket bucket;
register int addr;
{

if(bucket->num > 0)
  {
    if((addr == bucket->global_max) && (bucket->cells[addr]->bucket_next == NULL) && (bucket->cells[addr]->bucket_prev == NULL))
      {
	do
	  {
	    bucket->global_max--;
	  }
	while(bucket->cells[bucket->global_max] == NULL);
	if(bucket->global_max < 0)
	  printf("bucket delete error\n");
      }
  }
else
  bucket->global_max = 0;
}


