#include "copyright.h"
#include "port.h"

#include "oct.h"
#include "st.h"
#include "header.h"
#include "region.h"
#include "tap.h"
#define OCT_TO_LAMBDA 20

extern pnet DEAD_NETS;
extern pbucket FREE[2];
extern char *TECH_DIR;
ppathList new_pathList();
extern pcell FIXED_MET1,FIXED_MET2;
extern octObject *getMaster();
extern char *oct_find_str_prop();

fix_paths()
{
pcell met1,met2;
int cnt;

get_cells_from_bucket(FREE[PART_A],&met1,&cnt);
get_cells_from_bucket(FREE[PART_B],&met2,&cnt);

fix_all_paths(met1, LAYER1, LAYER2);
fix_all_paths(met2, LAYER2, LAYER1);
fix_all_paths(FIXED_MET1, LAYER1, LAYER2);
fix_all_paths(FIXED_MET2, LAYER2, LAYER1);
}

inst_has_prop_value(inst,prop_name,str)
octObject *inst;
char *prop_name;
char *str;
{
if(oct_str_prop_exist(inst,prop_name) == TRUE)
  if(strcmp(str,oct_find_str_prop(inst,prop_name)) == 0)
    return(TRUE);
return(FALSE);
} 

oct_str_prop_exist(obj,prop_name)
octObject *obj;
char *prop_name;
{
octGenerator p_gen;
octObject prop;
octStatus stat;

octInitGenContents(obj,OCT_PROP_MASK,&p_gen);
while(((stat = octGenerate(&p_gen,&prop)) == OCT_OK) && (strcmp(prop.contents.prop.name,prop_name) != 0))
  {}
if(stat != OCT_OK)
  {
    return(FALSE);
  }
return(TRUE);
}

fix_vias()
{
octObject bag,inst,term,path,new_inst,new_term,new_bag;
octGenerator inst_gen,path_gen;
int lay,l;
int found;
int via_needed;
int num, made;
ppathList pl,pl2;
struct octPoint p[2];
int cnt;
int abort;

init_masters();
pl = NULL;
made = num = 0;
new_bag.type = OCT_BAG;
new_bag.contents.bag.name = "NEW_CONNECTORS";
OCTCHKOK(octCreate(&network,&new_bag));
bag.type = OCT_BAG;
bag.contents.bag.name = "CONNECTORS";
OCTCHKOK(octGetByName(&network,&bag));
OCTCHKOK(octInitGenContents(&bag,OCT_INSTANCE_MASK,&inst_gen));
while(octGenerate(&inst_gen,&inst) == OCT_OK)
  {
    OCTCHKOK(octGenFirstContent(&inst,OCT_TERM_MASK,&term));
    if(term_is_formal(&term) == TRUE)
      continue;
    found = FALSE;
    via_needed = FALSE;

    OCTCHKOK(octInitGenContainers(&term,OCT_PATH_MASK,&path_gen));
    OCTCHKOK(octGenerate(&path_gen,&path));
    pl = new_pathList();
    pl->id = path.objectId;
    lay = path_layer(&path);
    if(lay == OTHER_LAYER)
      {
	free_pathList(pl);
	continue;
      }
    cnt = 1;
    abort = FALSE;
    while(octGenerate(&path_gen,&path) == OCT_OK)
      {
	found = TRUE;
	if(lay != (l = path_layer(&path)))
	  via_needed = TRUE;
	if(l == OTHER_LAYER)
	  abort = TRUE;
	pl2 = new_pathList();
	pl2->id = path.objectId;
	pl2->next = pl;
	pl = pl2;
	cnt++;
      }
    if(abort == TRUE)
      {
	free_pathList(pl);
	continue;
      }
    if(found == FALSE)
      {
	get_path2(&path,p);
	printf("(MIZER): WARNING only one path on via at %d %d %d %d\n",p[0].x,p[0].y,p[1].x,p[1].y);
      }
    if(via_needed == TRUE)
      {
	num++;
      }
    made++;
    createOctVia(&new_bag,pl,
		 inst.contents.instance.transform.translation.x,
		 inst.contents.instance.transform.translation.y,&new_inst);
    OCTCHKOK(octGenFirstContent(&new_inst,OCT_TERM_MASK,&new_term));
    while(pl != NULL)
      {
	path.objectId = pl->id;
	OCTCHKOK(octGetById(&path));
	OCTCHKOK(octDetach(&path,&term));
	OCTCHKOK(octAttach(&path,&new_term));
	pl2 = pl;
	pl = pl->next;
	FREE_MEM(1, pl2, struct pathList);	
      }
    OCTCHKOK(octDelete(&inst));
    abutt_paths(&new_term);
  }
OCTCHKOK(octInitGenContents(&new_bag,OCT_INSTANCE_MASK,&inst_gen));
while(octGenerate(&inst_gen,&inst) == OCT_OK)
  {
    OCTCHKOK(octDetach(&new_bag,&inst));
    OCTCHKOK(octAttach(&bag,&inst));
  }
OCTCHKOK(octDelete(&new_bag));
free_masters();
}

path_layer(path)
octObject *path;
{
octObject layer;

OCTCHKOK(octGenFirstContainer(path,OCT_LAYER_MASK,&layer));
return(which_layer(&layer));
}

createOctVia(connBag,paths,x,y,inst)
    ppathList paths;
    octObject *connBag;
    int x,y;
    octObject *inst;
{
    ppathList pl;
    struct octPoint p[2];
    octObject path;
    tapLayerListElement *layerlist;
    octStatus stat;
    int i;
    int num_subnets;
    static int via_cnt = 0;
    char str[32];

    num_subnets = 0;
    for(pl = paths;pl != NULL;pl = pl->next)
      num_subnets++;

    layerlist = CALLOC(num_subnets, tapLayerListElement);
    i = 0;
    for(pl = paths;pl != NULL;pl = pl->next, i++)
      {
	  path.objectId = pl->id;
	  OCTCHKOK(octGetById(&path));
	  OCTCHKOK(octGenFirstContainer(&path, OCT_LAYER_MASK, &(layerlist[i].layer)));
	  layerlist[i].width = path.contents.path.width;
	  get_path2(&path,p);
	  if(direction(p) == HOR)
	    layerlist[i].direction = TAP_HORIZONTAL;
	  else
	    layerlist[i].direction = TAP_VERTICAL;
      }
    if((stat = tapGetConnector(num_subnets,layerlist,inst)) != OCT_OK) {
	(void) printf("(tap_stuff): ERROR in getting connector-- status %d\n");
	exit(9);
    }

    FREE_MEM(num_subnets, layerlist, tapLayerListElement);
    (void) sprintf(str,"via.%d",via_cnt++);
    inst->contents.instance.name = str;
    inst->contents.instance.transform.translation.x = x;
    inst->contents.instance.transform.translation.y = y;
    OCTCHKOK(octCreate(&network, inst));    
    OCTCHKOK(octAttach(connBag,inst));
}


abutt_paths(term)
octObject *term;
{
octObject path,inst;
octGenerator gen;
struct octBox box;
struct octPoint p[2];

OCTCHKOK(octGenFirstContainer(term, OCT_INSTANCE_MASK, &inst));
OCTCHKOK(octBB(&inst,&box));
OCTCHKOK(octInitGenContainers(term,OCT_PATH_MASK,&gen));
while(octGenerate(&gen,&path) == OCT_OK)
  {
    get_path2(&path,p);
    if(direction(p) == HOR)
      {
	if((MAX(p[0].x,p[1].x) <= box.upperRight.x) &&
	   (MIN(p[0].x,p[1].x) < box.upperRight.x))
	  {
	    if(MAX(p[0].x,p[1].x) < box.lowerLeft.x)
	      {
#ifndef QUIET
		printf("streatching path at %d %d %d %d to %d\n",p[0].x,p[0].y,p[1].x,p[1].y,box.lowerLeft.x);
#endif
		if(p[0].x > p[1].x)
		  p[0].x = box.lowerLeft.x;
		else
		  p[1].x = box.lowerLeft.x;
		if(p[0].x == p[1].x)
		  p[1].x++;
		OCTCHKOK(octPutPoints(&path,2,p));
		OCTCHKOK(octModify(&path));
	      }
	  }
	else
	  {
	    if(MIN(p[0].x,p[1].x) > box.upperRight.x)
	      {
#ifndef QUIET
		printf("streatching path at %d %d %d %d to %d\n",p[0].x,p[0].y,p[1].x,p[1].y,box.upperRight.x);
#endif
		if(p[0].x < p[1].x)
		  p[0].x = box.upperRight.x;
		else
		  p[1].x = box.upperRight.x;
		if(p[0].x == p[1].x)
		  p[1].x++;
		OCTCHKOK(octPutPoints(&path,2,p));
		OCTCHKOK(octModify(&path));
	      }
	  }
      }
    else
      {
	if((MAX(p[0].y,p[1].y) <= box.upperRight.y) &&
	   (MIN(p[0].y,p[1].y) < box.upperRight.y))
	  {
	    if(MAX(p[0].y,p[1].y) < box.lowerLeft.y)
	      {
#ifndef QUIET
		printf("streatching path at %d %d %d %d to %d\n",p[0].x,p[0].y,p[1].x,p[1].y,box.lowerLeft.y);		
#endif
		if(p[0].y > p[1].y)
		  p[0].y = box.lowerLeft.y;
		else
		  p[1].y = box.lowerLeft.y;
		if(p[0].y == p[1].y)
		  p[1].y++;
		OCTCHKOK(octPutPoints(&path,2,p));
		OCTCHKOK(octModify(&path));
	      }
	  }
	else
	  {
	    if(MIN(p[0].y,p[1].y) > box.upperRight.y)
	      {
#ifndef QUIET
		printf("streatching path at %d %d %d %d to %d\n",p[0].x,p[0].y,p[1].x,p[1].y,box.upperRight.y);
#endif
		if(p[0].y < p[1].y)
		  p[0].y = box.upperRight.y;
		else
		  p[1].y = box.upperRight.y;
		if(p[0].y == p[1].y)
		  p[1].y++;
		OCTCHKOK(octPutPoints(&path,2,p));
		OCTCHKOK(octModify(&path));
	      }
	  }
      }    
  }
}

check_all_paths()
{
octObject net,path,term1,term2;
octGenerator net_gen, path_gen,term_gen;
struct octPoint p[2];
struct octBox box1,box2;

OCTCHKOK(octInitGenContents(&network,OCT_NET_MASK,&net_gen));
while(octGenerate(&net_gen,&net) == OCT_OK)
  {
    OCTCHKOK(octInitGenContents(&net,OCT_PATH_MASK,&path_gen));
    while(octGenerate(&path_gen,&path) == OCT_OK)
      {
	get_path2(&path,p);
	OCTCHKOK(octInitGenContents(&path,OCT_TERM_MASK,&term_gen));
	OCTCHKOK(octGenerate(&term_gen,&term1));
	if(octGenerate(&term_gen,&term2) != OCT_OK)
	  {
	    printf("WARNING - PATH found with only one terminal at %d %d %d %d\n",p[0].x,p[0].y,p[1].x,p[1].y);
	    continue;
	  }
	if(regFindImpl(&term1,&box1) != REG_OK)
	  {
	    printf("ERROR in finding reg box\n");
	    quit();
	  }
	if(regFindImpl(&term2,&box2) != REG_OK)
	  {
	    printf("ERROR in finding reg box\n");
	    quit();
	  }

	if(direction(p) == HOR)
	  {
	    if(in_box_hor(p[0].x,&box1) == TRUE)
	      {
		if(in_box_hor(p[1].x,&box2) == FALSE)
		  {
		    adjust_path_hor(&path,p,1,&box2);
		  }
	      }
	    else
	      {
		if(in_box_hor(p[0].x,&box2) == TRUE)
		  {
		    if(in_box_hor(p[1].x,&box1) == FALSE)
		      {
			adjust_path_hor(&path,p,1,&box1);
		      }
		  }
		else
		  {
		    if(in_box_hor(p[1].x,&box1) == TRUE)
		      {
			adjust_path_hor(&path,p,0,&box2);
		      }
		    else
		      {
			if(in_box_hor(p[1].x,&box2) == TRUE)
			  {
			    adjust_path_hor(&path,p,0,&box1);
			  }
			else
			  {
			    adjust_path_hor(&path,p,0,&box1);
			    adjust_path_hor(&path,p,1,&box2);
			  }
		      }
		  }
	      }
	  }
	else
	  {
	    if(in_box_ver(p[0].y,&box1) == TRUE)
	      {
		if(in_box_ver(p[1].y,&box2) == FALSE)
		  {
		    adjust_path_ver(&path,p,1,&box2);
		  }
	      }
	    else
	      {
		if(in_box_ver(p[0].y,&box2) == TRUE)
		  {
		    if(in_box_ver(p[1].y,&box1) == FALSE)
		      {
			adjust_path_ver(&path,p,1,&box1);
		      }
		  }
		else
		  {
		    if(in_box_ver(p[1].y,&box1) == TRUE)
		      {
			adjust_path_ver(&path,p,0,&box2);
		      }
		    else
		      {
			if(in_box_ver(p[1].y,&box2) == TRUE)
			  {
			    adjust_path_ver(&path,p,0,&box1);
			  }
			else
			  {
			    adjust_path_ver(&path,p,0,&box1);
			    adjust_path_ver(&path,p,1,&box2);
			  }
		      }
		  }
	      }
	  }
      }
  }
}

in_box_hor(x,box)
int x;
struct octBox *box;
{
  if((box->lowerLeft.x <= x) && (x <= box->upperRight.x))
    {
      return(TRUE);
    }
return(FALSE);
}

adjust_path_hor(path,p,num,box)
octObject *path;
int num;
struct octBox *box;
struct octPoint *p;
{

p[num].x = (box->upperRight.x + box->lowerLeft.x) / 2;
if(p[0].x == p[1].x)
  p[1].x++;
OCTCHKOK(octPutPoints(path,2,p));
OCTCHKOK(octModify(path));
}

in_box_ver(y,box)
int y;
struct octBox *box;
{
  if((box->lowerLeft.y <= y) && (y <= box->upperRight.y))
    {
      return(TRUE);
    }
return(FALSE);
}

adjust_path_ver(path,p,num,box)
octObject *path;
int num;
struct octBox *box;
struct octPoint *p;
{

p[num].y = (box->upperRight.y + box->lowerLeft.y) / 2;
if(p[0].y == p[1].y)
  p[1].y++;
OCTCHKOK(octPutPoints(path,2,p));
OCTCHKOK(octModify(path));
}

term_is_formal(term)
octObject *term;
{
octObject term2;

return((octGenFirstContainer(term, OCT_TERM_MASK, &term2) == OCT_OK)?TRUE:FALSE);
}    

count_vias()
{
octGenerator inst_gen, path_gen;
octObject bag,inst, path, term;
int vias;
int l1_found;
int l2_found;

vias = 0;
bag.type = OCT_BAG;
bag.contents.bag.name = "CONNECTORS";
OCTCHKOK(octGetByName(&network,&bag));
OCTCHKOK(octInitGenContents(&bag,OCT_INSTANCE_MASK,&inst_gen));
while(octGenerate(&inst_gen,&inst) == OCT_OK)
  {
    OCTCHKOK(octGenFirstContent(&inst, OCT_TERM_MASK, &term));
    OCTCHKOK(octInitGenContainers(&term,OCT_PATH_MASK,&path_gen));
    l1_found = l2_found = 0;

    while(octGenerate(&path_gen,&path) == OCT_OK)
      {
	l1_found |= (path_layer(&path) == LAYER1);
	l2_found |= (path_layer(&path) == LAYER2);
      }
    if((l1_found == 1) && (l2_found == 1))
      vias++;
  }
printf("%d\n",vias);
fflush(stdout);
}

fix_all_paths(list,layer_num, wrong_layer_num)
pcell list;
int layer_num, wrong_layer_num;
{
pcell cell,c2;
ppathList pl, pl2;
octObject path,layer;

for(cell = list;cell != NULL;)
  {
    pl = cell->paths;
    while(pl != NULL)
      {
	path.objectId = pl->id;
	pl2 = pl;
	pl = pl->next;
	FREE_MEM(1, pl2, struct pathList);
	OCTCHKOK(octGetById(&path));
	OCTCHKOK(octGenFirstContainer(&path,OCT_LAYER_MASK,&layer));
	if(octIdsEqual(layer.objectId, layers[wrong_layer_num].objectId))
	  {
	    if(path.contents.path.width == layer_width[wrong_layer_num])
	      {
		path.contents.path.width = layer_width[layer_num];
		OCTCHKOK(octModify(&path));
	      }
	    OCTCHKOK(octDetach(&layers[wrong_layer_num],&path));
	    OCTCHKOK(octAttach(&layers[layer_num],&path));
	  }
      }
    cell->paths = NULL;
    c2 = cell;
    cell = cell->next;
    if(c2->HLparent == TRUE)
      do_free_cell(c2);
  }
}

octId
print_net_number(id)
octId id;
{
pnet n;

for(n = NETS;n != NULL;n = n->next)
  if(n->OCTid == id)
    {
      printf("net %d cut\n",n->id);
      return(n->id);
    }
for(n = DEAD_NETS;n != NULL;n = n->next)
  if(n->OCTid == id)
    {
      printf("net %d cut\n",n->id);
      return(n->id);
    }
    return (oct_null_id);
}


free_pathList(pl)
ppathList pl;
{
ppathList pl2;

while(pl != NULL)
  {
    pl2 = pl;
    pl = pl->next;
    FREE_MEM(1, pl2, struct pathList);
  }
}
