#include "copyright.h"
#include "port.h"

#include "header.h"
#define INF 0x7fffffff
#define get_best_gain(buc) (buc->global_max)
pcell pick_candidate();
extern pcell FIXED_MET1,FIXED_MET2;

/*******************************************************************/

do_cut()
{
register int cut_size,new_cut,cnt;
pcell a,b,cell;

if(CELLS == NULL)
  return;
#ifndef QUIET
  printf("begin do_cut ");
#endif
clear_all_nets();
for(cnt = 0,cell = CELLS;cell != NULL;cell = cell->next,cnt++)
  {
    if(cell->fixed == TRUE)
      printf("cell in wrong list %d\n",cell->id);
  }
#ifdef CLUST
pre_cluster(&a,&b); 
#else
set_up_rand_partition(CELLS,&a,&b);
#endif
initialize_nets(a,b);
initialize_partition(a,b);
make_hard_links(a);
#ifndef QUIET
  printf("num of cells %d\n",NUM_OF_CELLS);
#endif
init_HL_cells();
cut_size = init_nets_cut();
CELLS = a;
for(cell = a;cell->next != NULL;cell = cell->next)
  {}
cell->next = b;

#ifndef QUIET
  printf("init cut size %d\n",cut_size);
#endif
while(cut_size > (new_cut = cut(cut_size)))
  {
    if(new_cut < cut_size)
      cut_size = new_cut;
  }
#ifndef QUIET
    printf("final cut size %d\n",cut_size);
    printf("time %.2f\n",tot_time());
    fflush(stdout);
#endif

/*
show_cut();
print_net_dist();
*/
}

/*******************************************************************/

cut(nets_cut)
int nets_cut;
{
register int moved,best_moved;
register int best_nets_cut;
register pcell cell;
register pnet net;
int i;

best_moved = 0;
moved = 0;
LOCKED_NETS = 0;

best_nets_cut = nets_cut;
while((LOCKED_NETS < nets_cut) && ((cell = pick_move_cell()) != NULL))
  {
    moved++;
    cell->order = moved;
    if(cell->HLparent == TRUE)
      {
/*	printf("old %d minus %d cell %d -- %d %d\n",nets_cut,cell->gain,cell->id,cell->hl1->id,cell->hl2->id); */
	nets_cut -= cell->hl1->gain;
	nets_cut -= cell->hl2->gain;
	cell->hl1->order = cell->order;
	cell->hl2->order = cell->order;
      }
    else
      {
/*	printf("old %d minus %d cell %d\n",nets_cut,cell->gain,cell->id);  */
	nets_cut -= cell->gain;
      }
    if(nets_cut < best_nets_cut)
      {
	best_nets_cut = nets_cut;
	best_moved = moved;
      }
    move(cell);
/*
    check_cell_gains(PART_A);
    check_cell_gains(PART_B);
    check_HL_cells();
*/
/*
    if(nets_cut != (i = init_nets_cut()))
      {
	printf("++++++++++++++++++++++++++++++++++++ gain wrong %d actual %d on cell %d  %d %d\n",nets_cut,i,cell->id,cell->hl1->id,cell->hl2->id);
	nets_cut = i;
      }
*/
  }
for(net = NETS;net != NULL;net = net->next)
  net->lock = FALSE;
#ifndef QUIET
    printf("cut %d\n",best_nets_cut);
    printf("-------------- restoring\n");
#endif

restore_best_partition(best_moved);
if(best_nets_cut != (i = init_nets_cut()))
  {
    printf("++++++++++++++++++++++++++++++++++++ restore wrong %d actual %d\n",best_nets_cut,i);
  }
return(best_nets_cut);
}

/*******************************************************************/

get_best_cell(buc,c)
pbucket buc;
pcell *c;
{
pcell cell;
int i;

if(buc->num > 0)
  {
for(i = buc->global_max ;i >= 0;i--)
  {
    if((cell = buc->cells[i]) != NULL)
      {
	(*c) = pick_candidate(cell);
	if((*c) != NULL)
	  return(i);
/*
	for(;cell != NULL;cell = cell->bucket_next)
	  {
	    if((cell->HLparent == TRUE) || 
	       (cell->hard_link == NULL))
	      {
		(*c) = cell;
		return(i);
	      }
	  }
*/
      }
  }
}
(*c) = NULL;
return(-P);
}

/*******************************************************************/

pcell pick_move_cell()
{
register int a,b;
pcell cellA,cellB;

a = get_best_cell(FREE[PART_A],&cellA);
b = get_best_cell(FREE[PART_B],&cellB);
if(cellA == NULL)
  return(cellB);
if(cellB == NULL)
  return(cellA);
if(a > b)
  {
    return(cellA);
  }
else 
  if(b > a)
    {
      return(cellB);
    }
else
  if(random()%2)
    {
      return(cellA);
    }
  else
    {
      return(cellB);
    }
}

/*******************************************************************/

restore_best_partition(best)
int best;
{
register pcell cell;
register pcell a,b,hl;

a = b = hl = NULL;
while((cell = get_max_cell(FREE[PART_A])) != NULL)
  {
    remove_from_bucket(cell);
    if(cell->HLparent == TRUE)
      {
	cell->next = hl;
	hl = cell;
      }
    else
      {
	cell->next = a;
	a = cell;
      }
  }
while((cell = get_max_cell(LOCKED[PART_A])) != NULL)
  {
    remove_from_bucket(cell);
    if(cell->HLparent == TRUE)
      {
	cell->next = hl;
	hl = cell;
      }
    else
      {
	if(cell->order > best)
	  {
	    cell->next = b;
	    b = cell;
	  }
	else
	  {
	    cell->next = a;
	    a = cell;
	  }
      }
  }
while((cell = get_max_cell(FREE[PART_B])) != NULL)
  {
    remove_from_bucket(cell);
    if(cell->HLparent == TRUE)
      {
	printf("ERROR: in min cut\n");
	quit();
      }
    cell->next = b;
    b = cell;
  }
while((cell = get_max_cell(LOCKED[PART_B])) != NULL)
  {
    remove_from_bucket(cell);
    if(cell->HLparent == TRUE)
      {
	printf("ERROR: in min cut\n");
	quit();
      }
    else
      {
	if(cell->order > best)
	  {
	    cell->next = a;
	    a = cell;
	  }
	else
	  {
	    cell->next = b;
	    b = cell;
	  }
      }
  }
clear_all_nets();
initialize_nets(a,b);
initialize_partition(a,b);
while(hl != NULL)
  {
    cell = hl;
    hl = hl->next;
    put_in_bucket(cell,FREE[PART_A]);
  }
init_HL_cells();
}


clear_all_nets()
{
register pnet net;

for(net = NETS;net != NULL;net = net->next)
  {
    net->free[PART_A] = 0;
    net->free[PART_B] = 0;
    net->locked[PART_A] = 0;
    net->locked[PART_B] = 0;
  }
}

/*******************************************************************/

print_net_gains()
{
register pnet net;

for(net = NETS;net != NULL;net = net->next)    
  if((net->free[PART_A] + net->locked[PART_A] > 0) && 
     (net->free[PART_B] + net->locked[PART_B] > 0))
    {
      printf("net %d cut\n",net->id);
    }
}


