#include "copyright.h"
#include "port.h"

#include "oct.h"
#include "region.h"
#include "header.h"
#define POLY 0
#define MET1 1
#define MET2 2

struct octBox *intersect_boxes();
extern int  CONT_HEIGHT;
extern int  CONT_WIDTH;

extern pcell FIXED_MET1,FIXED_MET2;
extern int  MAX_SPACING;
extern int  MAX_WIDTH;
extern int  GRIDHEIGHT ;
extern int  GRIDWIDTH ;
extern char 	*via_nameTable[3][3];
extern char *TECH_DIR;

octObject *getMaster();



show_crossings()
{
octObject bag,path1,path2,path3;
octGenerator gen,gen_p;
struct octBox box1,box2;
int i;

i = 0;
OCTCHKOK(octInitGenContents(&network,OCT_BAG_MASK,&gen));
while(octGenerate(&gen,&bag) == OCT_OK)
  {
    if(strncmp("CROSSING",bag.contents.bag.name,8) == 0)
      {
	OCTCHKOK(octInitGenContents(&bag,OCT_PATH_MASK,&gen_p));
	OCTCHKOK(octGenerate(&gen_p,&path1));
	OCTCHKOK(octGenerate(&gen_p,&path2));
	if(octGenerate(&gen_p,&path3) == OCT_OK)
	  printf("ERROR more than two paths in crossing bag\n");
	get_pathBB(&path1,&box1);
	get_pathBB(&path2,&box2);
	new_box5(intersect_boxes(&box1,&box2));
	i++;
      }
  }
printf("%d crossings marked\n",i);
}

new_box5(box)
struct octBox *box;
{
octObject obj,layer;

obj.type = OCT_BOX;
obj.contents.box.lowerLeft.x = box->lowerLeft.x;
obj.contents.box.lowerLeft.y = box->lowerLeft.y;
obj.contents.box.upperRight.x = box->upperRight.x;
obj.contents.box.upperRight.y = box->upperRight.y;
OCTCHKOK(octCreate(&network,&obj));
layer.type = OCT_LAYER;
layer.contents.layer.name = "NDIFF";
OCTCHKOK(octGetOrCreate(&network,&layer));
OCTCHKOK(octAttach(&layer,&obj));
}


new_box2(box)
struct octBox *box;
{
octObject obj,layer;

obj.type = OCT_BOX;
obj.contents.box.lowerLeft.x = box->lowerLeft.x;
obj.contents.box.lowerLeft.y = box->lowerLeft.y;
obj.contents.box.upperRight.x = box->upperRight.x;
obj.contents.box.upperRight.y = box->upperRight.y;
printf("--- %d %d %d %d\n",box->lowerLeft.x,box->lowerLeft.y,box->upperRight.x,box->upperRight.y);
OCTCHKOK(octCreate(&network,&obj));
layer.type = OCT_LAYER;
layer.contents.layer.name = "POLY";
OCTCHKOK(octGetByName(&network,&layer));
OCTCHKOK(octAttach(&layer,&obj));
}

/***********************************************************/


print_cross_bags()
{
octGenerator gen;
octObject bag;
int i;

i = 0;
OCTCHKOK(octInitGenContents(&network,OCT_BAG_MASK,&gen));
while(octGenerate(&gen,&bag) == OCT_OK)
  {
    if(strncmp(bag.contents.bag.name,"CROSSING",8) == 0)
      {
	i++;
	printf(".");
	fflush(stdout);
/*
	OCTCHKOK(octInitGenContents(&bag,OCT_PATH_MASK,&gen_p));
	OCTCHKOK(octGenerate(&gen_p,&p));
	OCTCHKOK(octGenerate(&gen_p,&p2));
	get_pathBB(&p,&b);
	get_pathBB(&p2,&b2);
	b3 = intersect_boxes(&b,&b2);
	new_box5(b3);
*/
      }
  }
printf("%d crossing bags\n",i);
}

struct octBox *intersect_boxes(box,box1)
struct octBox *box,*box1;
{
struct octBox *box2;

box2 = CALLOC(1,struct octBox);

box2->lowerLeft.x = MAX(box->lowerLeft.x,box1->lowerLeft.x);
box2->lowerLeft.y = MAX(box->lowerLeft.y,box1->lowerLeft.y);
box2->upperRight.x = MIN(box->upperRight.x,box1->upperRight.x);
box2->upperRight.y = MIN(box->upperRight.y,box1->upperRight.y);
return(box2);
}

new_box44(path,layer_name)
octObject *path;
char *layer_name;
{
octObject obj,layer;
struct octPoint p[2];

get_path2(path,p);

obj.type = OCT_BOX;
if(direction(p) == HOR)
  {
    if(p[0].x < p[1].x)
      {
	obj.contents.box.lowerLeft.x = p[0].x + 40;
	obj.contents.box.lowerLeft.y = p[0].y - path->contents.path.width/2 - 20;
	obj.contents.box.upperRight.x = p[1].x - 40;
	obj.contents.box.upperRight.y = p[1].y + path->contents.path.width/2 + 20;
      }
    else
      {
	obj.contents.box.lowerLeft.x = p[1].x + 40;
	obj.contents.box.lowerLeft.y = p[1].y - path->contents.path.width/2 - 20;
	obj.contents.box.upperRight.x = p[0].x - 40;
	obj.contents.box.upperRight.y = p[0].y + path->contents.path.width/2 + 20;
      }
  }
else
  {
    if(p[0].y < p[1].y)
      {
	obj.contents.box.lowerLeft.x = p[0].x - path->contents.path.width/2 - 20;
	obj.contents.box.lowerLeft.y = p[0].y + 40;
	obj.contents.box.upperRight.x = p[1].x + path->contents.path.width/2 + 20;
	obj.contents.box.upperRight.y = p[1].y - 40;
      }
    else
      {
	obj.contents.box.lowerLeft.x = p[1].x - path->contents.path.width/2 - 20;
	obj.contents.box.lowerLeft.y = p[1].y + 40;
	obj.contents.box.upperRight.x = p[0].x + path->contents.path.width/2 + 20;
	obj.contents.box.upperRight.y = p[0].y - 40;
      }      
  }
OCTCHKOK(octCreate(&network,&obj));
layer.type = OCT_LAYER;
layer.contents.layer.name = layer_name;
OCTCHKOK(octGetOrCreate(&network,&layer));
OCTCHKOK(octAttach(&layer,&obj));
}


find_a_path(x,y,x2,y2)
int x,y,x2,y2;
{
pcell cell;
ppathList pl;
octObject path;
struct octPoint p[2];

path.type = OCT_PATH;
for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    for(pl = cell->paths;pl != NULL;pl = pl->next)
      {
	path.objectId = pl->id;
	OCTCHKOK(octGetById(&path));
	get_path2(&path,p);
	if((p[0].x == x) &&
	   (p[0].y == y) &&
	   (p[1].x == x2) &&
	   (p[1].y == y2))
	  {
	    printf("found path on cell %d\n",cell->id);
	    print_graph();
	  }
      }
  }
}
