#include "copyright.h"
#include "port.h"

#include "oct.h"
#include "st.h"
#include "header.h"
extern pcell FIXED_MET1,FIXED_MET2;
extern struct octBox *intersect_boxes();
extern int CONT_WIDTH;
extern pcell CELLS;
extern pnet NETS;
octObject *getMaster();
ppathList new_pathList();

check_cells()
{
register pcell cell;
register int l;
register pnetlist nl;

for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    for(l=0,nl = cell->nets;nl != NULL;nl = nl->next,l++)
      {}
    if(l < 1)
      {
	printf("error no terminals on cell %s\n",cell->name);
      }
  }
}

/*******************************************************************/

check_nets()
{
register pnet net;
register int l;
register pcellist cl;

for(net = NETS;net != NULL;net = net->next)
  {
    for(l = 0,cl = net->cells;cl != NULL;cl = cl->next,l++)
      {}
    if(l < 2)
      {
	printf("error less than two connections on net\n");
      }
  }
}

new_box3(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
octObject obj,layer;

obj.type = OCT_BOX;
obj.contents.box.lowerLeft.x = x1;
obj.contents.box.lowerLeft.y = y1;
obj.contents.box.upperRight.x = x2;
obj.contents.box.upperRight.y = y2;
OCTCHKOK(octCreate(&network,&obj));
layer.type = OCT_LAYER;
layer.contents.layer.name = "NDIFF";
OCTCHKOK(octGetOrCreate(&network,&layer));
OCTCHKOK(octAttach(&layer,&obj));
}


new_box4(box)
struct octBox *box;
{
octObject obj,layer;

obj.type = OCT_BOX;
obj.contents.box.lowerLeft.x = box->lowerLeft.x;
obj.contents.box.lowerLeft.y = box->lowerLeft.y;
obj.contents.box.upperRight.x = box->upperRight.x;
obj.contents.box.upperRight.y = box->upperRight.y;
OCTCHKOK(octCreate(&network,&obj));
layer.type = OCT_LAYER;
layer.contents.layer.name = "NDIFF";
OCTCHKOK(octGetOrCreate(&network,&layer));
OCTCHKOK(octAttach(&layer,&obj));
}

new_box45(box)
struct octBox *box;
{
octObject obj,layer;

obj.type = OCT_BOX;
obj.contents.box.lowerLeft.x = box->lowerLeft.x;
obj.contents.box.lowerLeft.y = box->lowerLeft.y;
obj.contents.box.upperRight.x = box->upperRight.x;
obj.contents.box.upperRight.y = box->upperRight.y;
OCTCHKOK(octCreate(&network,&obj));
layer.type = OCT_LAYER;
layer.contents.layer.name = "NDIFF";
OCTCHKOK(octGetOrCreate(&network,&layer));
OCTCHKOK(octAttach(&layer,&obj));
}

check_net_conn()
{
pcell cell;
pnetlist nl;
pcellist cl;

printf("checking net conn\n");
for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	for(cl = nl->net->cells;cl != NULL;cl = cl->next)
	  if(in_cell_list(cl->cell) == FALSE)
	    printf("network error\n");
      }
  }
}

in_cell_list(cell)
pcell cell;
{
pcell c;

for(c = CELLS;c != NULL;c = c->next)
  if(c == cell)
    return(TRUE);
return(FALSE);
}

count_cells()
{
pcell c;
int i;

for(i = 0,c = CELLS;c != NULL;c = c->next,i++)
  {}
return(i);
}



print_graph()
{
pcell cell;
pnetlist nl;
pcellist cl;
pnet net;

printf("fixed cells MET1\n");
for(cell = FIXED_MET1;cell != NULL;cell = cell->next)
  {
    printf("FIXED1 cell %d %s ",cell->id,cell->name);
/*    for(paths = 0,pl = cell->paths;pl != NULL;pl = pl->next,paths++)
      {}
    printf(" %d paths ",paths);
*/    printf(" connected to nets ");
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      printf("%d ",nl->net->id);
    printf("\n");
  }
printf("fixed cells MET2\n");
for(cell = FIXED_MET2;cell != NULL;cell = cell->next)
  {
    printf("fixed2 cell %d %s ",cell->id,cell->name);
/*    for(paths = 0,pl = cell->paths;pl != NULL;pl = pl->next,paths++)
      {}
    printf(" %d paths ",paths);
*/    printf(" connected to nets ");
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      printf("%d ",nl->net->id);
    printf("\n");
  }
for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    printf("cell %d %s ",cell->id,cell->name);
    if(cell->hard_link != NULL)
      printf(" --- %d ",cell->hard_link->id);
/*    for(paths = 0,pl = cell->paths;pl != NULL;pl = pl->next,paths++)
      {}
    printf(" %d paths ",paths);
*/
    printf(" connected to nets ");
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      printf("%d ",nl->net->id);
    printf("\n");
  }
printf("\n");
for(net = NETS;net != NULL;net = net->next)
  {
    printf("net %d ",net->id);
    printf(" connected to cells ");
    for(cl = net->cells;cl != NULL;cl = cl->next)
      printf("%d ",cl->cell->id);
    printf("\n");
  }
}



check_cell_gains(part)
int part;
{
printf("check cell gains\n");
check_bucket_gains(FREE[part],part);
check_bucket_gains(LOCKED[part],part);
}

/*******************************************************************/

check_bucket_gains(bucket,part)
pbucket bucket;
int part;
{
register pcell cell;
int num;

for(num = bucket->global_max;num >= 0;num--)
  {
    for(cell = bucket->cells[num];cell != NULL;cell = cell->bucket_next)
      {
	check_single_cell_gain(cell,part);
      }
  }
}

print_cell_gain(cell)
pcell cell;
{
printf("CELL %d - gain %d\n",cell->id,cell->gain);
}


check_single_cell_gain(cell,part)
pcell cell;
int part;
{
int gain;

if(cell->HLparent == TRUE)
  {
    if(cell->hl1->gain + cell->hl2->gain != cell->gain)
      {
	printf("HL cell gain error\n");
      }
  }
else
  {
    gain = cell->gain;
    cell->gain = 0;
    set_cell_gain(cell,part);
    if(gain != cell->gain)
      {
	printf("cell gain error\n");
	print_cell_gain(cell);
	printf("wrong gain:\n");
	cell->gain = gain;
	print_cell_gain(cell);
	err("cell gain error");
      }
  }
}

print_part(bucket)
pbucket bucket;
{
register pcell cell,list;

list = NULL;
while((cell = get_max_cell(bucket)) != NULL)
  {
    remove_from_bucket(cell);
    cell->next = list;
    list = cell;
    if(cell->HLparent == TRUE)
      printf("CELL %d = %d %d - gain %d\n",cell->id,cell->hl1->id,cell->hl2->id,cell->gain);
    else
      printf("CELL %d - gain %d\n",cell->id,cell->gain);
  }
for(cell = list;cell != NULL;cell = cell->next)
  put_in_bucket(cell,bucket);
}

check_cells_for_dups()
{
pcell cell;
pnetlist nl,nl2;

printf("checking for dup connections\n");
for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	for(nl2 = nl->next;nl2 != NULL;nl2 = nl2->next)
	  if(nl2->net == nl->net)
	    printf("net prob on cell %d two connections to net %d\n",cell->id,nl->net->id);
      }
  }
}


/*******************************************************************/

err(str)
char *str;
{
printf("%s\n",str);
fflush(stdout);
exit(20);
}

/*******************************************************************/


print_cells()
{
register pcell cell;
register int l;
register pnetlist nl;

for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    for(l=0,nl = cell->nets;nl != NULL;nl = nl->next,l++)
      {
	printf("cell %s",cell->name);
	printf(" -- net %d\n",nl->net->id);
      }
    printf("	%d\n",l);
  }
printf("---------------------------------------------\n");
}

/*******************************************************************/

print_nets()
{
register pnet net;
register int l;
register pcellist cl;

for(net = NETS;net != NULL;net = net->next)
  {
    for(l = 0,cl = net->cells;cl != NULL;cl = cl->next,l++)
      printf("net %d -- cell %d\n",net->id,cl->cell->id);
    printf("	%d\n",l);
  }
}

print_net_dist()
{
register pnet net;
int cnt;

cnt = 0;
for(net = NETS;net != NULL;net = net->next)
  {
    printf("NET %d --	 %d	 %d 	%d	 %d ",net->id,net->free[PART_A],net->locked[PART_A],net->free[PART_B],net->locked[PART_B]);
    if((net->free[PART_A] + net->locked[PART_A] > 0) && 
       (net->free[PART_B] + net->locked[PART_B] > 0))
      {
	cnt ++;
	printf("  %d",cnt);
/*
	for(cl = net->cells;(cl != NULL);cl = cl->next)
	  if((cl->cell->bucket == FREE[PART_A]) || 
	     (cl->cell->bucket == LOCKED[PART_A]))
	    {
	      show_clust(cl->cell->paths,"NDIF");
	    }
	for(cl = net->cells;(cl != NULL);cl = cl->next)
	  if((cl->cell->bucket == FREE[PART_B]) || 
	     (cl->cell->bucket == LOCKED[PART_B]))
	    {
	      show_clust(cl->cell->paths,"POLY");
	    }
*/
      }
    printf("\n");
  }
}


check_HL_cells()
{
int num;
pcell cell;
pbucket buc;

#ifndef QUIET
  printf("check HL cells\n");
#endif

buc = FREE[PART_A];
for(num = buc->global_max;num >= 0;num--)
  {
    for(cell = buc->cells[num];cell != NULL;cell = cell->bucket_next)
      if(cell->HLparent == TRUE)
	{
	  if(cell->hl1->part == cell->hl2->part)
	    printf("HL ERROR 1\n");
	}
  }
buc = FREE[PART_B];
for(num = buc->global_max;num >= 0;num--)
  {
    for(cell = buc->cells[num];cell != NULL;cell = cell->bucket_next)
      if(cell->HLparent == TRUE)
	{
	  printf("HL ERROR 3\n");
	}
  }
}

print_cells2()
{
pcell cell;

for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    printf("%d",cell->id);
    if(cell->hard_link != NULL)
      printf(" --- %d ",cell->hard_link->id);
    if(cell->fixed == TRUE)
      printf(" FIXED");
    printf("\n");
  }
}

/*******************************************************************/

show_clusters()
{
pcell cell;
octObject path;
int cnt;

cnt = 0;
path.type = OCT_PATH;
for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    if(cell->hard_link == NULL)
      {
	show_clust(cell->paths,"POLY");
      }
    else
      if((cell->hard_link != NULL) && 
	(cell->id <= cell->hard_link->id))
	{
/*
	  if((cell->nets == NULL) && (cell->hard_link->nets == NULL))
	    {
	      show_clust(cell->paths,"NDIFF");
	      show_clust(cell->hard_link->paths,"NWEL"); 	      
	      show_clust2(cell->paths,"POLY");
	      show_clust2(cell->hard_link->paths,"NDIF"); 	      

	    }
	  else
*/
	    {
	      cnt++;
	      switch(cnt%5)
		{
		case 0:
		  show_clust2(cell->paths,"NDIF");
		  show_clust2(cell->hard_link->paths,"NDIF"); 
		  break;
		case 1:
		  show_clust2(cell->paths,"PDIF");
		  show_clust2(cell->hard_link->paths,"PDIF"); 
		  break;
		case 2:
		  show_clust2(cell->paths,"POLY");
		  show_clust2(cell->hard_link->paths,"POLY"); 
		  break;
		case 3:
		  show_clust2(cell->paths,"NWEL");
		  show_clust2(cell->hard_link->paths,"NWEL"); 
		  break;
		case 4:
		  show_clust2(cell->paths,"PWEL");
		  show_clust2(cell->hard_link->paths,"PWEL"); 
		  break;
		}
	    }
	}
  }
}

show_fixed()
{
pcell cell;
octObject path;
int cnt;

cnt = 0;
path.type = OCT_PATH;
for(cell = FIXED_MET1;cell != NULL;cell = cell->next)
  {
    show_clust(cell->paths,"NWEL");
  }
for(cell = FIXED_MET2;cell != NULL;cell = cell->next)
  {
    show_clust(cell->paths,"NDIFF");
  }
printf("%d clusters\n",cnt);
}




show_clust(pl,layer_name)
ppathList pl;
char *layer_name;
{
octObject path,path2;
octObject layer;
struct octPoint p[2];

path.type = OCT_PATH;

  for(;(pl != NULL);pl = pl->next)
    {
      path2.objectId = pl->id;
      OCTCHKOK(octGetById(&path2));
      get_path2(&path2,p);
      path.contents.path.width = path2.contents.path.width + 40;
      
      if(p[0].x == p[1].x)
	{
	  if(p[0].y < p[1].y)
	    {
	      p[0].y += 50;
	      p[1].y -= 50;
	    }
	  else
	    {
	      p[0].y -= 50;
	      p[1].y += 50;
	    }
	}
      else
	{
	  if(p[0].x < p[1].x)
	    {
	      p[0].x += 50;
	      p[1].x -= 50;
	    }
	  else
	    {
	      p[0].x -= 50;
	      p[1].x += 50;
	    }
	}
      OCTCHKOK(octCreate(&network,&path));
      OCTCHKOK(octPutPoints(&path,2,p));
      layer.type = OCT_LAYER;
      layer.contents.layer.name = layer_name;
      OCTCHKOK(octGetOrCreate(&network, &layer));
      OCTCHKOK(octAttach(&layer,&path));
      OCTCHKOK(octModify(&path));
    }
}

/*
printNetwork()
{
pcell cell;
pcellist cl;
pnet net;
pnetlist nl;

for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    printf("cell ");
    if(cell->fixed == TRUE)
      printf("FIXED ");
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      printf(" %s",nl->net->name);
    printf("\n");
  }
printf("\n\n");
for(net = NETS;net != NULL;net = net->next)
  {
    printf("%s -- ",net->name);
    for(cl = net->cells;cl != NULL;cl = cl->next)
      if(cl->cell->paths != NULL)
	{
	  if(cl->cell->paths->path != NULL)
	    printf(" %s", octFormatId(cl->cell->paths->path->objectId));
	}
      else
	printf(" -xxx-");
    printf("\n");
  }
fflush(stdout);
}
*/

printHL()
{
pcell cell;
ppathList pl;

for(cell = CELLS;cell != NULL;cell = cell->next)
  if((cell->hard_link != NULL) && (cell->paths->id <= cell->hard_link->paths->id))
    {
      printf("HL - %d %d\n",cell->paths->id,cell->hard_link->paths->id);
      for(pl = cell->paths;pl != NULL;pl = pl->next)
	printf("     %d\n",pl->id);
      for(pl = cell->hard_link->paths;pl != NULL;pl = pl->next)
	printf("          %d\n",pl->id);
    }
}

new_box6(path,layer_name)
octObject *path;
char *layer_name;
{
octObject obj,layer;
struct octPoint p[2];

get_path2(path,p);

obj.type = OCT_BOX;
if(direction(p) == HOR)
  {
    if(p[0].x < p[1].x)
      {
	obj.contents.box.lowerLeft.x = p[0].x + 40;
	obj.contents.box.lowerLeft.y = p[0].y - path->contents.path.width/2 - 20;
	obj.contents.box.upperRight.x = p[1].x - 40;
	obj.contents.box.upperRight.y = p[1].y + path->contents.path.width/2 + 20;
      }
    else
      {
	obj.contents.box.lowerLeft.x = p[1].x + 40;
	obj.contents.box.lowerLeft.y = p[1].y - path->contents.path.width/2 - 20;
	obj.contents.box.upperRight.x = p[0].x - 40;
	obj.contents.box.upperRight.y = p[0].y + path->contents.path.width/2 + 20;
      }
  }
else
  {
    if(p[0].y < p[1].y)
      {
	obj.contents.box.lowerLeft.x = p[0].x - path->contents.path.width/2 - 20;
	obj.contents.box.lowerLeft.y = p[0].y + 40;
	obj.contents.box.upperRight.x = p[1].x + path->contents.path.width/2 + 20;
	obj.contents.box.upperRight.y = p[1].y - 40;
      }
    else
      {
	obj.contents.box.lowerLeft.x = p[1].x - path->contents.path.width/2 - 20;
	obj.contents.box.lowerLeft.y = p[1].y + 40;
	obj.contents.box.upperRight.x = p[0].x + path->contents.path.width/2 + 20;
	obj.contents.box.upperRight.y = p[0].y - 40;
      }      
  }
OCTCHKOK(octCreate(&network,&obj));
layer.type = OCT_LAYER;
layer.contents.layer.name = layer_name;
OCTCHKOK(octGetOrCreate(&network,&layer));
OCTCHKOK(octAttach(&layer,&obj));
}

show_zero_clusters()
{
pcell c;
pbucket buc;

buc = FREE[PART_A];
if(buc->global_max >= 0)
  {
    for(c = buc->cells[P];c != NULL;c = c->next)
      {
	if(c->HLparent == TRUE)
	  {
	    show_clust(c->hl1->paths,"NDIFF");
	    show_clust(c->hl2->paths,"NDIF");
	  }
	else
	  {
	    if(c->hard_link == NULL)
	      {
		show_clust(c->paths,"POLY");
	      }
	  }
      }
  }
buc = FREE[PART_B];
if(buc->global_max >= 0)
  {
    for(c = buc->cells[P];c != NULL;c = c->next)
      {
	if(c->HLparent == TRUE)
	  {
	    show_clust(c->hl1->paths,"NDIFF");
	    show_clust(c->hl2->paths,"NDIF");
	  }
	else
	  {
	    if(c->hard_link == NULL)
	      {
		show_clust(c->paths,"POLY");
	      }
	  }
      }
  }
}

show_cut()
{
register pnet net;
octObject inst;
struct octBox boxx;

for(net = NETS;net != NULL;net = net->next)    
/*
  if((net->free[PART_A] + net->locked[PART_A] > 0) && 
     (net->free[PART_B] + net->locked[PART_B] > 0))
*/
    {
      inst.objectId = net->OCTid;
      OCTCHKOK(octGetById(&inst));
      OCTCHKOK(octBB(&inst,&boxx));
      new_box45(&boxx);
    }
}


show_clust2(pl,layer_name)
ppathList pl;
char *layer_name;
{
    int32 i;
    octObject path,path2,facet2;
    octObject layer,facet,poly,poly2,layer2;
    struct octPoint p[2], *pp;
    octStatus status;

    if(pl == NULL)
      return;
    openFacet(&facet,"tmp","symbolic","contents","w");
    new_prop(&facet,"TECHNOLOGY","scmos");
    new_prop(&facet,"VIEWTYPE","SYMBOLIC");
    path.type = OCT_PATH;

    for(;(pl != NULL);pl = pl->next)
      {
	  path2.objectId = pl->id;
	  OCTCHKOK(octGetById(&path2));
	  get_path2(&path2,p);
	  path.contents.path.width = path2.contents.path.width + 40;
      
	  if(p[0].x == p[1].x)
	    {
		if(p[0].y < p[1].y)
		  {
		      p[0].y += 50;
		      p[1].y -= 50;
		  }
		else
		  {
		      p[0].y -= 50;
		      p[1].y += 50;
		  }
	    }
	  else
	    {
		if(p[0].x < p[1].x)
		  {
		      p[0].x += 50;
		      p[1].x -= 50;
		  }
		else
		  {
		      p[0].x -= 50;
		      p[1].x += 50;
		  }
	    }

	  OCTCHKOK(octCreate(&facet,&path));
	  OCTCHKOK(octPutPoints(&path,2,p));
	  layer.type = OCT_LAYER;
	  layer.contents.layer.name = layer_name;
	  OCTCHKOK(octGetOrCreate(&facet, &layer));
	  OCTCHKOK(octAttach(&layer,&path));
	  OCTCHKOK(octModify(&path));
	  printf("path\n");
      }
    OCTCHKOK(octCloseFacet(&facet));
    (void) system("vulcan tmp:symbolic");
    openFacet(&facet2,"tmp","symbolic","interface","r");

    layer2.type = OCT_LAYER;
    layer2.contents.layer.name = "PLACE";
    OCTCHKOK(octGetOrCreate(&facet2, &layer2));

    OCTCHKOK(octGenFirstContent(&layer2,OCT_POLYGON_MASK,&poly));

    i = 2;
    pp = p;
    if((status = octGetPoints(&poly,&i,pp)) != OCT_OK)
      {
	  printf("Two is too small - status %d\n",status);
	  printf("%d points\n",i);

	  pp = CALLOC(i,struct octPoint);
	  if(octGetPoints(&poly,&i,pp) != OCT_OK)
	    {
		printf("ERROR in getting path points\n");
	    }
      }

    poly2.type = OCT_POLYGON;
    OCTCHKOK(octCreate(&network,&poly2));
    OCTCHKOK(octPutPoints(&poly2,i,pp));

    layer.type = OCT_LAYER;
    layer.contents.layer.name = layer_name;
    OCTCHKOK(octGetOrCreate(&network, &layer));
    OCTCHKOK(octAttach(&layer,&poly2));
    OCTCHKOK(octCloseFacet(&facet2));
}

