#include "copyright.h"
#include "port.h"

#include "header.h"
static pcell save1[20],save2[20];
static pcell A_CELLS = NULL, B_CELLS = NULL;
extern pcell FIXED_MET1,FIXED_MET2;
extern int ESSENTIAL;

exhaustive()
{
int i;
pcell c;
int cut;

if(CELLS == NULL)
  return;
for(c = CELLS,i = 0;c != NULL;c = c->next)
  {
    if((c->hard_link == NULL) || (c->id > c->hard_link->id))
      i++;
  }
/*
printf("number of cells %d\n",i);
*/

if(i <= 16)
  {
    cut = run_exhaustive(CELLS);
    ESSENTIAL += cut;
    printf("(MIZER %.2f sec): final exhaustive search -- %d essential vias\n",tot_time(),cut);
    for(i = 0;(i < 20) && (save1[i] != NULL);i++)
      {
	merge_two_nodes(FIXED_MET1,save1[i]);
      }
    for(i = 0;(i < 20) && (save2[i] != NULL);i++)
      {
	merge_two_nodes(FIXED_MET2,save2[i]);
      }
  }
}


run_exhaustive(cell)
pcell cell;
{
pcell c;
static int best = INF;
int cut, i;

if(cell == NULL)
  {
    clear_all_nets();
    initialize_nets2(A_CELLS,B_CELLS);
    cut = init_nets_cut();
    if(cut < best)
      {
	best = cut;
	for(i = 0,c = A_CELLS;c != NULL;c = c->bucket_next,i++)
	  {
	    save1[i] = c;
	  }
	save1[i] = NULL;
	for(i = 0,c = B_CELLS;c != NULL;c = c->bucket_next,i++)
	  {
	    save2[i] = c;
	  }
	save2[i] = NULL;
      }
  }
else
  {
    
    for(;(cell != NULL) && 
	(cell->hard_link != NULL) && 
	(cell->id < cell->hard_link->id);
	cell = cell->next)
      {}
    if(cell == NULL)
      run_exhaustive((pcell) NULL);
    else
      {
	cell->bucket_next = A_CELLS;
	A_CELLS = cell;
	c = cell->hard_link;
	if(c != NULL)
	  {
	    c->bucket_next = B_CELLS;
	    B_CELLS = c;
	  }

	run_exhaustive(cell->next);
	
	A_CELLS = A_CELLS->bucket_next;
	if(c != NULL)
	  B_CELLS = B_CELLS->bucket_next;
	
	cell->bucket_next = B_CELLS;
	B_CELLS = cell;
	c = cell->hard_link;
	if(c != NULL)
	  {
	    c->bucket_next = A_CELLS;
	    A_CELLS = c;
	  }
	run_exhaustive(cell->next);
	if(c != NULL)
	  A_CELLS = A_CELLS->bucket_next;
	B_CELLS = B_CELLS->bucket_next;
      }
  }
return(best);
}

initialize_nets2(a,b)
pcell a,b;
{
register pcell cell;
register pnetlist nl;


for(cell = FIXED_MET1;cell != NULL;cell = cell->next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	nl->net->locked[PART_A]++;
      }
for(cell = FIXED_MET2;cell != NULL;cell = cell->next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	nl->net->locked[PART_B]++;
      }

for(cell = a;cell != NULL;cell = cell->bucket_next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	nl->net->free[PART_A]++;
      }
for(cell = b;cell != NULL;cell = cell->bucket_next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	nl->net->free[PART_B]++;
      }
}
