#include "copyright.h"
#include "port.h"

#include "header.h"
FILE *AllocFile;
char *AllocPtr;
extern pcell FIXED_MET1,FIXED_MET2;
extern octObject layers[3];
#define MET1 1

/*******************************************************************/

initialize_cut()
{

    /*
      AllocFile = fopen("allo","w");
      */

    get_max_P();
    make_buckets();
}

/*******************************************************************/

set_up_rand_partition(cells,aa,bb)
pcell cells;
pcell *aa,*bb;
{
register pcell cell,a,b;
register pcellist cl;

a = b = NULL;
for(cell = cells;cell != NULL;cell = cell->next)
  cell->side = 0;
while(cells != NULL)
  {
    cell = cells;
    cells = cells->next;

    if(cell->hard_link != NULL)
      {
	if(cell->hard_link->side == 0)
	  {
	    cell->side = 1;
	  }
	else
	  {
	    if(((cell->paths != NULL) && 
		(path_layer_by_id(cell->paths->id) == 1)) ||
	       ((cell->hard_link->paths != NULL) && 
		(path_layer_by_id(cell->hard_link->paths->id) == 2)))
	      {
 		cell->next = a;
		a = cell;
		
		if(cell->hard_link->fixed == TRUE)
		  {
		    printf("ERROR: in setting up random partition\n");
		    quit();
		  }
		cell->hard_link->next = b;
		b = cell->hard_link;
	      }
	    else
	      {
		cell->next = b;
		b = cell;
		
		if(cell->hard_link->fixed == TRUE)
		  {
		    printf("ERROR: in setting up random partition\n");
		    quit();
		  }
		cell->hard_link->next = a;
		a = cell->hard_link;
	      }
	  }
      }
    else
      {
	if(cell->paths != NULL)
	  {
	    if(path_layer_by_id(cell->paths->id) == 1)
	      {
		cell->next = a;
		a = cell;
	      }
	    else
	      {
		cell->next = b;
		b = cell;
	      }
	  }
	else
	  {
	    for(cl = cell->nets->net->cells;
		(cl != NULL) && (cl->cell == cell);cl = cl->next)
	      {}
	    if((cl != NULL) && 
	       (cl->cell->paths != NULL) && 
	       (path_layer_by_id(cl->cell->paths->id) == 1))
	      {
		cell->next = a;
		a = cell;
	      }
	    else
	      {
		cell->next = b;
		b = cell;
	      }
	  }
      }
  }
(*aa) = a;
(*bb) = b;
}

/*******************************************************************/

initialize_partition(a,b)
pcell a,b;
{
register pcell cell;

for(cell = a;cell != NULL;cell = cell->next)
  {
    cell->gain = 0;
    set_cell_gain(cell,PART_A);
    put_in_bucket(cell,FREE[PART_A]);
  }
for(cell = b;cell != NULL;cell = cell->next)
  {
    cell->gain = 0;
    set_cell_gain(cell,PART_B);
    put_in_bucket(cell,FREE[PART_B]);
  }
}

/*******************************************************************/

init_nets_cut()
{
register pnet net;
register int cnt;

cnt = 0;
for(net = NETS;net != NULL;net = net->next)    
  if((net->free[PART_A] + net->locked[PART_A] > 0) && 
     (net->free[PART_B] + net->locked[PART_B] > 0))
    {
      cnt++;
    }
return(cnt);
}

/*******************************************************************/

initialize_nets(a,b)
pcell a,b;
{
register pcell cell;
register pnetlist nl;


for(cell = FIXED_MET1;cell != NULL;cell = cell->next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	nl->net->locked[PART_A]++;
      }
for(cell = FIXED_MET2;cell != NULL;cell = cell->next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	nl->net->locked[PART_B]++;
      }

for(cell = a;cell != NULL;cell = cell->next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	nl->net->free[PART_A]++;
      }
for(cell = b;cell != NULL;cell = cell->next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      {
	nl->net->free[PART_B]++;
      }
for(cell = a;cell != NULL;cell = cell->next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      if(nl->net->free[PART_A] + nl->net->free[PART_B] == 1)
	if(nl->net->locked[PART_A] + nl->net->locked[PART_B] == 0)
	  nl->net->locked[PART_A] = nl->net->locked[PART_B] = 1;
for(cell = b;cell != NULL;cell = cell->next)
    for(nl = cell->nets;nl != NULL;nl = nl->next)
      if(nl->net->free[PART_A] + nl->net->free[PART_B] == 1)
	if(nl->net->locked[PART_A] + nl->net->locked[PART_B] == 0)
	  nl->net->locked[PART_A] = nl->net->locked[PART_B] = 1;
}

/*******************************************************************/

get_max_P()
{
register pcell cell;
register int l;
register pnetlist nl;

for(cell = CELLS;cell != NULL;cell = cell->next)
  {
    for(l = 0,nl = cell->nets;nl != NULL;nl = nl->next,l++)
      {}
    if(l > P)
      P = l;
  }
P = 2 * P;
}

/*******************************************************************/

make_hard_cell(cell)
pcell cell;
{
pcell c;

c = new_cell();
c->HLparent = TRUE;

c->hl1 = cell;
c->hl2 = cell->hard_link;
cell->hl1 = c;
cell->hard_link->hl1 = c;
c->gain = 0;
c->part = PART_A;
put_in_bucket(c,FREE[PART_A]);
}

/*******************************************************************/

init_HL_cells()
{
int num;
pcell cell,list;

get_cells_from_bucket(FREE[PART_A],&list,&num);
for(cell = list;cell != NULL;cell = cell->next)
  {
    if(cell->HLparent == TRUE)
      {
	cell->gain = cell->hl1->gain + cell->hl2->gain;
      }
  }
for(cell = list;cell != NULL;cell = cell->next)
  put_in_bucket(cell,FREE[PART_A]);
check_HL_cells(); 
}


make_hard_links(a)
pcell a;
{
register pcell cell;

for(cell = a;cell != NULL;cell = cell->next)
  {
    if(cell->hard_link != NULL)
      make_hard_cell(cell);
  }
}

path_layer_by_id(id)
octId id;
{
octObject path,layer;

path.objectId = id;
OCTCHKOK(octGetById(&path));
OCTCHKOK(octGenFirstContainer(&path,OCT_LAYER_MASK,&layer));
if(octIdsEqual(layer.objectId, layers[MET1].objectId))
  return(1);
return(2);
}
