#include "copyright.h"
#include "port.h"

#include "oct.h"
#include "region.h"
#include "header.h"

extern int  CONT_HEIGHT;
extern int  CONT_WIDTH;

extern char *TECH_DIR;

#define OCT_TO_LAMBDA 20

octObject *getMaster();

int NEW_VIAS = 0;

struct octBox *intersect_boxes(), *get_term_box();
struct octBox *intersect_boxes2();

/***********************************************************/

pboxList new_boxList()
{
pboxList bl;

bl = CALLOC(1,struct boxList);
bl->next = NULL;
bl->box = NULL;
bl->bagId = -1;
return(bl);
}

/***********************************************************/

pboxList sort_list_Y(list)
pboxList list;
{
pboxList head,bl,l;

head = list;
list = list->next;
head->next = NULL;
while(list != NULL)
  {
    l = list;
    list = list->next;
    if(l->box->lowerLeft.y < head->box->lowerLeft.y)
      {
	l->next = head;
	head = l;
      }
    else
      {
	for(bl = head;
	    (bl != NULL) && 
	    (bl->next != NULL) && 
	    (bl->next->box->lowerLeft.y < l->box->lowerLeft.y);bl = bl->next)
	  {}
	if(bl == NULL)
	  {
	    printf("ERROR: in sorting y lists\n");
	    quit();
	  }
	if(bl->next == NULL)
	  {
	    bl->next = l;
	    l->next = NULL;
	  }
	else
	  {
	    l->next = bl->next;
	    bl->next = l;
	  }
      }
  }
return(head);
}

/***********************************************************/

pboxList sort_list_X(list)
pboxList list;
{
pboxList head,bl,l;

head = list;
list = list->next;
head->next = NULL;
while(list != NULL)
  {
    l = list;
    list = list->next;
    if(l->box->lowerLeft.x < head->box->lowerLeft.x)
      {
	l->next = head;
	head = l;
      }
    else
      {
	for(bl = head;
	    (bl != NULL) && 
	    (bl->next != NULL) && 
	    (bl->next->box->lowerLeft.x < l->box->lowerLeft.x);bl = bl->next)
	  {}
	if(bl == NULL)
	  {
	    printf("ERROR: in sorting x lists\n");
	    quit();
	  }
	if(bl->next == NULL)
	  {
	    bl->next = l;
	    l->next = NULL;
	  }
	else
	  {
	    l->next = bl->next;
	    bl->next = l;
	  }
      }
  }
return(head);
}


/***********************************************************/

insert_vias()
{
octGenerator net_gen,term_gen,path_gen,path_gen2,bag_gen;
octObject net2,net,term1,term2,path,path1,path2,bag,layer;
struct octBox box;
pboxList bl,list;
static int bag_num = 1;
char buf[80];

other_layers_exist();
init_masters();
#ifndef QUIET
  MEM_SIZE("before bags");
#endif
OCTCHKOK(octInitGenContents(&network,OCT_NET_MASK,&net_gen));
while(octGenerate(&net_gen,&net) == OCT_OK)
  {
    OCTCHKOK(octInitGenContents(&net,OCT_PATH_MASK,&path_gen));
    while(octGenerate(&path_gen,&path) == OCT_OK)
      {
	OCTCHKOK(octGenFirstContainer(&path,OCT_LAYER_MASK,&layer));
	if(which_layer(&layer) != OTHER_LAYER)
	  {
	    get_pathBB(&path,&box);
	    list = NULL;
	    if(kdRegObjStart(&box) != REG_NOMORE)
	      {
		while(kdRegObjNext(&path2) != REG_NOMORE)
		  {
		    if((path2.type == OCT_PATH) && 
		       (path.objectId < path2.objectId))
		      {
			OCTCHKOK(octGenFirstContainer(&path2,OCT_NET_MASK,&net2));
			if(!octIdsEqual(net2.objectId, net.objectId))
			  {
			    bag.type = OCT_BAG;
			    (void) sprintf(buf,"CROSSING%d",bag_num++);
			    bag.contents.bag.name = buf;
			    OCTCHKOK(octCreate(&network,&bag));
			    OCTCHKOK(octAttach(&bag,&path));
			    OCTCHKOK(octAttach(&bag,&path2));
			    check_for_short(&path,&path2);
			  }
		      }
		  }
	      }
	  }
      }
    OCTCHKOK(octFreeGenerator(&path_gen));
  }
kd_kill_tree();
OCTCHKOK(octFreeGenerator(&net_gen));
#ifndef QUIET
    printf("\n %d bags made at %.2f\n",bag_num - 1,tot_time());
    MEM_SIZE("after bags");
    fflush(stdout);
#endif


OCTCHKOK(octInitGenContents(&network,OCT_NET_MASK,&net_gen));
while(octGenerate(&net_gen,&net) == OCT_OK)
  {
    OCTCHKOK(octInitGenContents(&net,OCT_PATH_MASK,&path_gen));
    while(octGenerate(&path_gen,&path) == OCT_OK)
      {
	OCTCHKOK(octGenFirstContainer(&path,OCT_LAYER_MASK,&layer));
	if(which_layer(&layer) != OTHER_LAYER)
	  {
	    list = NULL;
	    OCTCHKOK(octInitGenContainers(&path,OCT_BAG_MASK,&bag_gen));
	    while(octGenerate(&bag_gen,&bag) == OCT_OK)
	      {
		if(strncmp(bag.contents.bag.name,"CROSSING",8) == 0)
		  {
		    OCTCHKOK(octInitGenContents(&bag,OCT_PATH_MASK,&path_gen2));
		    OCTCHKOK(octGenerate(&path_gen2,&path1));
		    if(octIdsEqual(path1.objectId, path.objectId))
		      OCTCHKOK(octGenerate(&path_gen2,&path1));
		    if(octIdsEqual(path1.objectId, path.objectId))
		      {
			printf("ERROR in crossing bag contents\n");
			quit();
		      }
		    OCTCHKOK(octFreeGenerator(&path_gen2));
		    
		    bl = new_boxList();
		    bl->next = list;
		    bl->bagId = bag.objectId;
		    list = bl;
		    bl->box = intersect_boxes2(&path,&path1);
		  }
	      }
	    if(list != NULL)
	      {
		OCTCHKOK(octInitGenContents(&path,OCT_TERM_MASK,&term_gen));
		
		OCTCHKOK(octGenerate(&term_gen,&term1));
		if((octGenFirstContainer(&term1,OCT_NET_MASK,&net2) == OCT_OK) ||
		   (term_is_on_poly(&term1) == TRUE))
		  {
		    bl = new_boxList();
		    bl->box = get_term_box(&term1);
		    bl->next = list;
		    list = bl;
		  }
		
		OCTCHKOK(octGenerate(&term_gen,&term2));
		if((octGenFirstContainer(&term2,OCT_NET_MASK,&net2) == OCT_OK) ||
		   (term_is_on_poly(&term2) == TRUE))
		  {
		    bl = new_boxList();
		    bl->box = get_term_box(&term2);
		    bl->next = list;
		    list = bl;
		  }
		put_in_vias(&path,&net,list);
		OCTCHKOK(octFreeGenerator(&term_gen)); 
	      }
	    OCTCHKOK(octFreeGenerator(&bag_gen));
	  }
      }
    OCTCHKOK(octFreeGenerator(&path_gen));
  }
OCTCHKOK(octFreeGenerator(&net_gen));

#ifndef QUIET
  printf("\n===  %d VIAS ADDED\n",NEW_VIAS);
#endif
free_masters();

#ifndef QUIET
    MEM_SIZE("after adding vias"); 
    fflush(stdout);
#endif

coalesce_bags(bag_num - 1);
}

/***********************************************************/

coalesce_bags(num_of_bags)
int num_of_bags;
{
octGenerator net_gen,path_gen,path_gen2,bag_gen;
octObject net,path,path2,bag,first_bag;


OCTCHKOK(octInitGenContents(&network,OCT_NET_MASK,&net_gen));
while(octGenerate(&net_gen,&net) == OCT_OK)
  {
    OCTCHKOK(octInitGenContents(&net,OCT_PATH_MASK,&path_gen));
    while(octGenerate(&path_gen,&path) == OCT_OK)
      {
	OCTCHKOK(octInitGenContainers(&path,OCT_BAG_MASK,&bag_gen));
	if(octGenerate(&bag_gen,&first_bag) == OCT_OK)
	  {
	    while(octGenerate(&bag_gen,&bag) == OCT_OK)
	      {
		OCTCHKOK(octInitGenContents(&bag,OCT_PATH_MASK,&path_gen2));
		while(octGenerate(&path_gen2,&path2) == OCT_OK)
		  {
		    if((!octIdsEqual(path2.objectId, path.objectId)) && 
		       (in_bag(&first_bag,&path2) == FALSE))
		      {
			OCTCHKOK(octAttach(&first_bag,&path2));
		      }
		  }
		num_of_bags--;
		OCTCHKOK(octDelete(&bag));
		OCTCHKOK(octFreeGenerator(&path_gen2));
	      }
	  }
	OCTCHKOK(octFreeGenerator(&bag_gen));
      }
    OCTCHKOK(octFreeGenerator(&path_gen));
  }
OCTCHKOK(octFreeGenerator(&net_gen));

#ifndef QUIET
    printf("%d bags left after coalescing\n",num_of_bags);
    MEM_SIZE("after coalescing bags");
    fflush(stdout);
#endif
}

/***********************************************************/

in_bag(bag,path)
octObject *bag,*path;
{
return((octIsAttached(bag,path) == OCT_OK)?TRUE:FALSE);
}

/***********************************************************/

struct octBox *intersect_boxes2(path,path1)
octObject *path,*path1;
{
struct octBox *box;
struct octPoint p[2],p1[2];
int min_p,min_p1;

box = CALLOC(1,struct octBox);
get_path2(path,p);
get_path2(path1,p1);

if(direction(p) == VER)
  {
    box->lowerLeft.x = p[0].x - MAX(CONT_WIDTH,path->contents.path.width) / 2;
    box->upperRight.x = p[0].x + MAX(CONT_WIDTH,path->contents.path.width) / 2;
    if(direction(p1) == VER)
      {
	min_p1 = MIN(p1[0].y,p1[1].y);
	min_p  = MIN(p[0].y, p[1].y);
	if(((min_p1 <= MAX(p[0].y,p[1].y)) &&
	    (min_p <= min_p1)) ||
	   ((min_p <= MAX(p1[0].y,p1[1].y)) &&
	    (min_p1 <= min_p)))
	  {
	    box->lowerLeft.y = MAX(MIN(p[0].y,p[1].y),
				   MIN(p1[0].y,p1[1].y));
	    box->upperRight.y = MIN(MAX(p[0].y,p[1].y),
				    MAX(p1[0].y,p1[1].y));
	  }
	else
	  {
	    box->lowerLeft.y = MIN(p[0].y,p[1].y);
	    box->upperRight.y = MAX(p[0].y,p[1].y);
	  }
      }
    else
      {
	box->lowerLeft.y = p1[0].y - 
	  MAX(CONT_WIDTH,path1->contents.path.width) / 2;
	box->upperRight.y = p1[0].y + 
	  MAX(CONT_WIDTH,path1->contents.path.width) / 2;
      }
  }
else
   {
    box->lowerLeft.y = p[0].y - MAX(CONT_WIDTH,path->contents.path.width) / 2;
    box->upperRight.y = p[0].y + MAX(CONT_WIDTH,path->contents.path.width) / 2;
    if(direction(p1) == VER)
      {
	box->lowerLeft.x = p1[0].x - 
	  MAX(CONT_WIDTH,path1->contents.path.width) / 2;
	box->upperRight.x = p1[0].x + 
	  MAX(CONT_WIDTH,path1->contents.path.width) / 2;
      }
    else
      {
	min_p1 = MIN(p1[0].x,p1[1].x);
	min_p  = MIN(p[0].x, p[1].x);
	if(((min_p1 <= MAX(p[0].x,p[1].x)) &&
	    (min_p <= min_p1)) ||
	   ((min_p <= MAX(p1[0].x,p1[1].x)) &&
	    (min_p1 <= min_p)))
	  {
	    box->lowerLeft.x  = MAX(MIN(p[0].x,p[1].x),
				    MIN(p1[0].x,p1[1].x));
	    box->upperRight.x = MIN(MAX(p[0].x,p[1].x),
				    MAX(p1[0].x,p1[1].x));
	  }
	else
	  {
	    box->lowerLeft.x = MIN(p[0].x,p[1].x);
	    box->upperRight.x = MAX(p[0].x,p[1].x);
	  }
      }
  }
return(box);
}

#define USE_REG

#ifdef USE_REG
struct octBox *get_term_box(term)
octObject *term;
{
struct octBox *box;

box = CALLOC(1,struct octBox);
if(regFindImpl(term,box) !=REG_OK)
  {
    printf("ERROR in finding reg box\n");
    quit();
  }
return(box);
}

#else

struct octBox *get_term_box(term)
octObject *term;
{
octObject net,inst,*master,term2,box3;
struct octBox *box;

box = CALLOC(1,struct octBox);
if(octGenFirstContainer(term,OCT_NET_MASK,&net) == OCT_OK)
  {

    OCTCHKOK(octGenFirstContainer(term,OCT_INSTANCE_MASK,&inst));

    master = getMaster(inst.contents.instance.master,inst.contents.instance.view);
    
    term2.type = OCT_TERM;
    term2.contents.term.name = term->contents.term.name;
    OCTCHKOK(octGetByName(master,&term2));

    get_term_BB(&term2, &box3);

    octTransformGeo(&box3,&inst.contents.instance.transform);
    box->lowerLeft.x = box3.contents.box.lowerLeft.x;
    box->lowerLeft.y = box3.contents.box.lowerLeft.y;
    box->upperRight.x = box3.contents.box.upperRight.x;
    box->upperRight.y = box3.contents.box.upperRight.y;

/*
      {
	if(regFindImpl(term,&box4) != REG_OK)
	  printf("ERROR in finding reg box\n");
	if((box->lowerLeft.x == box4.lowerLeft.x) &&
	   (box->lowerLeft.y == box4.lowerLeft.y) &&
	   (box->upperRight.x == box4.upperRight.x) &&
	   (box->upperRight.y == box4.upperRight.y))
	  printf("REG BOX ok\n");
	else
	  printf("---------- REG BOX not ok \n");
      }
*/
  }
else
  {
    OCTCHKOK(octGenFirstContainer(term,OCT_INSTANCE_MASK,&inst));
    OCTCHKOK(octBB(&inst,box));
  }

return(box);
}
#endif
make_via(term,x,y,path)
octObject *term;
octObject *path;
int x,y;
{
static octObject *bag = NULL;
char str[25];
char buf[256];
static int via_cnt = 0;
octObject via;
char *name;
struct pathList pl;

pl.id = path->objectId;
pl.next = NULL;
NEW_VIAS++;
if(bag == NULL)
  {
    bag = CALLOC(1,octObject);
    bag->type = OCT_BAG;
    bag->contents.bag.name = "CONNECTORS";
    OCTCHKOK(octGetByName(&network,bag));
  }

createOctVia( bag,&pl,x,y,&via);
OCTCHKOK(octGenFirstContent(&via, OCT_TERM_MASK, term));
}

createOctInstance(inst,instname, instmaster, instview, x, y, transform)
    octObject 	*inst;
    char	*instname;
    char	*instmaster;
    char	*instview;
    octCoord	x, y;
    octTransformType transform;
{
    int		debug;

    debug = 0;

    if (debug >= 1)  printf("Start createOctInstance.c\n");

    /*
     *  Place an instance of the current object in the contents facet of
     *  the oct cell.
     */

    inst->type = OCT_INSTANCE;
    inst->contents.instance.name = instname;
    inst->contents.instance.master = instmaster;
    inst->contents.instance.view = instview;
    inst->contents.instance.version = OCT_CURRENT_VERSION;
    inst->contents.instance.facet = "contents";
    inst->contents.instance.transform.translation.x = x;
    inst->contents.instance.transform.translation.y = y;
    inst->contents.instance.transform.transformType = transform;

    if (octCreate(&network, inst) != OCT_OK) {
	octError("createOctInstance:  attaching instance to content facet.\n");
	printf("createOctInstance:  attaching instance to content facet.\n");
	printf("instname=%s, instmaster=%s, instview=%s, x,y=%d,%d\n",
	       instname, instmaster, instview, x, y);
	quit();
    }
    if (debug >= 1)  printf("End createOctInstance.c\n");
}


/*******************************************************************/

check_for_short(path,path2)
    octObject *path,*path2;
{
    struct octPoint p[2];
    struct octPoint p2[2];

    if(path_layer(path) == path_layer(path2)) {
	get_path2(path,p);
	get_path2(path2,p2);
	printf("(MIZER):WARNING two paths are shorted:\n\t (%d,%d) (%d,%d) and (%d,%d) (%d,%d)\n",
	       p[0].x / OCT_TO_LAMBDA,
	       p[0].y / OCT_TO_LAMBDA,
	       p[1].x / OCT_TO_LAMBDA,
	       p[1].y / OCT_TO_LAMBDA,
	       p2[0].x / OCT_TO_LAMBDA,
	       p2[0].y / OCT_TO_LAMBDA,
	       p2[1].x / OCT_TO_LAMBDA,
	       p2[1].y / OCT_TO_LAMBDA
	       );
	fflush( stdout );
    }
}
