#include "copyright.h"
#include "port.h"

#include "header.h"
extern int  CONT_HEIGHT;
extern int  CONT_WIDTH;
int MINIMIZE = TRUE;
extern int SHORTS;
extern pnet DEAD_NETS;
extern pcell FIXED_MET1, FIXED_MET2;

extern char *tmp_out_cell_name;
octObject network;
#define TRUE 1
#define FALSE 0

main(argc,argv)
int argc;
char **argv;
{
    process_command_line(argc,argv);
    getDRC();
#ifndef QUIET
    printf("time %.2f\n",tot_time());
#endif

    remove_contacts();
    if(MINIMIZE == TRUE)
      {
	  printf("(MIZER %.2f sec): existing vias ",tot_time());
	  count_vias();
	  insert_vias();
	  if(SHORTS == TRUE)
	    VOVend(0);
#ifndef QUIET
	  printf("making the graph...\n");
	  fflush(stdout);
#endif
	  make_graph();
    
#ifndef QUIET
	  printf("doing cut\n");
#endif
	  fflush(stdout);
	  initialize_cut();
	  do_cut();
    
#ifndef QUIET
	  printf("time %.2f\n",tot_time());
	  fflush(stdout);
#endif
    
	  fix_paths();
	  remove_contacts();
	  fix_vias();
	  check_all_paths();
	  printf("(MIZER %.2f sec): total vias ",tot_time());
	  count_vias();
      }
    clean_up_mem();
    finish_oct();
    printf("(MIZER %.2f sec): total time\n",tot_time());
    VOVend(0);
}

/*******************************************************************/

finish_oct()
{
OCTCHKOK(octCloseFacet(&network));
octEnd();
}

/*******************************************************************/

get_pathBB(path,box)
octObject *path;
struct octBox *box;
{
octGenerator term_gen;
octObject term1,term2;
struct octBox *box1,*box2, *get_term_box();
struct octPoint p[2];

OCTCHKOK(octInitGenContents(path,OCT_TERM_MASK,&term_gen));
OCTCHKOK(octGenerate(&term_gen,&term1));
OCTCHKOK(octGenerate(&term_gen,&term2));

OCTCHKOK(octFreeGenerator(&term_gen));

box1 = get_term_box(&term1);
box2 = get_term_box(&term2);

get_path2(path,p);
if(direction(p) == HOR)
  {
    box->lowerLeft.x = MIN(box1->lowerLeft.x,box2->lowerLeft.x);
    box->lowerLeft.y = p[0].y -MAX((path->contents.path.width/2),CONT_WIDTH/2);
    box->upperRight.x = MAX(box1->upperRight.x,box2->upperRight.x);
    box->upperRight.y = p[0].y+MAX((path->contents.path.width/2),CONT_WIDTH/2);
  }
else
  {
    box->lowerLeft.x = p[0].x -MAX((path->contents.path.width/2),CONT_WIDTH/2);
    box->lowerLeft.y = MIN(box1->lowerLeft.y,box2->lowerLeft.y);
    box->upperRight.x = p[0].x+MAX((path->contents.path.width/2),CONT_WIDTH/2);
    box->upperRight.y = MAX(box1->upperRight.y,box2->upperRight.y);
  }
FREE_MEM(1,box1,struct octBox);
FREE_MEM(1,box2,struct octBox);
}

/***********************************************************/


direction(points)
struct octPoint *points;
{
    if(points[0].x == points[1].x)
      {
	  return(VER);
      }
    if(points[0].y == points[1].y)
      {
	  return(HOR);
      }
    printf("(MIZER):ERROR - diagional path at %d %d %d %d\n",
	   points[0].x,
	   points[0].y,
	   points[1].x,
	   points[1].y);
    quit();
    /*NOTREACHED*/
}

get_path2(path,points)
octObject *path;
struct octPoint *points;
{
    int32 i;

    i = 2;
    if((octGetPoints(path,&i,points) != OCT_OK) || (i != 2))
      {
	  printf("ERROR in getting path points\n");
	  quit();
      }
}

quit()
{
    octEnd();
    printf("(MIZER %.2f sec): ERROR - aborting. Facet has not been altered\n",tot_time());
    VOVend(1);
}

clean_up_mem()
{
    pcell c, c2;
    pcellist cl, cl2;
    pnet n, n2;
    pnetlist nl,nl2;
    ppathList pl,pl2;

    free_all_buckets();
    c = FIXED_MET1;
    while(c != NULL)
      {
	  nl = c->nets;
	  while(nl != NULL)
	    {
		nl2 = nl;
		nl = nl->next;
		FREE_MEM(1,nl2,struct netlist);
	    }
	  pl = c->paths;
	  while(pl != NULL)
	    {
		pl2 = pl;
		pl = pl->next;
		FREE_MEM(1,pl2,struct pathlist);
	    }
	  c2 = c;
	  c = c->next;
	  FREE_MEM(1,c2,struct cell);
      }
    c = FIXED_MET2;
    while(c != NULL)
      {
	  nl = c->nets;
	  while(nl != NULL)
	    {
		nl2 = nl;
		nl = nl->next;
		FREE_MEM(1,nl2,struct netlist);
	    }
	  pl = c->paths;
	  while(pl != NULL)
	    {
		pl2 = pl;
		pl = pl->next;
		FREE_MEM(1,pl2,struct pathlist);
	    }
	  c2 = c;
	  c = c->next;
	  FREE_MEM(1,c2,struct cell);
      }
    n = NETS;
    while(n != NULL)
      {
	  cl = n->cells;
	  while(cl != NULL)
	    {
		cl2 = cl;
		cl = cl->next;
		FREE_MEM(1,cl2,struct cellist);
	    }
	  n2 = n;
	  n = n->next;
	  FREE_MEM(1,n2,struct net);
      }
    n = DEAD_NETS;
    while(n != NULL)
      {
	  n2 = n;
	  n = n->next;
	  FREE_MEM(1,n2,struct net);
      }
}
