#include "copyright.h"
#include "port.h"
#include "header.h"
#include "st.h"
#include "vov.h"

static st_table *MASTER_HASH;

/*******************************************************************/

init_masters()
{
MASTER_HASH = st_init_table(strcmp,st_strhash);
}

/*******************************************************************/

octObject *getMaster(name,view)
char *name;
char *view;
{
    octObject *master;

    if(st_lookup(MASTER_HASH, name, (char **)&master) == FALSE)
      {
	  master = CALLOC(1, octObject);
	  openFacet(master, name,view,"interface","r");
	  VOVinputFacet( master );
	  st_insert(MASTER_HASH, name, (char *)master);
      }
    return(master);
}


/*******************************************************************/

free_masters()
{
st_generator *gen;
char *name;
octObject *master;

gen = st_init_gen(MASTER_HASH);
while(st_gen(gen, &name, (char **)&master) != 0)
  {
    octCloseFacet(master);
    FREE_MEM(1,master,octObject);
  }
st_free_gen(gen);
st_free_table(MASTER_HASH);
}

