#include "copyright.h"
#include "port.h"

#include "oct.h"
#include "header.h"

/*******************************************************************/

remove_contacts()
{
octGenerator path_gen,inst_gen, path_gen2;
octObject term,path1,path2,bag,inst,layer1,layer2;
int i;
#ifndef QUIET
int num;
#endif
int found;

#ifndef QUIET
  printf("removing extra contacts %.2f\n",tot_time());
#endif

#ifndef QUIET
num = 0;
#endif
bag.type = OCT_BAG;
bag.contents.bag.name = "CONNECTORS";
OCTCHKOK(octGetByName(&network,&bag));
OCTCHKOK(octInitGenContents(&bag,OCT_INSTANCE_MASK,&inst_gen));
while(octGenerate(&inst_gen,&inst) == OCT_OK)
  {
    OCTCHKOK(octGenFirstContent(&inst,OCT_TERM_MASK,&term));
    OCTCHKOK(octInitGenContainers(&term,OCT_PATH_MASK,&path_gen));
    for(i = 0;octGenerate(&path_gen,&path1) == OCT_OK;i++)
      {}
    OCTCHKOK(octFreeGenerator(&path_gen));
    if(i == 2)
      {
	OCTCHKOK(octInitGenContainers(&term,OCT_PATH_MASK,&path_gen2));
	if(octGenerate(&path_gen2,&path1) == OCT_OK)
	  {
	    if(octGenerate(&path_gen2,&path2) == OCT_OK)
#ifndef QUIET
	      num += check_intersection(&term,&path1,&path2);
#else
	      (void) check_intersection(&term,&path1,&path2);
#endif
	  }
	octFreeGenerator(&path_gen2);
      }
  }
OCTCHKOK(octFreeGenerator(&inst_gen));
#ifndef QUIET
    printf("killed %d contacts\n",num);
    printf("done %.2f\n",tot_time());
#endif

do
  {
    found = FALSE;
    OCTCHKOK(octInitGenContents(&bag,OCT_INSTANCE_MASK,&inst_gen));
    while(octGenerate(&inst_gen,&inst) == OCT_OK)
      {
	OCTCHKOK(octGenFirstContent(&inst,OCT_TERM_MASK,&term));
	OCTCHKOK(octInitGenContainers(&term,OCT_PATH_MASK,&path_gen));
	for(i = 0;octGenerate(&path_gen,&path1) == OCT_OK;i++)
	  {}
	OCTCHKOK(octFreeGenerator(&path_gen));
	if(i == 2)
	  {
	    OCTCHKOK(octInitGenContainers(&term,OCT_PATH_MASK,&path_gen));
	    
	    OCTCHKOK(octGenerate(&path_gen,&path1));
	    OCTCHKOK(octGenerate(&path_gen,&path2));
	    
	    OCTCHKOK(octGenFirstContainer(&path1,OCT_LAYER_MASK,&layer1));
	    OCTCHKOK(octGenFirstContainer(&path2,OCT_LAYER_MASK,&layer2));
	    if(which_layer(&layer1) == which_layer(&layer2))
	      {
		if(check_overlap(&inst,&term,&path1,&path2) == FALSE)
		  {
		    if(check_overlap(&inst,&term,&path2,&path1) == TRUE)
		      found = TRUE;
		  }
		else
		  found = TRUE;
	      }
	    OCTCHKOK(octFreeGenerator(&path_gen));
	  }
      }
  }while(found == TRUE);
}

/*******************************************************************/

check_intersection(term,path1,path2)
octObject *path1,*term,*path2;
{
struct octPoint p1[2],p2[2];
octObject layer1,layer2,inst;
struct octBox box;

OCTCHKOK(octGenFirstContainer(path1,OCT_LAYER_MASK,&layer1));
OCTCHKOK(octGenFirstContainer(path2,OCT_LAYER_MASK,&layer2));
if(which_layer(&layer1) != which_layer(&layer2))
  {
    return(0);
  }
get_path2(path1,p1);
get_path2(path2,p2);
OCTCHKOK(octGenFirstContainer(term, OCT_INSTANCE_MASK, &inst));
OCTCHKOK(octBB(&inst,&box));

if(direction(p1) == VER)
  {
    if(p1[0].x != p2[0].x)
      return(0);
    if(((MAX(p1[0].y,p1[1].y) <= box.upperRight.y) && 
	(MAX(p2[0].y,p2[1].y) <= box.upperRight.y)) ||
       ((MIN(p1[0].y,p1[1].y) >= box.lowerLeft.y) && 
	(MIN(p2[0].y,p2[1].y) >= box.lowerLeft.y)))
      return(0);
  }
else
  {
    if(p1[0].y != p2[0].y)
      return(0);
    if(((MAX(p1[0].x,p1[1].x) <= box.upperRight.x) && 
	(MAX(p2[0].x,p2[1].x) <= box.upperRight.x)) ||
       ((MIN(p1[0].x,p1[1].x) >= box.lowerLeft.x) && 
	(MIN(p2[0].x,p2[1].x) >= box.lowerLeft.x)))
      return(0);
  }
if(path1->contents.path.width != path2->contents.path.width)
  {
    return(0);
  }

merge_paths(term,path1,path2);
return(1);
}

/*******************************************************************/

merge_paths(term,path1,path2)
octObject *path1,*path2,*term;
{
octObject inst,term2;
struct octPoint p1[2],p2[2];
int i,min,max;

OCTCHKOK(octGenFirstContainer(term,OCT_INSTANCE_MASK,&inst));
OCTCHKOK(octDelete(&inst));

/*
OCTCHKOK(octGenFirstContent(path2,OCT_TERM_MASK,&term2));
*/
if(octGenFirstContent(path2,OCT_TERM_MASK,&term2) != OCT_OK)
  {
    get_path2(path2,p2);
    printf("(MIZER): ERROR path %d %d %d %d has no terminals\n",p2[0].x,p2[0].y,p2[1].x,p2[1].y);
    quit();
  }
if(!octIdsEqual(term2.objectId, term->objectId))
  {
    OCTCHKOK(octAttach(path1,&term2));
  }
else
  {
    printf("(MIZER): ERROR path %d %d %d %d has >2 terminals\n",p2[0].x,p2[0].y,p2[1].x,p2[1].y);
    quit();
  }

get_path2(path1,p1);
get_path2(path2,p2);
if(direction(p1) == HOR)
  {
    min = p1[0].x;
    max = p1[0].x;
    for(i = 0;i < 2;i++)
      {
	if(min > p1[i].x)
	  min = p1[i].x;
	if(max < p1[i].x)
	  max = p1[i].x;
	if(min > p2[i].x)
	  min = p2[i].x;
	if(max < p2[i].x)
	  max = p2[i].x;
      }
    p1[0].x = min;
    if(min == max)
      max++;
    p1[1].x = max;
  }
else
  {
    min = p1[0].y;
    max = p1[0].y;
    for(i = 0;i < 2;i++)
      {
	if(min > p1[i].y)
	  min = p1[i].y;
	if(max < p1[i].y)
	  max = p1[i].y;
	if(min > p2[i].y)
	  min = p2[i].y;
	if(max < p2[i].y)
	  max = p2[i].y;
      }
    p1[0].y = min;
    if(min == max)
      max++;
    p1[1].y = max;
  }
OCTCHKOK(octPutPoints(path1,2,p1));
OCTCHKOK(octDelete(path2));
}

/******************************************************/

check_overlap(inst,term,path1,path2)
octObject *inst, *path1, *path2,*term;
{
struct octPoint p1[2],p2[2];
int dir;
struct octBox box;

get_path2(path1,p1);
get_path2(path2,p2);
if((dir = direction(p1)) == direction(p2))
  {
    OCTCHKOK(octBB(inst,&box));
    if(dir == VER)
      {
	if((MAX(p1[0].y,p1[1].y) <= box.upperRight.y) && 
	   (MIN(p1[0].y,p1[1].y) >= box.lowerLeft.y))
	  {
	    merge_contact(inst,term,path1,path2);
	    return(TRUE);
	  }
      }
    else
      {
	if((MAX(p1[0].x,p1[1].x) <= box.upperRight.x) && 
	   (MIN(p1[0].x,p1[1].x) >= box.lowerLeft.x))
	  {
	    merge_contact(inst,term,path1,path2);
	    return(TRUE);
	  }
      }
  }
return(FALSE);
}

/******************************************************/

merge_contact(inst,term,path1,path2)
octObject *inst, *path1,*path2,*term;
{
octObject term1,term2;
struct octPoint p1[2],p2[2];
octGenerator term_gen;
struct octBox *box1,*box2,*get_term_box();

OCTCHKOK(octInitGenContents(path1,OCT_TERM_MASK,&term_gen));
OCTCHKOK(octGenerate(&term_gen,&term1));
if(octIdsEqual(term1.objectId, term->objectId))
  {
    if(octGenerate(&term_gen,&term1) != OCT_OK)
      {
	get_path2(path1,p2);
	printf("(MIZER): ERROR path %d %d %d %d has only one terminal\n",
	       p2[0].x,
	       p2[0].y,
	       p2[1].x,
	       p2[1].y);
	quit();
      }
    if(octIdsEqual(term1.objectId, term->objectId))
      {
	printf("(MIZER):ERROR - internal problems\n");
	quit();
      }
  }
box1 = get_term_box(&term1);

OCTCHKOK(octInitGenContents(path2,OCT_TERM_MASK,&term_gen));
if(octGenerate(&term_gen,&term2) != OCT_OK)
  {
    get_path2(path2,p2);
    printf("(MIZER): ERROR path %d %d %d %d has no terminals\n",
	   p2[0].x,
	   p2[0].y,
	   p2[1].x,
	   p2[1].y);
    quit();
  }
if(octIdsEqual(term2.objectId, term->objectId))
  {
    if(octGenerate(&term_gen,&term2) != OCT_OK)
      {
	get_path2(path2,p2);
	printf("(MIZER): ERROR path %d %d %d %d has only one terminal\n",
	       p2[0].x,
	       p2[0].y,
	       p2[1].x,
	       p2[1].y);
	quit();
      }
    if(octIdsEqual(term2.objectId, term->objectId))
      {
	printf("(MIZER):ERROR - internal problems\n");
	quit();
      }
  }
get_path2(path2,p2);
box2 = get_term_box(&term2);
if(direction(p2) == HOR)
  {
    p1[0].y = p2[0].y;
    p1[1].y = p2[1].y;
    p1[0].x = (box2->upperRight.x + box2->lowerLeft.x) / 2;
    p1[1].x = (box1->upperRight.x + box1->lowerLeft.x) / 2;
    if(p1[0].x == p1[1].x)
      p1[1].x++;
  }
else
  {
    p1[0].x = p2[0].x;
    p1[1].x = p2[1].x;
    p1[0].y = (box2->upperRight.y + box2->lowerLeft.y) / 2;
    p1[1].y = (box1->upperRight.y + box1->lowerLeft.y) / 2;
    if(p1[0].y == p1[1].y)
      p1[1].y++;
  }
OCTCHKOK(octDetach(path2,term));
OCTCHKOK(octAttach(path2,&term1));

OCTCHKOK(octPutPoints(path2,2,p1));
OCTCHKOK(octDelete(path1));
OCTCHKOK(octDelete(inst));
}
