#include "copyright.h"
#include "port.h"

#include "header.h"

/*******************************************************************/

move(cell)
pcell cell;
{
if(cell->HLparent == TRUE)
  {    move_single(cell->hl1);
    move_single(cell->hl2);
    remove_from_bucket(cell);
    cell->gain = cell->hl1->gain + cell->hl2->gain;
    put_in_bucket(cell,LOCKED[cell->part]);
  }
else
  {
    move_single(cell);
  }
}

move_single(cell)
register pcell cell;
{
register int part;
register pnetlist nl;
register pcellist cl;
register pnet net;

remove_from_bucket(cell);

if(cell->id == 50)
  cell =cell;
part = cell->part;
cell->part = !part;
cell->gain = 0;
for(nl = cell->nets;nl != NULL;nl = nl->next)
  {
    net = nl->net;
    if(net->locked[!part] == 0)
      {
	if(net->free[!part] == 0)
	  {
	    for(cl = net->cells;cl != NULL;cl = cl->next)
	      inc_gain(cl->cell);
	  }
	else
	  if(net->free[!part] == 1)
	    {
	      for(cl = net->cells;cl != NULL;cl = cl->next)
		if(cl->cell->part == !part)
		  dec_gain(cl->cell);
	    }
      }
    net->free[part]--;      
    net->locked[!part]++;
    
    if(net->locked[part] == 0)
      {
	if(net->free[part] == 0)
	  {
	    for(cl = net->cells;cl != NULL;cl = cl->next)
	      dec_gain(cl->cell);
	  }
	else
	  if(net->free[part] == 1)
	    {
	      for(cl = net->cells;cl != NULL;cl = cl->next)
		if(cl->cell->part == part)
		  inc_gain(cl->cell);
	    }
      }
    
    add_net_gain(net->free[!part],net->locked[!part],net->free[part],net->locked[part],cell);
    if((net->lock == FALSE) && (net->locked[part] > 0) && (net->locked[!part] > 0))
      {
	LOCKED_NETS++;
	net->lock = TRUE;
      }
  }
put_in_bucket(cell,LOCKED[cell->part]);
}

/*******************************************************************/

inc_gain(cell)
register pcell cell;
{
register pbucket bucket;
register int addr;

if(cell->bucket != NULL)
  {
    if(cell->hard_link != NULL)
      {
	inc_gain(cell->hl1);
      }
    bucket = cell->bucket;
    addr = cell->gain + P;

    if(cell->bucket_prev == NULL)
	bucket->cells[addr] = cell->bucket_next;
    else
      cell->bucket_prev->bucket_next = cell->bucket_next;
    
    if(cell->bucket_next != NULL)
      cell->bucket_next->bucket_prev = cell->bucket_prev;
    
    cell->gain++;
    addr++;

    if(addr > bucket->global_max)
      bucket->global_max = addr;
    
    cell->bucket_next = bucket->cells[addr];
    cell->bucket_prev = NULL;
    
    if(cell->bucket_next != NULL)
      cell->bucket_next->bucket_prev = cell;
    bucket->cells[addr] = cell;
  }
}

/*******************************************************************/

dec_gain(cell)
register pcell cell;
{
register pbucket bucket;
register int addr;

if(cell->bucket != NULL)
  {
    if(cell->hard_link != NULL)
      {
	dec_gain(cell->hl1);
      }
    bucket = cell->bucket;
    addr = cell->gain + P;

    if(cell->bucket_prev == NULL)
	bucket->cells[addr] = cell->bucket_next;
    else
      cell->bucket_prev->bucket_next = cell->bucket_next;
    
    if(cell->bucket_next != NULL)
      cell->bucket_next->bucket_prev = cell->bucket_prev;
    
    cell->gain--;

    if((addr == bucket->global_max) && (bucket->cells[addr] == NULL))
      bucket->global_max--;

    addr--;
    cell->bucket_next = bucket->cells[addr];
    cell->bucket_prev = NULL;
    
    if(cell->bucket_next != NULL)
      cell->bucket_next->bucket_prev = cell;
    bucket->cells[addr] = cell;
  }
}

/*******************************************************************/
