#include "copyright.h"
#include "port.h"

#include "oct.h"
#include "region.h"
#include "header.h"

octObject *getMaster();
extern int  CONT_HEIGHT;
extern int  CONT_WIDTH;

extern int  MIN_SPACING;
extern char *TECH_DIR;
pboxList sort_list_X();
pboxList sort_list_Y();
static octObject *inst_bag = NULL;

put_in_vias(path,net,bl)
octObject *path,*net;
pboxList bl;
{
pboxList bl2,bl3;
int loc;
octObject path1,term1,term2,inst1,inst2,lay,term,*term3;
struct octPoint p[2],p1[2];
int layer;
octGenerator term_gen;
int loc1, loc2;

if(inst_bag == NULL)
  {
    inst_bag = CALLOC(1, octObject);
    inst_bag->type = OCT_BAG;
    inst_bag->contents.bag.name = "INSTANCES";
    OCTCHKOK(octGetByName(&network,inst_bag));
  }
OCTCHKOK(octGenFirstContainer(path,OCT_LAYER_MASK,&lay));
layer = which_layer(&lay);
path1.type = OCT_PATH;
path1.contents.path.width = path->contents.path.width;

get_path2(path,p);
if(direction(p) == HOR)
  {
    bl = sort_list_X(bl);
    
    OCTCHKOK(octInitGenContents(path,OCT_TERM_MASK,&term_gen));
    OCTCHKOK(octGenerate(&term_gen,&term1));
    OCTCHKOK(octGenerate(&term_gen,&term2));
    
    OCTCHKOK(octGenFirstContainer(&term1,OCT_INSTANCE_MASK,&inst1));
    OCTCHKOK(octGenFirstContainer(&term2,OCT_INSTANCE_MASK,&inst2));

    OCTCHKOK(octFreeGenerator(&term_gen));
    
    if(octIsAttached(inst_bag,&inst1) == OCT_OK)
      {
	octObject *facet,temp,boxx;

	facet = getMaster(inst1.contents.instance.master,inst1.contents.instance.view);
	temp.type = OCT_TERM;
	temp.contents.term.name = term1.contents.term.name;
	OCTCHKOK(octGetByName(facet, &temp));
	get_term_BB(&temp,&boxx);
	octTransformGeo(&boxx,&(inst1.contents.instance.transform));
	loc1 = boxx.contents.box.lowerLeft.x;
      }
    else
      {
	loc1 = inst1.contents.instance.transform.translation.x;
      }
    if(octIsAttached(inst_bag,&inst2) == OCT_OK)
      {
	octObject *facet,temp,boxx;

	facet = getMaster(inst2.contents.instance.master,inst2.contents.instance.view);
	temp.type = OCT_TERM;
	temp.contents.term.name = term2.contents.term.name;
	OCTCHKOK(octGetByName(facet, &temp));
	get_term_BB(&temp,&boxx);
	octTransformGeo(&boxx,&(inst2.contents.instance.transform));
	loc2 = boxx.contents.box.lowerLeft.x;
      }
    else
      {
	loc2 = inst2.contents.instance.transform.translation.x;
      }
    
    if(loc1 < loc2)
      {
	term3 = &term1;
	OCTCHKOK(octDetach(path,&term1));
      }
    else
      {
	term3 = &term2;
	OCTCHKOK(octDetach(path,&term2));
      }
    p1[0].y = p[0].y;
    p1[1].y = p[1].y;
    bl2 = bl;
    while(bl != NULL)
      {
	if((bl->next != NULL) && 
	   (bl->next->box->lowerLeft.x - bl->box->upperRight.x >=
	    MAX(path->contents.path.width,CONT_WIDTH)+MIN_SPACING+MIN_SPACING))
	  {
	    loc = (bl->next->box->lowerLeft.x + bl->box->upperRight.x) / 2;

	    if(p[0].x < p[1].x)
	      {
		p1[0].x = p[0].x;
		p1[1].x = loc;
	      }
	    else
	      {
		p1[0].x = loc;
		p1[1].x = p[1].x;
	      }

	    OCTCHKOK(octCreate(net,&path1));
	    OCTCHKOK(octAttach(&lay,&path1));
	    if(p1[0].x == p1[1].x)
	      p1[1].x++;
	    OCTCHKOK(octPutPoints(&path1,2,p1));

	    OCTCHKOK(octAttach(&path1,term3));
	    make_via(&term,loc,p[0].y,path);
	    OCTCHKOK(octAttach(&path1,&term));
	    term3 = &term;

	    if(p[0].x < p[1].x)
	      p[0].x = loc;
	    else
	      p[1].x = loc;
	    if(p[0].x == p[1].x)
	      p[1].x++;
	    OCTCHKOK(octPutPoints(path,2,p));
	    OCTCHKOK(octModify(path));

	    bl3 = bl;
	    bl = bl->next;
	    bl3->next = NULL;
	    set_up_crossing_bag(bl2,&path1,path);
	    bl2 = bl;
	  }
	else
	  bl = bl->next;
      }
    OCTCHKOK(octAttach(path,term3));
  }
else
  {
    bl = sort_list_Y(bl);
    OCTCHKOK(octInitGenContents(path,OCT_TERM_MASK,&term_gen));
    OCTCHKOK(octGenerate(&term_gen,&term1));
    OCTCHKOK(octGenerate(&term_gen,&term2));
    
    OCTCHKOK(octGenFirstContainer(&term1,OCT_INSTANCE_MASK,&inst1));
    OCTCHKOK(octGenFirstContainer(&term2,OCT_INSTANCE_MASK,&inst2));

    OCTCHKOK(octFreeGenerator(&term_gen));

    if(octIsAttached(inst_bag,&inst1) == OCT_OK)
      {
	octObject *facet,temp,boxx;

	facet = getMaster(inst1.contents.instance.master,inst1.contents.instance.view);
	temp.type = OCT_TERM;
	temp.contents.term.name = term1.contents.term.name;
	OCTCHKOK(octGetByName(facet, &temp));
	get_term_BB(&temp,&boxx);
	octTransformGeo(&boxx,&(inst1.contents.instance.transform));
	loc1 = boxx.contents.box.lowerLeft.y;
      }
    else
      {
	loc1 = inst1.contents.instance.transform.translation.y;
      }
    if(octIsAttached(inst_bag,&inst2) == OCT_OK)
      {
	octObject *facet,temp,boxx;

	facet = getMaster(inst2.contents.instance.master,inst2.contents.instance.view);
	temp.type = OCT_TERM;
	temp.contents.term.name = term2.contents.term.name;
	OCTCHKOK(octGetByName(facet, &temp));
	get_term_BB(&temp,&boxx);
	octTransformGeo(&boxx,&(inst2.contents.instance.transform));
	loc2 = boxx.contents.box.lowerLeft.y;
      }
    else
      {
	loc2 = inst2.contents.instance.transform.translation.y;
      }
    
    
    if(loc1 < loc2)
      {
	term3 = &term1;
	OCTCHKOK(octDetach(path,&term1));
      }
    else
      {
	term3 = &term2;
	OCTCHKOK(octDetach(path,&term2));
      }

    p1[0].x = p[0].x;
    p1[1].x = p[1].x;

    bl2 = bl;
    while(bl != NULL)
      {
	if((bl->next != NULL) && 
	   (bl->next->box->lowerLeft.y - bl->box->upperRight.y >=
	    MAX(path->contents.path.width,CONT_WIDTH)+MIN_SPACING+MIN_SPACING))
	  {
	    loc = (bl->next->box->lowerLeft.y + bl->box->upperRight.y) / 2;

	    if(p[0].y < p[1].y)
	      {
		p1[0].y = p[0].y;
		p1[1].y = loc;
	      }
	    else
	      {
		p1[0].y = loc;
		p1[1].y = p[1].y;
	      }


	    OCTCHKOK(octCreate(net,&path1));
	    OCTCHKOK(octAttach(&lay,&path1));
	    if(p1[0].y == p1[1].y)
	      p1[1].y++;
	    OCTCHKOK(octPutPoints(&path1,2,p1));

	    OCTCHKOK(octAttach(&path1,term3));
	    make_via(&term,p[0].x,loc,path);
	    OCTCHKOK(octAttach(&path1,&term));
	    term3 = &term;

	    if(p[0].y < p[1].y)
	      p[0].y = loc;
	    else
	      p[1].y = loc;

	    if(p[0].y == p[1].y)
	      p[1].y++;
	    OCTCHKOK(octPutPoints(path,2,p));
	    OCTCHKOK(octModify(path));

	    bl3 = bl;
	    bl = bl->next;
	    bl3->next = NULL;
	    set_up_crossing_bag(bl2,&path1,path);
	    bl2 = bl;
	  }
	else
	    bl = bl->next;	  
      }
    OCTCHKOK(octAttach(path,term3));
  }
while(bl2 != NULL)
  {
    bl = bl2;
    bl2 = bl2->next;
    FREE_MEM(1,bl->box,struct octBox);
    FREE_MEM(1,bl,boxList);
  }
}

set_up_crossing_bag(bl,path,master_path)
pboxList bl;
octObject *path,*master_path;
{
pboxList bl2;
octObject bag,p,layer;
octGenerator gen_p;
int found;

while(bl != NULL)
  {
    if(bl->bagId != -1)
      {
	found = FALSE;
	bag.objectId = bl->bagId;
	OCTCHKOK(octGetById(&bag));
	OCTCHKOK(octInitGenContents(&bag,OCT_PATH_MASK,&gen_p));
	while(octGenerate(&gen_p,&p) == OCT_OK)
	  {
	    OCTCHKOK(octGenFirstContainer(&p,OCT_LAYER_MASK,&layer));
	    if(which_layer(&layer) != OTHER_LAYER)
	      {
		if(octIdsEqual(p.objectId, master_path->objectId))
		  {
		    OCTCHKOK(octDetach(&bag,master_path));
		    OCTCHKOK(octAttach(&bag,path));
		    found = TRUE;
		  }
	      }
	  }
	if(found == FALSE)
	  {
	    printf("ERROR wrong crossing bags\n");
	    quit();
	  }
      }
    bl2 = bl;
    bl = bl->next;
    FREE_MEM(1,bl2->box,struct octBox);
    FREE_MEM(1,bl2,boxList);
  }
}

get_term_BB(term,box)
octObject *term,*box;
{
int found;
octObject box2;
octGenerator box_gen;

found = FALSE;
box->type = OCT_BOX;
OCTCHKOK(octInitGenContents(term,OCT_BOX_MASK,&box_gen));
while(octGenerate(&box_gen,&box2) == OCT_OK)
  {
    if(found == FALSE)
      {
	OCTCHKOK(octBB(&box2,&(box->contents.box)));
	found = TRUE;
      }
    else
      {
	if(box_is_bigger(&(box2.contents.box),&(box->contents.box)))
	  {
	    OCTCHKOK(octBB(&box2,&(box->contents.box)));
	  }	    
      }
  }
}
