#include "cpmInternal.h"

/*
 *	Simple, non-levelled (flat) scheduler for nodes
 */

/*
 *	Global variables
 */
struct cpmNode *EOL;
struct cpmNode *FLastNode, *FFirstNode;
unsigned FSchedCount;

void
Fschedule ( node )
struct cpmNode *node;
{
        if(node->sched != NULL) return; /* already scheduled */
        if(FFirstNode == EOL) FFirstNode = node;
        else FLastNode->sched = node;
        FLastNode = node;
	node->sched = EOL;
        FSchedCount++;
        return;
}

/* processing routine for scheduler */
struct cpmNode *
FnextNode()
{
        struct cpmNode *node;


	if(FFirstNode == EOL) return( NULL );
        node = FFirstNode;
        FFirstNode = node->sched;
        node->sched = NULL;
        return (node);

}

/*
 *  initialize the scheduler
 */
void
FschedInit()
{

        FSchedCount=0;
	EOL = ALLOC( struct cpmNode, 1 );
        FFirstNode = EOL;
        FLastNode = EOL;
}

/*
 *  return the number of schedules
 */
unsigned
FschedCount()
{
	return(FSchedCount);
}
