#include "port.h"
#include "cpm.h"
#include "utility.h"
#include "errtrap.h"
#define TRUE    1
#define FALSE   0
#define DUP     -1
#define NOROOM  0
#define OK      1
#define ERROR   -1
#define NODEHASH 13751
#define TRACE 1
#define TABLE 2
#define ELEMENT 4

#define RLEFT   -2
#define LEFT    -1
#define DCARE   0
#define RIGHT   1
#define RRIGHT  2
#define NODES   1
#define BRANCHES        2
#define FORWARD 1
#define REVERSE -1
#define ALL     9
#define UNDEF   -1
 
typedef struct cpmPath {
        struct cpmPath *next;              /* other branchPoints here 	*/
        struct cpmNode *branchPoint;       /* pointer to this branch point */
        int lower;      		   /* lower bound to branch point */
        int upper;      		   /* upper bound to branch point */
	struct cpmNode *upperConstraint;   /* edge constraining upper bd */
	struct cpmNode *lowerConstraint;   /* edge constraining lower bd */
	int active;			   /* dead (FALSE) or alive 	*/
} s_cpmPath;
/* errTrap stuff							*/

extern void cpmErrHandler();
extern int cpmDepth;
extern char *cpmRoutine;

#define CPM_START( name )\
	if( cpmDepth++ == 0 ){\
	    cpmRoutine = name;\
	    errPushHandler(cpmErrHandler);\
	}

#define CPM_END()\
	if( --cpmDepth == 0 ) errPopHandler();

/* internal functions							*/
extern s_cpmNode *FnextNode();
extern unsigned FschedCount();
extern void FschedInit();
extern void Fschedule();
extern s_cpmNode *LnextNode();
extern double LschedCount();
extern void LschedInit();
extern void Lschedule();
