#include "mkInternal.h"
/*** problems */
s_layer *Layerlist = NIL(s_layer);

/*
 * mk_get_layer
 * Copyright (c) 1986, Charles J Kring. All rights reserved.
 *
 * sets the layer pointer to the s_layer with the proper name.  If 
 * a s_layer si not found, a new one is created and its design rules
 * are read from TAP.
 */
void
mk_get_layer( array, name, layer )
s_array *array;		/* the array under construction			*/
char *name;		/* the name of the layer			*/
s_layer **layer;	/* the layer to be created			*/

{
    extern s_layer *Layerlist;		/* Global list of layers */
    octObject oFacet;
    octObject oLayer;

    for((*layer) = Layerlist; (*layer) != NIL( s_layer ); 
	(*layer) = (*layer)->next ){
	if( strcmp( (*layer)->name, name ) == 0 ) return;
    }
    (*layer) = mk_malloc_layer();
    (*layer)->next = Layerlist;
    Layerlist = (*layer);

    oFacet.objectId = array->contents.array.facetId;
    octGetById( &oFacet );

    oLayer.type = OCT_LAYER;
    oLayer.contents.layer.name = name;
    octGetOrCreate( &oFacet, &oLayer );
    (*layer)->objectId = oLayer.objectId;

    /* to get at the oLayer name stored in OCT				*/
    octGetById( &oLayer );
    (*layer)->name = oLayer.contents.layer.name;

    tapIsLayerDefined( &oFacet, oLayer.contents.layer.name );
    (*layer)->minWidth = tapGetMinWidth( &oLayer );

    /* an initial set of layer priorities which can be overriden	*/
    /* with the V_PRIORITY and H_PRIORITY properties in the rule facet	*/
    if ( strcmp( name, "MET2") == 0 ){
	(*layer)->hpriority = 4;
	(*layer)->vpriority = 3;
    } else if ( strcmp( (*layer)->name, "MET1") == 0 ){
	(*layer)->hpriority = 3;
	(*layer)->vpriority = 4;
    } else if ( strcmp( (*layer)->name, "POLY" ) == 0 ){
	(*layer)->hpriority = 2;
	(*layer)->vpriority = 2;
    } else if ( strcmp( (*layer)->name, "NDIF") == 0 ){
	(*layer)->hpriority = 1;
	(*layer)->vpriority = 1;
    } else if ( strcmp( (*layer)->name, "PDIF") == 0 ){
	(*layer)->hpriority = 1;
	(*layer)->vpriority = 1;
    } else {
	(*layer)->hpriority = UNDEF;
	(*layer)->vpriority = UNDEF;
    }
}
