/*LINTLIBRARY*/
#include "mkInternal.h"
/*
 * MkErrBuffer is declared here because nothing will work
 * if an array is not opened
 */
char MkErrBuffer[512];
char mkPkgName[] = "mkarray";
int mkDepth;
char *mkRoutine;

/*
 * mkOpenArray()
 */
void
mkOpenArray( arrayId, container )
mkId *arrayId;
octObject *container;
{
    s_array *array;
    char *mk_container_name();
    octObject oFacet;
    octObject oArray;

    MK_START( "mkOpenArray" );

    /* container not a facet or a bag					*/
    if(( container->type != OCT_FACET )&&(container->type != OCT_BAG )){
	errRaise( MK_PKG_NAME, 0,
	          "The container must be an OCT_FACET or an OCT_BAG");
    }

    array = mk_malloc_array();
    mk_init_array( array );

    if( container->type == OCT_FACET ){
	array->contents.array.facetId = container->objectId;
	oArray.type = OCT_BAG;
	oArray.contents.bag.name = "MKARRAY";
	octGetOrCreate( container, &oArray );
	array->contents.array.objectId = oArray.objectId;
    } else {
	octGetFacet( container, &oFacet );
	array->contents.array.facetId = oFacet.objectId;
	array->contents.array.objectId = container->objectId;
    }

    /* making the row and column constraint nodes			*/
    array->contents.array.Xgraph = ALLOC( struct cpmGraph, 1 );
    array->contents.array.Ygraph = ALLOC( struct cpmGraph, 1 );

    cpmInitGraph( array->contents.array.Xgraph );
    cpmInitGraph( array->contents.array.Ygraph );

    *arrayId = array->arrayId;
    mk_hash_array( array );

    MK_END();
}

