/*LINTLIBRARY*/
#include "mkInternal.h"
/*
 * mkPLaceArray
 *
 * Copyright (c) 1987, Charles J Kring. All rights reserved.
 *
 * This routine calls routines which build the X and Y constraint graphs
 * based on the placement of instances and terminals in the array, 
 * solve the constriant graph, and place the instances and net segments.
 * 
 * mkWireArray should be called before this routine if the array is to be 
 * wired by rules.
 */
void
mkPlaceArray( arrayId )
mkId arrayId;
{
    s_array *array;

    MK_START( "mkPlaceArray" );

    array = mk_get_array( arrayId );
    if( array->type == SUBARRAY )array = array->contents.subarray.array;

    mkSolveArray( array );
    mkPlaceInstances( array );
    mkPlaceNets( array );
    MK_END();
}
