#include "mkInternal.h"
/*
 * mk_read_term
 */
void
mk_read_term( array, element )
s_array *array;
s_element *element;
{
    octObject oTerm;
    octBox box;
    s_aterm *term;
    s_tframe *tframe;
    s_element *instance;
    octCoord size;
    char name[ 128 ];

    oTerm.objectId = element->objectId;
    octGetById( &oTerm );

    if (octIdIsNull(oTerm.contents.term.instanceId))
	octGenFirstContent( &oTerm, OCT_TERM_MASK, &oTerm );

    instance = mk_get_element( array, oTerm.contents.term.instanceId );
    if ( instance == NIL( s_element )){
	instance = mk_malloc_element();
	instance->objectId = oTerm.contents.term.instanceId;
	instance->type = OCT_INSTANCE;
	mk_read_instance( array, instance );
	mk_hash_element( array, instance );
    }

    for( term = instance->contents.instance->term; term != NIL( s_aterm );
	 term = term->next ){
	if (octIdsEqual(term->objectId, element->objectId)) {
	    element->contents.term = term;
	    term->element = element;
	    break;
	}
    }
    if( term == NIL( s_aterm )) MK_INT_ERROR( "lost an actual terminal");

    /* finding the bounding box of all the implementains of the term	*/

    box.lowerLeft.x = box.lowerLeft.y = CPM_INFINITY;
    box.upperRight.x = box.upperRight.y = -CPM_INFINITY;
    for( tframe = term->fterm->frame; tframe != NIL( s_tframe );
	 tframe = tframe->next ){
	box.lowerLeft.x = MIN( box.lowerLeft.x, tframe->box.lowerLeft.x );
	box.lowerLeft.y = MIN( box.lowerLeft.y, tframe->box.lowerLeft.y );
	box.upperRight.x = MAX( box.upperRight.x, tframe->box.upperRight.x );
	box.upperRight.y = MAX( box.upperRight.y, tframe->box.upperRight.y );
    }
    mk_transform_tframe( instance, &box );

    size = box.upperRight.x - box.lowerLeft.x;
    cpmInstallBranch( array->contents.array.Xgraph, 
		      &element->lnode, &element->rnode, NIL( s_cpmBranch ),
		      size, size, 0 );

    size = box.upperRight.y - box.lowerLeft.y;
    cpmInstallBranch( array->contents.array.Ygraph, 
		      &element->bnode, &element->tnode, NIL( s_cpmBranch ),
		      size, size, 0 );

    /* placing the terminal within the instance			*/

    if( array->contents.array.printGraph ){
	(void) sprintf(name,"%s.l", oTerm.contents.term.name);
	cpmResetNodeName( &element->lnode, name );

	(void) sprintf(name,"%s.r", oTerm.contents.term.name);
	cpmResetNodeName( &element->rnode, name );

	(void) sprintf(name,"%s.t", oTerm.contents.term.name);
	cpmResetNodeName( &element->tnode, name );

	(void) sprintf(name,"%s.b", oTerm.contents.term.name);
	cpmResetNodeName( &element->bnode, name );
    }
    cpmInstallNode( array->contents.array.Xgraph, &element->lnode );
    cpmInstallNode( array->contents.array.Xgraph, &element->rnode );
    cpmInstallNode( array->contents.array.Ygraph, &element->tnode );
    cpmInstallNode( array->contents.array.Ygraph, &element->bnode );

    cpmInstallBranch( array->contents.array.Ygraph, 
		      &instance->bnode, &element->bnode, NIL( s_cpmBranch ),
		      box.lowerLeft.y, box.lowerLeft.y, 0 );

    cpmInstallBranch( array->contents.array.Xgraph, 
		      &instance->lnode, &element->lnode, NIL( s_cpmBranch ),
		      box.lowerLeft.x, box.lowerLeft.x, 0 );

}
