/*LINTLIBRARY*/
#include "mkInternal.h"
/*
 * mk_sanitize_area
 *
 * ensures that the area is correct
 */
void
mk_sanitize_area( array, area )
s_array *array;
octBox *area;
{
    int tmp;

    /* switching the coordinates if the lowerLeft > upperRight		*/
    if( area->lowerLeft.x > area->upperRight.x ){
	tmp = area->lowerLeft.x;
	area->lowerLeft.x = area->upperRight.x;
	area->upperRight.x = tmp;
    }
    if( area->lowerLeft.y > area->upperRight.y ){
	tmp = area->lowerLeft.y;
	area->lowerLeft.y = area->upperRight.y;
	area->upperRight.y = tmp;
    }

    /* fixing MK_NULL_COORDS 						*/
    if( area->lowerLeft.y == MK_NULL_COORD ){
	area->lowerLeft.y = 0;
    } 
    if( area->lowerLeft.x == MK_NULL_COORD ){
	area->lowerLeft.x = 0;
    } 
    if( area->upperRight.y == MK_NULL_COORD ){
	area->upperRight.y = array->numRows - 1;
    } 
    if( area->upperRight.x == MK_NULL_COORD ){
	area->upperRight.x = array->numCols - 1;
    } 

    /* checking array bounds						*/
    if (( area->lowerLeft.y < 0 )||
	( area->lowerLeft.x < 0 )||
	( area->upperRight.y >= array->numRows )||
	( area->upperRight.x >= array->numCols )){
	errRaise( MK_PKG_NAME, 0,
		 "%s: area =  %s, array size = %s",
	         "The area overstepped the bounds of the array",
		 mk_print_area( area ), mk_print_array_bounds( array ));
    }
}
