/*LINTLIBRARY*/
#include "mkInternal.h" 
/* 
 * solveArray
 * Copyright (c) 1986, Charles J Kring. All rights reserved.
 * 
 */
void
mkSolveArray( array )
s_array *array;
{ 
    unsigned opflag;

    MK_START( "mkSolveArray" );

    opflag = CPM_SOLVE|CPM_NONCRIT;
    if( array->contents.array.debug > 0) opflag |= CPM_VERBOSE;
    if( array->contents.array.debug > 1) opflag |= CPM_OVERCON;

    array->contents.array.Xgraph->graphName = util_strsav("horizontal");
    array->contents.array.Ygraph->graphName = util_strsav("vertical");
    if( cpmSolveGraph( array->contents.array.Xgraph, opflag ) < CPM_OK ){
	mk_relax_segments( array, MK_VER_SEG );
	if( cpmSolveGraph( array->contents.array.Xgraph, opflag ) < CPM_OK ){
	    errRaise( MK_PKG_NAME, 0,
		    "Could not solve horizontal constraint graph");
	}
    }
    if( cpmSolveGraph( array->contents.array.Ygraph, opflag ) < CPM_OK ){
	mk_relax_segments( array, MK_HOR_SEG );
	if( cpmSolveGraph( array->contents.array.Ygraph, opflag ) < CPM_OK ){
	    errRaise( MK_PKG_NAME, 0,
		    "Could not solve vertical constraint graph");
	}
    }
    MK_END();
}
