#include "mkInternal.h"
char Strings[ 4 ][256];
static int StringsIndex = 0;
#define NEXT_STRING Strings[ (StringsIndex++)%4 ]
void
mkPrintSubarrayLinking( subArrayId )
mkId subArrayId;
{
    s_array *subArray, *getArray();
    int index;

    MK_START( "mkPrintSubarrayLinking" );

    subArray = mk_get_array( subArrayId );

    if( subArray->type == ARRAY ){
	fprintf( stderr, "Array is a full array, with %d rows and %d cols\n",
			 subArray->numRows, subArray->numCols );
	MK_END();
	return;
    } 

    fprintf( stderr, "The subarray has %d rows and %d cols\n",
		     subArray->numRows, subArray->numCols );
    fprintf( stderr, "Its array has %d rows and %d cols\n",
		     subArray->contents.subarray.array->numRows, 
		     subArray->contents.subarray.array->numCols );
    
    fprintf( stderr, "X means the subarray was not linked\n");
    fprintf( stderr, "The row mapping:\nsubarray\n" );
    for( index = 0; index < subArray->numRows; index++ ){
	fprintf( stderr,"%5d", index );
	if( index != 0 && index%20 == 0 )fprintf(stderr, "\n");
    }
    fprintf( stderr, "\narray:\n" );
    for( index = 0; index < subArray->numRows; index++ ){
	if( subArray->contents.subarray.rowmap[ index ] == MK_UNMAPPED_COORD ){
	    fprintf( stderr,"    X");
	} else {
	    fprintf( stderr,"%5d", subArray->contents.subarray.rowmap[ index ]);
	}
	if( index != 0 && index%20 == 0 )fprintf(stderr, "\n");
    }
    fprintf( stderr, "\nThe column mapping:\nsubarray:\n" );
    for( index = 0; index < subArray->numCols; index++ ){
	fprintf( stderr,"%5d", index );
	if( index != 0 && index%20 == 0 )fprintf(stderr, "\n");
    }
    fprintf( stderr, "\narray:\n" );
    for( index = 0; index < subArray->numCols; index++ ){
	if( subArray->contents.subarray.colmap[ index ] == MK_UNMAPPED_COORD ){
	    fprintf( stderr,"    X");
	} else {
	    fprintf( stderr,"%5d", subArray->contents.subarray.colmap[ index ]);
	}
	if( index != 0 && index%20 == 0 )fprintf(stderr, "\n");
    }
    MK_END();
}

void
mkPrintTranslation( subArrayId, subArea )
mkId subArrayId;
struct octBox *subArea;
{
    int mapping;
    s_array *subArray, *getArray();

    MK_START( "mkPrintTranslation" );

    subArray = mk_get_array( subArrayId );

    if( subArray->type == ARRAY ){
	fprintf( stderr, "Array is not a subarray\n");
    } else {
	mapping = subArray->contents.subarray.rowmap[ subArea->lowerLeft.y ];
	fprintf( stderr, "subArray[ %d ][] ", subArea->lowerLeft.y );
	if( mapping == MK_UNMAPPED_COORD ) fprintf( stderr," is unmapped\n");
	else if( mapping == MK_NULL_COORD ) fprintf( stderr," is unmapped\n");
	else fprintf( stderr, "maps to array[ %d ][]\n", mapping );

	mapping = subArray->contents.subarray.rowmap[ subArea->upperRight.y ];
	fprintf( stderr, "subArray[ %d ][] ", subArea->upperRight.y );
	if( mapping == MK_UNMAPPED_COORD ) fprintf( stderr," is unmapped\n");
	else if( mapping == MK_NULL_COORD ) fprintf( stderr," is unmapped\n");
	else fprintf( stderr, "maps to array[ %d ][]\n", mapping );

	mapping = subArray->contents.subarray.colmap[ subArea->lowerLeft.x ];
	fprintf( stderr, "subArray[][ %d ] ", subArea->lowerLeft.x );
	if( mapping == MK_UNMAPPED_COORD ) fprintf( stderr," is unmapped\n");
	else if( mapping == MK_NULL_COORD ) fprintf( stderr," is unmapped\n");
	else fprintf( stderr, "maps to array[][ %d ]\n", mapping );

	mapping = subArray->contents.subarray.colmap[ subArea->upperRight.y ];
	fprintf( stderr, "subArray[][ %d ] ", subArea->upperRight.y );
	if( mapping == MK_UNMAPPED_COORD ) fprintf( stderr," is unmapped\n");
	else if( mapping == MK_NULL_COORD ) fprintf( stderr," is unmapped\n");
	else fprintf( stderr, "maps to array[][ %d ]\n", mapping );
    }
    MK_END();
}

char *
mk_print_area( area )
octBox *area;
{
    char *string;

    string = NEXT_STRING;
    (void) sprintf( string, "(( %d, %d ),( %d, %d ))",
	     area->lowerLeft.x, area->lowerLeft.y,
	     area->upperRight.x, area->upperRight.y );
    return( string );
}
char *
mk_print_array_bounds( array )
s_array *array;
{
    char *string;

    string = NEXT_STRING;
    (void) sprintf( string, "%d x %d",
	             array->numRows, array->numCols );
    return( string );
}
