/*
 *  NUMBER DEFINITIONS
 *
 *  Author: 
 *      Kenneth S. Kundert
 *      UC Berkeley
 *
 *  Advising professor:
 *      Alberto Sangiovanni-Vincentelli
 *
 *  This module contains the definitons for the data structures and macros
 *  for real and complex numbers and their constants. Also included in this
 *  file is some type definitions for some C library functions.
 *
 *  >>> Revision information:
 *  $ Author: $
 *  $ Date: $
 *  $ Revision: $
 *  $ State: $
 */







/*
 *   MACRO DEFINITIONS
 *
 *   Macros are distinguished by using solely capital letters in their
 *   identifiers.  This contrasts with C defined identifiers which are strickly 
 *   lower case, and program variable and procedure names which use both upper 
 *   and lower case.
 */

/* Begin macros. */

/* NUMBERS */
#define PI   		   	3.14159265358973923846264338327950288419716939937511
#define ROOT_PI			1.77245385090550079417941169385593807863773354094388
#define TWO_PI			(2.0 * PI)
#define ROOT_TWO		1.41421356237309504880168872420969807856967187537694
#define ELECTRON_CHARGE		1.602191770e-19
#define BOLTZMANN_CONSTANT	1.38062259e-23
#define VELOCITY_OF_LIGHT	2.997924562e8
#define ZERO_DEGREES_CELSIUS	273.15
#define GCONST			.39894228040143610659         /* 1 / ROOT_TWO / ROOT_PI */


#define	MAX_INT			2147483647
#define MAX_DOUBLE              1.7014118346046923171e+38
#define MAX_FLOAT        	((float)1.701411733192644299e+38)
#define MIN_DOUBLE       	(0.01 * 2.938735877055718770e-37)
#define MIN_FLOAT        	((float)MINDOUBLE)
