#ifndef OCTTOOLS_COPYRIGHT_H
#define OCTTOOLS_COPYRIGHT_H
/*
 * Oct Tools Distribution 3.0
 *
 * Copyright (c) 1988, 1989, Regents of the University of California.
 * All rights reserved.
 *
 * Use and copying of this software and preparation of derivative works
 * based upon this software are permitted.  However, any distribution of
 * this software or derivative works must include the above copyright
 * notice.
 *
 * This software is made available AS IS, and neither the Electronics
 * Research Laboratory or the University of California make any
 * warranty about the software, its performance or its conformity to
 * any specification.
 *
 * Suggestions, comments, or improvements are welcome and should be
 * addressed to:
 *
 *   octtools@eros.berkeley.edu
 *   ..!ucbvax!eros!octtools
 */

#if !defined(lint) && !defined(SABER)
static char copyright[] = "Copyright (c) 1988, Regents of the University of California.  All rights reserved.";
#endif
#endif 

octStatus Mstatus;
int dumpCore;
#define OCT_GET_BY_NAME( container, object, error_msg) 					\
{									\
	Mstatus = octGetByName( container, object ); 				\
	switch(Mstatus){							\
	    case 1:								\
	    case -5:							\
		break;							\
	    default:							\
		octError( error_msg ); 					\
		FPRINTF( stderr, "Routine octGetByName returns %d \n", Mstatus );	\
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	}									\
}

#define OCT_GET_BY_ID( object, error_msg)						\
{									\
	Mstatus = octGetById( object );					\
	switch(Mstatus){							\
	    case 1:								\
	    case -5:							\
		break;							\
	    default:							\
		octError( error_msg );					\
		FPRINTF( stderr, "Routine octGetById returns %d \n", Mstatus );	\
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	}									\
}

#define OCT_GENERATE( generator, object, error_msg) 					\
{ 									\
	Mstatus = octGenerate( generator, object );		\
	switch(Mstatus){							\
	    case 1:								\
	    case 4:							\
		break;							\
	    default:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octGenerate returns %d \n", Mstatus );		\
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	}									\
}

#define OCT_INIT_GEN_CONTENTS( object, mask, generator, error_msg) 			\
{ 									\
	if( ( Mstatus = octInitGenContents( object, mask, generator ) ) != OCT_OK ) {\
	    octError( error_msg );						\
	    FPRINTF( stderr, "Routine octInitGenContents returns %d \n", Mstatus );	\
	    if( dumpCore ) 						\
		abort();				\
	    else							\
		exit(Mstatus);						\
	}									\
}

#define OCT_INIT_GEN_CONTAINERS( object, mask, generator, error_msg) 			\
{ 									\
	if( ( Mstatus = octInitGenContainers( object, mask, generator ) ) != OCT_OK ) {\
	    octError( error_msg );						\
	    FPRINTF( stderr, "Routine octInitGenContainers returns %d \n", Mstatus );	\
	    if( dumpCore ) 						\
		abort();				\
	    else							\
		exit(Mstatus);						\
	}									\
}


#define OCT_GET_CONTAINER_BY_NAME( content, object, error_msg) 			\
{ 									\
	Mstatus = octGetContainerByName( content, object );\
	switch(Mstatus){							\
	    case 1:								\
	    case -5:							\
		break;							\
	    default:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octGetContainerByName returns %d \n", Mstatus );	\
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	}									\
}

#define OCT_DELETE_M( object, error_msg) 			\
{ 									\
	Mstatus = octDelete( object );\
	switch(Mstatus){							\
	    case 1:								\
	    case -5:							\
		break;							\
	    default:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octDelete returns %d \n", Mstatus );	\
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	}									\
}

#define OCT_ATTACH( content, object, error_msg) 			\
{ 									\
	Mstatus = octAttach( content, object );\
	switch(Mstatus){							\
	    case 1:								\
	    case 6:							\
	    case 7:							\
		break;							\
	    default:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octAttach returns %d \n", Mstatus );	\
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	}									\
}

#define OCT_CREATE_M( content, object, error_msg) 			\
{ 									\
	if( ( Mstatus = octCreate( content, object ) ) != OCT_OK ) {\
	    octError( error_msg );						\
	    FPRINTF( stderr, "Routine octCreate returns %d \n", Mstatus );	\
	    if( dumpCore ) 						\
		abort();				\
	    else							\
		exit(Mstatus);						\
	}									\
}

#define OCT_GEN_FIRST_CONTAINER( content, mask, object, error_msg) 			\
{ 									\
	Mstatus = octGenFirstContainer( content, mask, object );		\
	switch(Mstatus){							\
	    case 1:								\
	    case 4:							\
		break;							\
	    default:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octGenFirstContainer returns %d \n", Mstatus );		\
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	}									\
}

#define OCT_GEN_FIRST_CONTENT( container, mask, object, error_msg) 		\
{ 									\
	Mstatus = octGenFirstContent( container, mask, object );		\
	switch(Mstatus){							\
	    case 1:								\
	    case 4:							\
		break;							\
	    default:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octGenFirstContent returns %d \n", Mstatus );		\
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	}									\
}

#define OCT_OPEN_FACET( facet, error_msg )					\
{										\
	Mstatus = octOpenFacet( facet );					\
	switch(Mstatus){							\
	    case 1:							\
	    case 2:							\
	    case 3:							\
	    case 5:							\
		break;							\
	    case -2:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octOpenFacet returns OCT_NO_EXIST <%d>\n", Mstatus ); \
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	    case -3:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octOpenFacet returns OCT_NO_PERM <%d>\n", Mstatus );	\
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	    case -5:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octOpenFacet returns OCT_NOT_FOUND <%d>\n", Mstatus); \
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	    default:							\
		octError( error_msg );						\
		FPRINTF( stderr, "Routine octOpenFacet returns OCT_NOT_FOUND <%d>\n", Mstatus); \
		if( dumpCore ) 						\
		    abort();				\
		else							\
		    exit(Mstatus);						\
	}									\
}
