#include "copyright.h"
#include "port.h"
#include	"oct.h"
#include	"octPlacement.h"


octObject	OLDInstanceClass; /* obsolete */
octObject	InstanceClass;	/* obsolescent */
octObject	PlacementClass;
octObject	Mobility;
octObject	TranCons;
octObject	Direction;
octObject	FloorplanBag;
octObject	MinHeightOverWidth;
octObject	MaxHeightOverWidth;
octObject	FloatingEdge;
octObject	PadEdge;
octObject	PeakCurrent;
octObject	TermEdge;
octObject	TermRelPosition;
octObject	TermType;
octObject	JoinedTerms;
octObject	OrderTerms;
octObject	NetType;
octObject	Criticality;
octObject	Technology;
octObject	ConnectorBag;
octObject	InstanceBag;
octObject	PadBondingPinsNet;
octObject	PadInternalPinsNet;
octObject	PadSupplyRing;
octObject	PadGroundRing;
octObject	PadPowerRequired;
octObject	PadMinSeparation;

/*
 *   initPlacementObjects()
 *   Initializes some useful oct objects
 */
initPlacementObjects()
{
  OLDInstanceClass.type= OCT_PROP;
  OLDInstanceClass.contents.prop.name = "INSTANCECLASS";
  OLDInstanceClass.contents.prop.type = OCT_STRING;

  InstanceClass.type= OCT_PROP;
  InstanceClass.contents.prop.name = "INSTANCE_CLASS";
  InstanceClass.contents.prop.type = OCT_STRING;

  PlacementClass.type= OCT_PROP;
  PlacementClass.contents.prop.name = "PLACEMENT_CLASS";
  PlacementClass.contents.prop.type = OCT_STRING;

  TermType.type = OCT_PROP;
  TermType.contents.prop.name = "TERMTYPE";
  TermType.contents.prop.type = OCT_STRING;

  Direction.type = OCT_PROP;
  Direction.contents.prop.name = "DIRECTION";
  Direction.contents.prop.type = OCT_STRING;

  JoinedTerms.type = OCT_BAG;
  JoinedTerms.contents.bag.name = "JOINEDTERMS";

  OrderTerms.type = OCT_BAG;
  OrderTerms.contents.bag.name = "ORDERTERMS";


  NetType.type = OCT_PROP;
  NetType.contents.prop.name = "NETTYPE";
  NetType.contents.prop.type = OCT_STRING;

  Criticality.type = OCT_PROP;
  Criticality.contents.prop.name = "CRITICALITY";
  Criticality.contents.prop.type = OCT_INTEGER;

  Mobility.type = OCT_PROP;
  Mobility.contents.prop.name = "MOBILITY";
  Mobility.contents.prop.type = OCT_STRING;

  TranCons.type = OCT_PROP;
  TranCons.contents.prop.name = "TRANSFORMCONSTRAINTS";
  TranCons.contents.prop.type = OCT_INTEGER;

  FloorplanBag.type = OCT_BAG;
  FloorplanBag.contents.bag.name = "FLOORPLAN";
    
  MinHeightOverWidth.type = OCT_PROP;
  MinHeightOverWidth.contents.prop.name = "MIN_Y_OVER_X";
  MinHeightOverWidth.contents.prop.type = OCT_REAL;

  MaxHeightOverWidth.type = OCT_PROP;
  MaxHeightOverWidth.contents.prop.name = "MAX_Y_OVER_X";
  MaxHeightOverWidth.contents.prop.type = OCT_REAL;

  FloatingEdge.type = OCT_PROP;
  FloatingEdge.contents.prop.name = "TERM_FLOATING_EDGES";
  FloatingEdge.contents.prop.type = OCT_STRING;

  PadEdge.type = OCT_PROP;
  PadEdge.contents.prop.name = "PAD_EDGE";
  PadEdge.contents.prop.type = OCT_STRING;


  PeakCurrent.type = OCT_PROP;
  PeakCurrent.contents.prop.name = "PEAKCURRENT";
  PeakCurrent.contents.prop.type = OCT_REAL ;

  TermEdge.type = OCT_PROP;
  TermEdge.contents.prop.name = "TERM_EDGE";
  TermEdge.contents.prop.type = OCT_STRING;

  TermRelPosition.type = OCT_PROP;
  TermRelPosition.contents.prop.name = "TERM_RELATIVE_POSITION";
  TermRelPosition.contents.prop.type = OCT_REAL;

  Technology.type = OCT_PROP;
  Technology.contents.prop.name = "TECHNOLOGY";
  Technology.contents.prop.type = OCT_STRING;

  ConnectorBag.type = OCT_BAG;
  ConnectorBag.contents.bag.name = "CONNECTORS";

  InstanceBag.type = OCT_BAG;
  InstanceBag.contents.bag.name = "INSTANCES";


  PadBondingPinsNet.type = OCT_NET;
  PadBondingPinsNet.contents.net.name = "PAD_BONDING_PINS";

  PadInternalPinsNet.type = OCT_NET;
  PadInternalPinsNet.contents.net.name = "PAD_INTERNAL_PINS";

  PadSupplyRing.type = OCT_NET;
  PadSupplyRing.contents.net.name = "PAD_SUPPLY_RING";

  PadGroundRing.type = OCT_NET;
  PadGroundRing.contents.net.name = "PAD_GROUND_RING";

  PadPowerRequired.type = OCT_PROP;
  PadPowerRequired.contents.prop.name = "PAD_VDD_GND_REQUIRED";
  PadPowerRequired.contents.prop.type = OCT_REAL;
  
  PadMinSeparation.type = OCT_PROP;
  PadMinSeparation.contents.prop.name = "PAD_MINIMUM_SEPARATION";
  PadMinSeparation.contents.prop.type = OCT_INTEGER;


}

