#include "copyright.h"
#include "port.h"
#include "defs.h"
/* 
 * addPadToEdge
 *
 * puts padP in the ordered list of pads on pad->edge
 */
addPadToEdge( chippads, padP , side, positionInSide, row )
    ChipPads* chippads;
    Pad *padP;
    int	side;
    double positionInSide;
    int	row;
{
    Pad *padPtr;
    extern char* stringSide();

    padP->termEdge = stringSide( side );
    padP->side = side;
    padP->relPos = positionInSide ;
    padP->row = row;

    chippads->totalWidth[row][ padP->side ] += padP->width;
    if( chippads->padsInEdge[row][ padP->side ]++ == 0 ){

	padP->nextInEdge = NULL;
	padP->precInEdge = NULL;
	chippads->LastPadInEdge[row][ padP->side ] = padP;
	chippads->FirstPadInEdge[row][ padP->side ] = padP;

    } else if( chippads->LastPadInEdge[row][ padP->side ]->relPos <= padP->relPos ){

	padP->nextInEdge = NULL;
	padP->precInEdge = chippads->LastPadInEdge[row][ padP->side ];
	chippads->LastPadInEdge[row][ padP->side ] = padP;

    } else if ( chippads->FirstPadInEdge[row][ padP->side ]->relPos >= padP->relPos ){

	padP->nextInEdge = chippads->FirstPadInEdge[row][ padP->side ];
	padP->precInEdge = NULL;
	chippads->FirstPadInEdge[row][ padP->side ] = padP;

    } else {

	padPtr = chippads->FirstPadInEdge[row][ padP->side ];
	while( padPtr->relPos < padP->relPos ) padPtr = padPtr->nextInEdge;
	padP->nextInEdge = padPtr;
	padP->precInEdge = padPtr->precInEdge;

    }
    if( padP->nextInEdge != NULL ) padP->nextInEdge->precInEdge = padP;
    if( padP->precInEdge != NULL ) padP->precInEdge->nextInEdge = padP;

    if (verbose) {
	(void)printf("Pad %20s at %5.2g on the %6s side (row %d)\n",
		     padP->name, padP->relPos, stringSide( padP->side ), padP->row);
    }


}


Pad* newPad( chippads )
    ChipPads* chippads;
{
    Pad* pad = ALLOC( Pad, 1 );

    chippads->numberOfPads++;
    if (chippads->numberOfPads == 1) { /* Link the pad to the list of all pads */
	chippads->FirstPad = pad;
    } 

    if ( chippads->LastPad == 0 ) {
	chippads->LastPad = pad;
	pad->prec = 0;
    } else {
	pad->prec = chippads->LastPad;
	chippads->LastPad->next = pad;
	chippads->LastPad = pad;
    }
    pad->next = 0;

    initPad( pad );
    
    return pad;
}

