#include "copyright.h"
#include "port.h"
#include "defs.h"

/*
 */

int
putSparcsConstraints(padInstP, side)
    octObject *padInstP;
    int side;
{
  octObject firstBag;
  octObject secondBag;
  octObject constBag;
  octObject Max, Min;
  int min, max;
  char *stringSide();

  if (verbose)  (void) printf("Sparcs constraint: %s to %s\n",
		       padInstP->contents.instance.name,
		       stringSide(side));

  constBag.type = OCT_BAG;
  constBag.contents.bag.name = "CONSTRAINT";

  /* See if adding an x or a y constraint. */
  firstBag.type = OCT_BAG;
  if (side == LEFT || side == RIGHT ) {
    firstBag.contents.bag.name = "XCONSTRAINTS";
  } else if (side == TOP || side == BOTTOM) {
    firstBag.contents.bag.name = "YCONSTRAINTS";
  } else {
    (void) sprintf(buf, "No side assigned to pad %s: cannot add sparcs constraints",
		    padInstP->contents.instance.name);
    Warning(buf);
    return(-1);
  }

  OH_ASSERT(octGetOrCreate(&Chip, &firstBag));   /* Get or create the top-level bag. */

  max =  0; min = 0;
  Max.type = OCT_PROP;
  Max.contents.prop.type = OCT_INTEGER;
  Max.contents.prop.name = "MAX";
  Max.contents.prop.value.integer = max;
  Min.type = OCT_PROP;
  Min.contents.prop.type = OCT_INTEGER;
  Min.contents.prop.name = "MIN";
  Min.contents.prop.value.integer = min;

  secondBag.type = OCT_BAG;
  if (side == LEFT)  {
    secondBag.contents.bag.name = "LEFT";
  } else if (side == RIGHT) {
    secondBag.contents.bag.name = "RIGHT";
  } else if (side == TOP )  {
    secondBag.contents.bag.name = "TOP";
  } else  {
    secondBag.contents.bag.name = "BOTTOM";
  }

  OH_ASSERT(octGetOrCreate(&firstBag, &secondBag)); 
  OH_ASSERT(octCreate(&secondBag, &constBag));
  OH_ASSERT(octAttach(&constBag, padInstP)); 
  OH_ASSERT(octCreate(&constBag, &Max));
  OH_ASSERT(octCreate(&constBag, &Min));

  return(1);
}
