#include "defs.h"
#include "global.h"

static int avCells;			/* count cells to anneal */
static int avNets;			/* count nets to anneal */
static int avFloatTerms;		/* count floating terms to anneal */

int
createAnnealVar(type,object)
    annealVarType  type;
    char 	*object;
{
  AnnealVar	*annealVar;
  ListElt	*annealVarLE;


  if (floatingTermsOnly == TRUE && type != AV_FLOAT_TERM) return(OK);
  
  if (numberOfAnnealVars == 0) {
    avCells = avNets = avFloatTerms = 0;
  }
  annealVar = SH_MALLOC( AnnealVar, 1);
  annealVar->type = type;
  switch (type) {
 case AV_CELL:
    annealVar->pointer.cell = (MacroCell *) object;
    avCells++;
    break;
 case AV_FLOAT_TERM:
    annealVar->pointer.term = (Term *) object;
    avFloatTerms++;
    break;
 case AV_NET:
    annealVar->pointer.net  = (Net *) object;
    avNets++;
    break;
 default:
    FatalError("Wrong type for annealing variable");
    break;
  }
  annealVar->ownerNext = NULL;
  annealVar->ownerPrec = NULL;
  annealVar->owner = 0;			/* Simple initialization */
  
  annealVarLE = SH_MALLOC( ListElt, 1);
  annealVarLE->pointer.annealVar = annealVar;
  numberOfAnnealVars++;
  linkEltToListHandle(&ListOfAnnealVars, annealVarLE);
  return(OK);
}


char *annealVarStatsString()
{
  static char str[40];
  
  (void) sprintf(str,"%d Cells + %d Nets + %d Float Terms", avCells, avNets, avFloatTerms);
  return(str);
}




