#include "defs.h"
#include "global.h"
#include "parall.h"


CurClusterCost( costP )
     Cost *costP;			/* RETURN */
{
  int			I;		/* counter */
  
  if (SM_clusterWeight > 0.0) {
    costP->cluster = 0.0;
    for (I=0 ; I < P ; I++) {
      costP->cluster += process[I].curCluster.momentum;
    }
  } else {
    costP->cluster = 0.0;
  }
}

/* cost due to the clustering of the cells */

MoveClusterCost(moveP)
    Move	*moveP;
{
  int	n;			/* a processor number */
  /*
   * this cost is computed only when the move is the
   * change of ownership. It does't affect the primary
   * cost
   */
  n = moveP->procNumber;
  if (moveP->type == CHANGE_OWNERSHIP) {
    moveP->cost.cluster = 
      myProc->newCluster.momentum - myProc->curCluster.momentum +
      process[n].newCluster.momentum - process[n].curCluster.momentum;
  }
}
