#include "defs.h"
#include "global.h"
#include "parall.h"


CurOverlapCost( costP )
     Cost *costP;			/* RETURN */
{
    extern int	curOverlap();
    int	I,J;			/* counter */

    /*   if (enableSubnets) curNetAngles(); */

    /* primaryCost due to overlap: Brute force method, but it is good enough here */
    /* Subtract the part due to overlap between fixed cells */
  
    costP->overlap = 0.0;
    if (SM_ovWeight > 0.0) {
	for (I=1 ; I <= numberOfCells ; I++) {
	    for (J = I+1; J <= numberOfCells ; J++) {
		if (allCellsArray[I]->mobility != FIXED || allCellsArray[J]->mobility != FIXED) {
		    costP->overlap += curOverlap(allCellsArray[I],allCellsArray[J]);
		}
	    }
	    if (allCellsArray[I]->mobility != FIXED) {
		costP->overlap += boundaryOverlap(allCellsArray[I],CURRENT);
	    }
	}
    }  
}



MoveOverlapCost(moveP)
    Move *moveP;		/* descriptor of the current move */
{
  int		curCellOverlap;
  int		newCellOverlap;
  int		curOverlap();
  int		newOverlap();
  int		newNewOverlap();
  int		TWoverlap();

  /*  cost due to overlap   */
  switch (moveP->type) {
  case TRANSLATION:
  case ALIGNMENT:
  case RL_TRANSLATION:
  case TRANSLATE_AND_TRANSFORM:
  case TRANSFORMATION:
    curCellOverlap = TWoverlap(moveP->cell, CURRENT);
    newCellOverlap = TWoverlap(moveP->cell, NEW);
    curCellOverlap += boundaryOverlap(moveP->cell,CURRENT);
    newCellOverlap += boundaryOverlap(moveP->cell,NEW);
    break;
  case CC_INTERCHANGE:
  case BB_INTERCHANGE:
    curCellOverlap = TWoverlap(moveP->cell, CURRENT);
    newCellOverlap = TWoverlap(moveP->cell, NEW);
    curCellOverlap += TWoverlap(moveP->cell2, CURRENT);
    newCellOverlap += TWoverlap(moveP->cell2, NEW);
    /* correct mutual overlap */
    curCellOverlap -= curOverlap(moveP->cell,moveP->cell2);
    newCellOverlap -= newOverlap(moveP->cell,moveP->cell2);
    newCellOverlap -= newOverlap(moveP->cell2,moveP->cell);
    newCellOverlap += newNewOverlap(moveP->cell,moveP->cell2);
    /* overlap with the boundary */
    curCellOverlap += boundaryOverlap(moveP->cell,CURRENT);
    curCellOverlap += boundaryOverlap(moveP->cell2,CURRENT);
    newCellOverlap += boundaryOverlap(moveP->cell,NEW);
    newCellOverlap += boundaryOverlap(moveP->cell2,NEW);

    break;
  case TERMINAL_MOVE:
  case SUBNET_MOVE:
  case CHANGE_OWNERSHIP:
  default:
    curCellOverlap = newCellOverlap = 0.0;
    break;
  }
  moveP->cost.overlap = newCellOverlap - curCellOverlap;
}


