/*
 *  FILE: errors.c
 *
 *  DESCRIPTION:
 *
 *
 *  CREATION DATE: xx/xx/xx		AUTHOR:
 *
 *  FUNCTIONS:
 */
#include "defs.h"
#include "global.h"
extern char *progName;
extern int  myself;

FatalError(es)
     char *es;			/* error string */
{
  if (debug) sign(stderr);
  fprintf(stderr,"\n\n%s: Fatal Error: %s\n" , progName, es);
#ifdef PARALLEL
  manageChildren(0);		/* kill all children, if any */
#endif
  VOVend(1);
}

FatalOctError(es)
     char *es;			/* error string */
{
  if (debug) sign(stderr);
  fprintf(stderr,"\n\n%s: Fatal Error: %s\n" , progName, es);
  octError("Last OCT error");
#ifdef PARALLEL
  manageChildren(0);		/* kill all children, if any */
#endif
  VOVend(1);
}

Warning(es)
     char *es;			/* error string */
{
  if (XDisplayActive) {
    displayWarning(es);
  } else {
    if (debug) sign(stderr);
    fprintf(stderr, "%s: Warning: %s\n", progName, es);
  }
  DFwriteComment(es);
}


Message(es)
     char *es;			/* error string */
{
  if (XDisplayActive) {
    displayMessage(es);
  } else {
    if (debug) sign(stderr);
    printf("%s: Message: %s\n", progName, es);
  }
}


char *CheckPtr(val)
    char *val;
{
  if (val == NIL(char)) FatalError("Ran out of memory -- good-bye");
  return(val);
}

/* output to fp your PID number, as signature */
int
sign(fp)
    FILE *fp;
{
  fprintf(fp,"-%ld-",mypid);
}
