#include  "copyright.h"
#include  "port.h"
#include	"oct.h"
#include	"octPlacement.h"

octObject	LayerPlace; 
octObject	InstanceClass;	/* obsolete */
octObject	OLDInstanceClass;	/* obsolete */
octObject	PlacementClass;
octObject	Mobility;
octObject	TranCons;
octObject	LegalTransform;
octObject	PlacCons;
octObject	FloorplanBag;
octObject	MinHeightOverWidth;
octObject	MaxHeightOverWidth;
octObject	FloatingEdge;
octObject	OldFloatingEdge; /* temporary to facilitate change of policy */
octObject	TermEdge;
octObject       RelTermPosition;
octObject	TermType;
octObject	SideRestrictions;
octObject	JoinedTerms;
octObject	OrderTerms;
octObject	PermTerms;
octObject	NetType;
octObject	Criticality;
octObject	NetMaxLength;

 
/*
 *   initializePlacementObjects()
 *   Initializes some useful oct objects
 */
initializePlacementObjects()
{
  LayerPlace.type = OCT_LAYER;
  LayerPlace.contents.layer.name = "PLACE";

  OLDInstanceClass.type= OCT_PROP;
  OLDInstanceClass.contents.prop.name = "INSTANCECLASS";
  OLDInstanceClass.contents.prop.type = OCT_STRING;
  

  InstanceClass.type= OCT_PROP;
  InstanceClass.contents.prop.name = "INSTANCE_CLASS";
  InstanceClass.contents.prop.type = OCT_STRING;
  
  PlacementClass.type= OCT_PROP;
  PlacementClass.contents.prop.name = "PLACEMENT_CLASS";
  PlacementClass.contents.prop.type = OCT_STRING;

  TermType.type = OCT_PROP;
  TermType.contents.prop.name = "TERMTYPE";
  TermType.contents.prop.type = OCT_STRING;

  SideRestrictions.type = OCT_PROP;
  SideRestrictions.contents.prop.name = "SIDERESTRICTIONS";
  SideRestrictions.contents.prop.type = OCT_STRING;

  JoinedTerms.type = OCT_BAG;
  JoinedTerms.contents.bag.name = "JOINEDTERMS";

  OrderTerms.type = OCT_BAG;
  OrderTerms.contents.bag.name = "ORDERTERMS";

  PermTerms.type = OCT_BAG;
  PermTerms.contents.bag.name = "PERMTERMS";

  NetType.type = OCT_PROP;
  NetType.contents.prop.name = "NETTYPE";
  NetType.contents.prop.type = OCT_STRING;

  Criticality.type = OCT_PROP;
  Criticality.contents.prop.name = "NET_CRITICALITY";
  Criticality.contents.prop.type = OCT_INTEGER;

  NetMaxLength.type = OCT_PROP;
  NetMaxLength.contents.prop.name = "NET_MAX_LENGTH"; /* temporary property */
  NetMaxLength.contents.prop.type = OCT_INTEGER;

  Mobility.type = OCT_PROP;
  Mobility.contents.prop.name = "MOBILITY";
  Mobility.contents.prop.type = OCT_STRING;

  TranCons.type = OCT_PROP;
  TranCons.contents.prop.name = "TRANSFORMCONSTRAINTS";
  TranCons.contents.prop.type = OCT_INTEGER;

  LegalTransform.type = OCT_PROP;
  LegalTransform.contents.prop.name = "LEGAL_TRANSFORMATIONS";
  LegalTransform.contents.prop.type = OCT_STRING;

  PlacCons.type = OCT_PROP;
  PlacCons.contents.prop.name = "PLACCONS";
  PlacCons.contents.prop.type = OCT_INTEGER;

  FloorplanBag.type = OCT_BAG;
  FloorplanBag.contents.bag.name = "FLOORPLAN";
    
  MinHeightOverWidth.type = OCT_PROP;
  MinHeightOverWidth.contents.prop.name = "MIN_Y_OVER_X";
  MinHeightOverWidth.contents.prop.type = OCT_REAL;

  MaxHeightOverWidth.type = OCT_PROP;
  MaxHeightOverWidth.contents.prop.name = "MAX_Y_OVER_X";
  MaxHeightOverWidth.contents.prop.type = OCT_REAL;

  FloatingEdge.type = OCT_PROP;
  FloatingEdge.contents.prop.name = "TERM_FLOATING_EDGES";
  FloatingEdge.contents.prop.type = OCT_STRING;

  OldFloatingEdge.type = OCT_PROP;
  OldFloatingEdge.contents.prop.name = "FLOATINGEDGE";
  OldFloatingEdge.contents.prop.type = OCT_STRING;
    
  TermEdge.type = OCT_PROP;
  TermEdge.contents.prop.name = "TERM_EDGE";
  TermEdge.contents.prop.type = OCT_STRING;

  RelTermPosition.type = OCT_PROP;
  RelTermPosition.contents.prop.name = "TERM_RELATIVE_POSITION";
  RelTermPosition.contents.prop.type = OCT_REAL;

}

