/*
 *  FILE: queue.c
 *
 *  DESCRIPTION:
 *
 *
 *  CREATION DATE: xx/xx/xx		AUTHOR:
 *
 *  FUNCTIONS:
 */
#include "defs.h"
/* #include <signal.h> */
#include "global.h"
#include "parall.h"


JobQueue *
PQinitQueue(size)
    int size;
{
  JobQueue *q;
  
  if (size == 0) size = DEFAULT_JOBS_IN_QUEUE;
  q = SH_MALLOC( JobQueue , 1);
  q->size = size;
  q->jobsArray = SH_MALLOC(PFI , size);
  q->jobs = 0;
  q->first = 0;
  q->last  = 0;
#ifdef PARALLEL
  s_init_lock(&(q->lock));
#endif
  return(q);
}

int
PQaddJob(q,func)
    JobQueue *q;
    PFI	func;
{
#ifdef PARALLEL
  s_lock(&q->lock);
#endif
  if (q->jobs == 0) {
    q->jobsArray[q->last] = func;
    q->jobs++;
  } else if (q->jobs < q->size) {
    if (++q->last >= q->size) q->last = 0;
    q->jobsArray[q->last] = func;
    q->jobs++;
  } else {
    Warning("Too many jobs in queue");
#ifdef PARALLEL
    s_unlock(&q->lock);
#endif
    return(NOT_OK);
  }
#ifdef PARALLEL
  s_unlock(&q->lock);
#endif
  return(OK);
}

int
PQdoJob(q,rv)
    JobQueue *q;
    int	*rv;			/* value returned by the job called */
{
  PFI	func = NULL;		/* returned function */


#ifdef PARALLEL
  s_lock(&q->lock);
#endif
  if (q->jobs > 0) {
    func = q->jobsArray[q->first];
    if (--q->jobs > 0) {	/* if it was not the last job, advance the first pointer */
      if (++q->first >= q->size) q->first = 0;
    }
  }
#ifdef PARALLEL
  s_unlock(&q->lock);
#endif

  /* call the function and return the value returned by it */
  if (func == NULL) {
    *rv = 0;
    return(NOT_OK);
  } else {
    *rv = (*func)();
    return(OK);
  }
}
