#include "copyright.h"
#include "sparcs.h"
/*#include "graph.h"*/

/*
 *  Simple, non-levelled (flat) scheduler for nodes.
 *
 *  Modified 9/23/85 for sparcs structs.
 *
 *  last modified 9/22/88
 */

struct node *pEOL;
struct node *pFLastNode, *pFFirstNode;
int SchedCount;

Fschedule (pnode)
struct node *pnode;
{
    if (pnode->cpm.sched != NIL(struct node))  return; /*  already scheduled  */
    if (pFFirstNode == pEOL)
	pFFirstNode = pnode;
    else
	pFLastNode->cpm.sched = pnode;
    pFLastNode = pnode;
    pnode->cpm.sched = pEOL;
    SchedCount++;
}

/*
 *  Processing routine for scheduler
 */
struct node *
FnextNode()
{
    struct node *pnode;

    if (pFFirstNode == pEOL)  return(NIL(struct node));
    pnode = pFFirstNode;
    pFFirstNode = pnode->cpm.sched;
    pnode->cpm.sched = NIL(struct node);
    return(pnode);
}

/*
 *  Initialize the scheduler
 */
FschedInit()
{
    SchedCount = 0;
    /* pEOL = (struct node *)malloc((unsigned)sizeof(struct node)); */
    pEOL = ALLOC(struct node, 1);
    pFFirstNode = pEOL;
    pFLastNode = pEOL;
}

/*
 *  Return the number of schedules
 */
FschedCount()
{
    return(SchedCount);
}
