#include "copyright.h"
#include "sparcs.h"
#include "oct.h"
#include "oh.h"
#include "facet.h"
/*#include "graph.h"*/




/*
 *  Print the results
 *
 *  9/23/85 - Modified to work with sparcs structs.
 *
 *  last modified 4/8/85
 */



cpm_dump(what)
    int what;
{
    struct node *pnode;
    struct branch *pb;
    struct cpm_path *bubble;

    if (what==NODES || what==ALL)  {
	fprintf(stdout,
		"NODES:\nLevel\tName\tNfanin,out\tLocations\n\n");
	for (pnode=pNodeList; pnode != NULL; pnode = pnode->cpm.list)  {
	    if (pnode->cpm.level >= 0)
		fprintf(stdout,"%5d    ",pnode->cpm.level);
	    else
		fprintf(stdout, "UND   ");
	    if ( pnode->key == INFINITY ) {
		fprintf(stdout, "SRC\t", pnode->key);
	    } else {
		fprintf(stdout, "%d\t", pnode->key);
	    }
	    fprintf(stdout, "%d,%d\t", pnode->cpm.numfanin,
						pnode->cpm.numfanout);

	    fprintf(  stdout, "(%5s,%5s,%5s)",
		    printbound( pnode->cpm.lower), 
		    printbound( pnode->cpm.loc), 
		    printbound( pnode->cpm.upper));
	    

	    if (pnode->cpm.lower > pnode->cpm.loc || pnode->cpm.upper < pnode->cpm.loc ) {
		fprintf(stdout, " <- out of range");
		{
		    octObject overconBag, obj;
		    if ( getOctElementByKey( &obj, pnode->key ) ) {
			ohGetOrCreateBag( &WorkingFacet, &overconBag, "SPARCS OVERCONSTRAINTS" );
			octAttach( &overconBag, &obj );
		    }
		}
	    }
	    if (pnode->cpm.lower == pnode->cpm.upper) {
		fprintf(stdout, " <- critical");
	    }
	    
	    fprintf(stdout, "\n");
        }
    }
    if (what==BRANCHES || what==ALL)  {
	fprintf(stdout, "\n\nBRANCHES:\n");
	fprintf(stdout, "Left	Right	(Low,High)	Force\n\n");

	for ( pb = pBranchList; pb!=NIL(struct branch); pb=pb->pnext)  {
	    fprintf(stdout, "%d\t%d\t", (pb->pfromNode)->key,
		    (pb->ptoNode)->key);
	    if (pb->lowerBound == 0) fprintf(stdout, "(ZER,");
	    else if (pb->lowerBound == INFINITY) fprintf(stdout, "(INF,");
	    else fprintf(stdout, "(%3d,", pb->lowerBound);
	    if (pb->upperBound == 0) fprintf(stdout, "ZER)");
	    else if (pb->upperBound == INFINITY) fprintf(stdout, "INF)");
	    else fprintf(stdout, "%3d)", pb->upperBound);
	    if (pb->force == RLEFT) fprintf(stdout, "	<==");
	    else if (pb->force == LEFT) fprintf(stdout, "	<--");
	    else if (pb->force == DCARE) fprintf(stdout, "	<->");
	    else if (pb->force == RIGHT) fprintf(stdout, "	-->");
	    else if (pb->force == RRIGHT) fprintf(stdout, "	==>");
	    else fprintf(stdout, "	ERR");
	    fprintf(stdout, "\n");
	}
    }
    if ((what==NODES || what==ALL) && NumUppers>0)  {
	fprintf(stdout, "\nBUBBLES:\n");
	pnode = pNodeList;
	for (; pnode!=NIL(struct node); pnode=pnode->cpm.list) {
	    fprintf(stdout, "pnode %d: ", pnode->key);
	    bubble = pnode->cpm.path;
	    for (; bubble!=NIL(struct cpm_path); bubble=bubble->next)  {
		if (bubble->branchPoint != NIL(struct node))  {
		    fprintf(stdout, "%d ",(bubble->branchPoint)->key);
		    if (bubble->active == TRUE)
			fprintf(stdout, "A ");
		    else
			fprintf(stdout, ". ");
		}
	    }
	    fprintf(stdout, "\n");
	}
    }
    fflush(stdout);
}
