#include "copyright.h"
#include "sparcs.h"
/*#include "graph.h"*/

/*
 *  Place non-critical nodes in correct locations.
 *
 *  Modified 9/23/85 for sparcs structs.
 *  Modified 9/25/85 for negative coordinates.
 *
 *  last modified 4/14/87
 */

noncrit(verbose)
int verbose;
{
    struct node *pnode, *FnextNode();
    struct branch *pb;
    int newub, newlb, newloc;
    
    FschedInit();
    for (pnode=pNodeList; pnode!=NIL(struct node); pnode=pnode->cpm.list)  {
	if (pnode->cpm.upper == pnode->cpm.lower)  {
	    pnode->cpm.loc = pnode->cpm.lower;
	} else  {
	    pnode->cpm.loc = (pnode->cpm.upper + pnode->cpm.lower)/2;
	    Fschedule(pnode);
	}
	if (verbose)  {
	    printf("node %d:  [%d, %d, %d]\n", pnode->key, pnode->cpm.lower,
		    pnode->cpm.loc, pnode->cpm.upper);
	    fflush(stdout);
	}
    }

    while ((pnode=FnextNode()) != NIL(struct node))  {

	/*  newlb = 0;   9/25/85  */
	newlb = -INFINITY;
	newub =  INFINITY;	

	for (pb=pnode->pfanins; pb!=NIL(struct branch); pb=pb->pnextFanin)  {
	    newlb = SPMAX(newlb, (pb->pfromNode->cpm.loc + pb->lowerBound));
	    newub = SPMIN(newub, (pb->pfromNode->cpm.loc + pb->upperBound));
	    /*************
	    printf("  pb->pfromNode->cpm.loc = %d, pb->lowerBound = %d, ",
	    	    pb->pfromNode->cpm.loc, pb->lowerBound);
	    printf("sum = %d\n", pb->pfromNode->cpm.loc + pb->lowerBound);

	    printf("  pb->pfromNode->cpm.loc = %d, pb->upperBound = %d, ",
	    	    pb->pfromNode->cpm.loc, pb->upperBound);
	    printf("sum = %d\n", pb->pfromNode->cpm.loc + pb->upperBound);
	    *************/
	}
	for (pb=pnode->pfanouts; pb!=NIL(struct branch); pb=pb->pnextFanout)  {
	    newlb = SPMAX(newlb, (pb->ptoNode->cpm.loc - pb->upperBound));
	    newub = SPMIN(newub, (pb->ptoNode->cpm.loc - pb->lowerBound));
	    /*************
	    printf("  pb->ptoNode->cpm.loc = %d, pb->upperBound = %d, ",
	    	    pb->ptoNode->cpm.loc, pb->upperBound);
	    printf("diff = %d\n", pb->ptoNode->cpm.loc - pb->upperBound);

	    printf("  pb->ptoNode->cpm.loc = %d, pb->lowerBound = %d, ",
	    	    pb->ptoNode->cpm.loc, pb->lowerBound);
	    printf("diff = %d\n", pb->ptoNode->cpm.loc - pb->lowerBound);
	    *************/
	}

	newloc = (newlb+newub)/2;

	if (verbose)  {
	    printf("    node %d:  [%d, %d --> %d, %d]\n", pnode->key,
		    pnode->cpm.lower, pnode->cpm.loc, newloc, pnode->cpm.upper);
	    fflush(stdout);
	}

	if (newloc != pnode->cpm.loc)  {
	    if (newloc < pnode->cpm.lower  ||  newloc > pnode->cpm.upper) {
		printf("noncrit:  node %d violates bounds;\n", pnode->key);
		printf("\t  newloc = %d, lower = %d, upper = %d.\n",
			newloc, pnode->cpm.lower, pnode->cpm.upper);
		exit(-1);

	    } else  {
		pnode->cpm.loc = newloc;
		if (verbose)  fprintf(stderr," - changed\n");
		pb = pnode->pfanins;
		for (; pb!=NIL(struct branch); pb=pb->pnextFanin)  {
		    if (pb->pfromNode->cpm.lower != pb->pfromNode->cpm.upper) {
			Fschedule((pb->pfromNode));
		    }
		}
		pb = pnode->pfanouts;
		for (; pb!=NIL(struct branch); pb=pb->pnextFanout)  {
		    if (pb->ptoNode->cpm.lower != pb->ptoNode->cpm.upper)  {
			Fschedule((pb->ptoNode));
		    }
		}
	    }
        } else  {
	    if(verbose)  fprintf(stderr," - no change\n");
	}
    }
    return( OK );
}
