#include "copyright.h"
#include "sparcs.h"

/*
 *  Control routine for solving constraint graph (critical path, slack dis-
 *  tribution, etc.).  From stand-alone cpm program.
 *
 *  7/16/85
 *  last modified 4/3/88
 */

void
doCpm(direction)
directionType direction;
{
    int status;

    if (direction!=HORIZONTAL && direction!=VERTICAL)  {
	fprintf(stdout, "doCpm:  illegal direction.\n");
	exit(100);
    }

    if (TraceFlag)  {
	printf("    Solving graph:\n");
	fflush(stdout);
    }
    
    status = sanitize(FALSE);
    if(status != OK) {
	errRaise( "SPARCS", SPARCS_BUG_CODE, "Illegal constraint graph.\n");
    }
    if (NumUppers >0) {
	;
	/****
        printf("\nchecking for overconstraints...\n\n");
	status = overcon(FALSE);
	****/
    }
    if(status != OK) {
	cpm_dump(ALL);
	exit(0);
    }

    status = solve(direction, FALSE);
    if(status != OK) {
	printf("Can't solve constraint graph.\n");
	exit(-1);
    }

    /*
     *  Locate the noncritical nodes.
     */
    if (TraceFlag)  {
	printf("\tnon-critical elements...");
	fflush(stdout);
    }
    if (direction == HORIZONTAL)  {
	if (HardLeftFlag)  {
	    status = simpleNoncrit(MIN);
	} else if (HardRightFlag)  {
	    status = simpleNoncrit(MAX);
	} else  {
	    status = clusterNoncrit(FALSE);
	    /* status = new_noncrit(FALSE); */
	}
    } else  {
	if (HardBottomFlag) {
	    status = simpleNoncrit(MIN);
	} else if (HardTopFlag)  {
	    status = simpleNoncrit(MAX);
	} else  {
	    status = clusterNoncrit(FALSE);
	    /* status = new_noncrit(FALSE); */
	}
    }
    if (TraceFlag)  {
	printf("\n");
	fflush(stdout);
    }

    /*
     *  obsolete...
     *
     *	  if (MinChangeFlag)  status = minChangeNoncrit(direction);
     */

    if(status != OK) {
	printf("Can't place noncritical elements..\n");
	exit(-1);
    }
}
