#include "copyright.h"
#include "sparcs.h"

/*
 *  Routine to place non-critical nodes when the force-directed approach is
 *  not desired.  This is a one-pass algorithm (each non-critical-path node
 *  is processed only once).  Each non-critical node is placed either its
 *  minimum or its maximum position, corresponding to compacting left or right
 *  (or down or up).
 *
 *  9/27/86
 *  last modified 10/1/86
 */

simpleNoncrit(minOrMax)
int minOrMax;	/* MIN or MAX; designates location for each non-critical node */
{
    struct node *node;
    int i;
    
    if (minOrMax != MIN  &&  minOrMax != MAX)  {
	printf("simpleNoncrit:  \"minOrMax\" arg must be MIN or MAX.\n");
	exit(-1);
    }

    for(i=1; i<=NumElements; i++)  {
	if (NodeArray[i]->key != UNDEF)  {
	    node = NodeArray[i];
	    if (node->cpm.upper == node->cpm.lower)  {
		node->cpm.loc = node->cpm.lower;
	    } else  {
		if (minOrMax == MIN)  {
		    node->cpm.loc = node->cpm.lower;
		} else  {
		    node->cpm.loc = node->cpm.upper;
		}
		/******
		printf("simpleNoncrit:
			node %d placed at %d (min: %d, max: %d)\n",
					    node->key, node->cpm.loc,
					    node->cpm.lower, node->cpm.upper);
		******/
	    }
	}
    }
    return( OK );
}
