#include "copyright.h"
#include "sparcs.h"
/*#include "graph.h"*/

/*
 *  Routine to put in the force values for the parallel wires.
 *
 *  Called by:
 *  Calls:
 *
 *  4/6/87
 *  last modified 8/20/87
 */

void
addForces(direction)
directionType direction;		/*  HORIZONTAL or VERTICAL.  */
{
    struct node *pn1, *pn2;
    struct wire *pw;
    struct object *po1, *po2;
    int i;

    if (direction == HORIZONTAL)  {
	for (i=NumObjects+1; i<=NumElements; i++)  {
	    pw = ElementByKey[i].ptr.pw;
	    if (pw->horizontal == TRUE)  {
		if (pw->force != UNDEF)  {
		    po1 = pw->po1;
		    po2 = pw->po2;
		    pn1 = NodeArray[po1->key];
		    pn2 = NodeArray[po2->key];
		    if (po1->origin.x < po2->origin.x)  {
		        link(pn1, pn2, ZERO, INFINITY, pw->force);
		        /* link(pn1, pn2, -INFINITY, INFINITY, pw->force); */
		    } else if (po2->origin.x < po1->origin.x)  {
		        link(pn2, pn1, ZERO, INFINITY, pw->force);
		        /* link(pn2, pn1, -INFINITY, INFINITY, pw->force); */
		    } else  {
			if (po1->key < po2->key)  {
		            link(pn1, pn2, ZERO, INFINITY, pw->force);
			    /*link(pn1, pn2, -INFINITY, INFINITY, pw->force);*/
			} else  {
		            link(pn2, pn1, ZERO, INFINITY, pw->force);
		            /*link(pn2, pn1, -INFINITY, INFINITY, pw->force);*/
			}
		    }
		}
	    }
	}
    } else  {
	for (i=NumObjects+1; i<=NumElements; i++)  {
	    pw = ElementByKey[i].ptr.pw;
	    if (pw->horizontal == FALSE)  {
		if (pw->force != UNDEF)  {
		    po1 = pw->po1;
		    po2 = pw->po2;
		    pn1 = NodeArray[po1->key];
		    pn2 = NodeArray[po2->key];
		    if (po1->origin.y < po2->origin.y)  {
		        link(pn1, pn2, ZERO, INFINITY, pw->force);
		        /* link(pn1, pn2, -INFINITY, INFINITY, pw->force); */
		    } else if (po2->origin.y < po1->origin.y)  {
		        link(pn2, pn1, ZERO, INFINITY, pw->force);
		        /* link(pn2, pn1, -INFINITY, INFINITY, pw->force); */
		    } else  {
			if (po1->key < po2->key)  {
		            link(pn1, pn2, ZERO, INFINITY, pw->force);
		            /*link(pn1, pn2, -INFINITY, INFINITY, pw->force);*/
			} else  {
		            link(pn2, pn1, ZERO, INFINITY, pw->force);
		            /*link(pn2, pn1, -INFINITY, INFINITY, pw->force);*/
			}
		    }
		}
	    }
	}
    }
}
