#include "copyright.h"
#include "sparcs.h"

/*
 *  Routine to link the sink node to the constraint graph.
 *
 *  From link() 1/23/88
 *  last modified 9/2288
 */

void
linkSink(pfrom, lower)
struct node *pfrom;
int lower;
{
    register struct branch *pb;
    
    /*
     *  Reuse an old branch or allocate a new one if necessary.
     */
    if (pNextFreeBranch != NIL(struct branch))  {
	pb = pNextFreeBranch;
	pNextFreeBranch = pNextFreeBranch->pnext;
    } else  {
	pb = ALLOC(struct branch, 1);
	pb->pnext = pBranchList;
	pBranchList = pb;
    }
    
    pb->lowerBound = lower/UNITSPERLAMBDA;
    pb->upperBound = INFINITY;
    pb->force = 0;
    pb->proc  = 0;
    pb->pfromNode = pfrom;
    pb->ptoNode = pSink;
    
    pb->pnextFanout = pfrom->pfanouts;
    pfrom->pfanouts = pb;
    pfrom->cpm.numfanout++;
    
    pb->pnextFanin = pSink->pfanins;
    pSink->pfanins = pb;
    pSink->cpm.numfanin++;

    NumLowers++;
    NumBranches++;
}
