#include "copyright.h"
#include "sparcs.h"

/*
 *  Routine to link the source node to the constraint graph.
 *
 *  From link() 1/23/88
 *  last modified 9/22/88
 */

void
linkSource(pto)
struct node *pto;
{
    register struct branch *pb;
    
    /*
     *  Reuse an old branch or allocate a new one if necessary.
     */
    if (pNextFreeBranch != NIL(struct branch))  {
	pb = pNextFreeBranch;
	pNextFreeBranch = pNextFreeBranch->pnext;
    } else  {
	pb = ALLOC(struct branch, 1);
	pb->pnext = pBranchList;
	pBranchList = pb;
    }
    
    pb->lowerBound = 0;
    pb->upperBound = INFINITY;
    pb->force = 0;
    pb->proc  = 0;
    pb->pfromNode = pSource;
    pb->ptoNode = pto;
    
    pb->pnextFanout = pSource->pfanouts;
    pSource->pfanouts = pb;
    pSource->cpm.numfanout++;
    
    pb->pnextFanin = pto->pfanins;
    pto->pfanins = pb;
    pto->cpm.numfanin++;
    
    NumLowers++;
    NumBranches++;
}
