#include "copyright.h"

/*
 *  Sparcs global variables.
 *  flags.h entries placed here 6/4/86.
 *
 *  last modified 4/11/88
 */

char *Facet = "contents";
char *InCell = NIL(char);
char *InView = "unspaced";
char *OutCell = NIL(char);
char *OutView = "spaced";

int UNITSPERLAMBDA = 0;		/* Absurd default (will cause an error). */
octObject WorkingFacet;		/*  facet for spaced view's contents; extern
				    is in facet.h  */

char StopCriterion = 'A';

int RPCSparcs = FALSE;		/*  set to TRUE if running rpc-vem version  */

char *TechRoot  = NIL(char);
char *RulesFile = NIL(char);

int NumObjects = 0;		/*  total number of instances in layout  */
struct object *pObjectList = NIL(struct object);

int NumWires = 0;		/*  total number of wire segments in layout  */
struct wire *pWireList = NIL(struct wire);
				/*  list of the wire segments  */

int NumElements = 0;		/*  NumObjects + NumWires  */

int ElementKey;			/*  to index objs/wires by key value  */

int NumLayers;			/*  number of mask layers read  */

int MaxBBX, MaxBBY;		/*  largest coords in layout  */
int MinBBX, MinBBY;		/*  smallest coords in layout  */

struct edgePtr *pMaxEdgeListHead = NIL(struct edgePtr); /* 2/15/87, scan */
struct edgePtr *pMaxEdgeListTail = NIL(struct edgePtr); /* 3/4/87, scan */
struct edgePtr *pMidEdgeListHead = NIL(struct edgePtr); /* 6/25/87, scan */
struct edgePtr *pMidEdgeListTail = NIL(struct edgePtr); /* 6/25/87, scan */
struct edgePtr *pMinEdgeListHead = NIL(struct edgePtr); /* 2/21/87, scan */
struct edgePtr *pMinEdgeListTail = NIL(struct edgePtr); /* 3/4/87, scan */


struct element *ElementByKey;	/*  an array of 'element' structs; 8/12/85
						for the above  */

struct layer
	LayerMap[MAXLAYERS];	/*  layer struct array for name-number map  */

/*  suppress missing rule warning for these layers  */

/*  design rules  */
struct rule Rules[MAXLAYERS][MAXLAYERS];	/*  rules matrix  */
int RuleExp;				/*  factor to expand all rules  */

/*  for output  */
FILE *pout = stdout;

/*  for convergence  */
int Iterations;
int IterationLimit = 0;		/* 0 ==> to convergence */

/* used in clusterNoncrit() to mark visited nodes in depth-first search */
int ClusterCtr = 0;

/*  for the virtual grid  */
struct gridLine *pHorizontalGrid;	/*  for HORIZ. compaction, hence
					    gridlines are VERTICAL        */
struct gridLine *pVerticalGrid;

/*
 *  For the graph; extern declarations are in graph.h
 */
struct node Source;			/* source of the graph */
struct node Sink;			/* sink of the graph */

struct node *pSource = &Source;		/* pointer to source of the graph */
struct node *pSink = &Sink;		/* pointer to sink of the graph */
struct node **NodeArray;		/* node pointers for the graph */

struct node *pNodeList;			/* initialized in reset routine */
struct branch *pBranchList = NIL(struct branch);
struct branch *pNextFreeBranch = NIL(struct branch);

int NumNodes;		/* per-iteration node count, incl. source and sink */
int NumBranches;	/* per-iteration branch count */
int NumLowers;		/* per-iteration finite lower-bound constraints */
int NumUppers;		/* per-iteration finite upper-bound constraints */
int MaxLevel;

/*
 *  Depth to search for existing branch in graph
 */
int LinkSearchDepth = INFINITY;

/*
 *  Added 11/2/86
 */
struct userConstraint *pXConsts = NIL(struct userConstraint);
struct userConstraint *pYConsts = NIL(struct userConstraint);

/*
 *  Added 12/8/87
 */
struct activeConstraint *pXActiveConsts = NIL(struct activeConstraint);
struct activeConstraint *pYActiveConsts = NIL(struct activeConstraint);

/*
 *  The following flags were in flags.h (6/4/86)
 */
int TraceFlag = FALSE;		/* print messages r/e execution progress */
int MinChangeFlag = FALSE;	/* chg noncrit el'ts as little as possible */
/*
 *  10/9/87  Following two replace IncrementalFlag.
 */
int ShowIterationsFlag = FALSE;	/* rpc version only.  display ea. iteration */
int SaveIterationsFlag = FALSE;	/* save a view for each spacing */
int VGridFlag = FALSE;		/* virtual grid mode */
int HorizontalFirstFlag = TRUE; /* vert. first if FALSE */
int PrintObjectsFlag = FALSE;	/* print graph at each iteration */
int PrintWiresFlag = FALSE;	/* print graph at each iteration */
int PrintGraphFlag = FALSE;	/* print graph at each iteration */
int PrintCpmGraphFlag = FALSE;	/* print cpm graph at each iteration */
int NoUserConstraintsFlag = FALSE;	/* ignore user-constraints */
int ReadDB = FALSE;
int RulesDB = FALSE;
int UpdateDB = FALSE;
/*
 *  For simpleNoncrit(); added 9/29/86.
 */
int HardLeftFlag = FALSE;
int HardRightFlag = FALSE;
int HardTopFlag = FALSE;
int HardBottomFlag = FALSE;
int OrthogonalCPFlag = TRUE;	/* not currently used in prod version */
