#include "copyright.h"

/*
 *  Structures to do the scan-line.
 *
 *  2/14/87
 *  last modified 6/30/87
 */

/*
 *  For hard-masked edges that become un-masked
 */
struct hlist  {
    struct edge *pedge;		/* unmasked edge to be reprocessed */
    int hardMaskedBy;		/* key of instance that hard masked it */
    struct hlist *pnext;
};

struct klist  {
    int key;
    struct klist *pnext;
};

struct elist  {
    struct edge *pedge;
    struct elist *pnext;
};

struct edge  {
    char active;  /* XXX REMOVE!! *//* 'Y' if in edge struct, 'N' otherwise. */
    int key;
    int max;			    /* upper coord of edge; for extension */
    int maskNumber;
    int loc;		    	    /* x coord for vert. edges, y for horiz. */
    int type;		    	    /* MIN (e.g., left) or MAX (e.g., top) */
    int netId;		    	    /* octId of net, or UNDEF */
    char masked;	    	    /* 'S', 'P', 'H', or 'N' */
    struct edge *pmasks;    	    /* edge 'S' or 'P' masked by this one */
    struct elist *phardMasks;	    /* edges H-masked by this one */
    struct klist *phardMaskedBy;    /* owners of edges that H-mask this one */
    struct edge *pnext;	            /* edge structure ptr (doubly-linked) */
    struct edge *pprev;	    	    /* edge structure ptr (doubly-linked) */
    struct edge *plist;	    	    /* list on object for loc updating */
    struct terminal *pt;    	    /* XXX needed??? */
};

/*
 *  Made singly-linked 6/12/87, since double links not needed in mergesort.
 */
struct edgePtr  {
    int coord;
    struct edge *pedge;
    struct edgePtr *pnext;
    struct edgePtr *plist;
};
