#include "copyright.h"
#include "sparcs.h"
#include "rpc.h"

#ifndef NIL
#define NIL(type) 	((type *) 0)
#endif

/*
 *  UserMain() for the rpc version of sparcs.
 *
 *  5/28/86
 *  last modified 9/22/88
 */

int sparcs();
int addBorderConst();
int showBorderConsts();
int clearBorderConsts();
int clearAllBorderConsts();
int deleteAllBorderConsts();
int showCritical();
int clearCritical();
int showNonCritical();
int clearNonCritical();


int
sparcsExit(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    RPCExit(0);
}


int
showIterations(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    ShowIterationsFlag = TRUE;
    return(RPC_OK);
}

int
trace(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    TraceFlag = TRUE;
    return(RPC_OK);
}

int
noWarningLayers(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    struct RPCArg *parg;
    lsGen gen;
    lsStatus status;

    if (lsLength(cmdList) < 1)  goto usage;

    gen = lsStart(cmdList);
    
    while ((status=lsNext(gen, (Pointer *)&parg, 0)) == LS_OK)  {
	if (parg->argType != VEM_TEXT_ARG)  goto usage;

	noWarningAdd( parg->argData.string);
    }
    if (status != LS_NOMORE)  {
	vemMessage("noWarningLayers: can't end arg(s) gen for some reason.\n",
		   MSG_DISP);
    }	
    return(RPC_OK);

usage:
    vemMessage("usage: \"list of layers to ignore\" outview-name\n", MSG_DISP);
    return(RPC_OK);
}

int
hardBottom(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    HardBottomFlag = TRUE;
    return(RPC_OK);
}

int
hardLeft(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    HardLeftFlag = TRUE;
    return(RPC_OK);
}

int
oneStep(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    IterationLimit = 1;
    return(RPC_OK);
}

int
iterLimit(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    struct RPCArg *parg;

    if (lsLength(cmdList) != 1)  goto usage;

    if (lsFirstItem(cmdList, (Pointer *)&parg, 0) != LS_OK)  {
	vemMessage("can't get arg for some reason.\n", MSG_DISP);
	return(RPC_OK);
    }
    if (parg->argType != VEM_TEXT_ARG)  goto usage;

    IterationLimit = atoi(parg->argData.string);
    return(RPC_OK);

usage:
    vemMessage("usage: \"iterations\" iter-limit\n", MSG_DISP);
    return(RPC_OK);
}

int
vertFirst(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    HorizontalFirstFlag = FALSE;
    return(RPC_OK);
}

int
setRulesFile(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    struct RPCArg *parg;

    if (lsLength(cmdList) != 1)  goto usage;

    if (lsFirstItem(cmdList, (Pointer *)&parg, 0) != LS_OK)  {
	vemMessage("can't get arg for some reason.\n", MSG_DISP);
	return(RPC_OK);
    }
    if (parg->argType != VEM_TEXT_ARG)  goto usage;

    RulesFile = STRSAVE(parg->argData.string);
    return(RPC_OK);

usage:
    vemMessage("usage: \"rules-file-name\" rules-file\n", MSG_DISP);
    return(RPC_OK);
}

int
setOutCell(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    struct RPCArg *parg;

    if (lsLength(cmdList) != 1)  goto usage;

    if (lsFirstItem(cmdList, (Pointer *)&parg, 0) != LS_OK)  {
	vemMessage("can't get arg for some reason.\n", MSG_DISP);
	return(RPC_OK);
    }
    if (parg->argType != VEM_TEXT_ARG)  goto usage;

    OutCell = STRSAVE(parg->argData.string);
    return(RPC_OK);

usage:
    vemMessage("usage: \"outCellName\" outcell-name\n", MSG_DISP);
    return(RPC_OK);
}

int
setOutView(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    struct RPCArg *parg;

    if (lsLength(cmdList) != 1)  goto usage;

    if (lsFirstItem(cmdList, (Pointer *)&parg, 0) != LS_OK)  {
	vemMessage("can't get arg for some reason.\n", MSG_DISP);
	return(RPC_OK);
    }
    if (parg->argType != VEM_TEXT_ARG)  goto usage;

    OutView = STRSAVE(parg->argData.string);
    return(RPC_OK);

usage:
    vemMessage("usage: \"outViewName\" outview-name\n", MSG_DISP);
    return(RPC_OK);
}

int
setRuleExp(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    struct RPCArg *parg;

    if (lsLength(cmdList) != 1)  goto usage;

    if (lsFirstItem(cmdList, (Pointer *)&parg, 0) != LS_OK)  {
	vemMessage("can't get arg for some reason.\n", MSG_DISP);
	return(RPC_OK);
    }
    if (parg->argType != VEM_TEXT_ARG)  goto usage;

    RuleExp = atoi(parg->argData.string);
    return(RPC_OK);

usage:
    vemMessage("usage: \"integerFactor\" rule-exp-factor\n", MSG_DISP);
    return(RPC_OK);
}

int
killSparcs(spot, cmdList, userOptionWord)
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    vemCommand("kill-application", spot, cmdList, 0);
    return(RPC_OK);
}

struct RPCFunction CommandArray[] = {
    {sparcs, "run", "RUN", NIL(char), 0},
    {sparcsExit, "run", "exit-sparcs", NIL(char), 0},
    {killSparcs, "run", "kill-sparcs", NIL(char), 0},
    {showIterations, "options", "show-each-iteration", NIL(char), 0},
    {trace, "options", "trace", NIL(char), 0},
    {noWarningLayers, "options", "no-warning-layers", NIL(char), 0},
    {hardBottom, "options", "bottom", NIL(char), 0},
    {hardLeft, "options", "left", NIL(char), 0},
    {setOutCell, "options", "outcell-name", NIL(char), 0},
    {setOutView, "options", "outview-name", NIL(char), 0},
    {setRulesFile, "options", "rules-file", NIL(char), 0},
    {iterLimit, "options", "iter-limit", NIL(char), 0},
    {vertFirst, "options", "vertical-first", NIL(char), 0},
    {addBorderConst, "constraints", "add-border", NIL(char), 0},
    {deleteAllBorderConsts, "constraints", "delete-all-border", NIL(char), 0},
    {showBorderConsts, "constraints", "show-border", NIL(char), 0},
    {clearBorderConsts, "constraints", "clear-border", NIL(char), 0},
    {clearAllBorderConsts, "constraints", "clear-all", NIL(char), 0},
    {showCritical, "display", "show-critical", NIL(char), 0},
    {clearCritical, "display", "clear-critical", NIL(char), 0},
    {showNonCritical, "display", "show-noncritical", NIL(char), 0},
    {clearNonCritical, "display", "clear-noncritical", NIL(char), 0},
};


/*
 *  The main control routine for the rpc version of sparcs.  If the "sparcs"
 *  menu item is invoked without arguments, the options may be edited and the
 *  program run via the "RUN" menu item.  If "sparcs" is invoked with the text
 *  argument "run" then sparcs runs with the defaults.
 *
 *  5/28/86
 *  last modified 4/11/88
 */

long
UserMain(display, spot, cmdList, userOptionWord, array)
char *display;
struct RPCSpot *spot;
lsList cmdList;
long userOptionWord;
RPCFunction **array;
{
    struct RPCArg *parg;
    int argc;
    char buffer[BIGBUF];

    /*
     *  Initialize sparcs.  Values can be changed via the menu.
     */
    SPinit();
    RPCSparcs = TRUE;

    /*
     *  If there is a text argument "run" then immediately invoke sparcs.  If
     *  not, the user can change the options via the menu.
     */
    argc = lsLength(cmdList);
    if (argc == 1)  {
	if (lsFirstItem(cmdList, (Pointer *)&parg, 0) != LS_OK)  {
	    vemMessage("UserMain: can't get first arg.\n", MSG_DISP);
	    return(RPC_OK);
	}
	if (parg->argType != VEM_TEXT_ARG)  {
	    goto usage;
	}
	if (strcmp(parg->argData.string, "run") == 0)  {
            sparcs(spot, cmdList, userOptionWord);
	} else  {
	    goto usage;
	}
    } else if (argc != 0)  {
	goto usage;
    } else  {
	sprintf(buffer, "2sparcs version %s initialized.0\n",
		sparcsVersion());
        vemMessage(buffer, MSG_DISP);
	vemPrompt();
	*array = CommandArray;
	return(sizeof(CommandArray)/sizeof(struct RPCFunction));
    }

usage:
    vemMessage("usage:  [\"run\"] sparcs\n", MSG_DISP);
    exit(-1);
}
