#include "copyright.h"
#include "sparcs.h"

/*
 *  Add branches from the source and to the sink as required.  This routine
 *  is called after all other parts of the graph have been built.  So, the
 *  only nodes considered here are those that have no fanins/fanouts.
 *
 *  2/20/87
 *  last modified 3/25/88
 */

void
bindSoSi(direction)
directionType direction;
{
    int width;
    int i;

    /*
     *  First initialize the source and sink.
     */
/*** XXX Should do elsewhere; no need to do more than once!!!  ***/
    /*  fill in the source and sink (allocated statically)  */
    pSource->key = ZERO;
    pSink->key = INFINITY;
    /*********  6/18/87 pSource->loc.x = MinBBX;  pSource->loc.y = MinBBY; */
    pSource->loc.x = MinBBX/UNITSPERLAMBDA;
    pSource->loc.y = MinBBY/UNITSPERLAMBDA;
    pSink->loc.x = pSink->loc.y = INFINITY;
    pSource->pfanins = pSource->pfanouts = NIL(struct branch);
    pSink->pfanins = pSink->pfanouts = NIL(struct branch);
    
    pSource->cpm.lower 	     = pSink->cpm.lower       = -INFINITY;
    pSource->cpm.loc 	     = pSink->cpm.loc         =  ZERO;
    pSource->cpm.upper       = pSink->cpm.upper       =  INFINITY;
    pSource->cpm.level 	     = pSink->cpm.level       =  UNDEF;
    pSource->cpm.active      = pSink->cpm.active      =  UNDEF;
    pSource->cpm.upperInFlg  = pSink->cpm.upperInFlg  =  FALSE;
    pSource->cpm.upperOutFlg = pSink->cpm.upperOutFlg =  FALSE;
    pSource->cpm.lowerInFlg = FALSE;
    pSink->cpm.lowerInFlg = TRUE;
    pSource->cpm.lowerOutFlg = TRUE;
    pSink->cpm.lowerOutFlg = FALSE;
    pSource->cpm.overcon     = pSink->cpm.overcon     =  FALSE;
    pSource->cpm.list        = pSink->cpm.list	      =  NIL(struct node);
    pSource->cpm.sched       = pSink->cpm.sched       =  NIL(struct node);
    pSource->cpm.path        = pSink->cpm.path        =  NIL(struct cpm_path);
    pSource->cpm.numfanout   = pSink->cpm.numfanout   =  ZERO;
    pSource->cpm.numfanin    = pSink->cpm.numfanin    =  ZERO;

    /* XXX */
    cpm_installNode(pSource);
    cpm_installNode(pSink);

    for (i=1; i<=NumElements; i++)  {
	if (NodeArray[i]->key == UNDEF)  continue;

	if (NodeArray[i]->cpm.lowerInFlg == FALSE)  {
	    /*
	     *  Must be linked to the source.
	     */
	    linkSource(NodeArray[i]);
	    /* link(pSource, NodeArray[i], ZERO, INFINITY, 0); */
	    /* NumSourceFanouts++; */
	}
	/*
	 *  XXX 3/18/87
	 */
	/* if (NodeArray[i]->pfanouts == NIL(struct branch))  { */
	if (NodeArray[i]->cpm.lowerOutFlg == FALSE)  {
	    /*
	     *  Must be linked to the sink.
	     */
	    if (i <= NumObjects)  {
		if (direction == HORIZONTAL)  {
		    width = ElementByKey[i].ptr.po->bbUpperR.x;
		} else  {
		    width = ElementByKey[i].ptr.po->bbUpperR.y;
		}
	    } else  {
		width = ElementByKey[i].ptr.pw->width;
	    }
	    linkSink(NodeArray[i], width);
	    /* link(NodeArray[i], pSink, width, INFINITY, 0); */
	    /* NumSinkFanins++; */
	}
    }
}
