#include "copyright.h"
#include "sparcs.h"

/*
 *  Before each spacing, the edgePtrs of each object must be linked so that
 *  linkEdges() can put them into the global edgePtr lists, namely
 *  pMaxEdgeList and pMinEdgeList.  This re-linking must be done on every
 *  iteration because the global lists are sorted each iteration, and thus
 *  an object's edgePtrs get scrambled.
 *
 *  3/1/87
 *  last modified 6/12/87
 */

linkEdgePtrs(phead, pfirstEP, plastEP)
struct edgePtr *phead;		/* first edgePtr in singly-linked list */
struct edgePtr **pfirstEP;	/* set to head of re-linked list */
struct edgePtr **plastEP;	/* set to tail of re-linked list */
{
    struct edgePtr *pcur;
    struct edgePtr *plast;

    if (phead == NIL(struct edgePtr))  {
	printf("linkEdgePtrs:  NIL phead.\n");
	exit(-1);
    }

    plast = phead;
    pcur = phead->plist;

    *pfirstEP = plast;

    while (pcur != NIL(struct edgePtr))  {
	plast->pnext = pcur;

	plast = pcur;
	pcur = pcur->plist;
    }
    plast->pnext = NIL(struct edgePtr);
    *plastEP = plast;
}
