#include "copyright.h"
#include "sparcs.h"

/*
 *  Print the contents of the edge struct.
 *
 *  2/17/87
 *  last modified 6/7/87
 */

void
printEdgeStruct(pedgeHead, verbose)
struct edge *pedgeHead;		/* point in edge struct to begin printing */
int verbose;
{
    struct edge *pe;
    struct elist *phM;
    struct klist *pmB;

    printf("    Current edge struct contents:\n");
    if (verbose == FALSE)  {
	for (pe=pedgeHead; pe!=NIL(struct edge); pe=pe->pnext)  {
	    printf("\t%s, ", (pe->type == MIN) ? "MIN" : "MAX");
	    printf("at loc %d, on layer %s, from obj. %d, ", pe->loc,
		    LayerMap[pe->maskNumber].name, pe->key);
	    if (pe->netId == UNDEF)  {
		printf("netId UNDEF");
	    } else  {
		printf("netId %d", pe->netId);
	    }
	    printf(", masked %c\n", pe->masked);
	}
    } else  {
	for (pe=pedgeHead; pe!=NIL(struct edge); pe=pe->pnext)  {
	    printf("\t%s, ", (pe->type == MIN) ? "MIN" : "MAX");
	    printf("at loc %d, on layer %s, from obj. %d, ", pe->loc,
		    LayerMap[pe->maskNumber].name, pe->key);
	    if (pe->netId == UNDEF)  {
		printf("netId UNDEF");
	    } else  {
		printf("netId %d", pe->netId);
	    }
	    printf(", masked %c\n", pe->masked);

	    if (pe->pmasks != NIL(struct edge))  {
		printf("\t    ");
		printf("%c-masks %s, ", pe->pmasks->masked,
			(pe->pmasks->type == MIN) ? "MIN" : "MAX");
		printf("at %d, on %s, from %d, ", pe->pmasks->loc,
			LayerMap[pe->pmasks->maskNumber].name,pe->pmasks->key);
		if (pe->pmasks->netId == UNDEF)  {
		    printf("netId UNDEF\n");
		} else  {
		    printf("netId %d\n", pe->pmasks->netId);
		}
	    }
	    if (pe->phardMasks != NIL(struct elist))  {
		phM = pe->phardMasks;
		for (; phM!=NIL(struct elist); phM=phM->pnext)  {
		    printf("\t    ");
		    printf("hard-masks edge of obj. %d\n", phM->pedge->key);
		}
	    }
	    if (pe->phardMaskedBy != NIL(struct klist))  {
		pmB = pe->phardMaskedBy;
		for (; pmB!=NIL(struct klist); pmB=pmB->pnext)  {
		    printf("\t    ");
		    printf("masked by obj. %d\n", pmB->key);
		}
	    }
	}
    }
}
