#include "copyright.h"
#include "sparcs.h"
/*#include "graph.h"*/
#include "grid.h"
#include "oct.h"
#include "globals.h"

/*
 *  To initialize global variables.  This routine is called BEFORE the command-
 *  line is processed; thus some of these values may be overridden.
 *
 *  last modified 4/20/87
 */

void
SPinit()
{
    int i, j;

    NumLayers = 0;

    Iterations = 0;

    ElementKey = 1;

    MaxBBX = -INFINITY;
    MaxBBY = -INFINITY;
    MinBBX =  INFINITY;
    MinBBY =  INFINITY;

    /*  initialize the grid pointers  */
    pHorizontalGrid = NIL(struct gridLine);
    pVerticalGrid   = NIL(struct gridLine);

    /*
     *  Put the value "NO_RULE" into all locations of Rules[][].
     */
    for (i=0; i<MAXLAYERS; i++)  {
	for (j=0; j<MAXLAYERS; j++)  {
	    Rules[i][j].spacing = NO_RULE;
	    Rules[i][j].mergeable = UNDEF;
	}
    }

    RuleExp = 1;

    /*  play it safe with LayerMap  */
    for (i=0; i<MAXLAYERS; i++)  {
	LayerMap[i].name = NIL(char);
	LayerMap[i].ohmsPerSquare = UNDEF;
	LayerMap[i].maxRule = UNDEF;
    }
}
