#include "copyright.h"
#include "sparcs.h"

/*
 *  Change the coordinates of the protection and terminal frames to make them
 *  relative to the origin of the object (the lower-left corner of its bounding
 *  box).
 *
 *  Modified 5/9/86 to compute the center of the object, which is needed for
 *  constructGrid().
 *
 *  Called by:  readOct()
 *  Calls:	-
 *
 *  1/26/86
 *  last modified 10/21/87
 */

void
SPmakeFramesRelative(pobj)
struct object *pobj;		/*  current object  */
{
    int deltaX, deltaY;
    /* struct frame *pf; */
    struct terminal *pt;

    if (pobj == NIL(struct object))  {
	fprintf(pout, "SPmakeFramesRelative:  NIL object pointer.\n");
	return;
    }

    deltaX = pobj->origin.x;
    deltaY = pobj->origin.y;

    /*
     *  First do the bb of the object.
     */
    /**
    pobj->relBB.lowerL.x -= deltaX;
    if (pobj->relBB.lowerL.x != 0)  {
	fprintf(pout, "SPmakeFramesRelative:  error in relBB calculation.\n");
	return;
    }
    pobj->relBB.lowerL.y -= deltaY;
    if (pobj->relBB.lowerL.y != 0)  {
	fprintf(pout, "SPmakeFramesRelative:  error in relBB calculation.\n");
	return;
    }
    pobj->relBB.upperR.x -= deltaX;
    pobj->relBB.upperR.y -= deltaY;
    **/
    pobj->bbUpperR.x -= deltaX;
    pobj->bbUpperR.y -= deltaY;

    /*  do the terminals.  */
    for (pt=pobj->pterminal; pt!=NIL(struct terminal); pt=pt->pnext)  {
	pt->bb.lowerL.x -= deltaX;
	pt->bb.lowerL.y -= deltaY;
	pt->bb.upperR.x -= deltaX;
	pt->bb.upperR.y -= deltaY;
    }
}
