#include "copyright.h"
#include "sparcs.h"
/*#include "graph.h"*/

/*
 *  Print out the graph.  Modified 7/14/86 for new graph structure.
 *
 *  7/11/85
 *  last modified 4/3/87
 */

void
printGraph()
{
    struct node *pn;
    struct branch *pb;
    int i;

    /*
     *  the source node
     */
    fprintf(pout, "\nSource Node:");
    fprintf(pout, "   node's location is %d, %d\n", pSource->loc.x,
								pSource->loc.y);
    fprintf(pout, "  fanin nodes:\n");

    pb = pSource->pfanins;
    for (; pb!=NIL(struct branch); pb=pb->pnextFanin)  {
	fprintf(pout, "    lower/upper Bounds:  %d/%d",
			   pb->lowerBound, pb->upperBound);
	fprintf(pout, "  (from node %d)\n", pb->pfromNode->key);
    }

    fprintf(pout, "  fanout nodes:\n");

    pb = pSource->pfanouts;
    for (; pb!=NIL(struct branch); pb=pb->pnextFanout)  {
	fprintf(pout, "    lower/upper Bounds:  %d/%d",
			pb->lowerBound, pb->upperBound);
	fprintf(pout, "  (to node %d)\n", pb->ptoNode->key);
    }
    fflush(pout);


    /* 
     *  The nodes for the elements.
     */
    for (i=1; i<=NumElements; i++)  {
	if ((pn = NodeArray[i]) == NIL(struct node))  {
	    fprintf(pout, "printGraph:  NIL node pointer for el't %d.\n", i);
	    continue;
	}
	if (pn->key == UNDEF)  continue;	/*  Inactive.  */

	fprintf(pout, "\nNode for element %d:", pn->key);
	fprintf(pout, "   node's location is %d, %d\n", pn->loc.x, pn->loc.y);
	fprintf(pout, "  fanin nodes:\n");

	fflush(pout);

	pb = pn->pfanins;
	for (; pb!=NIL(struct branch); pb=pb->pnextFanin)  {
	    fprintf(pout, "    lower/upper Bounds:  %d/%d",
			    pb->lowerBound, pb->upperBound);
	    fflush(pout);
	    fprintf(pout, "  (from node %d)\n", pb->pfromNode->key);
	    fflush(pout);
	}

	fprintf(pout, "  fanout nodes:\n");

	pb = pn->pfanouts;
	for (; pb!=NIL(struct branch); pb=pb->pnextFanout)  {
	    fprintf(pout, "    lower/upper Bounds:  %d/%d",
			     pb->lowerBound, pb->upperBound);
	    fflush(pout);
	    fprintf(pout, "  (to node %d)\n", pb->ptoNode->key);
	    fflush(pout);
	}
    }

    /*
     *  the sink node
     */
    fprintf(pout, "\nSink Node:");
    fprintf(pout, "   node's location is %d, %d\n", pSink->loc.x, pSink->loc.y);
    fprintf(pout, "  fanin nodes:\n");

    pb = pSink->pfanins;
    for (; pb!=NIL(struct branch); pb=pb->pnextFanin)  {
	fprintf(pout, "    lower/upper Bounds:  %d/%d", pb->lowerBound,
						 pb->upperBound);
	fprintf(pout, "  (from node %d)\n", pb->pfromNode->key);
    }

    fprintf(pout, "  fanout nodes:\n");

    pb = pSink->pfanouts;
    for (; pb!=NIL(struct branch); pb=pb->pnextFanout)  {
	fprintf(pout, "    lower/upper Bounds:  %d/%d", pb->lowerBound,
						 pb->upperBound);
	fprintf(pout, "  (to node %d)\n", pb->ptoNode->key);
    }
    fflush(pout);
}
