#include "copyright.h"
#include "sparcs.h"

/*
 *  Print the WireList.  For debugging.
 *
 *  9/4/85
 *  last modified 6/12/87
 */

void
printWireList()
{
    struct wire *pw;
    int count = 0;

    for (pw=pWireList; pw!=NIL(struct wire); pw=pw->pnext)  {
	count++;
	fprintf(pout, "\nWire segment with key %d:\n", pw->key);
	fprintf(pout, "\tendpoint coordinates are (%d, %d) (%d, %d)\n",
		    pw->p1.x, pw->p1.y, pw->p2.x, pw->p2.y);
	fprintf(pout, "\twidth is %d, layer %d (%s)\n", pw->width,
		    pw->maskNumber, LayerMap[pw->maskNumber].name);
	fprintf(pout, "\tintersects a terminal on object %d with area ",
		    pw->po1->key);
	fprintf(pout, "(%d, %d) (%d, %d),\n",
		    pw->pt1->bb.lowerL.x + pw->po1->origin.x,
		    pw->pt1->bb.lowerL.y + pw->po1->origin.y,
		    pw->pt1->bb.upperR.x + pw->po1->origin.x,
		    pw->pt1->bb.upperR.y + pw->po1->origin.y);
	fprintf(pout, "\tand a terminal on object %d with area ", pw->po2->key);
	fprintf(pout, "(%d, %d) (%d, %d)\n",
		    pw->pt2->bb.lowerL.x + pw->po2->origin.x,
		    pw->pt2->bb.lowerL.y + pw->po2->origin.y,
		    pw->pt2->bb.upperR.x + pw->po2->origin.x,
		    pw->pt2->bb.upperR.y + pw->po2->origin.y);
    }
    fprintf(pout, "\n%d wires were found.\n\n", count);
}
