#include "copyright.h"
#include "sparcs.h"

/*
 *  Routines to return sparcs version number, in the format
 *
 *	"MAJOR_REVISION-MINOR_REVISION (month day, year)"
 *
 *  The pre-processor variable CUR_DATE is filled in at compile time; its
 *  value is the output of the `date` program.  The month, day, and year (from
 *  CUR_DATE) and MAJOR_REVISION and MINOR_REVISION are used by procVersion()
 *  to build the version string.  The string is returned by sparcsVersion().
 *
 *  Basic idea from VEM's version routines.
 *
 *  4/21/87
 *  last modified 4/11/88
 */

#define	MAJOR_REVISION	2
#define MINOR_REVISION	00

static char *
procVersion(datestr)
char *datestr;
{
    char buffer[25];
    char *version;
    char day[10], month[10], zone[10];
    int date, hour, minute, second, year;

    if (sscanf(datestr, "%s %s %2d %2d:%2d:%2d %s %4d", day, month, &date,
				&hour, &minute, &second, zone, &year) == 8)  {
	sprintf(buffer, "%d-%d (%s %d, %d)", MAJOR_REVISION, MINOR_REVISION,
		month, date, year);
	version = STRSAVE(buffer);
    } else  {
        sprintf(buffer, "%d-%d", MAJOR_REVISION, MINOR_REVISION);
	version = STRSAVE(buffer);
    }
    return(version);
}


char *
sparcsVersion()
{
    return(procVersion(CUR_DATE));
}
