#include "copyright.h"
#include "port.h"
#include "spider.h"

MIGHTYinWrite(fp)
FILE *fp;
{
    int 	n_corner;
    int 	side;
    int 	netnum;
    int 	colnum, rownum;
    int		top_n_pins   = CHAN_PINS->numpins[TOP];
    int		btm_n_pins   = CHAN_PINS->numpins[BOTTOM];
    int		left_n_pins  = CHAN_PINS->numpins[LEFT];
    int		right_n_pins = CHAN_PINS->numpins[RIGHT];
    int 	iii;

    pin_type 	*pin;

    if (NUM_NET == 0)
    {
        printf("(inWrite): zero net count. program exit.\n");
        exit(channel_types+2);
    }

/* ==== Set the new rec-linear corners for the top and btm channel boundary */

    newcorner();

    /* Output number of nets */
    fprintf(fp, "number_of_nets %d\n", NUM_NET);

    /* Output total num of corners of the channel boundary */
    n_corner = count_corners();
    fprintf(fp, "rectagoncorners %d\n", n_corner);

    /* Output the channel boundarys */

    outputBoundarys(fp);

    /* Output number of pins */
    fprintf(fp, "number_of_pins %d\n", (top_n_pins + btm_n_pins));

    /* For each pin DO */

    for (side=TOP;  side <= BOTTOM;  side++)  
      {
	for (pin=FIRST_PIN(side); pin != NULL; pin=pin->next) 
	  {
	    netnum = pin->netid;
	    colnum = pin->col;
	    rownum = get_row(side,pin);

	    if (netlist[netnum]->numpins > 1)  
	      {
		fprintf(fp, "%d %d %d %d\n", 
			netnum, colnum, rownum, (pin->layer == 0)?1:pin->layer); 
	      }
	  }
      }

  if (FIRST_PIN(LEFT) != NULL)  
    {
      fprintf(fp, "left_list %d\n", left_n_pins);
      
      iii = 0;
      for (pin=FIRST_PIN(LEFT); pin != NULL; pin=pin->next) 
	{
	  netnum = pin->netid;
	  
	  if (netlist[netnum]->numpins > 1)  
	    {
	      fprintf(fp, "%d ", netnum); 
	      iii ++;
	      if ( (iii%40) == 0 ) fprintf(fp, "\n");
	    }
        }
    }

    if (FIRST_PIN(RIGHT) != NULL)  
      {
	if ( (iii%40) != 0 ) fprintf(fp, "\n");
        fprintf(fp, "right_list %d\n", right_n_pins);

        iii = 0;
        for (pin=FIRST_PIN(RIGHT); pin != NULL; pin=pin->next) 
	  {
             netnum = pin->netid;

	     if (netlist[netnum]->numpins > 1)  
	       {
                 fprintf(fp, "%d ", netnum); 
		 iii ++;
	         if ( (iii%40) == 0 ) fprintf(fp, "\n");
	     }
	   }
	if ( (iii%40) != 0 ) fprintf(fp, "\n");
      }
  doObstacles(fp);
}

/*****************************************************************************/

outputBoundarys(fp)
FILE *fp;
{
  outputBoundaryForward(fp, grid_chan_boundary[BOTTOM]);
  outputBoundaryReverse(fp, grid_chan_boundary[TOP]);
}

outputBoundaryForward(fp,start)
FILE *fp;
vertex_type *start;
{
int r;
vertex_type *vert, *vert2;

for(vert = start,vert2 = NULL;vert != NULL;vert = vert->next)
  {
    vert->prev = vert2;
    vert2 = vert;
  }

  for(vert = start;vert != NULL;vert = vert->next)
    {
      if(detect_stub_forward(vert) == TRUE)
	{
	  if(vert->y != vert->next->next->next->y)
	    {
	      fprintf(fp, "%d %d \n", vert->x, vert->y - 1);
	      fprintf(fp, "%d %d \n", vert->x, vert->next->next->next->y - 1);
	    }
	  else
	    {
	      if(vert->prev == NULL)
		fprintf(fp, "%d %d \n", vert->x, vert->y + 1);
	      if(vert->next->next->next->next == NULL)
		fprintf(fp, "%d %d \n", vert->x, vert->y + 1);
	    }
	  vert = vert->next->next->next;
	}
      else
	{
	  r = vert->y - 1;
	  fprintf(fp, "%d %d \n", vert->x, r);
	}
    }
}

outputBoundaryReverse(fp,start)
FILE *fp;
vertex_type *start;
{
int r;
vertex_type *vert,*vert2;

for(vert = start,vert2 = NULL;vert != NULL;vert = vert->next)
  {
    vert->prev = vert2;
    vert2 = vert;
  }
for(vert = vert2;vert != NULL;vert = vert->prev)
  {
    if(detect_stub_reverse(vert) == TRUE)
      {
	if(vert->y != vert->prev->prev->prev->y)
	  {
	    fprintf(fp, "%d %d \n", vert->x, vert->y + 1);
	    fprintf(fp, "%d %d \n", vert->x, vert->prev->prev->prev->y + 1);
	  }
	else
	  {
	    if(vert->next == NULL)
	      fprintf(fp, "%d %d \n", vert->x, vert->y + 1);
	    if(vert->prev->prev->prev->prev == NULL)
	      fprintf(fp, "%d %d \n", vert->x, vert->y + 1);
	  }
	vert = vert->prev->prev->prev;
      }
    else
      {
	r = vert->y + 1;
	fprintf(fp, "%d %d \n", vert->x, r);
      }
  }
}

/*****************************************************************************/

doObstacles(fp)
FILE *fp;
{
int n;

n = countObstacles(grid_chan_boundary[BOTTOM]) + countObstacles(grid_chan_boundary[TOP]);
if(n > 0)
  {
    fprintf(fp,"obstacles %d\n",n * 2);
    outputObstacles(fp, grid_chan_boundary[BOTTOM],BOTTOM);
    outputObstacles(fp, grid_chan_boundary[TOP],TOP);
  }
}

countObstacles(vert)
vertex_type *vert;
{
int c;

c = 0;
for(;vert != NULL;vert = vert->next)
  if(detect_stub_forward(vert) == TRUE)
    c++;
return(c);
}

outputObstacles(fp,vert,side)
FILE *fp;
vertex_type *vert;
int side;
{
int offset;
int loc;

offset = (side == TOP)?1:-1;
for(;vert != NULL;vert = vert->next)
  {
    if(detect_stub_forward(vert) == TRUE)
      {
	if(vert->y == vert->next->next->next->y)
	  {
	    fprintf(fp,"%d %d %d %d  %d\n",
		    vert->x,vert->y + offset,
		    vert->x,vert->next->y + offset,1);
	    fprintf(fp,"%d %d %d %d  %d\n",
		    vert->x,vert->y + offset,
		    vert->x,vert->next->y + offset,2);
	  }
	else
	  {
	    if(vert->y < vert->next->y)
	      loc = MAX(vert->y, vert->next->next->next->y);
	    else
	      loc = MIN(vert->y, vert->next->next->next->y);

	    fprintf(fp,"%d %d %d %d  %d\n",
		    vert->x,loc + offset,
		    vert->x,vert->next->y + offset,1);
	    fprintf(fp,"%d %d %d %d  %d\n",
		    vert->x,loc + offset,
		    vert->x,vert->next->y + offset,2);
	  }
      }
  }
}

/*****************************************************************************/

count_corners()
{
int cnt;
vertex_type *vert,*vert2;

cnt = 0;
vert = grid_chan_boundary[BOTTOM];
for(vert2 = NULL;vert != NULL;vert = vert->next)
  {
    vert->prev = vert2;
    vert2 = vert;
  }
vert = grid_chan_boundary[BOTTOM];
for(;vert != NULL;vert = vert->next)
  {
    if(detect_stub_forward(vert) == TRUE)
      {
	if(vert->y == vert->next->next->next->y)
	  {
	    if(vert->prev == NULL)
	      cnt++;
	    if(vert->next->next->next->next == NULL)
	      cnt++;
	    vert = vert->next->next->next;
	  }
	else
	  vert = vert->next;

	continue;
      }
    cnt++;
  }

vert = grid_chan_boundary[TOP];
for(vert2 = NULL;vert != NULL;vert = vert->next)
  {
    vert->prev = vert2;
    vert2 = vert;
  }
vert = grid_chan_boundary[TOP];
for(;vert != NULL;vert = vert->next)
  {
    if(detect_stub_forward(vert) == TRUE)
      {
	if(vert->y == vert->next->next->next->y)
	  {
	    if(vert->prev == NULL)
	      cnt++;
	    if(vert->next->next->next->next == NULL)
	      cnt++;
	    vert = vert->next->next->next;
	  }
	else
	  vert = vert->next;
	continue;
      }
     cnt++;
  }
return(cnt);
}

detect_stub_reverse(vert)
vertex_type *vert;
{
vertex_type *vert2, *vert3, *vert4;

if((vert->prev != NULL) && 
   (vert->prev->prev != NULL) && 
   (vert->prev->prev->prev != NULL))
  {
    vert2 = vert->prev;
    vert3 = vert2->prev;
    vert4 = vert3->prev;
    
    if((vert->x == vert2->x) && (vert->x == vert3->x) && (vert->x == vert4->x))
      {
	if ((vert2->y == vert3->y) &&
	    (((vert->y < vert2->y) && (vert4->y < vert3->y)) ||
	     ((vert->y > vert2->y) && (vert4->y > vert3->y))))
	  {
	    return(TRUE);
	  }
      }
  }
return(FALSE);
}

detect_stub_forward(vert)
vertex_type *vert;
{
vertex_type *vert2, *vert3, *vert4;

if((vert->next != NULL) && 
   (vert->next->next != NULL) && 
   (vert->next->next->next != NULL))
  {
    vert2 = vert->next;
    vert3 = vert2->next;
    vert4 = vert3->next;
    
    if((vert->x == vert2->x) && (vert->x == vert3->x) && (vert->x == vert4->x))
      {
	if ((vert2->y == vert3->y) &&
	    (((vert->y < vert2->y) && (vert4->y < vert3->y)) ||
	     ((vert->y > vert2->y) && (vert4->y > vert3->y))))
	  {
	    return(TRUE);
	  }
      }
  }
return(FALSE);
}

