#include "copyright.h"
#include "port.h"
#include "spider.h"

int MIGHTYoutRead(fp)
FILE *fp;

/**********************************************************************
 *  
 * 		  MIGHTYoutRead -- read MIGHTY output 
 * 		  -----------------------------------
 *
 *	---- This routine sets up the following data structure. 
 *
 *  
 ***********************************************************************/

{
    char 	card[256];
    char 	keyword[40];
    char 	skip[40];

    int 	via_count;
    int 	wire_count;
    int 	netid;
    int 	col, col1, col2;
    int 	row, row1, row2;
    int 	layernum, layerOne, layerTwo;
    int 	netwidth; 
    int         i;
    int         debug;

    debug = 0;

    /*  Initialize */
    ROUTING = CALLOC(routing_type, 1);
    ROUTING->first_col = 0;
    ROUTING->first_row = 0;
    ROUTING->last_col = RC_LOC->col_count;
    ROUTING->last_row = RC_LOC->row_count;
	    
    via_count = 0;
    wire_count = 0;

    /*  Start reading the output file */

    while (fgets(card,sizeof(card), fp) != NULL)
    {
    	if (debug>=1)  printf("Read LINE: %s \n", card);

        (void) strcpy(keyword, "");
        (void) sscanf(card,"%s", keyword);
	    
    	if (strcmp(keyword, "vias") == 0)   {

           if (sscanf(card,"%s %d", 
               skip, &via_count) != 2) {

    	       printf("INPUT: %s\n", card);
   	       logError("Bad INPUT file, while reading vias",NONFATAL);
	       return(-1);
    	   } 

	   for (i=1;  i <= via_count;  i++ )  {

		/* read in */
        	if (fscanf(fp, "%d %d %d %d %d", 
		           &netid, &col, &row, &layerOne, &layerTwo)
		    != 5)  {

    	            printf("netid= %d, col,row= %d %d, layerOne,2= %d %d \n", 
			    netid, col,row, layerOne, layerTwo);

   		    logError("Bad INPUT file.  It occurs while reading a via",
			      NONFATAL);
	            return(-1);
        	}

		bldvia("m_via", netid, col,row, col,row, layerOne, layerTwo);
	   }
    	}
	    
    	else if (strcmp(keyword, "wires") == 0)   {

           if (sscanf(card,"%s %d", skip, &wire_count) != 2)  {
    	       printf("wire_count = %d \n", wire_count);
   	       logError("Bad INPUT file.  It occurs while reading wires",
			 NONFATAL);
	       return(-1);
           }

	   if (wire_count == 0) {
    	       printf("(readinfile): zero wire count. program exit.\n");
	       exit(channel_types+2);
	   }

	   for (i=1;  i <= wire_count;  i++ )  {

		/* read in */
        	if (fscanf(fp, "%d %d %d %d %d %d", 
		           &netid, &col1, &row1, &col2, &row2, &layernum)
		    != 6)  {

    	            printf("netid= %d, col,row = (%d %d) (%d %d), layer= %d\n", 
			    netid, col1, row1, col2, row2, layernum);  

   		    logError("Bad INPUT file.  It occurs while reading a wire",
			      NONFATAL);
	            return(-1);
        	}

		/* build a new subnet */

		netwidth = layer_width[layernum];
 		bldsubnet(netid, 
			  0,0,0,0, netwidth, layernum,
			  row1, col1, row2, col2,(term_type *)NULL,(term_type *)NULL,0,0,(col1 == col2)?VERTICAL:HORIZONTAL);
	      }
	}

    	else if (strcmp(keyword, "error") == 0)   {
   		printf("msg:  %s\n", card); 
	        return(-1);
	}
    }

    if (via_count == 0 && wire_count == 0)   {
   	printf("no via and wire information found\n"); 
	return(-1);
    }
    printf("\n (MIGHTYoutRead)--\n");
    printf("routing col= %d\n", RC_LOC->col_count);
    printf("routing row= %d\n", RC_LOC->row_count);
    printf("total #_row= %d\n", NUM_ROWS(ROUTING));
    printf("# vias= %d\n", via_count);
    printf("# wire= %d\n", wire_count);

    printf("Complete MIGHTYoutRead.c\n");
fflush(stdout);
    return(0);
}

