#include "copyright.h"
#include "port.h"
#include "spider.h"

int 	bottomRefY;
int  YACR_ROW_OFFSET = 0;

extern pin_type *relative_pins[2];

YACRinWrite(fp)
FILE *fp;
{
    int i, side, count, netnum;
    int rownum,min;
    pin_type *p;

    if (NUM_NET == 0)
    {
        printf("(inWrite): zero net count. program exit.\n");
        exit(channel_types+2);
    }

    /* Output number of columns */
    fprintf(fp, "ncol= %d\n", RC_LOC->col_count);

    /* Output number of nets */
    fprintf(fp, "nnet= %d\n", NUM_NET);

    /* Output TOP and BOTTOM sequence */
    fprintf(fp,"top_list\n");
    for(i = 1; i <= RC_LOC->col_count; i++)
    {
	if (RC_LOC->col_pins[TOP][i] == NULL)
    	    netnum = 0;
	else  {
 	    netnum = RC_LOC->col_pins[TOP][i]->netid;
 	    if (netlist[netnum]->numpins <= 1)  {
		netnum = RC_LOC->col_pins[TOP][i]->netid = 0;
	        RC_LOC->col_pins[TOP][i] = NULL;
 	    }
	}

	fprintf(fp, "%d ",netnum);
	if (((i+1)%16 == 0) || (i == RC_LOC->col_count))
		fprintf(fp, "\n");
    }
   
    fprintf(fp,"bottom_list\n");
    for(i = 1; i <= RC_LOC->col_count; i++)
    {
	if (RC_LOC->col_pins[BOTTOM][i] == NULL)
    	    netnum = 0;
	else  {
 	    netnum = RC_LOC->col_pins[BOTTOM][i]->netid;
 	    if (netlist[netnum]->numpins <= 1)  {
		netnum = RC_LOC->col_pins[BOTTOM][i]->netid = 0;
	        RC_LOC->col_pins[BOTTOM][i] = NULL;
 	    }
	}

	fprintf(fp, "%d ",netnum);
	if (((i+1)%16 == 0) || (i == RC_LOC->col_count))
		fprintf(fp, "\n");
    }
   
   
    /* Output LEFT and RIGHT edge sequence order */

    for(side = LEFT; side <= RIGHT; side++) {

	count = 0;

	for(p = FIRST_PIN(side); p != NULL; p = p->next)
	    count++;

	if (side == LEFT)
	    fprintf(fp, "left_list %d\n", count);
	else
	    fprintf(fp, "right_list %d\n", count);

	for(i = 0, p = FIRST_PIN(side); p != NULL; p = p->next, i++) {

 	    netnum = p->netid;
 	    if (netlist[netnum]->numpins <= 1)  netnum = 0;

	    fprintf(fp, "%d ", netnum);
	    if (((i+1)%16 == 0) || (i+1 == count))
		fprintf(fp, "\n");
	}
    }

    for(side = TOP; side <= BOTTOM; side++) 
      {
	count = 0;
	
	for(p = relative_pins[side]; p != NULL; p = p->next)
	  count++;
	
	if (side == TOP)
	  fprintf(fp, "partial_up %d\n", count);
	else
	  fprintf(fp, "partial_down %d\n", count);
	
      	for(i = 0, p = relative_pins[side]; p != NULL; p = p->next, i++) 
	  {
 	    netnum = p->netid;
 	    if (netlist[netnum]->numpins <= 1)  
	      netnum = 0;
	    
	    fprintf(fp, "%d ", netnum);
	    if (((i+1)%16 == 0) || (i+1 == count))
	      fprintf(fp, "\n");
	  }
      }

    fprintf(fp,"top_offset\n");
    min = MAXINT;
    for(i = 1; i <= RC_LOC->col_count; i++)
      {
	min = MIN(min,get_col_offset(TOP,i));
      }
    if(min < 0)
      logError("problem in writing router file",FATAL);

    for(i = 1; i <= RC_LOC->col_count; i++)
      {
	rownum = get_col_offset(TOP,i) - min;

	fprintf(fp, "%d ", rownum);
	if (((i+1)%16 == 0) || (i == RC_LOC->col_count))
		fprintf(fp, "\n");
    }
   
    fprintf(fp,"bottom_offset\n");
    min = MAXINT;
    for(i = 1; i <= RC_LOC->col_count; i++)
      {
	min = MIN(min,get_col_offset(BOTTOM,i));
      }
    if(min < 0)
      logError("problem in writing router file",FATAL);
    YACR_ROW_OFFSET = min;
    for(i = 1; i <= RC_LOC->col_count; i++)
      {
	rownum = get_col_offset(BOTTOM,i) - YACR_ROW_OFFSET;
	
	fprintf(fp, "%d ", rownum);
	if (((i+1)%16 == 0) || (i == RC_LOC->col_count))
	  fprintf(fp, "\n");
    }

    printf("\n (routerinwrite)-- ");
    printf("rowcount= %d\n", RC_LOC->row_count);
}


