#include "copyright.h"
#include "port.h"
#include "spider.h"

struct subnet_list	**col_subnet; 
struct subnet_list *new_subnet_list();
extern int MIN_SPACING;
static int PARTIAL;

/**************************************************************************/

adjustVnet2()
{
 int col, row;
 int netid;
 int colnum;
 int side;
 pin_type	*pin;
 subnet_type    *subnet;
 int		**newcol_loc;
 colnum = RC_LOC->col_count+5;
 newcol_loc   = CALLOC(int *, 2);
 newcol_loc[TOP]= CALLOC( int, colnum+1);
 newcol_loc[BOTTOM]= CALLOC( int, colnum+1);
 col_subnet = CALLOC( struct subnet_list *, colnum+1);
 /* setup the working space */
 for (col = 1;  col <= colnum;  col++) 
   {
     col_subnet[col] = NULL;
   }
 for(netid = 1;netid <= net_count;netid++)
   {
     for (subnet=netlist[netid]->subnetlist; 
	  subnet!=NULL; 
 	  subnet=subnet->next)  
       {
	 if((subnet->dir == VERTICAL) && 
	    (subnetIsOnLayer(subnet,LAYER1) == TRUE))
	   add_to_col_subnet(subnet,subnet->col1);
       }
   }
for(side = TOP;side <= BOTTOM;side++)
  {
    for(pin = FIRST_PIN(side);pin != NULL;pin = pin->next)
      {
	col = pin->col;
	row = get_row(side,pin);
	for (subnet=netlist[pin->netid]->subnetlist; 
	     subnet!=NULL; 
	     subnet=subnet->next)  
	  if((subnet->dir != VERTICAL) && 
	     ((col == subnet->col1 && row == subnet->row1)  ||
	      (col == subnet->col2 && row == subnet->row2)) &&
	     (subnetIsOnLayer(subnet,LAYER1) == TRUE))
	    add_to_col_subnet(subnet,subnet->col1);
      }
  }
PARTIAL = FALSE;
adjustAllNets();

/*  this is doing something weird -- comment out
i = 0;
do {
  adjustAllNets();
  i++;
}while((i < 10) && ((forwardPassPartial() == TRUE) || (backwardPassPartial() == TRUE)));

PARTIAL = TRUE;
i = 0;
do {
  adjustAllNets();
  i++;
}while((i < 10) && ((forwardPassPartial() == TRUE) || (backwardPassPartial() == TRUE)));
*/

printf("adjustVnet2 complete\n");
}

/**************************************************************************/

adjustAllNets()
{
int k,moved;

k = 1;
do {
  moved = FALSE;
  moved = forwardPass();
  moved |= backwardPass();
}while((moved == TRUE) && (k++ < 10));
}

/**************************************************************************/

add_to_col_subnet(subnet,col)
subnet_type *subnet;
int col;
{
struct subnet_list *sl;
 
sl = new_subnet_list();
sl->subnet = subnet;
sl->next = col_subnet[col];
col_subnet[col] = sl;
}

/**************************************************************************/

adjustCol(side,pin)
int side;
pin_type *pin;
{
int row1,row2;
subnet_type *sub;
int loc, subnet_loc;
int col,row;

if((pin->netid == 0) || 
   (netlist[pin->netid]->numpins <= 1) || 
   (pin->power != 0))
  return(FALSE);

col = pin->col;
row = get_row(side,pin);
if((sub = find_connecting_subnet(pin,side)) == NULL)
  return(FALSE);

row1 = MIN(sub->row1, sub->row2);
row2 = MAX(sub->row1, sub->row2);
if((sub->row1 == row) && (sub->col1 == col))
  subnet_loc = sub->x1;
else
  subnet_loc = sub->x2;

if((pin->jogged == TRUE) && (abs(pin->x - subnet_loc) > pin->netwidth))
  return(FALSE);
if((sub->dir == VERTICAL) && 
   (netlist[pin->netid]->subnetlist != NULL) &&
   (netlist[pin->netid]->subnetlist->next == NULL))
  return(FALSE);
if(subnet_loc < pin->x)
  {
    loc = findFirstObstructionToRight(side,col,row1,row2,MAX(sub->width,CONT_WIDTH)); 
    if(loc >= pin->x)
      {
	printf("moved %s to right from %d to %d\n",pin->pinname,subnet_loc,pin->x); 
	moveSubnets(sub,pin->x,row,col,pin->netid);
	return(TRUE);
     }
    else
      if((loc > subnet_loc) && (PARTIAL == TRUE))
	{
	  printf("*** partial move to right %s at %d loc %d orig %d\n",pin->pinname,pin->x,loc,subnet_loc);
	  moveSubnets(sub,loc,row,col,pin->netid);
	  return(TRUE);
	}
	  
  }
else
  if(subnet_loc > pin->x)
    {
      loc = findFirstObstructionToLeft(side,col,row1,row2,MAX(sub->width,CONT_WIDTH)); 
      if(loc <= pin->x)
	{
	  if(pin->x == 87514)
	    loc = loc;
	  printf("moved %s to left from %d to %d\n",pin->pinname,subnet_loc,pin->x); 
	  moveSubnets(sub,pin->x,row,col,pin->netid);
	  return(TRUE);
	}
      else
	if((loc < subnet_loc) && (PARTIAL == TRUE))
	  {
	    printf("*** partial move to left %s at %d loc %d orig %d\n",pin->pinname,pin->x,loc,subnet_loc);
	    moveSubnets(sub,loc,row,col,pin->netid);
	    return(TRUE);
	  }
    }
return(FALSE);
}

/**************************************************************************/

findFirstObstructionToLeft(side,col,row1,row2,width)
int side,col,row1,row2,width;
{
int min,m;
struct subnet_list *sl;

min = MININT;
for(col--;(col >= 1) && (min == MININT);col--)
  {
    for(sl = col_subnet[col];sl != NULL;sl = sl->next)
      {
	if(((side == TOP) && 
	    (MIN(sl->subnet->row1,sl->subnet->row2) <= row2)) ||
	   ((side == BOTTOM) && 
	    (MAX(sl->subnet->row1,sl->subnet->row2) >= row1)))
	  {
	    m = (MAX(sl->subnet->width,CONT_WIDTH))/2 + MIN_SPACING;
	    if(sl->subnet->dir == VERTICAL)
	      m = sl->subnet->x1 + m;
	    else
	      {
		if(sl->subnet->col1 == col)
		  m = sl->subnet->x1 + m;
		else
		  m = sl->subnet->x2 + m;
	      }
	    if(m > min)
	      min = m;
	  }
      }
  }
return(min + width/2);
}

/**************************************************************************/

findFirstObstructionToRight(side,col,row1,row2,width)
int side,col,row1,row2,width;
{
int max,m;
struct subnet_list *sl;

max = MAXINT;
for(col++;(col <= RC_LOC->col_count) && (max == MAXINT);col++)
  {
    for(sl = col_subnet[col];sl != NULL;sl = sl->next)
      {
	if(((side == TOP) && 
	    (MIN(sl->subnet->row1,sl->subnet->row2) <= row2)) ||
	   ((side == BOTTOM) && 
	    (MAX(sl->subnet->row1,sl->subnet->row2) >= row1)))
	  {
	    m = (MAX(sl->subnet->width,CONT_WIDTH))/2 + MIN_SPACING;
	    if(sl->subnet->dir == VERTICAL) 
	      m = sl->subnet->x1 - m;
	    else
	      {
		if(sl->subnet->col1 == col)
		  m = sl->subnet->x1 - m;
		else
		  m = sl->subnet->x2 - m;
	      }
	    if(m < max)
	      max = m;
	  }
      }
  }
return(max - width/2);
}

/**************************************************************************/

subnetIsOnLayer(subnet,layer)
subnet_type *subnet;
int layer;
{
if(subnet->layerid == layer)
  return(TRUE);
if((subnet->term1_status == VIA) && 
   ((subnet->term1.via->layer1 == layer) ||
    (subnet->term1.via->layer2 == layer)))
  return(TRUE);
if((subnet->term2_status == VIA) && 
   ((subnet->term2.via->layer1 == layer) ||
    (subnet->term2.via->layer2 == layer)))
  return(TRUE);
printf("found a wholly MET2 wire\n");
return(FALSE);
}

/**************************************************************************/

moveSubnets(sub,loc,row,col,netid)
subnet_type *sub;
int row,col,loc;
int netid;
{
subnet_type *subnet, *down;
term_type subnet_term;
int x1;
struct subnet_list *sl;

if(sub->col1 == col)
  moveEnd1(sub,loc);
if(sub->col2 == col)
  moveEnd2(sub,loc);

for (subnet=netlist[netid]->subnetlist; 
      subnet != NULL; 
      subnet=subnet->next)  
   {
     if(subnet != sub)
       {
	 if((subnet->col1 == col) && (subnet->row1 == row))
	   {
	     if(subnet->dir == HORIZONTAL)
	       moveEnd1(subnet,loc);
	     else
	       {
		 subnet_term.via = subnet->term1.via;
		 removeSubnetFromViaList(subnet->term1.via,subnet);
		 subnet->term1.via = bldvia("via4a", netid, subnet->x1, subnet->y1, col, row, 
					  LAYER1, LAYER1);
		 add_to_subnet_list(subnet->term1.via,subnet);
		 bldsubnet(netid, subnet->x1, subnet->y1, loc, subnet->y1, 
			   layer_width[LAYER1], LAYER1, row,
			   col,row,col,&(subnet->term1),&subnet_term,VIA,VIA,HORIZONTAL);
	       }
	   }
	 if((subnet->col2 == col) && (subnet->row2 == row))
	   {
	     if(subnet->dir == HORIZONTAL)
	       moveEnd2(subnet,loc);
	     else
	       {
		 subnet_term.via = subnet->term2.via;
		 removeSubnetFromViaList(subnet->term2.via,subnet);
		 subnet->term2.via = bldvia("via4b", netid, subnet->x1, subnet->y1, col, row, 
					  LAYER1, LAYER1);
		 add_to_subnet_list(subnet->term2.via,subnet);
		 bldsubnet(netid, subnet->x1, subnet->y1, loc, subnet->y1, 
			   layer_width[LAYER1], LAYER1, row,
			   col,row,col,&(subnet->term2),&subnet_term,VIA,VIA,HORIZONTAL);
	       }
	   }
       }
   }
if(sub->dir == HORIZONTAL)
  return;
if(sub->row1 == row)
  {
    row = sub->row2;
    subnet_term = sub->term2;
  }
else
  {
    row = sub->row1;
    subnet_term = sub->term1;
  }

down = NULL;
for (sl=subnet_term.via->subnets;
      sl != NULL; 
      sl = sl->next)  
   {
     subnet = sl->subnet;
     if(subnet != sub)
       {
	 if(subnet->term1.via == subnet_term.via)
	   {
	     if((subnet->x1 == subnet->x2) && (subnet->y1 != subnet->y2))
	       down = subnet;
	     else
	       {
		 moveEnd1(subnet,loc);
	       }
	   }
	 if(subnet->term2.via == subnet_term.via)
	   {
	     if((subnet->x1 == subnet->x2) && (subnet->y1 != subnet->y2))
	       down = subnet;
	     else
	       {
		 moveEnd2(subnet,loc);
	       }
	   }
       }
   }
if(down == NULL)
  return;

if((sub->col1 == col) && (sub->row1 == row))
  {
    x1 = sub->x1;
    subnet_term.via = sub->term1.via;
  }
else
  {
    x1 = sub->x2;
    subnet_term.via = sub->term2.via;  
  }
if(down->row1 == row)
  {
    removeSubnetFromViaList(down->term1.via,down);
    down->term1.via = bldvia("via4c", netid, down->x1, down->y1, col, row, 
		       LAYER1, LAYER1);
    add_to_subnet_list(down->term1.via,down);
    bldsubnet(netid, down->x1, down->y1, x1, down->y1, 
	      layer_width[LAYER1], LAYER1, row,
	      col,row,col,&(down->term1),&subnet_term,VIA,VIA,HORIZONTAL);
  }
else
  {
    removeSubnetFromViaList(down->term2.via,down);
    down->term2.via = bldvia("via4d", netid, down->x2, down->y2, col, row, 
		       LAYER1, LAYER1);
    add_to_subnet_list(down->term2.via,down);
    bldsubnet(netid, down->x2, down->y2, x1, down->y2, 
	      layer_width[LAYER1], LAYER1, row,
	      col,row,col,&(down->term2),&subnet_term,VIA,VIA,HORIZONTAL);
  }
}

/**************************************************************************/

moveEnd1(sub,loc)
subnet_type *sub;
int loc;
{
via_type *via;

sub->x1 = loc;
via = sub->term1.via;
if(via != NULL)
  via->x = loc;
else
  logError("(adjVnet): ERROR - no via on subnet ",NONFATAL);
}

/**************************************************************************/

moveEnd2(sub,loc)
subnet_type *sub;
int loc;
{
via_type *via;

sub->x2 = loc;
via = sub->term2.via;
if(via != NULL)
  via->x = loc;
else
  logError("(adjVnet): ERROR - no via on subnet ",NONFATAL);
}

/**************************************************************************/

forwardPass()
{
int side;
pin_type *pin;
int moved;

printf("start forward pass\n");
moved = FALSE;
for(side = TOP;side <= BOTTOM;side++)
  for(pin = FIRST_PIN(side);pin != NULL;pin = pin->next)
    moved |= adjustCol(side,pin);
return(moved);
}

/**************************************************************************/

backwardPass()
{
int side;
int moved;

printf("start backwards pass\n");
moved = FALSE;
for(side = TOP;side <= BOTTOM;side++)
  moved |= backwardsRecursion(side,FIRST_PIN(side));
return(moved);
}

/**************************************************************************/

backwardsRecursion(side,pin)
int side;
pin_type *pin;
{
int moved;

moved = FALSE;
if(pin != NULL)
  {
    moved |= backwardsRecursion(side,pin->next);
    moved |= adjustCol(side,pin);
  }
return(moved);
}

/**************************************************************************/

removeSubnetFromViaList(via,subnet)
via_type	*via;
subnet_type	*subnet;
{
struct subnet_list *sl;

if(via->subnets->subnet == subnet)
  via->subnets = via->subnets->next;
else
  {
    for(sl = via->subnets;(sl != NULL) && (sl->next != NULL) && 
	(sl->next->subnet != subnet);sl = sl->next)
      {}
    if((sl == NULL) || (sl->next == NULL))
      logError("ERROR in removing subnet from via list\n",FATAL);
    sl->next = sl->next->next;
  }
}

/**********************************************************/

findMovementSpaceToLeft(side,col,row1,row2,width,loc)
int side,col,row1,row2,width,loc;
{
int min,m;
struct subnet_list *sl;

min = MININT;
for(col--;(col >= 1) && (min == MININT);col--)
  {
    for(sl = col_subnet[col];sl != NULL;sl = sl->next)
      {
	if(((side == TOP) && 
	    (MIN(sl->subnet->row1,sl->subnet->row2) <= row2)) ||
	   ((side == BOTTOM) && 
	    (MAX(sl->subnet->row1,sl->subnet->row2) >= row1)))
	  {
	    m = (MAX(sl->subnet->width,CONT_WIDTH))/2 + MIN_SPACING;
	    if(sl->subnet->dir == VERTICAL)
	      m = sl->subnet->x1 + m;
	    else
	      {
		if(sl->subnet->col1 == col)
		  m = sl->subnet->x1 + m;
		else
		  m = sl->subnet->x2 + m;
	      }
	    if(m + width/2 > loc)
	      {
		if(side == TOP)
		  row2 = MIN(sl->subnet->row1,sl->subnet->row2) - 1;
		else
		  row1 = MAX(sl->subnet->row1,sl->subnet->row2) + 1;
	      }
	  }
      }
  }
return((side == TOP)?row2:row1);
}

/**************************************************************************/

findMovementSpaceToRight(side,col,row1,row2,width,loc)
int side,col,row1,row2,width,loc;
{
int max,m;
struct subnet_list *sl;

max = MAXINT;
for(col++;(col <= RC_LOC->col_count) && (max == MAXINT);col++)
  {
    for(sl = col_subnet[col];sl != NULL;sl = sl->next)
      {
	if(((side == TOP) && 
	    (MIN(sl->subnet->row1,sl->subnet->row2) <= row2)) ||
	   ((side == BOTTOM) && 
	    (MAX(sl->subnet->row1,sl->subnet->row2) >= row1)))
	  {
	    m = (MAX(sl->subnet->width,CONT_WIDTH))/2 + MIN_SPACING;
	    if(sl->subnet->dir == VERTICAL)
	      m = sl->subnet->x1 - m;
	    else
	      {
		if(sl->subnet->col1 == col)
		  m = sl->subnet->x1 - m;
		else
		  m = sl->subnet->x2 - m;
	      }
	    if(m - width/2 < loc)
	      {
		if(side == TOP)
		  row2 = MIN(sl->subnet->row1,sl->subnet->row2) - 1;
		else
		  row1 = MAX(sl->subnet->row1,sl->subnet->row2) + 1;
	      }
	  }
      }
  }
return((side == TOP)?row2:row1);
}

/**************************************************************************/

forwardPassPartial()
{
int side;
pin_type *pin;
int moved;

printf("start forward pass\n");
moved = FALSE;
for(side = TOP;(side <= BOTTOM) && (moved == FALSE);side++)
  for(pin = FIRST_PIN(side);(pin != NULL) && (moved == FALSE);pin = pin->next)
    moved |= adjustColPartial(side,pin);
return(moved);
}

/**************************************************************************/

backwardPassPartial()
{
int side;
int moved;

printf("start backwards pass\n");
moved = FALSE;
for(side = TOP;(side <= BOTTOM) && (moved == FALSE);side++)
  moved |= backwardsRecursionPartial(side,FIRST_PIN(side));
return(moved);
}

/**************************************************************************/

backwardsRecursionPartial(side,pin)
int side;
pin_type *pin;
{
int moved;

moved = FALSE;
if(pin != NULL)
  {
    moved |= backwardsRecursion(side,pin->next);
    if(moved == FALSE)
      moved |= adjustCol(side,pin);
  }
return(moved);
}

/**************************************************************************/

adjustColPartial(side,pin)
int side;
pin_type *pin;
{
int row1,row2;
subnet_type *sub,*sub2;
int loc, subnet_loc;
int col,row,r,found;

if((pin->netid == 0) || (netlist[pin->netid]->numpins <= 1) || (pin->power != 0))
  return(FALSE);
col = pin->col;
row = get_row(side,pin);
if((sub = find_connecting_subnet(pin,side)) == NULL)
  return(FALSE);

row1 = MIN(sub->row1, sub->row2);
row2 = MAX(sub->row1, sub->row2);
if((sub->row1 == row) && (sub->col1 == col))
  subnet_loc = sub->x1;
else
  subnet_loc = sub->x2;

if((pin->jogged == TRUE) && (abs(pin->x - subnet_loc) > pin->netwidth))
  return(FALSE);
if(sub->dir == VERTICAL)
  {
    found = FALSE;
    if((sub->row1 == row) && (sub->col1 == col))
      r = sub->row2;
    else
      r = sub->row1;
    for (sub2=netlist[pin->netid]->subnetlist; 
	 sub2!=NULL; 
	 sub2=sub2->next)  
      {
	if((sub2 != sub) && 
	   ((col == sub2->col1 && r == sub2->row1)  ||
	    (col == sub2->col2 && r == sub2->row2)))
	  found = TRUE;
      }
    if(found == FALSE)
      return(FALSE);
  }
/*
   (netlist[pin->netid]->subnetlist != NULL) &&
   (netlist[pin->netid]->subnetlist->next == NULL))
  return;
*/

if(subnet_loc < pin->x)
  {
    loc = findMovementSpaceToRight(side,col,row1,row2,MAX(sub->width,CONT_WIDTH),pin->x); 
    if(((side == TOP) && (loc > row1)) || ((side == BOTTOM) && (loc < row2)))
      {
	printf("side %d col %d row1 %d row2 %d -- loc %d\n",side,col,row1,row2,loc);
	moveSubnetsPartial(sub,pin->x,row,col,loc,pin->netid);
	return(TRUE);
      }
  }
else
  if(subnet_loc > pin->x)
    {
      loc = findMovementSpaceToLeft(side,col,row1,row2,MAX(sub->width,CONT_WIDTH),pin->x); 
      if(((side == TOP) && (loc > row1)) || ((side == BOTTOM) && (loc < row2)))
	{
	  printf(" left side %d col %d row1 %d row2 %d -- loc %d\n",side,col,row1,row2,loc);
	  moveSubnetsPartial(sub,pin->x,row,col,loc,pin->netid);
	  return(TRUE);
	}
    }
return(FALSE);
}

/**************************************************************************/

moveSubnetsPartial(sub,loc,row,col,break_row,netid)
subnet_type *sub;
int row,col,loc,break_row;
int netid;
{
term_type term,term2,subnet_term;
int x1;
int break_y;

if((sub->col1 == col) && (sub->row1 == row))
  {
    x1 = sub->x1;
    break_y = RC_LOC->row_loc[break_row];
    moveEnd1(sub,loc);
    subnet_term.via = sub->term2.via;
    removeSubnetFromViaList(sub->term2.via,sub);
    if(break_y != sub->y2)
      {
	term.via = bldvia("via5a", netid, x1, break_y, col, break_row, 
			  LAYER1, LAYER1);
	bldsubnet(netid, x1, break_y, x1, sub->y2, 
		  layer_width[LAYER1], LAYER1, break_row,
		  col,sub->row2,col,&term,&(subnet_term),VIA,VIA,VERTICAL); 
	/* hack alert ---------------------- */
	add_to_col_subnet(netlist[netid]->subnetlist,col);
      }
    else
      term.via = subnet_term.via;
    term2.via = bldvia("via6a", netid, loc, break_y, col, break_row, 
		       LAYER1, LAYER1);
    bldsubnet(netid, x1, break_y, loc, break_y, 
	      layer_width[LAYER1], LAYER1, break_row,
	      col,break_row,col,&term,&term2,VIA,VIA,HORIZONTAL);
    /* hack alert ---------------------- */
    add_to_col_subnet(netlist[netid]->subnetlist,col);
    sub->y2 = break_y;
    sub->x2 = loc;
    sub->row2 = break_row;
    sub->col2 = MAXINT;
    sub->term2.via   = term2.via;
    add_to_subnet_list(term2.via,sub);
  }
else
  {
    x1 = sub->x2;
    break_y = RC_LOC->row_loc[break_row];
    moveEnd2(sub,loc);
    subnet_term.via = sub->term1.via;
    removeSubnetFromViaList(sub->term1.via,sub);
    if(break_y != sub->y2)
      {
	term.via = bldvia("via5b", netid, x1, break_y, col, break_row, 
			  LAYER1, LAYER1);
	bldsubnet(netid, x1, break_y, x1, sub->y1, 
		  layer_width[LAYER1], LAYER1, break_row,
		  col,sub->row1,col,&term,&(subnet_term),VIA,VIA,VERTICAL);
	/* hack alert ---------------------- */
	add_to_col_subnet(netlist[netid]->subnetlist,col);
      }
    else
      term.via = subnet_term.via;
    term2.via = bldvia("via6b", netid, loc, break_y, col, break_row, 
		       LAYER1, LAYER1);
    bldsubnet(netid, x1, break_y, loc, break_y, 
	      layer_width[LAYER1], LAYER1, break_row,
	      col,break_row,col,&term,&term2,VIA,VIA,HORIZONTAL);
    /* hack alert ---------------------- */
    add_to_col_subnet(netlist[netid]->subnetlist,col);
    sub->y1 = break_y;
    sub->x1 = loc;
    sub->row1 = break_row;
    sub->col1 = MAXINT;
    sub->term1.via   = term2.via;
    add_to_subnet_list(term2.via,sub);
  }
}
