#include "copyright.h"
#include "port.h"
#include "spider.h"
#define abs(a) (((a) < 0)?(-(a)):(a))
double colAssErr();
pcol insertPinInClosestCol();
pjogged newJogged();

/* Forward declaration of static functions */
static int AChavePin();
static int pinIsLarge();
static int pinsTooClose();


pcol newCol();
pcol findClosestColToX();
pjogged JOGGED_PINS;
static pcol COL_LIST = NULL;
static pcol POWER_COL_LIST = NULL;
extern pcol COLS;

/********************************************************************/

addToColList(col,side,powerCol)
pcol col,powerCol;
int side;
{
static pcol AR_LAST = NULL;
pjogged j;

col->side = side;
col->prev = powerCol;
if(COL_LIST == NULL)
  COL_LIST = AR_LAST = col;
else
  {
    AR_LAST->next = col;
    col->prev = AR_LAST;
    AR_LAST = AR_LAST->next;
  }
AR_LAST->next = NULL;

j = newJogged();
j->pin = col->pin[side];
j->side = side;
j->pin->jogged = TRUE;

if(JOGGED_PINS == NULL)
  JOGGED_PINS = j;
else
  {
    j->next = JOGGED_PINS;
    JOGGED_PINS = j;
  }
}

addToPowerColList(c, side)
int side;
pcol c;
{
pjogged j;

c->side = side;
if(POWER_COL_LIST == NULL)
  POWER_COL_LIST = c;
else
  {
    c->next = POWER_COL_LIST;
    POWER_COL_LIST = c;
  }
j = newJogged();
j->pin = c->pin[side];
j->side = side;
j->pin->jogged = TRUE;

if(JOGGED_PINS == NULL)
  JOGGED_PINS = j;
else
  {
    j->next = JOGGED_PINS;
    JOGGED_PINS = j;
  }
}

assign_pins_to_cols(start,end)
int start,end;
{
    pcol col, last;
    pcol makeCols4(), getLastCol();
    pcol makePowerCols();
    pin_type *t_pin,*b_pin;

    check_same_side_pins();

    t_pin = FIRST_PIN(TOP);
    b_pin = FIRST_PIN(BOTTOM);
    COLS = last = NULL;
    while((t_pin != NULL) || (b_pin != NULL)) {
	col = makeCols4(&t_pin,&b_pin);
	if( col != NULL ) {
	    convert();
	    optimize();
	    if(COLS == NULL) {
		COLS = col;
	    } else {
		last->next = col;
		col->prev = last;
	    }
	    last = getLastCol(col);
	}
	if((t_pin != NULL) || (b_pin != NULL)) {
	    col = makePowerCols(&t_pin,&b_pin);
	    if ( col == NULL ) {
		fprintf(stderr, "Could not make space for power net\n" );
	    } else {
		if(COLS == NULL) {
		    COLS = col;
		} else  {
		    last->next = col;
		    col->prev = last;
		}
		last = getLastCol(col);
	    }
	}
    }
    convert();
    printf("final ");
    colAssErr(COLS);
    colSpacingOK();
    insertBlankCols();
    colSpacingOK();
    padChanStart(start,end);
    padChanEnd(end);
    /*
      print_pins();
      */

    jogPowerAround();
    jogAround();
    padChanStart(start,end);
    padChanEnd(end);
    return(setUpColData());
}

pcol makeCols4(t_pin,b_pin)
    pin_type **t_pin, **b_pin;
{
    pcol c,last;
    pin_type *pin, *pin1, *pin2;
    static int number = 1;
    int side;
    pcol cols;
    int do_it;			/* Control variable */

    cols = last = NULL;
    while( *t_pin && *b_pin ) {
	if((*t_pin)->x > (*b_pin)->x) {
	    pin1 = (*b_pin);
	    pin2 = (*t_pin);
	    side = BOTTOM;
	} else {
	    pin1 = (*t_pin);
	    pin2 = (*b_pin);
	    side = TOP;
	}
	if ( pinIsLarge(pin1) || (pinIsLarge(pin2) && pinsTooClose(pin1,pin2 ))) {
	    break;
	}
	c = newCol();
	if(last == NULL) {
	    cols = c;
	} else {
	    last->next = c;
	    c->prev = last;
	}
	last = c;
	if(c->prev == NULL) {
	    c->loc = pin1->x;
	} else {
	    c->loc = MAX(c->prev->loc + GRIDWIDTH,pin1->x);
	}
	c->width = CONT_WIDTH;
	c->index = number++;
	c->pin[TOP] = pin1;
	if(pin2->x < c->loc + GRIDWIDTH/2) {
	      c->pin[BOTTOM] = pin2;
	      if(side == BOTTOM)
		(*t_pin) = (*t_pin)->next;
	      else
		(*b_pin) = (*b_pin)->next;
	  }
	if(side == BOTTOM) {
	    (*b_pin) = (*b_pin)->next;
	} else {
	    (*t_pin) = (*t_pin)->next;
	}
    }

    do_it = 1;
    if ( !AChavePin(*t_pin, *b_pin ) ) {
	do_it = 0;		/* No good pin. */
    }
    if ( pinIsLarge( *t_pin ) || pinIsLarge(*b_pin ) ) {
	do_it = 0;		/* One is a power pin. */
    }

    if( do_it ) {
	  if((*t_pin) != NULL) {
		pin = *t_pin;
		side = TOP;
	    } else {
		pin = *b_pin;
		side = BOTTOM;
	    }
	  for(;(pin != NULL) && !pinIsLarge(pin); pin = pin->next) {
	      c = newCol();
	      if(last == NULL) {
		cols = c;
	      } else {
		  last->next = c;
		  c->prev = last;
	      }
	      last = c;
	      if(c->prev == NULL) {
		  c->loc = pin->x;
	      } else {
		  c->loc = MAX(c->prev->loc + GRIDWIDTH,pin->x);
	      }
	      c->width = CONT_WIDTH;
	      c->index = number++;
	      c->pin[side] = pin;
	  }
	  if(side == TOP)
	    (*t_pin) = pin;
	  else
	    (*b_pin) = pin;
      }
    return cols;
}

pcol getLastCol(col)
    pcol col;
{
    for(;(col != NULL) && (col->next != NULL);col = col->next) {}
    return(col);
}




static int AChavePin( p1, p2 )
    pin_type *p1, *p2;
{
    return ( p1 != NULL )  || ( p2 != NULL );
}

static int pinIsLarge( pin )
    pin_type *pin;
{
    if ( pin == 0 ) return 0;
    return (pin->netwidth > CONT_WIDTH) ;
}


static int onePinIsLarge( t_pin, b_pin )
    pin_type *t_pin, *b_pin;
{
    if ( (t_pin) == NULL || (b_pin) == NULL ) {
	return 0;
    }

    return pinIsLarge( t_pin ) || pinIsLarge( b_pin );
}

static int pinsTooClose( pin1, pin2 )
    pin_type *pin1, *pin2;
{
    if ( pin1->x < pin2->x ) {
	pin_type* tmp = pin1; pin1 = pin2; pin2 = tmp; /* Swap args */
    }
    {
	int m1 = MAX(pin1->netwidth,CONT_WIDTH)/2 ;
	int m2 = MAX(pin2->netwidth,CONT_WIDTH)/2 ;
	if ( (pin1->x + m1 ) > (pin2->x - m2 - MAX_SPACING)) {
	    return 1;
	}
	return 0;
    }
}



pcol makePowerCols(t_pin,b_pin)
pin_type **t_pin, **b_pin;
{
    pcol c;
    pcol cols = NULL;
    pcol last = NULL;
    pcol powerCol = NULL;

    pin_type *pin, *pin1, *pin2;
    int side;
  
    while( onePinIsLarge(*t_pin,*b_pin) ) {
	if ( !pinIsLarge(*b_pin) || (pinIsLarge(*t_pin) && ((*t_pin)->x < (*b_pin)->x))) {
	    side = TOP;
	    pin1 = (*t_pin);
	    pin2 = (*b_pin);
	    if( !pinsTooClose(pin1, pin2) ) {
		break;
	    }
	} else {
	    side = BOTTOM;
	    pin1 = (*b_pin);
	    pin2 = (*t_pin);
	    if ( !pinsTooClose( pin2, pin1 ) ) {
		break;
	    }
	}
	if((powerCol == NULL) || (powerCol->pin[side] != pin1)) {
	    powerCol = c = newCol();
	    if(last == NULL) {
		cols = c;
	    } else {
		last->next = c;
		c->prev = last;
	    }
	    last = c;
	    c->loc = pin1->x;
	    c->width = pin1->netwidth;
	    c->index = pin1->netwidth;
	    c->pin[side] = pin1;
	}

	for(;(pin2 != NULL) &&
	    (pin2->x - ((MAX(CONT_WIDTH,pin2->netwidth))/2) - MAX_SPACING <	
	     pin1->x + pin1->netwidth/2);pin2 = pin2->next)
	  {
	      if(pin2->netwidth > CONT_WIDTH)
		{
		    /*	    if(powerCol->pin[!side] == NULL)
			    {
			    powerCol->pin[!side] = pin2;
			    if(powerCol->width < pin2->netwidth)
			    powerCol->width = pin2->netwidth;
			    }
			    else
			    */
		    {
			c = newCol();
			c->pin[!side] = pin2;
			c->side = !side;
			c->prev = powerCol;
			addToPowerColList(c,!side);
		    }
		    /*
		      if(pin2->x + pin2->netwidth/2 > pin1->x + pin1->netwidth/2)
		      {
		      break;
		      }
		      */
		}
	      else
		{
		    c = newCol();
		    c->pin[!side] = pin2;
		    addToColList(c,!side,powerCol);
		}
	  }
    
	if(side == TOP) {
	    (*t_pin) = (*t_pin)->next;
	    (*b_pin) = pin2;
	} else {
	    (*b_pin) = (*b_pin)->next;
	    (*t_pin) = pin2;
	}
    }

    if((((*t_pin) != NULL) || ((*b_pin) != NULL)) &&
       ((((*t_pin) == NULL) || ((*t_pin)->netwidth > CONT_WIDTH)) &&
	(((*b_pin) == NULL) || ((*b_pin)->netwidth > CONT_WIDTH))))
      {
	  if((*t_pin) != NULL) {
	      pin = *t_pin;
	      side = TOP;
	  } else {
	      pin = *b_pin;
	      side = BOTTOM;
	  }
	  for(;(pin != NULL) && (pin->netwidth > CONT_WIDTH);pin = pin->next)
	    {
		c = newCol();
		if(last == NULL) {
		    cols = c;
		} else {
		    last->next = c;
		    c->prev = last;
		}
		last = c;
		c->loc = pin->x;
		c->width = pin->netwidth;
		c->index = pin->netwidth;
		c->pin[side] = pin;
	    }
	  if(side == TOP) {
	      (*t_pin) = pin;
	  } else {
	      (*b_pin) = pin;
	  }
      }

    return cols;
}

pcol getBlankCols(side)
int side;
{
pcol col, c, last, cols;

col = c = last = NULL;
for(cols = COLS;cols != NULL;cols = cols->next)
  {
    if(cols->pin[side] == NULL)
      {
	c = newCol();
	c->loc = cols->loc;
	if(col == NULL)
	  col = c;
	else
	  {
	    last->next = c;
	    c->prev = last;
	  }
	last = c;
      }
  }
return(col);
}

jogAround()
{
pcol col,c,blanks;
int side;
pcol pins[2], last, last2;

last = last2 = pins[BOTTOM] = pins[TOP] = NULL;
c = COL_LIST;
while(c != NULL)
  {
    col = c;
    c = c->next;
    col->next = NULL;
    col->prev = NULL;
    if(col->pin[TOP] != NULL)
      {
	if(pins[TOP] == NULL)
	  pins[TOP] = col;
	else
	  {
	    last->next = col;
	    col->prev = last;
	  }
	last = col;
      }
    else
      {
	if(pins[BOTTOM] == NULL)
	  pins[BOTTOM] = col;
	else
	  {
	    last2->next = col;
	    col->prev = last2;
	  }
	last2 = col;
      }
  }
for(side = TOP;side <= BOTTOM;side++)
  {
    col = blanks = getBlankCols(side);
    for(c = pins[side];c != NULL;c = c->next)
      {
	insertPinInClosestCol(c->pin[side], blanks, side);
      }
    colAssErr(blanks);
    last = getLastCol(blanks);
    pinSwitch(side,blanks);
    colAssErr(blanks);
    for(col = blanks;col != NULL;col = col->next)
      {
	if(col->pin[side] != NULL)
	  {
	    for(c = COLS;(c != NULL) && (c->loc != col->loc);c = c->next)
	      {}
	    if(c == NULL)
	      logError("ERROR probs in around\n",FATAL);
	    c->pin[side] = col->pin[side];
	  }
      }
  }
}
	    
pcol findClosestColToX(cols,x)
pcol cols;
int x;
{
pcol col;

for(col = cols;(col->next != NULL) && (col->loc < x);col = col->next)
  {}
if(col->loc < x)
  return(col);
if(col->prev == NULL)
  return(col);
if(abs(col->loc - x) < abs(col->prev->loc - x))
  return(col);
return(col->prev);
}
  
pin_type *rmPinNumber(col,side,i,c)
pcol col,*c;
int i;
{
pin_type *pin;

for(;(col != NULL);col = col->next)
  if(col->pin[side] != NULL)
    {
      i--;
      if(i == 0)
	break;
    }
if(col == NULL)
  logError("ERROR in removing pin ",FATAL);
pin = col->pin[side];
col->pin[side] = NULL;
(*c) = col;
return(pin);
}

pinSwitch(side,first)
pcol first;
int side;
{
pcol c;
int i, num;
double best;

for(num = 0,c = first;c != NULL;c = c->next)
  if(c->pin[side] != NULL)
    num++;
if(num <= 1)
  return;
best = colAssErr(first);
for(i=0;i < 50 * num;i++)
  {
    swapPins(first,side,&best,random()%num + 1,random()%(num - 1) + 1);
  }
}

pcol insertPinInClosestCol(pin,col,side)
pin_type *pin;
int side;
pcol col;
{
pcol c;
pcol left,right;
int lDist,rDist;

c = findClosestColToX(col,pin->x);
if(c->pin[side] != NULL)
  {
    for(left = c;(left != NULL) && (left->pin[side] != NULL);left = left->prev)
      {}
    for(right = c;(right != NULL) && (right->pin[side] != NULL);right = right->next)
      {}
    if(left != NULL)
      lDist = abs(pin->x - left->loc);
    else
      lDist = MAXINT;
    if(right != NULL)
      rDist = abs(pin->x - right->loc);
    else
      rDist = MAXINT;
    if((left == NULL) && (right == NULL))
      logError("ERROR not enough columns to route around power pins\n",FATAL);
    if(rDist < lDist)
      c = right;
    else
      c = left;
  }
c->pin[side] = pin;
return(c);
}

swapPins(first,side,best,num1,num2)
pcol first;
int side;
double *best;
int num1,num2;
{
pcol c1,c2,c1new,c2new;
pin_type *pin1,*pin2;
double err;

pin1 = rmPinNumber(first,side,num1,&c1);
pin2 = rmPinNumber(first,side,num2,&c2);
c1new = insertPinInClosestCol(pin1,first,side);
c2new = insertPinInClosestCol(pin2,first,side);
err = colAssErr(first);
if(abs(c1new->loc - pin1->x) < GRIDWIDTH/2)
  {
    err -= 100 + (c1new->loc - pin1->x) * (c1new->loc - pin1->x);
  }	
if(abs(c2new->loc - pin2->x) < GRIDWIDTH/2)
  {
    err -= 100 + (c2new->loc - pin2->x) * (c2new->loc - pin2->x);
  }
if(err < (*best))
  {
    (*best) = err;
  }
else
  {
    c1new->pin[side] = c2new->pin[side] = NULL;
    c1->pin[side] = pin1;
    c2->pin[side] = pin2;
  }
}

pcol findClosestOpenSpace(width,loc,side)
int width,loc;
int side;
{
pcol c;
pcol left,right;
int lDist,rDist;
int lPinsKilled,rPinsKilled;

lDist = MAXINT;
rDist = MAXINT;
c = findClosestColToX(COLS,loc);
for(left = c;(left != NULL);left = left->prev)
  {
    if((left->pin[side] == NULL) && 
       ((lPinsKilled = spaceWidth(left,side,width)) >= 0))
      {
	lDist = abs(loc - left->loc);
	break;
      }
  }
for(right = c;(right != NULL);right = right->next)
  {
    if((right->pin[side] == NULL) && 
       ((rPinsKilled = spaceWidth(right,side,width)) >= 0))
      {
	rDist = abs(loc - right->loc);
	break;
      }
  }
if((left == NULL) && (right == NULL))
  logError("ERROR not enough columns to route around power pins\n",FATAL);
if(right == NULL)
  c = left;
else
  {
    if(left == NULL)
      c = right;
    else
      {
	if((rPinsKilled == 0) && (lPinsKilled == 0))
	  {
	    c = (rDist < lDist)?right:left;
	  }
	else
	  c = (rDist * rPinsKilled < lDist * lPinsKilled)?right:left;
      }
  }
openUpSpace(width,c,side);
return(c);
}

jogPowerAround()
{
pcol powerCol,c;
pin_type *pin;

if(POWER_COL_LIST == NULL)
  return;
logError("WARNING jogging power net\n",NONFATAL);
/*print_col(COLS);*/
for(powerCol = POWER_COL_LIST;powerCol != NULL;powerCol = powerCol->next)
  {
    pin = powerCol->pin[powerCol->side];
    printf("WARNING jogging power net %s \n",pin->pinname);
    c = findClosestOpenSpace(pin->netwidth,pin->x,powerCol->side);
    c->pin[powerCol->side] = pin;
  }
/*print_col(COLS);*/
}

spaceWidth(col,side,width)
pcol col;
int side;
{
pcol right,left;
int killed_pins;

killed_pins = 0;
for(left = col;
    (left->prev != NULL) && 
    ((left->prev->pin[side] == NULL) ||
     (left->prev->pin[side]->netwidth <= CONT_WIDTH)) &&
    ((left->prev->pin[!side] == NULL) ||
     (left->prev->pin[!side]->netwidth <= CONT_WIDTH));
    left = left->prev)
  {
    if(col->loc - width/2 >=
       left->prev->loc + maxNetWidthOnCol(left->prev)/2 + MAX_WIDTH)
      break;
    if(left->prev->pin[TOP] != NULL)
      killed_pins++;
    if(left->prev->pin[BOTTOM] != NULL)
      killed_pins++;
  }
if((left->prev != NULL) && (col->loc - width/2 < 
	    left->prev->loc + maxNetWidthOnCol(left->prev)/2 + MAX_WIDTH))
   return(-1);

for(right = col;
    (right->next != NULL) && 
    (right->next->pin[side] == NULL) &&
    ((right->next->pin[!side] == NULL) ||
     (right->next->pin[!side]->netwidth <= CONT_WIDTH));
    right = right->next)
  {
    if(col->loc + width/2 <=
       right->next->loc - maxNetWidthOnCol(right->next)/2 - MAX_WIDTH)
      break;
    if(right->next->pin[TOP] != NULL)
      killed_pins++;
    if(right->next->pin[BOTTOM] != NULL)
      killed_pins++;
  }
if((right->next != NULL) && (col->loc + width/2 > 
	     right->next->loc - maxNetWidthOnCol(right->next)/2 - MAX_WIDTH))
  return(-1);

return(killed_pins);
}

maxNetWidthOnCol(c)
pcol c;
{

if(c->pin[TOP] != NULL)
  {
    if(c->pin[BOTTOM] != NULL)
      {
	return(MAX(CONT_WIDTH,MAX(c->pin[TOP]->netwidth,c->pin[BOTTOM]->netwidth)));
      }
    else
      {
	return(MAX(CONT_WIDTH,c->pin[TOP]->netwidth));
      }
  }
else
  {
    if(c->pin[TOP] != NULL)
      {
	return(MAX(CONT_WIDTH,c->pin[BOTTOM]->netwidth));
      }
    else
      {
	return(0);
      }
  }
}
    
openUpSpace(width,col,side)
int width,side;
pcol col;
{
pcol right,left,c,cc;

for(right = col;(right->next != NULL) && 
    (right->next->loc - maxNetWidthOnCol(right->next)/2 - MAX_SPACING <
     col->loc + width/2);
    right = right->next)
  {}
for(left = col;(left->prev != NULL) && 
    (left->prev->loc + maxNetWidthOnCol(left->prev)/2 + MAX_SPACING >
     col->loc - width/2);
    left = left->prev)
  {}

for(c = right;c != left->prev;c = c->prev)
  if(c != col)
    {
      if(c->pin[side] != NULL)
	{
	  cc = newCol();
	  cc->pin[side] = c->pin[side];
	  addToColList(cc,side,NULL);
	}
      if(c->pin[!side] != NULL)
	{
	  cc = newCol();
	  cc->pin[!side] = c->pin[!side];
	  addToColList(cc,!side,NULL);
	}
    }
left = left->prev;
for(c = right;c != left;)
  {
    if(c != col)
      {
	cc = c;
	c = c->prev;
	deleteCol(cc);
      }
    else
      c = c->prev;
  }
}

pjogged removeVCVs(jog)
pjogged jog;
{
pjogged j,jj,tail;
int col;

/* assume there are no cyclic constraints */

for(tail = NULL,j = jog;j != NULL;j = j->next)
  {
    for(jj = j->next;jj != NULL;jj = jj->next)
      if((j->side == jj->side) && 
	 ((jj->start == j->stop) || (j->start == jj->stop)))
	{
	  col = (jj->start == j->stop)?jj->start:jj->stop;
	  if(abs(RC_LOC->col_loc[col] - jj->pin->x) < abs(RC_LOC->col_loc[col] - j->pin->x))
	     {
	       if(tail == NULL)
		 {
  		   jog = jog->next;
		 }
	       else
		 {
		   tail->next = j->next;
		 }
	       j->next = jj->next;
	       jj->next = j;
	       printf("INFO -- VCV in jogged wires removed\n");
	       return(removeVCVs(jog));
	     }
	}
    tail = j;
  }
return(jog);
}

fixJoggedPins()
{
pjogged j, jj, tail, sTail, sorted;
int i, row, min,r;

if(JOGGED_PINS == NULL)
  return;
for(j = JOGGED_PINS;j != NULL;j = j->next)
  {
    j->start = findClosestCol(j->pin->x);    
    j->stop = findPinCol(j->pin,j->side);
    if(j->start > j->stop)
      {
	i = j->start;
	j->start = j->stop;
	j->stop = i;
      }
  }
sorted = NULL;
while(JOGGED_PINS != NULL)
  {
    for(min = MAXINT,tail = jj = j = JOGGED_PINS;j != NULL;j = j->next)
      {
	if(j->stop - j->start < min)
	  {
	    min = j->stop - j->start;
	    jj = j;
	    sTail = tail;
	  }
	tail = j;
      }
    if(jj == JOGGED_PINS)
      JOGGED_PINS = JOGGED_PINS->next;
    else
      {
	sTail->next = jj->next;
      }
    jj->next = sorted;
    sorted = jj;
  }
sorted = removeVCVs(sorted);
JOGGED_PINS = sorted;
for(j = JOGGED_PINS;j != NULL;j = j->next)
  {
    j->pin->jogged = TRUE;
    printf("jogged pin %s\n",j->pin->pinname);
    if(j->side == TOP)
      row = MAXINT;
    else
      row = MININT;

    for(i = j->start;i <= j->stop;i++)
      if(j->side == TOP)
	row = MIN(RC_LOC->boundary[TOP][i],row);
      else
	row = MAX(RC_LOC->boundary[BOTTOM][i],row);

    j->row = row;
    printf("jog row %d\n",row);
    if(j->side == TOP)
      r = row - 1;
    else
      r = row + 1;
    for(i = j->start;i <= j->stop;i++)
      {
	RC_LOC->boundary[j->side][i] = r;
      }
  }
}

findClosestCol(x)
int x;
{
int i;

for(i = 1;i <= RC_LOC->col_count;i++)
  {
    if(RC_LOC->col_loc[i] > x)
      break;
  }
if(i == 1)
  {
    return(i);
  }
else
  if((i == RC_LOC->col_count) && (RC_LOC->col_loc[i] < x))
    {
      return(i);
    }
  else
    {
      if(abs(RC_LOC->col_loc[i-1] - x) < abs(RC_LOC->col_loc[i] - x))
	return(i - 1);
      else
	return(i);
    }
}

findPinCol(pin,side)
pin_type *pin;
int side;
{
int i;

for(i = 1;i <= RC_LOC->col_count;i++)
  {
    if(RC_LOC->col_pins[side][i] == pin)
      return(i);
  }
logError("ERROR pin not found\n",FATAL);
}

updateJoggedPins(side,del)
int side,del;
{
pjogged j;

for(j = JOGGED_PINS;j != NULL;j = j->next)
  {
    if(j->side == side)
      j->row = j->row + del;
  }
}






