#include "copyright.h"
#include "port.h"
#include "spider.h"
#include "powernet.h"

chan_bound_type *CHAN_BOUND;

#define V2_NULL 0x08
#define V3_NULL 0x10
#define V3_GE_V1 0x04
#define V2_GE_V1 0x02
#define V3_GE_V2 0x01

filter_bound()
{
int side;
vertex_type *vert1,*vert2,*vert3;
int type;

for(side = TOP;side <= BOTTOM;side++)
for(vert1 = CHAN_BOUND->first[side];vert1 != NULL;vert1 = vert1->next->next)
  {
    vert2 = vert1->next->next;
    if((vert2 == NULL) && (vert1 == CHAN_BOUND->first[side]))
      break;
    for(vert3 = CHAN_BOUND->first[side];
	(vert3 != NULL) &&
	(vert3->next != NULL) &&
	(vert3->next->next != vert1);
	vert3 = vert3->next->next)
      {}
    if(vert1->next->x - vert1->x < GRIDWIDTH)
      {
/*	printf("VERTS %d to %d  --- BAD\n",vert1->x,vert1->next->x); */
	type = 0;
	if(vert3 == NULL)
	  type |= V3_NULL;
	else
	  {
	    if(vert3->y >= vert1->y)
	      type |= V3_GE_V1;
	  }
	if(vert2 == NULL)
	  type |= V2_NULL;
	else
	  {
	    if(vert2->y >= vert1->y)
	      type |= V2_GE_V1;
	    if((vert3 != NULL) && (vert3->y >= vert2->y))
	      type |= V3_GE_V2;
	  }
	if(side == BOTTOM)
	  switch(type)
	    {
	    case (V2_NULL | V3_GE_V1):
	    case (V2_GE_V1 | V3_GE_V1):
	    case (V3_GE_V1 | V3_GE_V2):
	      vert1->next->y = vert3->y;
	      vert3->next = vert1->next;
	      break;

	    case V2_NULL:
	    case V3_GE_V2:
	      vert3->y = vert1->y;
	      vert3->next = vert1->next;
	      break;

	    case V3_NULL:
	    case 0:
	      vert2->next->y = vert1->y;
	      vert1->next = vert2->next;
	      break;

	    case (V2_GE_V1 | V3_GE_V1 | V3_GE_V2):
	    case (V3_NULL | V2_GE_V1):
	    case V2_GE_V1:
	      vert1->y = vert2->y;
	      vert1->next = vert2->next;
	      break;

	    case (V2_GE_V1 | V3_GE_V2):
	    case V3_GE_V1:
	    default:
	      logError("ERROR in boundary filtering\n",FATAL);
	    }
	else
	  switch(type)
	    {
	    case (V2_NULL | V3_GE_V1):
	    case (V2_GE_V1 | V3_GE_V1):
	      vert3->y = vert1->y;
	      vert3->next = vert1->next;
	      break;
	      
	    case V2_NULL:
	    case V3_GE_V2:
	    case V2_GE_V1:
	      vert1->next->y = vert3->y;
	      vert3->next = vert1->next;
	      break;
	      
	    case (V2_GE_V1 | V3_GE_V1 | V3_GE_V2):
	    case (V3_NULL | V2_GE_V1):
	      vert2->next->y = vert1->y;
	      vert1->next = vert2->next;
	      break;
	      
	    case V3_NULL:
	    case (V3_GE_V1 | V3_GE_V2):
	    case 0:
	      vert1->y = vert2->y;
	      vert1->next = vert2->next;
	      break;
	      
	    case (V2_GE_V1 | V3_GE_V2):
	    case V3_GE_V1:
	    default:
	      logError("ERROR in boundary filtering\n",FATAL);
	    }
      }
  }
}

/*************************************************************/

count_pins(pin)
pin_type *pin;
{
int i;

for(i = 0;pin != NULL;pin = pin->next,i++)
  {}
return(i);
}

/*************************************************************/

pin_type *link_up_pins(pin1,pin2)
pin_type *pin1,*pin2;
{
pin_type *p;

if(pin1 == NULL)
  return(pin2);
for(p = pin1;(p != NULL) && (p->next != NULL);p = p->next)
  {}
p->next = pin2;
return(pin1);
}

/*************************************************************/

filter_bound2()
{
int side;
vertex_type *vert1,*vert2,*vert3,*last_bound[2];
pin_type *pin;
int found;

/*
print_bound2(TOP);
printf("BOT\n");
print_bound2(BOTTOM);
printf("\n\n");
fflush(stdout);
*/

found = FALSE;
for(side = TOP;side <= BOTTOM;side++)
  {
    for(pin = FIRST_PIN(side);(pin != NULL) && (pin->next != NULL);pin = pin->next)
      {
	for(vert1 = CHAN_BOUND->first[side];
	    (vert1 != NULL) && (vert1->next != NULL);vert1 = vert1->next)
	  {
	    if((vert1->x <= pin->x) && (pin->x <= vert1->next->x) && (vert1->y == vert1->next->y))
	      break;
	  }
	if((vert1 == NULL) || (vert1->next == NULL))
	  {
	    printf("ERROR in filtering boundary, pin %s is outside channel boundary\n",pin->pinname);
	    exit(6);
	  }
	for(vert2 = CHAN_BOUND->first[side];
	    (vert2 != NULL) && (vert2->next != NULL);vert2 = vert2->next)
	  {
	    if((vert2->x <= pin->next->x) && (pin->next->x <= vert2->next->x) && (vert2->y == vert2->next->y))
	      break;
	  }
	if((vert2 == NULL) || (vert2->next == NULL))
	  {
	    printf("ERROR in filtering boundary, pin %s is outside channel boundary\n", pin->next->pinname);
	    exit(6);
	  }
	for(;(vert1 != NULL) && (vert2 != NULL) && (vert1->x < vert2->x) &&
	     (vert1->next != NULL) && (vert1->next->next != vert2);
	     vert1 = vert1->next->next)
	  {
	    if(side == BOTTOM)
	      {
		for(vert3 = vert1->next->next;
		    vert3 != vert2 && vert3 != NULL && vert3->next != NULL;
		    vert3 = vert3->next->next)
		  {
		    if(vert3->y >= vert1->y)
		      break;
		  }
		if((vert3->y >= vert1->y) && (vert1->next->next != vert3))
		  {
		    found = TRUE;
		    if(vert3->y == vert1->y)
		      {
			vert1->next = vert3->next;
		      }
		    else
		      {
			vert1->next->x = vert3->x;
			vert1->next->next = vert3;
		      }
		  }
	      }
	    else
	      {
		for(vert3 = vert1->next->next;
		    vert3 != vert2 && vert3 != NULL && vert3->next != NULL;
		    vert3 = vert3->next->next)
		  {
		    if(vert3->y <= vert1->y)
		      break;
		  }
		if((vert3->y <= vert1->y) && (vert1->next->next != vert3))
		  {
		    found = TRUE;
		    if(vert3->y == vert1->y)
		      {
			vert1->next = vert3->next;
		      }
		    else
		      {
			vert1->next->x = vert3->x;
			vert1->next->next = vert3;
		      }
		  }
	      }
	  }
      }
  }
clean_boundary(TOP);
clean_boundary(BOTTOM);

/*
print_bound2(TOP);
printf("BOT\n");
print_bound2(BOTTOM);
fflush(stdout);
*/

last_bound[TOP] = relink_boundary(TOP);
last_bound[BOTTOM] = relink_boundary(BOTTOM);

for(side = TOP;side <= BOTTOM;side++)
  {
    for(pin = FIRST_PIN(side);(pin != NULL) && (pin->next != NULL);pin = pin->next)
      {
	for(vert2 = last_bound[side];
	    (vert2 != NULL) && (vert2->prev != NULL);vert2 = vert2->prev)
	  {
	    if((vert2->x >= pin->x) && (pin->x >= vert2->prev->x) && (vert2->y == vert2->prev->y))
	      break;
	  }
	if((vert2 == NULL) || (vert2->prev == NULL))
	  {
	    printf("ERROR in filtering boundary, pin %s is outside channel boundary\n", pin->pinname);
	    exit(6);
	  }
	for(vert1 = last_bound[side];
	    (vert1 != NULL) && (vert1->prev != NULL);vert1 = vert1->prev)
	  {
	    if((vert1->x >= pin->next->x) && (pin->next->x >= vert1->prev->x) && (vert1->y == vert1->prev->y))
	      break;
	  }
	if((vert1 == NULL) || (vert1->prev == NULL))
	  {
	    printf("ERROR in filtering boundary, pin %s is outside channel boundary\n", pin->next->pinname);
	    exit(6);
	  }
	for(;(vert1 != NULL) && 
	    (vert2 != NULL) && 
	    (vert1->x > vert2->x) &&
	    (vert1->prev != NULL) &&
	    (vert1->prev->prev != vert2);vert1 = vert1->prev->prev)
	  {
	    if(side == BOTTOM)
	      {
		for(vert3 = vert1->prev->prev;vert3 != vert2;vert3 = vert3->prev->prev)
		  {
		    if(vert3->y >= vert1->y)
		      break;
		  }
		if((vert3->y >= vert1->y) && (vert1->prev->prev != vert3))
		  {
		    found = TRUE;
		    if(vert3->y == vert1->y)
		      {
			vert1->prev = vert3->prev;
		      }
		    else
		      {
			vert1->prev->x = vert3->x;
			vert1->prev->prev = vert3;
		      }
		  }
	      }
	    else
	      {
		for(vert3 = vert1->prev->prev;vert3 != vert2;vert3 = vert3->prev->prev)
		  {
		    if(vert3->y <= vert1->y)
		      break;
		  }
		if((vert3->y <= vert1->y) && (vert1->prev->prev != vert3))
		  {
		    found = TRUE;
		    if(vert3->y == vert1->y)
		      {
			vert1->prev = vert3->prev;
		      }
		    else
		      {
			vert1->prev->x = vert3->x;
			vert1->prev->prev = vert3;
		      }
		  }
	      }
	  }
      }
  }
CHAN_BOUND->first[TOP] = relink_boundary2(last_bound[TOP]);
CHAN_BOUND->first[BOTTOM] = relink_boundary2(last_bound[BOTTOM]);

CHAN_BOUND->last[TOP] = relink_boundary(TOP);
CHAN_BOUND->last[BOTTOM] = relink_boundary(BOTTOM);

clean_boundary(TOP);
clean_boundary(BOTTOM);

/*
print_bound2(TOP);
printf("BOT\n");
print_bound2(BOTTOM);
fflush(stdout);
*/

return(found);
}

print_bound2(side)
int side;
{
vertex_type *vert1;

for(vert1 = CHAN_BOUND->first[side];(vert1 != NULL);vert1 = vert1->next)
  printf("%d %d\n",vert1->x, vert1->y);
}


vertex_type *relink_boundary(side)
int side;
{
vertex_type *vert,*vert2;

for(vert = CHAN_BOUND->first[side],vert2 = NULL;vert != NULL;vert = vert->next)
  {
    vert->prev = vert2;
    vert2 = vert;
  }
return(vert2);
}

vertex_type *relink_boundary2(vert)
vertex_type *vert;
{
vertex_type *vert2;

for(vert2 = NULL;vert != NULL;vert = vert->prev)
  {
    vert->next = vert2;
    vert2 = vert;
  }
return(vert2);
}

clean_boundary(side)
int side;
{
vertex_type *vert;

for(vert = CHAN_BOUND->first[side];(vert != NULL) && 
    (vert->next != NULL) &&
    (vert->next->next != NULL);
    vert = vert->next)
  {
    if((vert->next->x == vert->next->next->x) &&
       (vert->next->y == vert->next->next->y))
      vert->next = vert->next->next->next;
  }
}

move_bound(side, delta)
int side;
int delta;
{
vertex_type *ptr;
pin_type *pinptr;

printf("move boundary %d by %d\n",side,delta);
for(ptr = CHAN_BOUND->first[side];(ptr != NULL);ptr = ptr->next)
    ptr->y += delta;
CHAN_BOUND->min_y[side] += delta;
CHAN_BOUND->max_y[side] += delta;

for (pinptr=FIRST_PIN(side); pinptr!=NULL; pinptr=pinptr->next)
  pinptr->y += delta;
CHAN_PINS->min_y[side] += delta;
CHAN_PINS->max_y[side] += delta;

CELL_LIST[side]->y += delta;

if(side == TOP)
  CHAN_BOUND->ur_y  += delta;
}
