#include "copyright.h"
#include "port.h"
#include "spider.h"
char     infilename[80];
char 	outfilename[80];
int  	totalDensity;

/*
	CALLROUTER

	1.  write_router_file
	2.  fire the route
	3.  read_outer_file
*/

int callrouter()
{
    FILE *fp;
    char routerInfilename[80];
    char routerOutfilename[80];
    int  rtn_code;

    rtn_code = 0;

    sprintf(routerInfilename,  "%s.in%s",  routerfile, channelIdname);
    sprintf(routerOutfilename, "%s.out%s", routerfile, channelIdname);

    /* Write out the file for the router */

    fp = fopen(routerInfilename, "w");
    if (fp == NULL) 
      {
	sprintf(error, "callrouter: unable to open file \"%s\"",routerInfilename);
	logError(error, FATAL);
      }
    
    if (strcmp(routerName, "YACR") == 0)  
      {
        YACRinWrite(fp);
	(void) fclose(fp);
	printf("START ROUTER %s ... \n", routerName);
	(void) fflush(stdout);
	runYacr(routerfile, "-m", "-O", routerOutfilename, routerInfilename);
	printf("\nRead symbolic routing results ...\n");
	fp = fopen(routerOutfilename, "r");
	if (fp == NULL) 
	  {
	    sprintf(error, "callrouter: unable to open file \"%s\"",routerOutfilename);
	    logError(error, FATAL);
	  }

       	rtn_code = YACRoutRead(fp);
	
	if (rtn_code != 0)  
	  {
	    printf("(callrouter): YACR can not route channel.\n");
	  }
	else
	  {
	    /* define contacts */
	    defcontacts(ROUTING);
	    
	    /* define subnets  */
	    defsubnets(ROUTING, ROUTING->layer1, ROUTING->layer2, LAYER1);
	    defsubnets(ROUTING, ROUTING->layer2, ROUTING->layer1, LAYER2);
	  }    
      }
    else
      {
	if (strcmp(routerName, "MIGHTY") == 0)  
	  {
	    MIGHTYinWrite(fp);
	    (void) fclose(fp);
	    printf("START ROUTER %s ... \n", routerName);
	    (void) fflush(stdout);
	    runMighty(routerfile, routerInfilename, routerOutfilename);
	    printf("\nRead symbolic routing results ...\n");
	    fp = fopen(routerOutfilename, "r");
	    if (fp == NULL) 
	      {
		sprintf(error, "callrouter: unable to open file \"%s\"",routerOutfilename);
		logError(error, FATAL);
	      }
	    /* allocate memory for viamap */
	    rtn_code = MIGHTYoutRead(fp);
	    
	    if (rtn_code != 0)  
	      {
		printf("(callrouter): MIGHTY can not route channel.\n");
	      }
	    else
	      {
		/* set routing matrix */
		setmatrix(); 
	      }
	  }
	else
	  {
	    sprintf(error, "unknown router.  RouterName= %s\n", routerName);
 	    logError(error, FATAL);
	  }
      }
    (void) fclose(fp);
    printf("Complete callrouter.c\n");

    (void) fflush(stdout);
    (void) fflush(stderr);

    return(rtn_code);
}

#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>

runMighty(command,in,out)
char *command;
char *in, *out;
{
struct rlimit rl,rl2;

if(fork() == 0)
  {
    rl.rlim_cur = 120;
    rl.rlim_max = 120;
#ifndef hpux
    setrlimit(RLIMIT_CPU,&rl);
    getrlimit(RLIMIT_CPU,&rl2);
#endif
    dup2(1,2);
    printf("---------------------- run MIGHTY ----------------------------\n");
    fflush(stdout);
    execlp(command,command,in,out,(char *)0);
    exit(127);
  }
wait(0);
printf("--------------------------------------------------------------\n");
}

runYacr(command,flag, flag2, out, in)
char *command;
char *in, *out;
char *flag, *flag2;
{
struct rlimit rl,rl2;

if(fork() == 0)
  {
    rl.rlim_cur = 1200;
    rl.rlim_max = 1200;
#ifndef hpux
    setrlimit(RLIMIT_CPU,&rl);
    getrlimit(RLIMIT_CPU,&rl2);
#endif
    dup2(1,2);
    printf("---------------------- run YACR ----------------------------\n");
    fflush(stdout);
    execlp(command,command,flag,flag2,out,in,(char *)0);
    exit(127);
  }
wait(0);
printf("--------------------------------------------------------------\n");
}





