#include "copyright.h"
#include "port.h"
#include "spider.h"

/*

  Channel profiles

*/
int STATIONARY_MIN = MAXINT;
int STATIONARY_MAX;

typedef struct chCorList *pchCorList;
struct chCorList 
  {
    int loc;
    int doub;
    int t_off;
    int b_off;
    pchCorList next;
    pchCorList prev;
  };

typedef struct mChCorList *pmChCorList;
struct mChCorList 
  {
    int den;
    pmChCorList next;
    pchCorList corner;
  };

pchCorList CH_CORS = NULL;
pmChCorList MOBILE_CH_CORS = NULL;

/*****************************************************************/

pchCorList newChCorList()
{
pchCorList ccl;

ccl = CALLOC(struct chCorList,1);
ccl->loc = MININT;
ccl->doub = FALSE;
ccl->t_off = MAXINT;
ccl->b_off = MAXINT;
ccl->next = NULL;
ccl->prev = NULL;
return(ccl);
}

/*****************************************************************/

pmChCorList newMChCorList()
{
pmChCorList ccl;

ccl = CALLOC(struct mChCorList,1);
ccl->den = MININT;
ccl->next = NULL;
ccl->corner = NULL;
return(ccl);
}

/*****************************************************************/

setUpChCors(movingSide,offset,normalize)
int movingSide;
int offset;
int normalize;
{
pchCorList ccl,ccl2;
int min,max;
pchCorList makeListOfPins();
pchCorList mergePinLists();
pchCorList leftMakeChanCorList();
pchCorList rightMakeChanCorList();

CH_CORS =  leftMakeChanCorList(movingSide,TOP,offset);
ccl = makeListOfPins(offset,TOP,movingSide);
CH_CORS = mergePinLists(CH_CORS,ccl);
ccl =  rightMakeChanCorList(movingSide,TOP,offset);
CH_CORS = mergePinLists(CH_CORS,ccl);

ccl =  leftMakeChanCorList(movingSide,BOTTOM,offset);
CH_CORS = mergePinLists(CH_CORS,ccl);
ccl = makeListOfPins(offset,BOTTOM,movingSide);
CH_CORS = mergePinLists(CH_CORS,ccl);
ccl =  rightMakeChanCorList(movingSide,BOTTOM,offset);
CH_CORS = mergePinLists(CH_CORS,ccl);
setUpMovingSide(movingSide);
if(normalize == TRUE)
  {
    for(max = MININT,ccl = CH_CORS;(ccl != NULL);ccl = ccl->next)
      if((ccl->b_off != MAXINT) && (max < ccl->b_off))
	max = ccl->b_off;
    for(min = MAXINT,ccl = CH_CORS;(ccl != NULL);ccl = ccl->next)
      if((ccl->t_off != MININT) && (min > ccl->t_off))
	min = ccl->t_off;
/*
    printf("MIN %d max %d\n",min,max);
*/
  }
for(ccl = CH_CORS;(ccl != NULL)/* && (ccl != MOBILE_CH_CORS->corner) */;ccl = ccl->next)
  {
    if(ccl->t_off != MAXINT)
      {
	if(normalize == TRUE)
	  ccl->t_off -= min;
	if((ccl->next != NULL) && (ccl->next->t_off == MAXINT))
	  {
	    for(ccl2 = ccl->next;(ccl2 != NULL) && (ccl2->t_off == MAXINT);ccl2 = ccl2->next)
	      {}
	    if(ccl2 != NULL)
	      {
		for(;ccl->next != ccl2;ccl = ccl->next)
		  ccl->next->t_off = ccl->t_off;
	      }
	  }
      }
  }
for(ccl = CH_CORS;(ccl != NULL) /*&& (ccl != MOBILE_CH_CORS->corner)*/;ccl = ccl->next)
  {
    if(ccl->b_off != MAXINT)
      {
	if(normalize == TRUE)
	  ccl->b_off = max - ccl->b_off;
	if((ccl->next != NULL) && (ccl->next->b_off == MAXINT))
	  {
	    for(ccl2 = ccl->next;(ccl2 != NULL) && (ccl2->b_off == MAXINT);ccl2 = ccl2->next)
	      {}
	    if(ccl2 != NULL)
	      {
		for(;ccl->next != ccl2;ccl = ccl->next)
		  ccl->next->b_off = ccl->b_off;
	      }
	  }
      }
  }

printChCorList();
}


/*****************************************************************/

printChCorList()
{
/*
pchCorList ccl;
pmChCorList mccl;

for(ccl = CH_CORS;ccl != NULL;ccl = ccl->next)
  {
    printf("chcor %d t_off %12d b_off %12d",ccl->loc,ccl->t_off,ccl->b_off);
    if(ccl->doub == TRUE)
      printf(" DOUBLE\n");
    else
      printf("\n");
  }
printf("MOBILE\n");
for(mccl = MOBILE_CH_CORS;mccl != NULL;mccl = mccl->next)
  {
    printf("chcor %d",mccl->corner->loc);
    if(mccl->corner->doub == TRUE)
      printf(" DOUBLE\n");
    else
      printf("\n");
  }
printf("+++++++++++++++++++++++++++++++++++++++++++++++++\n");
*/
}

/*****************************************************************/

moveChCorList(movingSide)
int movingSide;
{
pmChCorList mccl;
pchCorList ccl;

for(mccl = MOBILE_CH_CORS;mccl != NULL;mccl = mccl->next)
  {
    if((mccl->corner->next != NULL) && 
       (mccl->corner->next->loc == mccl->corner->loc + 1))
      {
	if(mccl->corner->doub == TRUE)
	  {
	    if(movingSide == TOP)
	      {
		mccl->corner->next->t_off = mccl->corner->t_off;
		if(mccl->corner->prev == NULL)
		  mccl->corner->t_off = MAXINT;
		else
		  mccl->corner->t_off = mccl->corner->prev->t_off;
	      }
	    else
	      {
		mccl->corner->next->b_off = mccl->corner->b_off;
		if(mccl->corner->prev == NULL)
		  mccl->corner->b_off = MAXINT;
		else
		  mccl->corner->b_off = mccl->corner->prev->b_off;
	      }
	    mccl->corner->doub = FALSE;
	    mccl->corner = mccl->corner->next;
	    mccl->corner->doub = TRUE;
	  }
	else
	  {
	    ccl = mccl->corner;
	    if(CH_CORS == ccl)
	      CH_CORS = ccl->next;

	    ccl->next->doub = TRUE;
	    if(movingSide == TOP)
	      ccl->next->t_off = ccl->t_off;
	    else
	      ccl->next->b_off = ccl->b_off;
	    mccl->corner = mccl->corner->next;
	    ccl->next->prev = ccl->prev;
	    if(ccl->prev != NULL)
	      ccl->prev->next = ccl->next;
	    FREE(ccl);
	  }
      }
    else
      if(mccl->corner->doub == TRUE)
	{
	  mccl->corner->doub = FALSE;
	  ccl = newChCorList();
	  ccl->loc = mccl->corner->loc + 1;
	  ccl->prev = mccl->corner;
	  ccl->next = mccl->corner->next;
	  ccl->prev->next = ccl;
	  if(ccl->next != NULL)
	    ccl->next->prev = ccl;
	  if(movingSide == TOP)
	    {
	      if(ccl->loc <= STATIONARY_MAX)
		ccl->b_off = mccl->corner->b_off;
	      ccl->t_off = mccl->corner->t_off;

	      if(mccl->corner->prev == NULL)
		mccl->corner->t_off = MAXINT;
	      else
		mccl->corner->t_off = mccl->corner->prev->t_off;
	    }
	  else
	    {
	      if(ccl->loc <= STATIONARY_MAX)
		ccl->t_off = mccl->corner->t_off;
	      ccl->b_off = mccl->corner->b_off;

	      if(mccl->corner->prev == NULL)
		mccl->corner->b_off = MAXINT;
	      else
		mccl->corner->b_off = mccl->corner->prev->b_off;
	    }
	  mccl->corner = ccl;
	}
    else
      {
	mccl->corner->loc++;
      }
  }
}

/*****************************************************************/

initChanSegDen(movingSide)
int movingSide;
{
pmChCorList mccl;

for(mccl = MOBILE_CH_CORS;mccl != NULL;mccl = mccl->next)
  {
    if(mccl->next != NULL)
      {
	if(movingSide == TOP)
	  {
	    if(mccl->corner->b_off != MAXINT)
	      mccl->den = max_den_in_range(mccl->corner->loc, mccl->corner->next->loc);
	  }
	else
	  {
	    if(mccl->corner->t_off != MAXINT)
	      mccl->den = max_den_in_range(mccl->corner->loc, mccl->corner->next->loc);
	  }
      }
  }
}

/*****************************************************************/

findMaxDen(off)
int off;
{
pchCorList ccl;
int den,extra;

extra = MAXINT;
for(ccl = CH_CORS;ccl != NULL;ccl = ccl->next)
  {
    if((ccl->next != NULL) && 
       ((ccl->next->loc >= 1) || (ccl->loc <= RC_LOC->col_count)))
      {
	den = max_den_in_range(((ccl->loc < 1)?1:ccl->loc), 
			       ((ccl->next->loc - 1 > RC_LOC->col_count)?RC_LOC->col_count:
				(ccl->next->loc - 1)));
	if(ccl->t_off + ccl->b_off - den < extra)
	  extra = ccl->t_off + ccl->b_off - den;
/*
	printf("from %d to %d den %d extra space %d max extra %d\n",ccl->loc, ccl->next->loc - 1, den, ccl->t_off + ccl->b_off - den,extra);
*/
      }
  }
/*
printf("min extra at offset %d ===================== %d\n",off,extra);
*/
return(extra);
}

/*****************************************************************/

findXinColFromBelow(x)
int x;
{
int col;

for(col = 1;(col < RC_LOC->col_count) && (RC_LOC->col_loc[col] < x);col++)
  {}
return(col);
}

/*****************************************************************/

findXinColFromAbove(x)
int x;
{
int col;

for(col = RC_LOC->col_count;(col > 1) && (RC_LOC->col_loc[col] > x);col--)
  {}
return(col);
}

/*****************************************************************/

findYinRowFromBelow(y)
int y;
{
int row;

for(row = 0;(row < RC_LOC->row_count) && (RC_LOC->row_loc[row] < y);row++)
  {}
return(row);
}

/*****************************************************************/

findYinRowFromAbove(y)
int y;
{
int row;

for(row = RC_LOC->row_count;(row > 1) && (RC_LOC->row_loc[row] > y);row--)
  {}
return(row);
}

/*****************************************************************/

pchCorList makeListOfPins(offset,side,movingSide)
int offset,side,movingSide;
{
pchCorList ccl,start,last;
pin_type *pin;
int row;

start = NULL;
if(FIRST_PIN(side) != NULL)
for(row = get_row(side,(FIRST_PIN(side))),
    pin = FIRST_PIN(side);
    (pin != NULL);pin = pin->next)
  {
    if((pin->row != row) || (pin->next == NULL) || (pin == FIRST_PIN(side)))
      {
	row = get_row(side,pin);
	
	ccl = newChCorList();
	ccl->loc = pin->col + ((movingSide == side)?offset:0);
	if(side == TOP)
	  ccl->t_off = RC_LOC->row_count - row;
	else
	  ccl->b_off = row;
	if(start == NULL)
	  {
	    start = last = ccl;
	  }
	else
	  {
	    ccl->prev = last;
	    last->next = ccl;
	    last = ccl;
	  }

/*
	if(movingSide == side)
	  {
	    mccl = newMChCorList();
	    mccl->corner = ccl;
	    mccl->next = MOBILE_CH_CORS;
	    MOBILE_CH_CORS = mccl;
	  }
	else
	  {
	    if(pin->col < STATIONARY_MIN)
	      STATIONARY_MIN = pin->col;
	    STATIONARY_MAX = pin->col;
	  }
*/
      }
  }
/*
printf("############## make ##################\n");
for(ccl = start;ccl != NULL;ccl = ccl->next)
     printf("loc %d t_off %d b_off %d\n",ccl->loc,ccl->t_off,ccl->b_off);
*/

return(start);
}

/*****************************************************************/

pchCorList mergePinLists(l1,l2)
pchCorList l1,l2;
{
pchCorList list,list1,list2,ccl;

if(l1 == NULL)
  {
    if(l2 == NULL)
      {
	fflush(stdout);
	logError("ERROR - in merging channel corner lists\n",FATAL);
      }
    else
      return(l2);
  }
else
  {
    if(l2 == NULL)
      return(l1);
  }
    
if(l1->loc < l2->loc)
  {
    list1 = l1;
    list = list2 = l2;
  }
else
  {
    list1 = l2;
    list = list2 = l1;
  }

while(list != NULL)
  {
    list2 = list;
    list = list->next;
    for(ccl = list1;
	(ccl->next != NULL) && 
	(ccl->loc < list2->loc);
	ccl = ccl->next)
      {}
    if(ccl == NULL)
      logError("ERROR -- in chan corner def\n",FATAL);
    if(ccl->loc == list2->loc)
      {
	ccl->doub = TRUE;
	if(ccl->t_off == MAXINT)
	  ccl->t_off = list2->t_off;
	else
	  ccl->b_off = list2->b_off;
	FREE(list2);
      }
    else
      {
	if(ccl->loc < list2->loc)
	  {
	    if(ccl->next != NULL)
	      logError("ERROR -2- in chan corner def\n",FATAL);
	    list2->prev = ccl;
	    list2->next = NULL;
	    ccl->next = list2;
	  }
	else
	  {
	    list2->next = ccl;
	    list2->prev = ccl->prev;
	    if(list2->prev != NULL)
	      list2->prev->next = list2;
	    ccl->prev = list2;
	  }
      }
  }
/*
printf("############## merge ##################\n");
for(ccl = list1;ccl != NULL;ccl = ccl->next)
     printf("loc %d t_off %d b_off %d\n",ccl->loc,ccl->t_off,ccl->b_off);
*/
return(list1);
}

/*****************************************************************/

pchCorList leftMakeChanCorList(movingSide,side,offset)
int side,offset;
{
pchCorList start,ccl,last;
vertex_type *vert;
int col,row,pinX;

if(FIRST_PIN(side) == NULL)
  return(NULL);
pinX = FIRST_PIN(side)->x;
start = NULL;
for(vert = CHAN_BOUND->first[side];
    (vert != NULL) && (vert->x < pinX);
    vert = vert->next->next)
  {
    ccl = newChCorList();
    col = findXinColFromBelow(vert->x);
    if(vert->x < RC_LOC->col_loc[col] - GRIDWIDTH)
      col = col - (RC_LOC->col_loc[col] - vert->x)/GRIDWIDTH;

    if(RC_LOC->col_loc[col] > pinX - GRIDWIDTH)
      continue;
    ccl->loc = col + ((movingSide == side)?offset:0);

    if(side == TOP)
      row = findYinRowFromBelow(vert->y - GRIDHEIGHT);
    else
      row = findYinRowFromAbove(vert->y);
/*
    if((RC_LOC->row_loc[row] < vert->y - GRIDHEIGHT) && (side == TOP))
      logError("ERROR - row limiting in set up chan corners\n",NONFATAL);
*/
    if(side == TOP)
      ccl->t_off = row;
    else
      ccl->b_off = row;
    if(start == NULL)
      {
	start = last = ccl;
      }
    else
      {
	ccl->prev = last;
	last->next = ccl;
	last = ccl;
      }

/*
    if(movingSide == side)
      {
	mccl = newMChCorList();
	mccl->corner = ccl;
	mccl->next = MOBILE_CH_CORS;
	MOBILE_CH_CORS = mccl;
      }
    else
      {
	if(ccl->loc < STATIONARY_MIN)
	  STATIONARY_MIN = ccl->loc;
	STATIONARY_MAX = ccl->loc;
      }
*/
  }
/*
printf("############## L chan make ##################\n");
for(ccl = start;ccl != NULL;ccl = ccl->next)
     printf("loc %d t_off %d b_off %d\n",ccl->loc,ccl->t_off,ccl->b_off);
*/
return(start);
}

/*****************************************************************/

pchCorList rightMakeChanCorList(movingSide,side,offset)
int side,offset;
{
pchCorList start,ccl,last;
vertex_type *vert;
int col,row,pinX;
pin_type *pin;

if(FIRST_PIN(side) == NULL)
  return(NULL);
start = NULL;
for(pin = FIRST_PIN(side);(pin->next != NULL);pin = pin->next)
  {}
pinX = pin->x;
vert = CHAN_BOUND->first[side];
for(vert = vert->next;
    (vert != NULL) && (vert->x > pinX);
    vert = ((vert->next == NULL)?NULL:vert->next->next))
  {
    ccl = newChCorList();
    col = findXinColFromBelow(vert->x);
    if(RC_LOC->col_loc[col] + GRIDWIDTH < vert->x)
      col = col + (vert->x - RC_LOC->col_loc[col])/GRIDWIDTH;
    ccl->loc = col + ((movingSide == side)?offset:0);

    if(side == TOP)
      ccl->t_off = row = findYinRowFromBelow(vert->y - GRIDHEIGHT);
    else
      ccl->b_off = row = findYinRowFromAbove(vert->y);
/*
    if((RC_LOC->row_loc[row] < vert->y - GRIDHEIGHT) && (side == TOP))
      logError("ERROR - row limiting in set up chan corners\n",NONFATAL);
*/
    if(start == NULL)
      {
	start = last = ccl;
      }
    else
      {
	ccl->prev = last;
	last->next = ccl;
	last = ccl;
      }

/*
    if(movingSide == side)
      {
	mccl = newMChCorList();
	mccl->corner = ccl;
	mccl->next = MOBILE_CH_CORS;
	MOBILE_CH_CORS = mccl;
      }
    else
      {
	if(ccl->loc < STATIONARY_MIN)
	  STATIONARY_MIN = ccl->loc;
	STATIONARY_MAX = ccl->loc;
      }
*/
  }
/*
printf("############## R chan make ##################\n");
for(ccl = start;ccl != NULL;ccl = ccl->next)
     printf("loc %d t_off %d b_off %d\n",ccl->loc,ccl->t_off,ccl->b_off);
*/

return(start);
}

setUpMovingSide(movingSide)
int movingSide;
{
pchCorList ccl;
pmChCorList mccl;

MOBILE_CH_CORS = NULL;
for(ccl = CH_CORS;ccl != NULL;ccl = ccl->next)
  if(((movingSide == TOP) && (ccl->t_off != MAXINT)) ||
     ((movingSide == BOTTOM) && (ccl->b_off != MAXINT)))
    {
      mccl = newMChCorList();
      mccl->corner = ccl;
      mccl->next = MOBILE_CH_CORS;
      MOBILE_CH_CORS = mccl;
    }
  else
    {
      if(ccl->loc < STATIONARY_MIN)
	STATIONARY_MIN = ccl->loc;
      STATIONARY_MAX = ccl->loc;
    }
/*
printf("############## mobile ##################\n");
for(mccl = MOBILE_CH_CORS;mccl != NULL;mccl = mccl->next)
     printf("loc %d\n",mccl->corner->loc);
*/
}
