#include "copyright.h"
#include "port.h"
#include "spider.h"

changeunits()

/*************************************************************************
 *
 *			      changeunits	
 *
 *  Change col/row units to placement unit for all the subnets and vias 
 *  after we adjusted RC_LOC->col_loc[], RC_LOC->row_loc[]
 *
 *  Old Coor --  col/row;
 *  New Coor --  placement unit;
 *
 *  This routine changes the following data:
 *
 *	subnet->x1
 *	subnet->x2
 *	subnet->y1
 *	subnet->y2
 *	via->x
 *	via->y
 *
 *************************************************************************/

{
    int		i;
    subnet_type *subnet;
    via_type    *via;

    for (i=1; i <= net_count; i++)  {

        for (subnet=netlist[i]->subnetlist; subnet!=NULL; subnet=subnet->next)  
 	{
	    subnet->x1 = RC_LOC->col_loc[subnet->col1];
	    subnet->y1 = RC_LOC->row_loc[subnet->row1];
	    subnet->x2 = RC_LOC->col_loc[subnet->col2];
	    subnet->y2 = RC_LOC->row_loc[subnet->row2];
 	}
    }

    for (via=vialist; via != NULL; via=via->next)  
      {
	via->x = RC_LOC->col_loc[via->col];
	via->y = RC_LOC->row_loc[via->row];
      }

    printf("Complete changeunits.c\n");
}
