#include "copyright.h"
#include "port.h"
#include "spider.h"
int		total_wire_length;
int		*wirelength;    /* array contains wire length for each layer */
computeWireLength()

/*************************************************************************
 *
 *
 *************************************************************************/

{
    int		i;
    int		x1, y1, x2, y2;
    int		layernum;
    int		num_layers;
    subnet_type *subnet;

    /* alloc the memory */
    num_layers = layer_count;
    if (num_layers < 2) num_layers = 2;
    wirelength = CALLOC(int, num_layers+1);

    /* init */

    for (i=0; i <= num_layers; i++)
    {
         wirelength[i] = 0;
    }

    /* update wire length for each layer */
    for (i=1; i <= net_count; i++)  {

        for (subnet=netlist[i]->subnetlist; subnet!=NULL; subnet=subnet->next)  
 	{
	    x1 = MIN(subnet->x1, subnet->x2);
	    x2 = MAX(subnet->x1, subnet->x2);
	    y1 = MIN(subnet->y1, subnet->y2);
	    y2 = MAX(subnet->y1, subnet->y2);

	    layernum = subnet->layerid;
	    wirelength[layernum] += (x2-x1+1) + (y2-y1+1);
 	}
    }

    total_wire_length = 0;

    for (layernum=0; layernum <= num_layers; layernum++)  {
         total_wire_length += wirelength[layernum];
    }
}
