#include "copyright.h"
#include "port.h"
#include "spider.h"

defcol()


/**********************************************************************
 *  
 * 		  defcol -- build vertical grid line 
 * 		  -----------------------------------
 *
 *	---- This routine sets up the following data structure. 
 *	RC_LOC->col_loc[]
 *	RC_LOC->col_pins[top/bottom][col#]
 *
 * 	RC_LOC->col_count
 *
 *   	---- This routine may modifies the following:
 *      netlist[pinptr->netid]->numpins
 *  
 ***********************************************************************/

{
    int		col_start,col_end;

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* Set first col location */

    printf("(defcol) CHAN_PINS->min_x, t,b=%d,%d\n", CHAN_PINS->min_x[TOP], CHAN_PINS->min_x[BOTTOM]);
    printf("(defcol) CHAN_PINS->max_x, t,b=%d,%d\n", CHAN_PINS->max_x[TOP], CHAN_PINS->max_x[BOTTOM]);

    col_start = getColStart();
    col_end = getColEnd(col_start);
    printf("(defcol) col_start %d end %d, max RC_LOC->col_count %d\n",
	   col_start, col_end, ((col_end - col_start)/GRIDWIDTH+1) );

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* define the rest of col (col 2-n) position */

    RC_LOC->col_count = assign_pins_to_cols(col_start,col_end);

    RC_LOC->col_loc[RC_LOC->col_count+1] = RC_LOC->col_loc[RC_LOC->col_count] + GRIDWIDTH;

    printf("(defcol):  RC_LOC->col_count = %d\n", RC_LOC->col_count);

printf("Complete defcol.c\n");

}    

getColStart()
{
int 	pin_start;
int 	chn_start;

  if (FIRST_PIN(LEFT) != NULL  && FIRST_PIN(LEFT)->pintype != FIXED)  
    {
      printf("(defcol) FIRST_PIN(L)_pintype=%d\n", FIRST_PIN(LEFT)->pintype);
      pin_start = MIN(CHAN_PINS->min_x[TOP], CHAN_PINS->min_x[BOTTOM]) - GRIDWIDTH;
      chn_start = MIN(CHAN_BOUND->min_x[TOP], CHAN_BOUND->min_x[BOTTOM]) + CONT_WIDTH/2;
      return(MIN(pin_start, chn_start));
    }
  else  
    {
      if (router_type == CHANNEL_ROUTER)
	return(CHAN_PINS->max_x[LEFT] + END_CLEARANCE);
      else /* (router_type == SWITCHBOX_ROUTER) */
	return(CHAN_PINS->min_x[LEFT] + END_CLEARANCE);
    }
}


getColEnd(col_start)
int col_start;
{
int 	pin_end;
int 	chn_end;
int end;

if (FIRST_PIN(RIGHT) != NULL  && FIRST_PIN(RIGHT)->pintype != FIXED)  
  {
    printf("(defcol) FIRST_PIN(R)_pintype=%d\n", FIRST_PIN(RIGHT)->pintype);
    pin_end = MAX(CHAN_PINS->max_x[TOP], CHAN_PINS->max_x[BOTTOM]) + GRIDWIDTH;
    chn_end = MAX(CHAN_BOUND->max_x[TOP], CHAN_BOUND->max_x[BOTTOM]) - CONT_WIDTH/2;
    end = MAX(pin_end, chn_end);
    
    /* rounded to next cell */
    end += (end - col_start) % GRIDWIDTH;
  }
else  
  {
    if (router_type == CHANNEL_ROUTER)
      end = CHAN_PINS->min_x[RIGHT] - END_CLEARANCE;
    else /* (router_type == SWITCHBOX_ROUTER) */
      end = CHAN_PINS->max_x[RIGHT] - END_CLEARANCE;
  }
return(end);
}



