#include "copyright.h"
#include "port.h"
#include "spider.h"
#include "den.h"

int offset,Llim,Rlim,offLim;
int *den;
int *del;
int *net[5];
static int nets;

pdelList List;
#ifdef FASTER
pdelList *updates;
#endif
pdelList *delPtr;
pdelList deadDelLists = NULL;

/*********************************************************************/

pdelList newDelList()
{
pdelList dl;

if(deadDelLists != NULL)
  {
    dl = deadDelLists;
    deadDelLists = dl->next;
  }
else
  dl = CALLOC(struct delList,1);

dl->loc = MININT;
#ifdef FASTER
dl->del = 0;
#endif
dl->next = NULL;
dl->prev = NULL;
return(dl);
}

/*********************************************************************/

generateModDels()
{
ppin_list pins,set_up_density();
int j;
int t,b,movingSide;
pin_type *tp,*bp;
int bestOff,bestExtra,zeroDen;

den = del = net[0] = net[1] = net[2] = net[3] = net[4] = NULL;
List = deadDelLists = NULL;
delPtr = NULL;

if((FIRST_PIN(TOP) == NULL) || (FIRST_PIN(BOTTOM) == NULL))
  return(FALSE);
for(tp = FIRST_PIN(TOP);(tp != NULL) && (tp->next != NULL);tp = tp->next)
  {}
t = tp->col - (FIRST_PIN(TOP))->col;
for(bp = FIRST_PIN(BOTTOM);(bp != NULL) && (bp->next != NULL);bp = bp->next)
  {}
b = bp->col - (FIRST_PIN(BOTTOM))->col;

movingSide = (t < b)?TOP:BOTTOM;
determineOffset(movingSide);
Llim = offset;
Rlim = RC_LOC->col_count;
/*
printf("ft %d fb %d t %d b %d off %d Llim %d Rlim %d offLim %d\n",FIRST_PIN(TOP)->col,FIRST_PIN(BOTTOM)->col,t,b,offset,Llim,Rlim,offLim);
fflush(stdout);
exit(20);
*/

setUpChCors((t < b)?TOP:BOTTOM,offset,TRUE);

if(t < b)
  {
    pins = set_up_density(offset,0);
    initNetInfo(pins,TOP);
  }
else
  {
    pins = set_up_density(0,offset);
    initNetInfo(pins,BOTTOM);
  }
initDelArray();
printf("starting density\n");
bestOff = 0;
bestExtra = MININT;
zeroDen = MAXINT;
while(offset <= offLim)
  {
    addDelToDen();
    print_density_off();
    offset++;
    Llim = MIN(offset,(t<b)?(FIRST_PIN(BOTTOM)->col):(FIRST_PIN(TOP)->col));
    Rlim = MAX(RC_LOC->col_count,(t<b)?(tp->col + offset):(bp->col + offset));
    updateDel();

    moveChCorList((t < b)?TOP:BOTTOM);
    printChCorList();
    if((j = findMaxDen(offset)) >= bestExtra)
      {
	if(j == bestExtra)
	  {
	    if(abs(offset) < abs(bestOff))
	      {
		bestExtra = j;
		bestOff = offset;
	      }
	  }
	else
	  {
	    bestExtra = j;
	    bestOff = offset;
	  }
      }
    if(offset == 0)
      zeroDen = j;
#ifdef CHK_DEN
    {
      int *c_d,i;

/*    print_density_off();*/
    c_d = col_den;
    if(t < b)
      pins = set_up_density(offset,0);
    else
      pins = set_up_density(0,offset);
    for(i = Llim;i <= Rlim; i++)
      if(c_d[i] != col_den[i])
	printf("ERROR in col density at %d differ %d and %d\n",i,c_d[i],col_den[i]);
    col_den = c_d;
    }
#endif
  }
printf("best extra %d at %d compared to %d at zero offset\n",bestExtra,bestOff,zeroDen);
fprintf(stderr,"(SPIDER): offset of %d changes routing density from %d tracks to %d tracks\n",bestOff,zeroDen,bestExtra);
/*
moveCellHor(movingSide,bestOff);
*/
return(bestOff);
}

/*********************************************************************/

initNetInfo(pins,side)
ppin_list pins;
int side;
{
int i;
ppin_list pl;
#ifdef FASTER
pdelList dl;

updates = CALLOC(pdelList ,3 * RC_LOC->col_count + 10);
for(i = 1;i <= 3 * RC_LOC->col_count + 10;i++)
  updates[i] = NULL;
updates = &(updates[(3 * RC_LOC->col_count / 2) + 5]);
#endif

for(pl = pins,i = 0;pl != NULL;pl = pl->next,i++)
  {}
nets = i;
net[1] = CALLOC(int,nets);
net[2] = CALLOC(int,nets);
net[3] = CALLOC(int,nets);
net[4] = CALLOC(int,nets);
for(pl = pins,i = 0;pl != NULL;pl = pl->next,i++)
  {
    if(((pl->left[side] == MININT) || (pl->left[!side] == MININT)) && 
       ((pl->right[side] == MAXINT) || (pl->right[!side] == MAXINT)))
      {
/*	printf("dropping net %d %d %d %d\n",pl->left[side],pl->right[side],pl->left[!side],pl->right[!side]);*/
	i--;
	continue;
      }
    if((pl->left[side] == MAXINT) && (pl->right[side] == MININT))
      {
/*	printf("not connected to top side -- dropping net %d %d %d %d\n",pl->left[side],pl->right[side],pl->left[!side],pl->right[!side]);*/
	i--;
	continue;
      }

    net[1][i] = MAXINT;
    net[2][i] = MININT;
    net[3][i] = MAXINT;
    net[4][i] = MININT;

    if((pl->left[side] == MAXINT) || (pl->left[side] == MININT))
      net[1][i] = pl->left[side];
    else
      net[1][i] = pl->left[side] - offset;
    if((pl->right[side] == MAXINT) || (pl->right[side] == MININT))
      net[2][i] = pl->right[side];
    else
      net[2][i] = pl->right[side] - offset;
    net[3][i] = pl->left[!side];
    net[4][i] = pl->right[!side];
#ifdef FASTER
/*    printf("net %d -- %d %d %d %d\n",i,net[1][i],net[2][i],net[3][i],net[4][i]);*/
    if((net[3][i] != MAXINT) && (net[1][i] + offset < net[3][i]))
      {
/*	printf("one ");*/
	addToList2(net[3][i] - net[1][i],net[1][i],1);
      }
    if((net[2][i] != MININT) && (net[4][i] != MAXINT) && (net[2][i] + offset < net[4][i]))
      addToList2(net[4][i] - net[2][i],net[2][i] + 1,1);
     if((net[1][i] == net[2][i]) && (net[3][i] == net[4][i]) &&
	(net[3][i] != MAXINT) && 
	(net[3][i] != MININT))
       {
/*	 printf("two point net\n");*/
	 if(net[1][i] + offset + 1 < net[3][i])
	   addToList2(net[3][i] - (net[1][i] + 1),net[1][i] + 1,-1);
	 if(net[1][i] + offset <= net[3][i])
	   {
	     addToList2(net[3][i] - net[1][i],net[1][i],1);
	     addToList2(net[3][i] - net[1][i],net[1][i] + 1,1);
	   }
	 if(net[1][i] + offset <= net[3][i])
	   {
	     addToList2(net[3][i] - (net[1][i] - 1),net[1][i],-1);
	   }
       }
#endif
  }
nets = i;
/*
for(i = 0;i < nets;i++)
    printf("%d %d %d  %d %d\n",i,net[1][i],net[2][i],net[3][i],net[4][i]);
#ifdef FASTER
for(i = offset;i <= 3 * RC_LOC->col_count / 2;i++)
  for(dl = updates[i];dl != NULL;dl = dl->next)
      printf("at %d change %d by %d\n",i,dl->loc,dl->del);
#endif
*/
}

/*********************************************************************/

initDelArray()
{
int i;

del = CALLOC(int,RC_LOC->col_count + 1);
delPtr = CALLOC(pdelList ,RC_LOC->col_count + 1);

for(i = 1;i <= RC_LOC->col_count;i++)
  {
    del[i] = 0;
    delPtr[i] = NULL;
  }

for(i = 0;i < nets;i++)
  {
    if((net[1][i] != MININT) && (net[1][i] + offset < net[3][i]))
      {
	decDel(net[1][i]);
      }
    if((net[2][i] != MAXINT) && (net[2][i] + offset >= net[4][i]))
      {
	incDel(net[2][i] + 1);
      }
    if((net[1][i] == net[2][i]) && (net[3][i] == net[4][i]))
      {
	if(net[1][i] + offset + 1 == net[3][i])
	  {
	    decDel(net[1][i] + 1);
	  }
	if(net[1][i] + offset == net[3][i])
	  {
	    incDel(net[1][i]);
	  }
      }	  
  }
/* printList();*/
}

/*********************************************************************/

printList()
{
/*
pdelList dl;
for(dl = List;dl != NULL;dl = dl->next)
  printf("list : %d -- %d\n",dl->loc + offset,del[dl->loc]);
*/
}

/*********************************************************************/

addToList(i)
int i;
{
pdelList dl;

/* printf("add %d\n",i + offset);*/
dl = newDelList();
dl->loc = i;
if(List != NULL)
  List->prev = dl;
dl->next = List;
List = dl;
if(delPtr[i] != NULL)
  logError("ERROR - del list element not deleted",FATAL);
delPtr[i] = dl;
}

/*********************************************************************/

#ifdef FASTER

addToList2(off,loc,de)
int off,loc,de;
{
pdelList dl;

/*printf("add2 off %d loc %d de %d\n",off,loc,de);*/
dl = newDelList();
dl->loc = loc;
dl->del = de;
dl->next = updates[off];
updates[off] = dl;
}
#endif
/*********************************************************************/

updateDel()
{
int i;

/* printf("update\n");*/
#ifdef FASTER
{
pdelList dl;

for(dl = updates[offset];dl != NULL;dl = dl->next)
  {
/*    printf("at %d change %d by %d\n",i,dl->loc,dl->del);*/
    if(dl->del == 1)
      {
	incDel(dl->loc);
      }
    else
      {
	decDel(dl->loc);
      }
  }
}
#else
for(i = 0;i < nets;i++)
  {
    if(net[1][i] + offset == net[3][i])
      {
	incDel(net[1][i]);
      }
    if(net[2][i] + offset == net[4][i])
      {
	incDel(net[2][i] + 1);
      }
    if((net[1][i] == net[2][i]) && (net[3][i] == net[4][i]))
      {
	if(net[1][i] + offset + 1 == net[3][i])
	  {
	    decDel(net[1][i] + 1);
	  }
	if(net[1][i] + offset == net[3][i])
	  {
	    incDel(net[1][i]);	    
	    incDel(net[1][i] + 1);
	  }
	if(net[1][i] + offset == net[3][i] + 1)
	  {
	    decDel(net[1][i]);	    
	  }
      }
  }
#endif
}

/*********************************************************************/

addDelToDen()
{
pdelList dl,dlp;

/* printf("offset %d\n",offset);*/
dl = List;
while(dl != NULL)
  {
    if(del[dl->loc] == 0)
      {
	if(List == dl)
	  {
	    List = dl->next;
	    List->prev = NULL;
	  }
	else
	  {
	    dl->prev->next = dl->next;
	    if(dl->next != NULL)
	      dl->next->prev = dl->prev;
	  }
	dlp = dl;
	delPtr[dl->loc] = NULL;
	dl = dl->next;
	FREE(dlp);
      }
    else
      {
/*	printf("add %d to old col_den[ %d] = %d ",del[dl->loc],dl->loc + offset, col_den[dl->loc + offset]);*/
	col_den[dl->loc + offset] += del[dl->loc];
/*	printf(" new %d\n",col_den[dl->loc + offset]);*/
	dl = dl->next;
      }
  }
}

/*********************************************************************/

removeFromList(dl)
pdelList dl;
{
/* printf("remove %d\n",dl->loc + offset);*/

if(dl == List)
  {
    List = dl->next;
    if(List != NULL)
      List->prev = NULL;
  }
else
  {
    dl->prev->next = dl->next;
    if(dl->next != NULL)
      dl->next->prev = dl->prev;
  }

delPtr[dl->loc] = NULL;

dl->next = deadDelLists;
deadDelLists = dl;
}

/*********************************************************************/

max_den()
{
int i,max;

for(i = Llim,max = 0;i <= Rlim;i++)
  if(max < col_den[i])
    max = col_den[i];
return(max);
}

/*********************************************************************/



print_density_off()
{
/*
int col;
*/

return;
/*
printf("limits %d to %d\n",Llim,Rlim);
for(col = Llim;col <= Llim + 9;col++)
  printf("%6d ",col);
printf("\n\n");

for(col = Llim;col <= Rlim;col++)
  {
    printf("%6d ",col_den[col]);
    if((col - Llim)%10 == 9)
      printf("\n");
  }
printf("\n");
*/
}


determineOffset(Mside)
int Mside;
{
vertex_type *vert;
int tLeft,tRight,bLeft,bRight;

vert = CHAN_BOUND->first[TOP];
tLeft = findXinColFromBelow(vert->x);

for(;vert->next != NULL;vert = vert->next)
  {}
tRight = findXinColFromAbove(vert->x);

vert = CHAN_BOUND->first[BOTTOM];
bLeft = findXinColFromBelow(vert->x);

for(;vert->next != NULL;vert = vert->next)
  {}
bRight = findXinColFromAbove(vert->x);

if(Mside == TOP)
  {
    offset = bLeft - (tLeft + OVERLAP_COLS);
    offLim = bRight + OVERLAP_COLS - (tRight - tLeft);
  }
else
  {
    offset = tLeft - (bLeft + OVERLAP_COLS);
    offLim = tRight + OVERLAP_COLS - (bRight - bLeft);
  }
}


