#include "copyright.h"
#include "port.h"

/*
	COMPUTE THE CHANNEL DENSITY  (temp)

	1.  write input file
	2.  fire the mighty
	3.  read density information
	4.  adjust channel & write a new input file
*/
#include "spider.h"
int      delt_density;

int density()
{
    FILE *fp;
    char command[256];
    char card[256];
    char infilename[80];
    char outfilename[80];
    int  status;

/* BEGIN */

/* initialize */

    /*GH = GRIDHEIGHT;*/
    delt_density = 0;


/* Write mighty input file  */

    (void) sprintf(infilename,  "mighty.in%s",  channelIdname);
    (void) sprintf(outfilename, "mighty.out%s", channelIdname);
    fp = fopen(infilename, "w");

    if (fp == NULL) {
	(void) sprintf(error, "unable to open file \"%s\"",infilename);
	logError(error, FATAL);
    }

    MIGHTYinWrite(fp);

    (void) fclose(fp);


/* Start mighty */

    (void) sprintf(command, "time mighty -e %s %s 2>&1 >> density.out",
                      infilename, outfilename);

    if ((status = system(command)) != 0) 
    {
	 printf("(desity):  ERROR: router or processor problem.  ");
	 printf(" router:  %s\n", routerName);
	 printf(" Bad exit status %d from \"%s\"\n", status, command);

	 (void) sprintf(error, "(desity):  ERROR: router or processor problem.\n");
	 logError(error, NONFATAL);

	 (void) sprintf(error, "Bad exit status %d from \"%s\"\n", status, command);
	 logError(error, NONFATAL);

	 return(-1);
    }

/* Read back in the density information */

    printf("\nRead density results ...\n");

    fp = fopen(outfilename, "r");
    if (fp == NULL) {
	sprintf(error, "desity: unable to open file \"%s\"",outfilename);
	logError(error, FATAL);
    }
    /*  Start reading the output file */

    /* skip 3 lines */
    (void) fgets(card,sizeof(card), fp);
    (void) fgets(card,sizeof(card), fp);
    (void) fgets(card,sizeof(card), fp);

    if (fscanf(fp, "%d", &delt_density) != 1)  {

    	printf("(density) delta density= %d\n", delt_density);

   	logError("Bad density file. ", FATAL);
    }
    (void) fclose(fp);

    totalDensity = RC_LOC->row_count + 1 + delt_density;
    printf("(density) mighty returns delt_density:%d ==> totalDensity= %d\n", 
		      delt_density, totalDensity);

    /* make sure density at least eq to num of pins at side */

    if (CHAN_PINS->numpins[LEFT] > totalDensity)
      {
	totalDensity = CHAN_PINS->numpins[LEFT];
	delt_density = totalDensity - (RC_LOC->row_count + 1);
        printf("(density): CHAN_PINS->numpins[LEFT]= %d \n", CHAN_PINS->numpins[LEFT]);
      }

    if (CHAN_PINS->numpins[RIGHT] > totalDensity)
      {
	totalDensity = CHAN_PINS->numpins[RIGHT];
	delt_density = totalDensity - (RC_LOC->row_count + 1);
        printf("(density): CHAN_PINS->numpins[RIGHT]= %d \n", CHAN_PINS->numpins[RIGHT]);
      }

/* Make sure there are enough space for routing */

   if (delt_density != 0)  {
	     
     /* Adjust top channel and pin location */
	if((delt_density > 0) || (ADJUST == TRUE))
	  {
	    if(delt_density < 0)
	      {
		delt_density = limit_delta(delt_density * GRIDHEIGHT);
		delt_density = delt_density / GRIDHEIGHT;
	      }
	    moveCellVert(TOP,delt_density);
	    printf("(desity): NOTE-- adjusted Top channel by: %d rows\n", 
		   delt_density);
	  }
    }

    fflush(stdout);
    fflush(stderr);
    printf("Complete desity.c\n");

    return(0);
}
