#include "copyright.h"
#include "port.h"
int CHANNEL_WIDTH;
/* 
*/
#include "spider.h"
#include "tap.h"
int 	LAYER1;
int 	LAYER2;
char 	layer_nameTable[3][40];
char	*via_nameTable[3][3];
int 	layer_width[3];
int 	layer_spacing[3];

int  INPUT_SCALE;
int  OUTPUT_SCALE;

char *FEED_NAME;
char *CONT_NAME;
char *CONT_TERMNAME;
int  CONT_HEIGHT;
int  CONT_WIDTH;

int  MAX_SPACING;
int  MIN_SPACING;
int  MAX_WIDTH;
int  GRIDHEIGHT ;
int  GRIDWIDTH ;
int  SIDE_CLEARANCE ;
int  END_CLEARANCE ;


octObject layers[3];
char *get_tech_name(), *mystrcpy();

getDRC(control_flag)
    char    *control_flag;
{
    int	POLY_CONT_HEIGHT;
    int	POLY_CONT_WIDTH;
    int	MET_CONT_HEIGHT;
    int	MET_CONT_WIDTH;
    struct octBox box;
    char	*techName;

    techName = get_tech_name();
    printf("(getDRC): control_flag= %s tech=%s\n", control_flag, techName);

    (void) strcpy(layer_nameTable[POLY], "POLY");
    (void) strcpy(layer_nameTable[MET1], "MET1");
    (void) strcpy(layer_nameTable[MET2], "MET2");

    set_up_layers(layers);
    CONT_NAME = mystrcpy("VIA");
    CONT_TERMNAME = mystrcpy("t");

    FEED_NAME = mystrcpy("FEED");

    /*  1 lamda = 20 oct units */
    INPUT_SCALE  = 1;
    OUTPUT_SCALE = 20;

    set_up_width_and_spacing(layers);

    get_connector_BB(&box,POLY,POLY,TAP_VERTICAL,TAP_HORIZONTAL);
    POLY_CONT_HEIGHT = box.upperRight.x - box.lowerLeft.x;
    POLY_CONT_WIDTH  = box.upperRight.y - box.lowerLeft.y;

    get_connector_BB(&box,MET1,MET1,TAP_VERTICAL,TAP_VERTICAL);
    MET_CONT_HEIGHT = box.upperRight.x - box.lowerLeft.x;
    MET_CONT_WIDTH  = box.upperRight.y - box.lowerLeft.y;

    get_connector_BB(&box,MET1,MET2,TAP_VERTICAL,TAP_HORIZONTAL);
    MET_CONT_HEIGHT = MAX(MET_CONT_HEIGHT,box.upperRight.x - box.lowerLeft.x);
    MET_CONT_WIDTH  = MAX(MET_CONT_WIDTH,box.upperRight.y - box.lowerLeft.y);

    get_connector_BB(&box,MET2,MET2,TAP_HORIZONTAL,TAP_HORIZONTAL);
    MET_CONT_HEIGHT = MAX(MET_CONT_HEIGHT,box.upperRight.x - box.lowerLeft.x);
    MET_CONT_WIDTH  = MAX(MET_CONT_WIDTH,box.upperRight.y - box.lowerLeft.y);

    get_standard_connector_names();

    /* ========================== */

    if (strcmp(control_flag,"-mm") == 0)  
      {
	  /* H -- metal1,  V -- metal2 */
	  LAYER1 = MET1; 
	  LAYER2 = MET2;
    
	  CONT_HEIGHT    = MET_CONT_HEIGHT;
	  CONT_WIDTH     = MAX(MET_CONT_WIDTH,MET_CONT_HEIGHT);
      }
    else
      if (strcmp(control_flag,"-mp") == 0)  
	{
	    /* H -- metal1,  V -- poly */
	    LAYER1 = POLY; 
	    LAYER2 = MET1; 
      
	    CONT_HEIGHT    = MET_CONT_HEIGHT;
	    CONT_WIDTH     = MET_CONT_WIDTH;
	}
      else
	if (strcmp(control_flag,"-mo") == 0)  
	  {
	      /* H -- metal1,  V -- metal2 */
	      LAYER1 = MET2; 
	      LAYER2 = MET1; 
	
	      CONT_HEIGHT    = POLY_CONT_HEIGHT;
	      CONT_WIDTH     = POLY_CONT_WIDTH;
	  }
	else
	  if (strcmp(control_flag,"-om") == 0)  
	    {
		/* H -- metal2,  V -- metal1 */
		LAYER1 = MET1; 
		LAYER2 = MET2; 
	  
		CONT_HEIGHT    = MET_CONT_HEIGHT;
		CONT_WIDTH     = MET_CONT_WIDTH;
	    }

    SPinit( &oCellFacet );	/* Spider Power init. */

    readInstNames();
    get_channel_width();
    closeTapFiles();

    MAX_WIDTH = MAX(layer_width[MET1], layer_width[MET2]);
    MAX_SPACING = MAX(layer_spacing[MET1], layer_spacing[MET2]);
    MIN_SPACING = MIN(layer_spacing[MET1], layer_spacing[MET2]);

    GRIDHEIGHT     = CONT_HEIGHT + MAX_SPACING;
    GRIDWIDTH      = CONT_WIDTH  + MAX_SPACING;

    END_CLEARANCE  = CONT_WIDTH/2  + MAX_SPACING;
    SIDE_CLEARANCE = CONT_HEIGHT/2 + MAX_SPACING;

    printf("(getDRC):---------------- design rules ----------------\n\n");

    printf("(getDRC):layers		POLY	MET1	MET2\n");
    printf("(getDRC):layer width	 %d	 %d	 %d\n",layer_width[POLY],layer_width[MET1],layer_width[MET2]);
    printf("(getDRC):layer spacing	 %d	 %d	 %d\n\n",layer_spacing[POLY],layer_spacing[MET1],layer_spacing[MET2]);

    printf("(getDRC):POLY_CONT width %d  height %d\n",POLY_CONT_WIDTH,POLY_CONT_HEIGHT);
    printf("(getDRC):MET_CONT width %d  height %d\n",MET_CONT_WIDTH,MET_CONT_HEIGHT);
    printf("(getDRC):CONT width %d  height %d\n",CONT_WIDTH,CONT_HEIGHT);
    printf("(getDRC):MAX_WIDTH %d\n",MAX_WIDTH);
    printf("(getDRC):MAX_SPACING %d\n",MAX_SPACING);
    printf("(getDRC):GRIDHEIGHT %d\n",GRIDHEIGHT);
    printf("(getDRC):GRIDWIDTH %d\n",GRIDWIDTH);
    printf("(getDRC):END_CLEARANCE %d\n",END_CLEARANCE);
    printf("(getDRC):SIDE_CLEARANCE %d\n\n",SIDE_CLEARANCE);
    printf("(getDRC):----------------- STANDARD CONNECTORS ---------------\n\n");
    printf("(getDRC):POLY POLY %s\n",via_nameTable[POLY][POLY]);
    printf("(getDRC):POLY MET1 %s\n",via_nameTable[POLY][MET1]);
    printf("(getDRC):POLY MET2 -- NOT ALLOWED\n");
    printf("(getDRC):MET1 MET1 %s\n",via_nameTable[MET1][MET1]);
    printf("(getDRC):MET1 MET2 %s\n",via_nameTable[MET1][MET2]);
    printf("(getDRC):MET2 MET2 %s\n",via_nameTable[MET2][MET2]);


    printf("Complete getDRC.c\n");
    fflush(stdout);
}


get_channel_width()
{
int gap;

if((strcmp("CPExtInst",CELL_LIST[0]->cellname) == 0) ||
   (strcmp("CPExtInst",CELL_LIST[1]->cellname) == 0))
  {
    CHANNEL_WIDTH = 1000000;
  }
else
  {
    if(channel_types == VERTICAL)
      {
	gap = get_inst_bound2(LEFT,CELL_LIST[0]->cellname) -
	  get_inst_bound2(RIGHT,CELL_LIST[1]->cellname);
      }
    else
      {
	gap = get_inst_bound2(BOTTOM,CELL_LIST[0]->cellname) -
	  get_inst_bound2(TOP,CELL_LIST[1]->cellname);
      }
    CHANNEL_WIDTH = gap;
  }
}
