#include "copyright.h"
#include "port.h"
#include "spider.h"

invlayer()

/****************************************************************
 *
 *  This routine is called when the channel is a VERTICAL channel.
 *
 *  Since YACR assumes that input channel is HORIZANTAL, we need  
 *  invert the layer for pins and subnets in order to make the 
 *  final connection correct.
 *
 *  Note:  This routine is called twice, at very beginning  AND 
 *         before going to Oct.
 *
 *	   When lst time this routine is called, the subnetlist 
 *         is NIL.
 *
 ********************************************************************/

{

/*  Functions */
/*  none  */

int		invfun[3];
int		newlayerid;

pin_type 	*pinptr;
net_type	*netptr;
subnet_type	*subnetptr;
via_type	*viaptr;

int		i, side;		/* temperary var. */

/** Set the invfun -- the look up table swith layer1 with layer2**/

    invfun[0] = 0;
    invfun[LAYER1] = LAYER2;
    invfun[LAYER2] = LAYER1;

i = layer_width[LAYER1];
layer_width[LAYER1] = layer_width[LAYER2];
layer_width[LAYER2] = i;

/** For each terminal Do -- **/

    for (side=TOP;  side <= RIGHT;  side++)  
         for (pinptr=FIRST_PIN(side);  pinptr!=NULL;  pinptr=pinptr->next)  {
		  newlayerid = invfun[pinptr->layer];
	 	  pinptr->layer = newlayerid;
         }

/** For each new subnet Do -- **/

    for (i=1;  i <= net_count;  ++i) {

	 netptr=netlist[i];

	 if (netptr != NULL && netptr->subnetlist != NULL) {

	     for (subnetptr=netptr->subnetlist;  subnetptr!=NULL;  
		  subnetptr=subnetptr->next)  {

		  newlayerid = invfun[subnetptr->layerid];
		  subnetptr->layerid   = newlayerid;
	     }
	 }
    }


/** For each new subnet Do -- **/

    for (viaptr=vialist;  viaptr != NULL;  viaptr=viaptr->next) {
	 
	 viaptr->layer1 = invfun[viaptr->layer1];
	 viaptr->layer2 = invfun[viaptr->layer2];
/*	 viaptr->mastername = via_nameTable[viaptr->layer1][viaptr->layer2];*/
    } 

    printf("Complete invlayer.c\n");
}
