#include "copyright.h"
#include "port.h"

#define MAIN
#include <sys/time.h>
#include <sys/resource.h>
#include "spider.h"

int       error_flag;
int  inv_flag;
int no_compact;
char     circuitName[80];
char 	channelIdname[80];
char     routerName[80];
char 	routerfile[80];
int      router_type;
extern octObject oCellFacet;
int COMPACT = FALSE;
int COMPACT_SPACE = -1;
int MIZER = FALSE;
static int rot_flag;

init(argc,argv)
    int argc;
    char *argv[];
{
  
  char layer_cntl[5];
    
  error_flag = 0;
  rot_flag = 0;
  no_compact = FALSE;
  			  /* process the command line */

  octBegin();
  errProgramName("spider");
  inv_flag = processCmdLine(argc,argv,layer_cntl);
  
			  /* Open files */
  openFile();
  
			  /* read in channel name */
  readInChanInfo();

  getDRC(layer_cntl);

			  /* Read in input information */
  readinfile();
  
			  /* If it is a horizontal channel, Then */
  if (channel_types == VERTICAL)
    {
      rot_flag = 1;
      rotate270();
      if (strcmp(routerName, "MIGHTY") == 0)  
	inv_flag =0;
      if (inv_flag == 1)  
	invlayer(); 
    }
  fix_poly_pins(); 

  filter_bound();
  {
    int cnt;
    
    cnt = 0;
    while((filter_bound2() == TRUE) && (cnt < 5))
      cnt++;
  }
   
			  /* Set up various data structures */
  setup();
  
			  /* Sort pins in order */
  sortpins();  
}

run_router()
{
			  /* Define grided channel */
  defgrid();
		    /* Compute the routing connection col, row for each pin */
  pin2grid();
			  /* Remove nets which have less than two pins */
  resetnet();
  			  /* call the router and read the output */
  if(doRouting() == FALSE)
    return(FALSE);
			  /* attach terminals of the two ending points
			     to subnets */
  attachterm();
			  /* change the units of subnet & via from col,row 
			     to placement units */
  changeunits();
			  /* adjust vertical nets,  remove unnecessary jugs */
  adjustVnet2();
			  /* connect pins */
  connectpins();
			  /* connect exits */
  connectexits();
			  /* diagionalize channels */
  push_nets_back();
			  /* compute power net width; readjust row locaion */
  wirewidth();
                          /* re-adjust row location, due to new row widths */ 
  redefrow();
  			  /* re-compute y loc of all wires and vias */
  multifyloc();
			  /* If it is a horizontal channel, Then rotate */
  bringOutPolyPins();

  if((channel_types == VERTICAL) || (rot_flag == 1))
    {
      rotate90();
      if (inv_flag == 1)  
	invlayer(); 
    }
			  /* write the result to Oct */
  toOct();
  if (channel_types == VERTICAL)
    {
      
      rot_flag = 1;
      rotate270();
      if (strcmp(routerName, "MIGHTY") == 0)  
	inv_flag =0;
      if (inv_flag == 1)  
	invlayer(); 
    }
return(TRUE);
}


finish()
{  
			  /* clean up, free unneeded memory space */
  freeSpace(); 

			    /* compute the CPU time */
  printCpuTime();

  if(no_compact == TRUE)
    channel_types = 2;
  printf("(main): exit code = %d\n", channel_types+2);
  fflush(stdout);
  octEnd();
  exit(channel_types+2);
}


processCmdLine(argc,argv,layer_cntl)
int argc;
char *argv[];
char layer_cntl[];
{
int inv_flag;
FILE *fp;

inv_flag = 1;
  (void) strcpy(layer_cntl,  "-mm");       	/* default: H: met2 V: met1 */
  
  /* Get circuit name and channel name */

  if (argc >= 5) 
    {   
      (void) strcpy(circuitName, argv[1]);
      (void) strcpy(channelIdname, argv[2]);
      (void) strcpy(routerName,  argv[3]);
      (void) strcpy(routerfile,  argv[4]);
      
      if (argc > 5)  
	{
	  (void) strcpy(layer_cntl,  argv[5]);
	  if (strcmp(argv[5],"-mo")==0 || strcmp(argv[5],"-om")==0 ) 
	    {
	      inv_flag = 0;
	    }
	  if(strcmp(argv[5],"COMPACT") == 0)
	    {
	      COMPACT = TRUE;
	      (void) strcpy(layer_cntl,  "-mm");       	/* default: H: met2 V: met1 */
	      if(argc >= 6)
		{
		  if(strcmp(argv[6],"MIZER") == 0)
		    {
		      MIZER = TRUE;
		    }
		  else
		    {
		      COMPACT_SPACE = atoi(argv[6]);
		      if((argc >= 7) && (strcmp(argv[7],"MIZER") == 0))
			{
			  MIZER = TRUE;
			}
		    }
		}
	    }
	  else
	    if(strcmp(argv[5],"MIZER") == 0)
	    {
	      MIZER = TRUE;
	    }
	    
	}
    }
  else 
    if ((argc == 2) && (*argv[1] == 'r')) 
      {
	
	/* open input file */
	
	if ((fp = fopen("comfile", "r")) == NULL) 
	  {
	    fprintf(stderr, "ERROR:  Unable to open file comfile\n");
	    exit(1);
	  }
	
	/* read in data */
	(void) fscanf( fp, "%s %s %s %s %s", 
	       circuitName, channelIdname, routerName, routerfile,
	       layer_cntl);
	
	if (strcmp(layer_cntl,"-mo")==0 || strcmp(layer_cntl,"-om")==0 ) 
	  {
	    inv_flag = 0;
	  }
      }
  else
    {   
      (void) printf("Circuit Name ? ");
      (void) scanf("%s", circuitName);
      (void) printf("Channel Id ? ");
      (void) scanf("%s", channelIdname);
      (void) printf("Which router ?: ");
      (void) scanf("%s", routerName);
      (void) printf("Router file Name ? ");
      (void) scanf("%s", routerfile);
      (void) printf("input:  %s %s %s %s\n", 
	     circuitName, channelIdname, routerName, routerfile);
    }
  if (strcmp(routerName, "MIGHTY") == 0)    
    router_type = SWITCHBOX_ROUTER;
  else /* strcmp(routerName, "YACR")==0 */  
    router_type = CHANNEL_ROUTER;
return(inv_flag);
}

doRouting()
{
int rtn_code;
int  loop_cnt;
int add, a;

rtn_code = 0;
loop_cnt = 5;
add = 1;

  /* Compute channel density, adjust the top channnel */
if (strcmp(routerName, "MIGHTY") == 0)  
  {
    rtn_code = density();
    if (rtn_code != 0)  
      {
	loop_cnt = 0;
	printf("(main): WARNING! ");
	printf(" MIGHTY density function return none 0 code. (%d)\n", 
	       rtn_code);
      }
  }


/* Call router, read back symbolic routing output (vias, wires) */
if (rtn_code == 0)  
  rtn_code = callrouter();

if (rtn_code != 0 )  
  {
    if (strcmp(routerName, "MIGHTY") == 0)  
      {
	while (loop_cnt > 0  &&  rtn_code != 0)  
	  {
	    /* Add one more track */
	    moveCellVert(TOP,add);
	    printf("(main): NOTE-- Adding %d more track(s) for mighty\n",add);
	    
	    /* re-route */
	    rtn_code = callrouter();
	    
	    add *= 2;
	    loop_cnt --;
	  }
	if (rtn_code != 0)   
	  {
	    printf("(main): WARNING-- Switch to Yacr\n");
	    a = ADJUST;
	    ADJUST = TRUE;
	    moveCellVert(TOP,- (add - 1));
	    ADJUST = a;
	    return(FALSE);
	  }
      }
    else
      {
	if (strcmp(routerName, "YACR") == 0)  
	  {
	    printf("(main): WARNING-- Switch to MIGHTY\n");
	    return(FALSE);
	  }
      }
  }
return(TRUE);
}

printCpuTime()
{
    double cputime;
#ifdef hpux
    struct tms ttime;
    clock_t time;

    times(&ttime);
    time = ttime.tms_utime + ttime.tms_stime;
    cputime = (double) time / sysconf(CLK_TCK);
#else
    struct rusage usage;  /* For getting cpu time */

    getrusage(0,&usage);
    cputime = (double)usage.ru_utime.tv_sec +
	(double)usage.ru_utime.tv_usec/1000000.0;
#endif
    printf("Total CPU time: %5.2g seconds.\n",cputime);
}

int minBound(side,start,stop)
int side,start,stop;
{
vertex_type *vert;
int min;

min = MAXINT;
if(start < CHAN_BOUND->first[side]->x)
  min = CHAN_BOUND->first[side]->y;
else
  {
    for(vert = CHAN_BOUND->first[side];
	(vert != NULL) && 
	(vert->next != NULL) && 
	(vert->next->x <= start);vert = vert->next)
      {}
  }
if((vert->next == NULL) && (start > vert->x))
  return(vert->y);
for(;(vert != NULL) && (vert->x < stop);vert = vert->next)
  min = MIN(vert->y,min);
printf("min -- %d to %d == %d\n",start,stop,min);
return(min);
}

int maxBound(side,start,stop)
int side,start,stop;
{
vertex_type *vert;
int max;

max = MININT;
if(start < CHAN_BOUND->first[side]->x)
  max = CHAN_BOUND->first[side]->y;
else
  {
    for(vert = CHAN_BOUND->first[side];
	(vert != NULL) && 
	(vert->next != NULL) && 
	(vert->next->x <= start);vert = vert->next)
      {}
  }
if((vert->next == NULL) && (start > vert->x))
  return(vert->y);
for(;(vert != NULL) && (vert->x < stop);vert = vert->next)
  max = MAX(vert->y,max);
printf("max -- %d to %d == %d\n",start,stop,max);
return(max);
}

