#include "copyright.h"
#include "port.h"
#include "spider.h"

multifyloc()

/*************************************************************************
 *
 *			      multify-y-loc	
 *
 *  multify y location for all the subnets and vias after new RC_LOC->row_loc
 *
 *  This routine changes the following data:
 *
 *	subnet->y1
 *	subnet->y2
 *	via->y
 *
 *************************************************************************/

{
    int		i;
    subnet_type *subnet;
    via_type    *via;
    pin_type    *pin;

    for (i=1; i <= net_count; i++)  {

        for (subnet=netlist[i]->subnetlist; subnet!=NULL; subnet=subnet->next)  
 	{
	    if ((subnet->term1_status == PIN) && 
		(subnet->term1.pin->cellid == TOP))
	    {
		/* this is the one conn to top pin */
		pin = subnet->term1.pin;
		subnet->y1 = pin->y;
	    }

	    if (subnet->term1_status != PIN) 
	      {
		subnet->y1 = RC_LOC->row_loc[subnet->row1];
	      }

	    if (subnet->term2_status != PIN) 
	      {
		subnet->y2 = RC_LOC->row_loc[subnet->row2];
	      }
 	}
    }

    for (via=vialist; via != NULL; via=via->next)  
    {
	    via->y = RC_LOC->row_loc[via->row];
	    
    }

    printf("Complete multifyloc.c\n");
}
