#include "copyright.h"
#include "port.h"
#include "spider.h"

vertex_type *new_vertex()
{
vertex_type *v;

v = CALLOC (vertex_type, 1);
v->x = 0;
v->y = 0;
v->col = 0;
v->row = 0;
v->next = NULL;	
v->prev = NULL;	
return(v);
}

pin_type *new_pin()
{
pin_type *p;

p = CALLOC(pin_type,1);

p->pinname = NULL;
p->pintype = 0;
p->termid = 0;
p->layer = 0;
p->x = 0;
p->y = 0;
p->power = 0;
p->netname = NULL;
p->nettype = 0;
p->netid = 0;
p->netwidth = 0;
p->cellid = 0;
p->row = 0;
p->col = 0;
p->aterm = NULL;
p->next = NULL;
p->jogged = FALSE;
p->poly_width = -1;
p->poly_delta = 0;
return(p);
}

net_type *new_net()
{
net_type *netptr;

netptr = CALLOC (net_type, 1);

netptr->netname = NULL;
netptr->nettype = -1;
netptr->numpins = 0;
netptr->subnetlist = NULL;
return(netptr);
}

struct subnet_list *new_subnet_list()
{
struct subnet_list *sn;

sn = CALLOC(struct subnet_list,1);
sn->next = NULL;
sn->subnet = NULL;
return(sn);
}

add_to_subnet_list(via,subnet)
via_type	*via;
subnet_type	*subnet;
{
struct subnet_list *sl;

sl = new_subnet_list();

sl->subnet = subnet;
sl->next = via->subnets;
via->subnets = sl;
}

/**************************************************************/

pjogged newJogged()
{
pjogged j;

j = CALLOC(struct jogged, 1);
j->next = NULL;
j->pin = NULL;
j->side = MININT;
j->row = MININT;
j->start = j->stop = MAXINT;
return(j);
}

/********************************************************************/

pcol newCol()
{
pcol col;

col = CALLOC(struct col,1);
col->loc = MININT;
col->index = MININT;
col->width = MAXINT;
col->leftLim = MAXINT;
col->rightLim = MININT;
col->side = -1;
col->pin[TOP] = NULL;
col->pin[BOTTOM] = NULL;
col->next = NULL;
col->prev = NULL;
return(col);
}

