/* test the iv.a routines */

#include "copyright.h"
#include "port.h"
#include "iv.h"
#include "spider.h"

static ivWhichItem routerPtr[] = {{"YACR", 1},
				{"mighty", 0}};
static   IVWindow 	*IVwin;
static int n;
static int Ac;
static char **Av;
int CHANNEL_WIDTH_LIM = 0;
extern int MIZER;
extern int COMPACT;

int
modified_disp()
{
  (void) fprintf(stderr,"(SPIDER) top (right) inst displacement is %d\n", n);
  return(IV_OK);
}

int
modified_width()
{
  (void) fprintf(stderr,"(SPIDER) minimum channel width -  %d\n", CHANNEL_WIDTH_LIM);
  return(IV_OK);
}

int
find_best_disp()
{
int best;

  best = generateModDels();
  n = (RC_LOC->col_loc[FIRST_PIN(TOP)->col + best] - RC_LOC->col_loc[FIRST_PIN(TOP)->col]) / 20;
  iv_UpdateVar(IVwin, &n);
  return(IV_OK);
}

int
set_router()
{
  (void) fprintf(stderr,"(SPIDER) router is %s\n",(iv_WhichSelect( IVwin, routerPtr ) == 0)?"YACR":"mighty");
  strcpy(routerName, (iv_WhichSelect( IVwin, routerPtr ) == 0)?"YACR":"MIGHTY");
  if (iv_WhichSelect( IVwin, routerPtr ) == 0)
    {
      router_type = CHANNEL_ROUTER;
      strcpy(routerfile,"yacr");
      strcpy(routerName, "YACR");
    }
  else
    {
      router_type = SWITCHBOX_ROUTER;
      strcpy(routerfile,"mighty");
      strcpy(routerName, "MIGHTY");
    }

  return(IV_OK);
}

int
run_compactor()
{
  (void) fprintf(stderr,"(SPIDER) Start compactor\n");
  if(makeSparcsConstraints() == 0)
    (void) fprintf(stderr,"(SPIDER) Compaction successful\n");
  else
    (void) fprintf(stderr,"(SPIDER) Compaction failed\n");

  (void) fprintf(stderr,"(SPIDER) Compactor done\n");
  return(IV_OK);
}

int
move_inst()
{
  (void) fprintf(stderr,"(SPIDER) move instance\n");
  moveCellHorLAMBDA(TOP,n);
  n = 0;
  iv_UpdateVar(IVwin, &n);
  return(IV_OK);
}

int
run_mizer()
{
  (void) fprintf(stderr,"(SPIDER) Start via minimizer\n");
  if(call_mizer() == 0)
    (void) fprintf(stderr,"(SPIDER) Via minimization successful\n");
  else
    (void) fprintf(stderr,"(SPIDER) Via minimization failed\n");
  (void) fprintf(stderr,"(SPIDER) Mizer done\n");
  return(IV_OK);
}

int
do_routing()
{
  (void) fprintf(stderr,"(SPIDER) do routing\n");
  if(run_router() == FALSE)
    (void) fprintf(stderr,"(SPIDER) Routing failed\n");
  else
    (void) fprintf(stderr,"(SPIDER) Routing complete\n");
  return(IV_OK);
}

main(argc,argv)
    int argc;
    char *argv[];
{
    int compactor = 0;
    int mizer = 0;
    int do_route = 0;
    int best_disp;
    int move = 0;
    Display 	*display;
    int		exitFlag = 0;
    char buf[256];

    Ac = argc;
    Av = argv;

    init(argc,argv);

    if((getenv("SPIDER_INTERACTIVE") != NULL) &&
       (strcmp("TRUE", getenv("SPIDER_INTERACTIVE")) == 0))
      {
	  ADJUST = TRUE;
	  if ((display = XOpenDisplay( (char*)0 )) == (Display *) 0 ) 
	    {
		abort();
	    }
	  sprintf(buf,"Channel %s - interactive routing",channelName);
	  IVwin = iv_InitWindow( display, "Spider", buf, 12 );
	  iv_AddVar(IVwin, "Do compaction", &compactor, IV_TOGGLE, IV_NO_OPT, run_compactor);
	  iv_AddVar(IVwin, "Do via min", &mizer, IV_TOGGLE, IV_NO_OPT, run_mizer);
	  iv_AddVar(IVwin, "Find best displacement", &best_disp, IV_TOGGLE, IV_NO_OPT, find_best_disp);
	  iv_AddVar(IVwin, "Top (right) Inst displ." , &n, IV_INT, IV_NO_OPT, modified_disp);
	  iv_AddVar(IVwin, "Do move inst", &move, IV_TOGGLE, IV_NO_OPT, move_inst);
	  iv_AddVar(IVwin, "Minimum channel width" , &CHANNEL_WIDTH_LIM, IV_INT, IV_NO_OPT, modified_width);
	  iv_AddVar(IVwin, "Router", (int*)routerPtr, IV_WHICH, (sizeof(routerPtr)/sizeof(ivWhichItem)) , set_router);
	  iv_AddVar(IVwin, "Do routing", &do_route, IV_TOGGLE, IV_NO_OPT, do_routing);
	  iv_AddVar(IVwin, "Exit", &exitFlag, IV_TOGGLE, IV_NO_OPT, IV_NULL_FUNCTION);
	  iv_MapWindow(IVwin, 500,500, IV_MOUSE);
    
	  while (!exitFlag) {
	      iv_ProcessAllEvents( display ); /* simpler than getting the event and passing it to iv (Andrea) */
	  }
	  iv_FreeWindow( IVwin );
	  finish();
      }
    else
      {
	  if(run_router() == FALSE)
	    {
		toggle_router();
		if(run_router() == FALSE)
		  {
		      fprintf(stderr,"(SPIDER): ROUTER FAILURE -- FATAL\n");
		      exit(0);
		  }
	    }

	  if(MIZER == TRUE)
	    run_mizer();
	  if(COMPACT == TRUE)
	    run_compactor();
	  finish();
      }
}


clear_all()
{
int side;
pin_type *pin;

for (side=TOP;  side <= BOTTOM;  side++)
  for (pin = FIRST_PIN(side); pin != NULL; pin = pin->next) 
    {
      pin->jogged = FALSE;
    }   
}

extern int inv_flag;

toggle_router()
{
if(strcmp(routerfile,"mighty") == 0)
  {
    router_type = CHANNEL_ROUTER;
    strcpy(routerfile,"yacr");
    strcpy(routerName, "YACR");
    inv_flag = 1;
    invlayer();
  }
else
  {
    router_type = SWITCHBOX_ROUTER;
    strcpy(routerfile,"mighty");
    strcpy(routerName, "MIGHTY");
  }
fprintf(stderr,"(SPIDER): switching to router %s\n",routerName);
}
