#include "copyright.h"
#include "port.h"
#include "spider.h"

pin2grid()

/**********************************************************************
 *  
 * 		  pin2grid-- 
 * 		  -----------------------------------
 *
 *	---- Function
 * 	This routine maps pin to grid coor. 
 *
 * 	note:
 * 	     pin->row = # of rows from outermost portion of the channel to
 *			routing connection point.
 *			for TOP:    pin->row = row position for the pin;
 *			for BOTTOM: pin->row = total row-count - row of the pin;
 *			i.e.  
 *			    pin->row = i
 *			         <==>  
 *			    pin is connected to i row from the top/bottom
 *
 *	---- This routine sets up the following data structure. 
 *
 *	pin->col
 *	pin->row
 *
 ***********************************************************************/

{

   int 	col; 

    /* For each pin, compute the connecting col,row position & offsets */
    
   for (col=1; col <= RC_LOC->col_count; col++)
     {
       if (RC_LOC->col_pins[TOP][col] != NULL)  
	 {
	   RC_LOC->col_pins[TOP][col]->col = col;
	 }
       if (RC_LOC->col_pins[BOTTOM][col] != NULL)  
	 {	   
	   RC_LOC->col_pins[BOTTOM][col]->col = col;
	 }
     }
   printf("\nComplete pin2grid.c\n");
}

findBoundAtX(side,x)
int side,x;
{
vertex_type *vert;

if(x < CHAN_BOUND->first[side]->x)
  return(CHAN_BOUND->first[side]->y);
for(vert = CHAN_BOUND->first[side];
    (vert != NULL) && (vert->next != NULL) && (vert->x < x);vert = vert->next)
  {}
if((vert->next == NULL) && (x > vert->x))
  return(vert->y);
if((vert->x == x) && (vert->next != NULL))
  {
    if(side == TOP)
      return(MIN(vert->y,vert->next->y));
    else
      return(MAX(vert->y,vert->next->y));
  }
return(vert->y);
}
