#include "copyright.h"
#include "port.h"
#include "spider.h"

fix_poly_pins()
{
pin_type 	*pin;
int		side;
int bound_loc;
int y;

for (side=TOP;  side <= BOTTOM;  side++)
  {
    for (pin = FIRST_PIN(side); pin != NULL; pin = pin->next) 
      if(pin->layer == POLY)
	{
	  if(side == TOP)
	    {
	      bound_loc = minBound(side,
			     pin->x - pin->netwidth/2,
			     pin->x + pin->netwidth/2);
	      y = bound_loc - pin->netwidth/2 - MAX(layer_spacing[POLY],layer_spacing[MET1]);
	    }
	  else
	    {
	      bound_loc = maxBound(side,
			     pin->x - pin->netwidth/2,
			     pin->x + pin->netwidth/2);
	      y = bound_loc + pin->netwidth/2 + MAX(layer_spacing[POLY],layer_spacing[MET1]);
	    }
	  pin->poly_width = pin->netwidth;
	  pin->poly_delta = pin->y - y;

	  pin->layer = ((channel_types == HORIZONTAL) ||
			(router_type == SWITCHBOX_ROUTER))?MET1:MET2;
	  pin->y = y;
	  if(pin->netwidth < layer_width[MET1])
	    pin->netwidth = layer_width[MET1];
	}
  }
}

bringOutPolyPins()
{
int side;
pin_type *pin;
int row;
char vianame[50];
term_type term,pin_term,*subnet_term;
subnet_type *subnet;
subnet_type *sub;

for(side = TOP;side <= BOTTOM;side++)
  {
    for(pin = FIRST_PIN(side);pin != NULL;pin = pin->next)
      if(pin->poly_width >= 0)
	{
	  pin->netwidth = pin->poly_width;
	  row = get_row(side,pin);
	  
	  /* note: terminal of type PIN is always in term1 */
	  
	  sub = NULL;
	  for (subnet = netlist[pin->netid]->subnetlist;
	       subnet!= NULL;
	       subnet = subnet->next)  
	    {
	      if ((subnet->term1_status == PIN) &&
		  (subnet->layerid == ((channel_types == HORIZONTAL)?MET1:MET2)) &&
		  (subnet->col1 == pin->col) && 
		  (subnet->row1 == -(get_row(side,pin))))
		{
		  if(sub == NULL) 
		    sub = subnet;
		  else
		    {
		      if((side == TOP) && (subnet->y1 > sub->y1))
			sub = subnet;
		      if((side == BOTTOM) && (subnet->y1 < sub->y1))
			sub = subnet;
		    }
		}
	    }

	  if(sub == NULL)
	    logError("ERROR in finding poly term\n",FATAL);
	  else
	    {
	      subnet = sub;
	      subnet->term1_status = VIA;
	      term.pin = subnet->term1.pin;
	      subnet_term = &(subnet->term1);
	    }
	  term.via = bldvia("p_via", pin->netid, 
			    pin->x, 
			    subnet->y1, 
			    pin->col, 
			    subnet->row1, 
			    POLY,
			    (((channel_types == HORIZONTAL) || (router_type == SWITCHBOX_ROUTER))?MET1:MET2));
	  (*subnet_term).via = term.via;
	  pin_term.pin = pin;
	  bldsubnet(pin->netid, 
		    pin->x, 
		    subnet->y1 + pin->poly_delta, 
		    pin->x, 
		    subnet->y1, 
		    layer_width[POLY], 
		    POLY, 
		    -row,
		    pin->col,
		    subnet->row1,
		    pin->col,
		    &pin_term,&term,PIN,VIA,VERTICAL);
	}
  }
}


