#include "copyright.h"
#include "port.h"
#include "spider.h"

rc_loc_type *RC_LOC;


rc_loc_type *new_rc_loc()
{
rc_loc_type *rcl;
int side;

rcl = CALLOC(rc_loc_type,1);
rcl->col_count = -1;
rcl->col_loc = NULL;
rcl->col_pins = NULL;
rcl->row_count = -1;
rcl->row_width = NULL;
rcl->row_loc = NULL;
for(side = TOP;side <= RIGHT;side++)
  {
    rcl->row_net[side] = NULL;
    rcl->boundary[side] = NULL;
  }
return(rcl);
}

	/* ==== Re-adjust channel so that:
	   for every col, top_channel_row# >= bottom_channel row#  */

fix_RC_LOC_overlap()
{
int col,max_delta_row,delta_row;

max_delta_row = 0;
	
for (col=1; col <= RC_LOC->col_count; col++)
  {
    delta_row = RC_LOC->boundary[BOTTOM][col] + 1 - RC_LOC->boundary[TOP][col];
    max_delta_row = MAX(delta_row, max_delta_row);
  }

if (max_delta_row > 0)
  {
    if(CHAN_PINS->pinstatus == FIXED)  
      {
	printf("\n (defHchannel): error.  Channel is not wide enough for router.\n");
	
	(void) sprintf(error, "ERROR.  channel is not wide enough for router");
	logError(error, FATAL);
      }
    else
      {
	printf("(defH): NOTE-- adjusted Top channel by: %d rows to avoid top and bottom overlap\n", 
	       max_delta_row);
	moveCellVert(TOP, max_delta_row);
      }
  }
}

get_min_RC_LOC_row()
{
int absMinRow;
int col;

  for(absMinRow = MAXINT,col = 1;col <= RC_LOC->col_count;col++)
    absMinRow = MIN(RC_LOC->boundary[BOTTOM][col], absMinRow);
return(absMinRow);
}

get_max_RC_LOC_row()
{
int absMaxRow;
int col;

for(absMaxRow = MININT,col = 1;col <= RC_LOC->col_count;col++)
  absMaxRow = MAX(RC_LOC->boundary[TOP][col], absMaxRow);

return(absMaxRow);
}


addRows(new_max_row)
int new_max_row;
{
int delta;
int  row;
rc_loc_type *old_rc_loc;
int side;

if(RC_LOC->row_count < 0)
  return;
delta = new_max_row - RC_LOC->row_count;
if(delta <= 0)
  return;

old_rc_loc = RC_LOC;

RC_LOC   = new_rc_loc();
RC_LOC->row_count = old_rc_loc->row_count + delta;
printf("add %d rows\n",delta);

RC_LOC->row_loc   = CALLOC( int, RC_LOC->row_count + 1);
RC_LOC->row_width = CALLOC( int, RC_LOC->row_count + 1);
RC_LOC->row_net[LEFT]= CALLOC(pin_type *, RC_LOC->row_count + 1);
RC_LOC->row_net[RIGHT]= CALLOC(pin_type *, RC_LOC->row_count + 1);

RC_LOC->col_count = old_rc_loc->col_count;
RC_LOC->col_loc = old_rc_loc->col_loc;
RC_LOC->col_pins = old_rc_loc->col_pins;
for (side=TOP;  side<=BOTTOM;  side++)  
  RC_LOC->boundary[side] = old_rc_loc->boundary[side];

for (row=0;  row <= old_rc_loc->row_count;  row++)  
  {
    RC_LOC->row_loc[row] = old_rc_loc->row_loc[row];
    RC_LOC->row_width[row] = old_rc_loc->row_width[row];
    
    RC_LOC->row_net[LEFT][row] = old_rc_loc->row_net[LEFT][row];
    RC_LOC->row_net[RIGHT][row] = old_rc_loc->row_net[RIGHT][row];
  }
for (;  row < RC_LOC->row_count + 1;  row++)  
  {
    RC_LOC->row_loc[row] = RC_LOC->row_loc[row-1] + GRIDHEIGHT;
    RC_LOC->row_net[LEFT][row] = RC_LOC->row_net[RIGHT][row] = NULL;
    RC_LOC->row_width[row] = GRIDHEIGHT;
  }
}


move_RC_LOC_bound(side, delta)
int side;
int delta;
{
int col;

if(delta > 0)
  addRows(RC_LOC->row_count + delta);
for(col = 1;col <= RC_LOC->col_count;col++)
  RC_LOC->boundary[side][col] += delta;

RC_LOC->row_count = get_max_RC_LOC_row();
}
