#include "copyright.h"
#include "port.h"

/*************************************************************************
 *
 * 		            REDEFROW 
 * 		            ---------
 *
 *	---- Functions 
 *
 *  	Re-define the row location based on the row width.
 *   	Note that this time row0 is the top of channel (same as router).
 *
 *************************************************************************/
#include "spider.h"

redefrow()
{
  int 	row;		/* loop counter */
  int   old_loc;
  int   slack;

    /* redefin: row0  to be the top of the top side of channel 
       rown+1 to be the bottom of the bottom side of channel 
    */

    old_loc = RC_LOC->row_loc[RC_LOC->row_count];
    RC_LOC->row_loc[0] = row_zero_loc() + (RC_LOC->row_width[0] + 1)/2;

    for (row = 1;row <= RC_LOC->row_count;  row++)
      {
    	RC_LOC->row_loc[row] = RC_LOC->row_loc[row-1] +
	  (RC_LOC->row_width[row-1]+1)/2 + (RC_LOC->row_width[row]+1)/2;
	printf("Redef row %d == %d\n",row,RC_LOC->row_loc[row]);
      }

  move_bound(TOP,RC_LOC->row_loc[RC_LOC->row_count] - old_loc);
  if((CHAN_BOUND->min_y[TOP] < refTopBoundMinY) && (ADJUST == FALSE))
    {
      slack = (refTopBoundMinY - CHAN_BOUND->min_y[TOP])/(RC_LOC->row_count + 1);
      for (row = 1;row <= RC_LOC->row_count+1;  row++)
	{
	  RC_LOC->row_loc[row] = RC_LOC->row_loc[row-1] +
	    (RC_LOC->row_width[row-1]+1)/2 + (RC_LOC->row_width[row]+1)/2 + slack;
	}
      move_bound(TOP,refTopBoundMinY - CHAN_BOUND->min_y[TOP]);
    }
/*
  d2 = del = find_movement();
  printf("DELTA %d\n",d2);
  del = limit_delta(del);

  for(p = CHAN_BOUND->first[TOP];(p != NULL);p = p->next)
    p->y += del;

  for (ptr=FIRST_PIN(TOP); ptr!=NULL; ptr=ptr->next)
    ptr->y += del;

  CHAN_BOUND->ur_y  += del;
  CHAN_PINS->min_y[TOP] += del;
  CHAN_PINS->max_y[TOP] += del;
  CHAN_BOUND->min_y[TOP] += del;
  CHAN_BOUND->max_y[TOP] += del;
  if((d2 < 0) && (d2 < del) && (last == TRUE))
    {
      slack = (del - d2)
      printf("SLACK %d\n",slack);

      RC_LOC->row_loc[0] = bottomRefY + (RC_LOC->row_width[0] + 1)/2;
      
    }
*/
  printf("Complete redefrow.c\n");
}

find_movement()
{
int max,del;
int col, row,row1;

max = MININT;
for (col=1;  col<=RC_LOC->col_count;  col++)  
  {
    row = find_highest_occupied_row(col);
    row1 = find_highest_occupied_row2(col);
    row = MAX(row,row1);

    del = (RC_LOC->row_loc[row] + (int)(((double)(RC_LOC->row_width[row] + MAX_SPACING))/2.0)) - 
      findBoundAtX(TOP,RC_LOC->col_loc[col]);
    max = MAX(max,del);
  }
return(max);
}

find_highest_occupied_row2(col)
int col;
{
int i,max,m;
net_type *net;
subnet_type *subnet;

max = 0;
for(i=1; i <= net_count; i++)  
  {
    net=netlist[i]; 
    if (net->numpins > 1)
      {
	for(subnet = net->subnetlist;subnet != NULL;subnet = subnet->next)
	  {
	    if((subnet->col1 <= col) && (col <= subnet->col2))
	      {
		m = MAX(subnet->row1,subnet->row2);
		max = MAX(max,m);
	      }
	  }
      }
  }
return(max);
}

find_highest_occupied_row(col)
int col;
{
int row;

FOREACH_ROW_REVERSE(ROUTING, row)
  if((ROUTING->layer1[row][col] != 0) || (ROUTING->layer2[row][col] != 0))
     break;
return(MAX(0,row));     
}

limit_delta(delta)
int delta;
{

printf("LIMITING %d ",delta);
if(ADJUST == FALSE)
  delta = MAX(delta,0);
if(CHANNEL_WIDTH + delta < (CHANNEL_WIDTH_LIM * 20))
  delta = (CHANNEL_WIDTH_LIM * 20)- CHANNEL_WIDTH;
printf("to %d -- adjust %d -- ch_width %d ch_wid_lim %d\n",delta, ADJUST, CHANNEL_WIDTH, CHANNEL_WIDTH_LIM * 20);
return(delta);
}
