#include "copyright.h"
#include "port.h"

/*
    RESET-NET --

    1. remove any nets with 0 or 1 pin connections

       It may be the case that some nets were given to use with only a single
       pin, or that after we "deleted" pins because of spacing violations,
       that a net has no pins, or only 1 pin.  

       Any net which has only 0 or 1 connections will be numbered zero, and
       hence appear as no connection.

    2. renumber the nets so that they run continously from 1 to num_net. 
       i.e.  set  netptr->seqnum
*/    
#include "spider.h"
int  	NUM_NET;

resetnet()
{
    int 	i;
    net_type 	*netptr;

    /*  remove any nets with 0 or 1 pin connections and  
	renumber them from 1 to num_net. */

    NUM_NET = 0;
	
    for(i=1; i <= net_count; i++)  
      {
        netptr=netlist[i]; 
	if (netptr->numpins > 1)
	    NUM_NET++;
      }
    printf("Complete resetnet.c\n");
}
