#include "copyright.h"
#include "port.h"
#include "spider.h"

rotate270()

/**********************************************************************
 * 		  ROTATE CLOCK-WISE 270 DEGREE 
 * 		  ---------------------------
 *
 *	---- Function
 *	x' = CHAN_BOUND->ur_y - y
 *	y' = x
 *
 *	---- This routine sets up the following data structure. 
 *
 ***********************************************************************/

{
     pin_type		*pinptr;
     vertex_type 	*ptr;
     int		x, y;
     int		side;
     int		i;


    /** For each points of the channel boundary, DO -- rotation **/  

    for (side=TOP;  side <= RIGHT;  side++)  
      {
	for(ptr = CHAN_BOUND->first[side];(ptr != NULL);ptr=ptr->next)
	  {
	    x = ptr->x;
	    y = ptr->y;
	    
	    ptr->x = CHAN_BOUND->ur_y - y;  
	    ptr->y = x;
	  }
      }

    /** For each pin, DO -- rotation **/  

    for (side=TOP;  side <= RIGHT;  side++)  
    for (pinptr=FIRST_PIN(side); pinptr != NULL; pinptr=pinptr->next) {

	x = pinptr->x;
	y = pinptr->y;

	pinptr->x = CHAN_BOUND->ur_y - y;  
	pinptr->y = x;
    }


    /** For each cell, DO -- rotation **/  

    for (i=0;  i <= 1;  i++)  {

	 x = CELL_LIST[i]->x;
	 y = CELL_LIST[i]->y;

	CELL_LIST[i]->x = CHAN_BOUND->ur_y - y;  
	CELL_LIST[i]->y = x;

    }


    /** Swap urx, ury **/  

    x = CHAN_BOUND->ur_x;
    y = CHAN_BOUND->ur_y;

    CHAN_BOUND->ur_x = y;
    CHAN_BOUND->ur_y = x;

    printf("Complete rotate270.c\n");
}
