#include "copyright.h"
#include "port.h"
#include "spider.h"

rotate90()

/**********************************************************************
 * 		  ROTATE CLOCK-WISE 90 DEGREE 
 * 		  ---------------------------
 *
 *	---- Function
 *	x' = y
 *	y' = CHAN_BOUND->ur_x - x
 *
 *	---- This routine sets up the following data structure. 
 *
 ***********************************************************************/

{
     pin_type		*pinptr;
     via_type		*viaptr;
     net_type		*netptr;
     subnet_type	*subnetptr;
     vertex_type 	*ptr;

     int		x, y;
     int		x1, y1, x2, y2;
     int		side;
     int		i;


    /** For each points of the channel boundary, DO -- rotation **/  

    for (side=TOP;  side <= RIGHT;  side++)  
      {
	for(ptr = CHAN_BOUND->first[side];(ptr != NULL);ptr=ptr->next)
	  {
	    x = ptr->x;
	    y = ptr->y;
	    
	    ptr->x = y;
	    ptr->y = CHAN_BOUND->ur_x - x;  
	  }
      }


    /** For each pin, DO -- rotation **/  

    for (side=TOP;  side <= RIGHT;  side++)  
    for (pinptr=FIRST_PIN(side); pinptr != NULL; pinptr=pinptr->next) {

	x = pinptr->x;
	y = pinptr->y;

	pinptr->x = y;
	pinptr->y = CHAN_BOUND->ur_x - x;  
    }


    /** For each via, DO -- rotation **/  

    for (viaptr=vialist;  viaptr!=NULL;  viaptr=viaptr->next) {

	 x = viaptr->x;
	 y = viaptr->y;

	viaptr->x = y;
	viaptr->y = CHAN_BOUND->ur_x - x;  
    }


    /** For each subnet, DO -- rotation **/  
    
    for (i=1;  i <= net_count;  ++i) {

	 netptr=netlist[i];

	 if (netptr->subnetlist != NULL) {

	     for (subnetptr=netptr->subnetlist;  subnetptr!=NULL;  
		  subnetptr=subnetptr->next)  {

		  x1 = subnetptr->x1;
		  y1 = subnetptr->y1;
		  x2 = subnetptr->x2;
		  y2 = subnetptr->y2;

		subnetptr->x1 = y1;
		subnetptr->y1 = CHAN_BOUND->ur_x - x1;  
		subnetptr->x2 = y2;
		subnetptr->y2 = CHAN_BOUND->ur_x - x2;  

	     }
	 }
    }


    /** For each cell, DO -- rotation **/  

    for (i=0;  i <= 1;  i++)  {

	 x = CELL_LIST[i]->x;
	 y = CELL_LIST[i]->y;

	CELL_LIST[i]->x = y;
	CELL_LIST[i]->y = CHAN_BOUND->ur_x - x;  

    }


    /** Swap urx, ury **/  
    x = CHAN_BOUND->ur_x;
    y = CHAN_BOUND->ur_y;

    CHAN_BOUND->ur_x = y;
    CHAN_BOUND->ur_y = x;


    printf("Complete rotate90.c\n");
}
