#include "copyright.h"
#include "port.h"
#include "spider.h"
#include "tap.h"
#include <sys/stat.h>
#define CONTACTS_DIR "special_contacts"
static num_of_insts = 0;

octObject oCellFacet;		/*  contents, top-level cell  */
FILE *pout;

struct subnet_list *new_subnet_list();
static octObject layer_table[3];

/**************************************************************/

toOct()
{
char		*instname1; 
char		*instname2;
char		*netname;

int		side;
int		netwidth;
int		termid;
int		term1id;
int		term2id;
int		ftermid;
int		atermid;

octCoord	x1, y1;
octCoord	x2, y2; 

int		i;
int		debug;

pin_type	*pinptr;
net_type	*netptr;
subnet_type	*subnetptr;

octObject 	net,old;


/** begin **/

    debug = 0;

    printf("Start toOct.c\n");
    num_of_insts = 0;

    pout = stdout;

/** Open up the top-level oct cell for the channel and the two instances **/

    /* For update instance placement location,  we need "add or write" mode */
    printf("\ntoOct: Open top-level oct cell. %s \n", channelName);

    old.type = OCT_FACET;
    old.contents.facet.cell = channelName;
    old.contents.facet.view = "preroute";
    old.contents.facet.version = OCT_CURRENT_VERSION;
    old.contents.facet.facet = "contents";

    oCellFacet.type = OCT_FACET;
    oCellFacet.contents.facet.cell = channelName;
    oCellFacet.contents.facet.view = "symbolic";
    oCellFacet.contents.facet.facet = "contents";
    oCellFacet.contents.facet.version = OCT_CURRENT_VERSION;
    oCellFacet.contents.facet.mode = "a";
    if(octCopyFacet(&oCellFacet,&old) != OCT_OK)
      {
	logError("(SPIDER):WARNING problem in copying preroute information",FATAL);
      }

    if(octOpenFacet(&oCellFacet) < OCT_OK)	
      logError("can not open oct file for channel\n",FATAL);

    instname1 = CELL_LIST[0]->cellname; 
    instname2 = CELL_LIST[1]->cellname; 

/** Update both instance location **/

    x1 = CELL_LIST[0]->x;
    y1 = CELL_LIST[0]->y;   
    x2 = CELL_LIST[1]->x;
    y2 = CELL_LIST[1]->y;   
    updateOctInst(instname1, x1, y1);
    updateOctInst(instname2, x2, y2);

for(i = 0;i <= 2;i++)
  get_layer(&(layer_table[i]),layer_nameTable[i]);

make_vias();

/** For each terminal Do -- Get terminal ID num **/

    for (side=TOP;  side <= RIGHT;  side++)  
         for (pinptr=FIRST_PIN(side);  pinptr!=NULL;  pinptr=pinptr->next)  
	   {
	     getOctTermId(CELL_LIST[pinptr->cellid]->cellname, 
			  pinptr->pinname, 
			  &termid);
	     pinptr->termid = termid;
	   }

/** For each new subnet Do -- create an Oct net and make proper attachment **/

    for (i=1;  i <= net_count;  ++i) {

	 netptr=netlist[i];

	 createOctNet(&net,netptr->netname);

	 if (netptr->subnetlist != NULL) {

	     for (subnetptr=netptr->subnetlist;  subnetptr!=NULL;  
		  subnetptr=subnetptr->next)  {

		  netwidth  = subnetptr->width;
		  if (netwidth != layer_width[subnetptr->layerid])
		    {
		      printf("(toOct): note net %s have a diff width %d\n",
			     netptr->netname, netwidth);
		    }

		  x1 = subnetptr->x1;
		  y1 = subnetptr->y1;
		  x2 = subnetptr->x2;
		  y2 = subnetptr->y2;

		  if (x1 != x2 ) {

		      if ((x2-x1) < GRIDWIDTH ) {
                         /* set flag, so that no compaction for now */
                         /* channel_types = 2; */
			 /*
                         printf("WARNING. net length less then a GW. ");
                         printf("x1,2= %d %d,  y1,2= %d %d\n", x1,x2, y1,y2);
			 */
		      }

		      if (subnetptr->term1_status == VIA)
		      {
			  if (x1 < x2)  x1 -= CONT_WIDTH/3;
			  else          x1 += CONT_WIDTH/3;
		      }
		      if (subnetptr->term2_status == VIA)
		      {
			  if (x2 < x1)  x2 -= CONT_WIDTH/3;
			  else          x2 += CONT_WIDTH/3;
		      }
		    }
		  if (y1 != y2 ) {

		      if (subnetptr->term1_status == VIA)
		      {
			  if (y1 < y2)  y1 -= CONT_WIDTH/3;
			  else          y1 += CONT_WIDTH/3;
		      }
		      if (subnetptr->term2_status == VIA)
		      {
			  if (y2 < y1)  y2 -= CONT_WIDTH/3;
			  else          y2 += CONT_WIDTH/3;
		      }
		  }

 		  if (subnetptr->term1_status == VIA)  
		    {
 		      term1id = subnetptr->term1.via->termid;
		    }
 		  else
		    {
 		      term1id = subnetptr->term1.pin->termid;
		    }
 		  if (subnetptr->term2_status == VIA)  
		    {
		      term2id = subnetptr->term2.via->termid;
		    }
 		  else
		    {
 		      term2id = subnetptr->term2.pin->termid;
		    }
    		  createOctSubnet(subnetptr->layerid, &net, netwidth, 
				  x1,y1, x2,y2, term1id, term2id, subnetptr->term1_status, subnetptr->term2_status);

		  if (debug >= 1)  {
	          printf("(toOct): wire. net=%d, layer=%s, coor= %d %d %d %d\n",
		           i, layer_nameTable[subnetptr->layerid], x1, y1, x2, y2);
		  }
		}
	   }
	 netptr->subnetlist = NULL;
       }

/** For each fterm Do -- Attach aterm to fterm **/
    for (side=LEFT;  side <= RIGHT;  side++)  
         for (pinptr=FIRST_PIN(side);  pinptr!=NULL;  pinptr=pinptr->next)  {
	    if (netlist[pinptr->netid]->numpins > 1)  {
	 	ftermid = pinptr->termid;
	 	atermid = pinptr->aterm->termid;
		netname = pinptr->netname;
		attachOctFTerm(ftermid, atermid, netname);

		if (debug >= 1)  {
        	    printf("fterm= %s, %d  aterm= %s, %d\n", 
        	            pinptr->pinname, pinptr->termid,
        	            pinptr->aterm->vianame, pinptr->aterm->termid);
        	    printf("netname= %s\n", netname);
		}
	    }

	    else  {
	      (void) printf("(toOct): WARNING!  %d pin %s doesn't conn to anything.\n",
	 	     side, pinptr->pinname);
	      (void) sprintf(error, "WARNING!  %d pin %s doesn't conn to anything.",
	 	     side, pinptr->pinname);
	      logError(error, NONFATAL);
	    }

         }

/** Save Oct Facets **/

    closeOctFacet(&oCellFacet);

    printf("Complete toOct.c\n");
    fflush(stdout);
}

/**************************************************************/

make_vias()
{
via_type	*viaptr;
int i;
struct subnet_list *sl;
octObject ConnectorBag;
octId id,createOctVia();

createOctBag(&ConnectorBag,"CONNECTORS");

for (viaptr=vialist;  viaptr!=NULL;  viaptr=viaptr->next) 
  {
    id = createOctVia(&ConnectorBag,viaptr);
    viaptr->termid = getOctViaTermId(id,viaptr->pinname);
    
    for(i = 0,sl = viaptr->subnets;sl != NULL;sl = sl->next,i++)
      {}
    if(i == 0)
      printf("ERROR via has one connection\n");
/*
    printf("via %s of type %s has %d nets connected\n",
	   viaptr->vianame,via_nameTable[viaptr->layer1][viaptr->layer2],i);
*/
  }
vialist = NULL;
}

/**************************************************************/

/*
 *  For a given terminal name with name of its containing instance, 
 *  find the Oct Terminal id
 */


attachOctFTerm(ftermid, atermid, netname)
int	ftermid;
int	atermid;
char	*netname;
{
  int		debug;
  octObject fterm,term,net;
  
  debug = 0;
  
  if (debug >= 1)  
    printf("Start attachOctFTerm.c\n");
  
  fterm.objectId = ftermid;
  if (octGetById(&fterm) != OCT_OK)  
    {
      printf("attachOctFTerm:  can't get formal terminal by Id");
      octError("attachOctFTerm:  getting formal terminal by Id");
      exit(-10);
    }
  
  term.objectId = atermid;
  if (octGetById(&term) != OCT_OK)  
    {
      printf("attachOctFTerm:  can't get actual terminal by Id");
      octError("attachOctFTerm:  getting actual terminal by Id");
      exit(-10);
    }
  
  attach(&fterm, &term);
  
  net.type = OCT_NET;
  net.contents.net.name = netname;
  if (octGetByName(&oCellFacet, &net) != OCT_OK)  
    {
      printf("attachOctFTerm:  Can't get net by name. net=%s\n", netname);
      octError("attachOctFTerm:  getting net by name");
      exit(-10);
    }
  
  attach(&net, &fterm);
  
  if (debug >= 1)  
    printf("Complete attachOctFTerm.c\n");
}

/**************************************************************/

createOctSubnet(layernum, net, netwidth, x1,y1, x2,y2, term1id, term2id,status1,status2)
octObject	*net;
int		layernum;
octCoord	netwidth;
octCoord	x1, y1;
octCoord	x2, y2;
octId		term1id, term2id;
int status1,status2;

/*  ---- Create Oct Subnet ----

	 *  Get or create the mask layer.

	 *  Get the net by name.

	 *  Create the segment (subnet).
	 *  Add the endpoint coordinates to the path

	 *  attach the segment to the net.
	 *  attach the segment to the layer.

	 *  Get the terminal connected at one end of the segment 
	 *  Attach it to the segment.
	 *  Attach it to the net.

	 *  Repeat for the terminal at pw->p2

*/
{
int		debug;
octObject term;
octObject segment;
struct octPoint path[2];	/*  points for a wire segment  */

debug = 0;

if (debug >= 1)  
  printf("Start createOctSubnet.c\n");

/* avoid zero length subnet */

if (x1 == x2 && y1 == y2) 
  {
    x2 ++;
  }
if(term1id == term2id)
  return;

/*
 *  Now, create the nets, subnets, etc. for the wire segments.
 */


/*
 *  Create the segment and attach it to net 
 */

segment.type = OCT_PATH;
segment.contents.path.width = netwidth;
if (octCreate(net, &segment) != OCT_OK)  
  {
    octError("createOctSubnet:  creating octPath for segment\n");
    exit(-10);
  }

/*
 *  The segment is also attached to the layer 
 */

if (octAttach(&(layer_table[layernum]), &segment) != OCT_OK)  
  {
    octError("createOctSubnet:  creating subnet\n");
    exit(-10);
  }

/*
 *  Add the endpoint coordinates to the path
 */
path[0].x = x1;
path[0].y = y1;
path[1].x = x2;
path[1].y = y2;

if (octPutPoints(&segment, 2, path) != OCT_OK)  
  {
    octError("createOctSubnet:  adding coordinates to path\n");
    exit(-10);
  }

/*
 *  Get the terminal connected at one end of net 
 */

term.type = OCT_TERM;
term.objectId = term1id;
if (octGetById(&term) != OCT_OK)  
  {
    printf("(createOctSubnet): OCT problem.  term1id=%d\n", term1id);
    octError("createOctSubnet:  getting terminal by Id\n");
    exit(-10);
  }

/*
 *  Attach it to the segment
 *  Attach it to the net.
 */

attach(&segment, &term);
if(status1 == PIN)
  attach(net, &term);

/*
 *  Repeat for the other terminal
 */

term.objectId = term2id; 
if (octGetById(&term) != OCT_OK)  
  {
    octError("createOctSubnet:  getting terminal by Id\n");
    exit(-10);
  }

attach(&segment, &term);
if(status2 == PIN)
  attach(net, &term);


    /*
     *  Done with the segment-making
     */

if (debug >= 1)  
  printf("End createOctSubnet.c\n");
}

/**************************************************************/

getOctTermId(instname, termname, termid)
char		*instname;
char		*termname;
int		*termid;
{

int		debug;
octObject *inst;
octObject term;
static octObject inst1,inst2;
octStatus status;

debug = 0;

if (debug >= 1) 
  {
    printf("Start getOctTermId.c\n");
    printf("instname = %s, termname = %s ch=%s\n", 
	   instname, termname,channelName);
  }

if (strcmp(instname,channelName) != 0)  
  {
    
    /* these are the pins asso w/ top and bottom cell */
    
    
    if(num_of_insts == 0)
      {
	inst1.type = OCT_INSTANCE;
	inst1.contents.instance.name = instname;
	if (octGetByName(&oCellFacet, &inst1) != OCT_OK)  
	  {
	    printf("getOctTermId:  ERROR. can't get instance.  Instname:");
	    fprintf(pout, "getOctTermId:  can't get instance.  Instname:");
	    fprintf(pout, "%s\n", instname);
	    octError("getOctTermId:  getting instance by name");
	    exit(-10);
	  }
	inst = &inst1;
	num_of_insts = 1;
      }
    else
      {
	if(strcmp(instname,inst1.contents.instance.name) == 0)  
	  inst = &inst1;
	else
	  {
	    if(num_of_insts == 1)
	      {
		inst2.type = OCT_INSTANCE;
		inst2.contents.instance.name = instname;
		if (octGetByName(&oCellFacet, &inst2) != OCT_OK)  
		  {
		    printf("getOctTermId:  ERROR. can't get instance: %s\n", 
			   instname);
		    octError("getOctTermId:  getting instance by name");
		    exit(-10);
		  }
		inst = &inst2;
		num_of_insts = 2;
	      }
	    else
	      if(strcmp(instname,inst2.contents.instance.name) == 0)  
		inst = &inst2;
	      else
		{
		  octError("getOctTermId:  getting instance by name");
		  exit(-10);
		}
	  }
	
      }	

    term.type = OCT_TERM;
    term.contents.term.name = termname;
    if ((status = octGetByName(inst, &term)) != OCT_OK)  
      {
	fprintf(pout, "getOctTermId:  ERROR. can't get terminal (#1) %d.  ",status);
	fprintf(pout, "Termname: %s;  Instname: %s\n", 
		termname, instname);
	octError("getOctTermId:  getting terminal by name");
	exit(-10);
      }
  }
else
  {
    term.type = OCT_TERM;
    term.contents.term.name = termname;
    if (octGetByName(&oCellFacet, &term) != OCT_OK)  
      {
	fprintf(pout,"getOctTermId:  ERROR. can't get terminal (#2). ");
	fprintf(pout, "Termname: %s\n", termname);
	octError("getOctTermId:  getting terminal by name");
	exit(-10);
      }
  }

*termid = term.objectId;

if (debug >= 1)  
  printf("End getOctTermId.c\n\n");
}

/**************************************************************/

updateOctInst(instname, x, y)

char		*instname;
octCoord 	x, y;

/*
 *  Routine to update the locations of the instance in oct.  
 *
 */

{
int		debug;
octObject inst;

debug = 0;

if (debug >= 1)  
  printf("Start updatOctInst.c\n");

if (strcmp(instname, "CPExtInst") == 0) 
  {
    printf("updateOctInst: skip dummy instance.  inst= %s\n", instname);
    return;
  }

inst.type = OCT_INSTANCE;
inst.contents.instance.name = instname;
if (octGetByName(&oCellFacet, &inst) != OCT_OK)  
  {
    fprintf(pout, "updateOct:  ERROR. ");
    fprintf(pout, "can't get oct instance for object ");
    fprintf(pout, "%s\n", instname);
    exit(-10);
  }

if (debug >= 1)  
  {
    fprintf(pout, "  old x trans. = %d,",
	    inst.contents.instance.transform.translation.x);
    fprintf(pout, "  old y trans. = %d\n",
	    inst.contents.instance.transform.translation.y);
  }

/*  and update it  */
inst.contents.instance.transform.translation.x = x;
inst.contents.instance.transform.translation.y = y;

if (debug >= 1)  {
  fprintf(pout, "  new x trans. = %d,",
	  inst.contents.instance.transform.translation.x);
  fprintf(pout, "  new y trans. = %d\n",
	  inst.contents.instance.transform.translation.y);
}

/*  finally, "octModify" the instance  */
if (octModify(&inst) != OCT_OK)  
  {
    fprintf(pout, "updateOct:  ERROR. ");
    fprintf(pout, "can't modify instance for obj.");
    fprintf(pout, " %s\n", instname);
  }

/*  get it again to see if it is correct  */
inst.contents.instance.name = instname;
if (octGetByName(&oCellFacet, &inst) != OCT_OK)  
  {
    fprintf(pout, "updateOct:  ERROR. ");
    fprintf(pout, "can't get oct instance for object");
    fprintf(pout, " %s\n", instname);
  }

if (debug >= 1)  
  printf("End updatOctInst.c\n");
}

/**************************************************************/

getOctViaTermId( instId, termname)
char		*termname;
octId		instId;

{
octObject term,inst;

inst.objectId = instId;
if (octGetById(&inst) != OCT_OK)  
  {
    printf("getOctTermId:  ERROR. can't get instance.  Instname:");
    fprintf(pout, "getOctTermId:  can't get instance.  Instname:");
    fprintf(pout, "\n");
    octError("getOctTermId:  getting instance by name");
    exit(-10);
  }

if (octGenFirstContent(&inst, OCT_TERM_MASK, &term) != OCT_OK)  
  {
    fprintf(pout, "getOctTermId:  ERROR. can't get terminal (#3).  ");
    fprintf(pout, "Termname: %s;\n", 
	    termname);
    octError("getOctTermId:  getting terminal by name");
    exit(-10);
  }
return( term.objectId);
}

/**************************************************************/

octId createOctVia(connBag,viaptr)
via_type	*viaptr;
octObject *connBag;
{
char *viamaster, *getOrCreateVia();
subnet_type *subnet;
struct subnet_list *sl;
int h_wid,v_wid;
int non_standard;
int num_subnets;
enum octTransformType trans;
int lay1,lay2;
octObject inst;

num_subnets = 0;
non_standard = FALSE;
h_wid = 0;
v_wid = 0;
for(sl = viaptr->subnets;sl != NULL;sl = sl->next,num_subnets++)
  {
    subnet = sl->subnet;
    if(((subnet->term1_status == VIA) && (subnet->term1.via == viaptr)) || 
       ((subnet->term2_status == VIA) && (subnet->term2.via == viaptr)))
      {
	non_standard |= (layer_width[subnet->layerid] != subnet->width);
	if(channel_types == HORIZONTAL)
	  {
	    if(subnet->dir == VERTICAL)
	      h_wid = MAX(h_wid,subnet->width);
	    else
	      v_wid = MAX(v_wid,subnet->width);
	  }
	else
	  {
	    if(subnet->dir == VERTICAL)
	      v_wid = MAX(v_wid,subnet->width);
	    else
	      h_wid = MAX(h_wid,subnet->width);
	  }
      }
    else
      printf("ERROR-- subnet not connected to via\n");
  }
trans = OCT_NO_TRANSFORM;
if(non_standard)
  {
    if(num_subnets == 0)
      printf("ERROR in via - subnet connections\n");
    lay1 = viaptr->layer1;
    lay2 = viaptr->layer2;
    if(num_subnets == 1)
      {
	lay1 = MET1;
	lay2 = MET2;
      }
    viamaster = getOrCreateVia(h_wid,v_wid,lay1,lay2,&trans);
  }
else
  {
    viamaster = via_nameTable[viaptr->layer1][viaptr->layer2];
    if(h_wid < v_wid)
	trans = OCT_ROT90;      
  }
if(abs((viaptr->layer1 - viaptr->layer2)) > 1)
  printf("WARNING -- two layer via jump being used\n");
createOctInstance(&inst, 
		  viaptr->vianame, 
		  viamaster, 
		  "physical", 
		  viaptr->x, 
		  viaptr->y, 
		  trans);
attach(connBag,&inst);
return(inst.objectId);
}

make_channel_outline(facet,layer)
octObject *facet, *layer;
{
vertex_type *vert;
int side;

for(side = TOP;side <= RIGHT;side++)
  {
    for(vert = CHAN_BOUND->first[side];vert != NULL;vert = vert->next)
      {
	if(vert->next != NULL)
	   make_segment(facet, layer, 20, vert->x, vert->y, vert->next->x, vert->next->y);
      }
  }
}

make_segment(facet, layer, width, x1, y1, x2, y2)
octObject *facet, *layer;
int  width, x1,x2,y1,y2;
{
octObject segment;
struct octPoint path[2];	/*  points for a wire segment  */

path[0].x = x1;
path[0].y = y1;
path[1].x = x2;
path[1].y = y2;

segment.type = OCT_PATH;
segment.contents.path.width = width;
if (octCreate(facet, &segment) != OCT_OK)  
  {
    octError("createOctSubnet:  creating octPath for segment\n");
    exit(-10);
  }

/*
 *  The segment is also attached to the layer 
 */

if (octAttach(layer, &segment) != OCT_OK)  
  {
    octError("createOctSubnet:  creating subnet\n");
    exit(-10);
  }

/*
 *  Add the endpoint coordinates to the path
 */
path[0].x = x1;
path[0].y = y1;
path[1].x = x2;
path[1].y = y2;

if (octPutPoints(&segment, 2, path) != OCT_OK)  
  {
    octError("createOctSubnet:  adding coordinates to path\n");
    exit(-10);
  }
}

extern octObject layers[3];

show_boundary(bound,layernum)
int layernum;
octObject *bound;
{
octObject layer,inst,connBag,old;
pin_type *pin;
int side;

old.type = OCT_FACET;
old.contents.facet.cell = channelName;
old.contents.facet.view = "preroute";
old.contents.facet.version = OCT_CURRENT_VERSION;
old.contents.facet.facet = "contents";

oCellFacet.type = OCT_FACET;
oCellFacet.contents.facet.cell = channelName;
oCellFacet.contents.facet.view = "symbolic";
oCellFacet.contents.facet.facet = "contents";
oCellFacet.contents.facet.version = OCT_CURRENT_VERSION;
oCellFacet.contents.facet.mode = "a";
if(octCopyFacet(&oCellFacet,&old) != OCT_OK)
  {
    logError("(SPIDER):WARNING problem in copying preroute information",FATAL);
  }

if(octOpenFacet(&oCellFacet) < OCT_OK)	
  logError("can not open oct file for channel\n",FATAL);

OCTCHKOK(octGetOrCreate(&oCellFacet,&(layers[layernum])));
make_channel_outline(&oCellFacet,&(layers[layernum]));
createOctBag(&connBag,"CONNECTORS");
for(side = TOP;side <= RIGHT;side++)
  {
    for(pin = FIRST_PIN(side);pin != NULL;pin = pin->next)
      {
	createOctInstance(&inst, 
			  pin->pinname,
			  via_nameTable[MET1][MET2],
			  "physical", 
			  pin->x, 
			  pin->y, 
			  OCT_NO_TRANSFORM);
	attach(&connBag,&inst);
      }
  }
}


