#include "oct.h"

enum Udirection  { U_UNDEFINED = 0, U_UP, U_DOWN, U_LEFT, U_RIGHT, U_AMBIG, U_STRAIGHT };

#define U_UP_MASK 	(1<<(int)U_UP)
#define U_DOWN_MASK 	(1<<(int)U_DOWN)
#define U_LEFT_MASK	(1<<(int)U_LEFT)
#define U_RIGHT_MASK	(1<<(int)U_RIGHT)
#define U_ALL_DIRECTION_MASK ( U_UP_MASK | U_DOWN_MASK | U_LEFT_MASK | U_RIGHT_MASK )

struct obj_list
{
struct obj_list *next;
struct obj_list *prev;
octObject obj;
};

typedef struct {
    octId    Ucenter;		/* center segment of the U */
    octCoord Uwidth;		/* width of the U = length of center segment */
    octId    Uc1;		/* connector 1 */
    octId    Uc2;		/* connector 2 */
    struct obj_list *center_list;
    struct obj_list *list1;
    struct obj_list *list2;
    enum Udirection Udir;
    int	     Usimple;		/* 1 if the U is simple like U and not complex like _U_ */
} U ;


typedef struct u_list_element {
    U* u;
    struct u_list_element* next;
    struct u_list_element* prec;
} UlistElement;

typedef struct {
    int count;
    UlistElement* first;
    UlistElement* last;
} Ulist;



extern Ulist* createUlist( /**/ );
extern U* createU( /**/ );
extern void clearUlist( /* list */ );
extern int findAllU( /* net, list, direction_mask, max_width, min_depth */ );
extern int push_U( /* facet, u */ );
