#include <stdio.h>
#include "myU.h"

static int debug = 0;

U* createU( center, direction, width ) 
    octObject* center;
    enum Udirection direction;
    octCoord width;
{
    U* u = (U*)malloc( sizeof(U) );
    u->Ucenter = center->objectId;
    u->Udir = direction;
    u->Uwidth = width;
    u->Usimple = 0;
    u->list1 = u->list2 = u->center_list = NULL;
    if (debug) {
      fprintf( stderr, "Created U: width %d, direction %d\n", width, direction );
    }
    return u;
}

UlistElement* createUlistElement( u ) 
    U* u;
{
    UlistElement* e = (UlistElement*)malloc( sizeof(UlistElement) );
    e->u = u;
    e->next = 0;
    e->prec = 0;
    return e;
}

Ulist* createUlist()
{
    Ulist* l = (Ulist*)malloc( sizeof(Ulist) );
    l->count = 0;
    l->first = (UlistElement*)0;
    l->last = (UlistElement*)0;
    return l;
}

void clearUlist( l )
    Ulist* l;
{
    l->count = 0;
    l->first = (UlistElement*)0;
    l->last = (UlistElement*)0;
}

/*
 * The list is always ordered by the Uwidth;
 */
addUlist( l , u )
    Ulist* l;
    U* u;
{
    UlistElement* e = createUlistElement( u );
    UlistElement* ptr;

    int w = u->Uwidth;
    if(alreadyInList(l,u) == TRUE)
      return;
    
    if ( l->count == 0 ) {
	l->first = e;
	l->last = e;
	l->count = 1;
	return;
    }
    /* linear search for the right position in the list */
    if ( w <= l->first->u->Uwidth ) {
	e->next = l->first;
	e->next->prec = e;
	l->first = e;
    } else if ( w >= l->last->u->Uwidth ) {
	e->prec = l->last;
	e->prec->next = e;
	l->last = e;
    } else {
	for ( ptr = l->first ; ptr != 0 ; ptr = ptr->next ) {
	    if ( ptr->u->Uwidth >= w ) {
		e->next = ptr;
		e->prec = ptr->prec;
		e->prec->next = e;
		e->next->prec = e;
		break;
	    }
	}
    }
    l->count++;
    return;
}

alreadyInList(l,u)
    Ulist* l;
    U* u;
{
  UlistElement* ptr;

  for ( ptr = l->first ; ptr != 0 ; ptr = ptr->next )
    {
      if((u->Uc1 == ptr->u->Uc1) || (u->Uc1 == ptr->u->Uc2))
	return(TRUE);
    }
return(FALSE);
}
