#include "copyright.h"
#include "port.h"
#include "myU.h"
#include "tap.h"
#include <sys/stat.h>
char *TECH_DIR = NULL;

#define OCT_TO_LAMBDA 20
#define CONTACTS_DIR "special_contacts"
static char *via_name_templates[3][3] = {
  {"",""     ,     ""},
  {"","m1m1","com2"},
  {"","com2","m2m2"}};

/****************************************************************/

char *getOrCreateVia(facet,h_wid,v_wid,lay1,lay2,trans)
octObject *facet;
int h_wid,v_wid,lay1,lay2;
enum octTransformType *trans;
{
char buf2[256];
char *name;

if(TECH_DIR == NULL)
  TECH_DIR = tapGetDirectory(facet);
name = malloc(sizeof(char) * 256);

(*trans) = OCT_NO_TRANSFORM;

if((h_wid == 0) || (v_wid == 0))
  {
    h_wid = MAX(h_wid,v_wid);
    v_wid = MAX(h_wid,v_wid);
  }
if(h_wid/OCT_TO_LAMBDA <= 3)
  h_wid = 4 * OCT_TO_LAMBDA;
if(v_wid/OCT_TO_LAMBDA <= 3)
  v_wid = 4 * OCT_TO_LAMBDA;
if(h_wid >= v_wid)
  sprintf(name,"%s/primitives/non_std_sizes/%s.%dx%d",
	  TECH_DIR,
	  via_name_templates[lay1][lay2],
	  h_wid/OCT_TO_LAMBDA,
	  v_wid/OCT_TO_LAMBDA);
else
  {
    sprintf(name,"%s/primitives/non_std_sizes/%s.%dx%d",
	    TECH_DIR,
	    via_name_templates[lay1][lay2],
	    v_wid/OCT_TO_LAMBDA,
	    h_wid/OCT_TO_LAMBDA);
    (*trans) = OCT_ROT90;
  }
if(checkViaExist(name) == FALSE)
  {
    if(h_wid >= v_wid)
      make_weird_via_name(name,		
			  via_name_templates[lay1][lay2],
			  h_wid/OCT_TO_LAMBDA,
			  v_wid/OCT_TO_LAMBDA);
    else
      make_weird_via_name(name,		
			  via_name_templates[lay1][lay2],
			  v_wid/OCT_TO_LAMBDA,
			  h_wid/OCT_TO_LAMBDA);  
    
    if(checkViaExist(name) == FALSE)
      {
	if(h_wid >= v_wid)
	  create_new_via( via_name_templates[lay1][lay2],
			 h_wid/OCT_TO_LAMBDA,
			 v_wid/OCT_TO_LAMBDA);
	else
	  create_new_via( via_name_templates[lay1][lay2],
			 v_wid/OCT_TO_LAMBDA,
			 h_wid/OCT_TO_LAMBDA);	    
      }	
    sprintf(buf2,"../%s",name);
    strcpy(name,buf2);
  }
return(name);
}

/****************************************************************/

checkViaExist(name)
char *name;
{
octObject facet;
struct octFacetInfo info;

facet.type = OCT_FACET;
facet.contents.facet.cell = name;
facet.contents.facet.view = "physical";
facet.contents.facet.facet = "contents";
facet.contents.facet.version = OCT_CURRENT_VERSION;
facet.contents.facet.mode = "r";

if(octGetFacetInfo(&facet,&info) < OCT_OK)
  return(FALSE);
return(TRUE);
}

/****************************************************************/

make_weird_via_name(buffer,name,wid,height)
char *buffer, *name;
int wid, height;
{
sprintf(buffer,"%s/%s.%dx%d",CONTACTS_DIR,name,wid,height);
}

/****************************************************************/

create_new_via(name,wid,height)
char *name;
int wid, height;
{
char command[200];
struct stat buf;

if(stat(CONTACTS_DIR,&buf) != 0)
  sprintf(command, "mkdir %s; cd %s; prim %s %d %d;",CONTACTS_DIR, CONTACTS_DIR, name, wid, height);
else
  sprintf(command, "cd %s; prim %s %d %d;",CONTACTS_DIR, name, wid, height);

system(command);
/*  commented out because prim returns garbage
if(system(command) != 0)
  {
    printf("ERROR in creating new contact\n");
    exit(99);
  }
*/
}




