#include "myU.h"
#define T1_min 0x8
#define T1_max 0x4
#define T2_min 0x2
#define T2_max 0x1
  
  struct obj_list *new_obj_list()
{
  struct obj_list *ol;
  
  ol = (  struct obj_list *)malloc( sizeof(struct obj_list));
  ol->next = NULL;
  ol->prev = NULL;
  ol->obj.objectId = 0;
  return(ol);
}

add_to_obj_list(end,obj)
     struct obj_list **end;
     octObject *obj;
{
  (*end)->next = new_obj_list();
  (*end)->next->obj = (*obj);
  (*end)->next->prev = (*end);
  (*end) = (*end)->next;
}

enum Udirection get_term_dir(path, term)
     octObject *path;		/* The segment connected to two terms. */
     octObject *term;
{
  octGenerator genTerm;
  struct octBox box1,box2;
  octObject term1;
  struct octPoint p[2];
  int status;
  int min,max;
  
  get_path(path,p);
  get_term_BB(term, &box1);

  OCTCHKOK(octInitGenContents(path, OCT_TERM_MASK, &genTerm));
  OCTCHKOK(octGenerate( &genTerm, &term1 ));
  if(octIdsEqual(term->objectId, term1.objectId))
    OCTCHKOK(octGenerate( &genTerm, &term1 ));
  get_term_BB(&term1, &box2);
  
  status = 0;
  if(direction(p) == HOR)
    {
      min = MIN(p[0].x,p[1].x);
      max = MAX(p[0].x,p[1].x);
      status |= ((box1.lowerLeft.x <= min) && (min <= box1.upperRight.x))?T1_min:0;
      status |= ((box1.lowerLeft.x <= max) && (max <= box1.upperRight.x))?T1_max:0;
      status |= ((box2.lowerLeft.x <= min) && (min <= box2.upperRight.x))?T2_min:0;
      status |= ((box2.lowerLeft.x <= max) && (max <= box2.upperRight.x))?T2_max:0;
    } 
  else 
    {
      min = MIN(p[0].y,p[1].y);
      max = MAX(p[0].y,p[1].y);
      status |= ((box1.lowerLeft.y <= min) && (min <= box1.upperRight.y))?T1_min:0;
      status |= ((box1.lowerLeft.y <= max) && (max <= box1.upperRight.y))?T1_max:0;
      status |= ((box2.lowerLeft.y <= min) && (min <= box2.upperRight.y))?T2_min:0;
      status |= ((box2.lowerLeft.y <= max) && (max <= box2.upperRight.y))?T2_max:0;
    }
  
  switch(status)
    {
    case 0x06 /* 0110 */:
    case 0x07 /* 0111 */:
    case 0x0e /* 1110 */:
      if(direction(p) == HOR)
	return(U_RIGHT);
      else 
	return(U_UP);
      break;
    case 0x09 /* 1001 */:
    case 0x0b /* 1011 */:
    case 0x0d /* 1101 */:
      if(direction(p) == HOR)
	return(U_LEFT);
      else 
	return(U_DOWN);
      break;
    case 0x0f /* 1111 */:
      printf("AMBIGUOUS PATH\n");
      return(U_AMBIG);
      break;
    default:
      printf("ERROR in determining terminal side -- status 0x0%x \n",status);
      printf("box1 %d %d %d %d\n",
	     box1.lowerLeft.x,
	     box1.lowerLeft.y,
	     box1.upperRight.x,
	     box1.upperRight.y);
      printf("box2 %d %d %d %d\n",
	     box2.lowerLeft.x,
	     box2.lowerLeft.y,
	     box2.upperRight.x,
	     box2.upperRight.y);
      printf("path %d %d %d %d\n",
	     p[0].x,p[0].y,
	     p[1].x,p[1].y);
      exit(8);
    }
}

find_continuous_path(path,ol)
     octObject *path;
     struct obj_list **ol;
{
  octObject term;
  octId id,save;
  enum Udirection Udir;
  struct obj_list *last;
  
  /*  move left (down) */
  save = id = path->objectId;
  Udir = (pathDirection(path) == HOR)? U_LEFT : U_DOWN;
  while(TRUE) 
    {
      if ( get_term_in_dir(path, Udir, &term) == FALSE)
	return(FALSE);
      if(is_term_a_connector(&term) == FALSE)
	break;
      if(countAdjacentSegments( &term, path ) != 1)
	return(FALSE);
      if(get_path_in_direction2(&term,path,Udir) == FALSE)
	break;
      id = path->objectId;
    }
  path->objectId = id;
  OCTCHKOK(octGetById(path));
  /* look right (up) */
  Udir = (Udir == U_LEFT)? U_RIGHT: U_UP;
  
  (*ol) = new_obj_list();
  (*ol)->obj = term;
  last = (*ol);
  
  while(TRUE)
    {
      add_to_obj_list(&last, path);
      if( get_term_in_dir(path, Udir, &term) == FALSE)
	return FALSE;
      add_to_obj_list(&last, &term);
      if(is_term_a_connector(&term) == FALSE)
	break;
      if(countAdjacentSegments( &term, path ) != 1)
	return FALSE;
      if(get_path_in_direction2(&term,path,Udir) == FALSE)
	break;
    }
  path->objectId = save;
  OCTCHKOK(octGetById(path));
  return(TRUE);
}

int
  get_path_in_direction(inst,path,dir)
octObject *inst, *path;
enum Udirection dir;
{
  octGenerator pathGen;
  enum Udirection t_dir;
  octObject term;

  OCTCHKOK(octGenFirstContent(inst,OCT_TERM_MASK,&term));
  OCTCHKOK(octInitGenContainers(&term, OCT_PATH_MASK, &pathGen));
  while(octGenerate(&pathGen,path) == OCT_OK)
    {
      t_dir = get_term_dir(path, &term);
      if(opposite_dir(t_dir) == dir)
	return(TRUE);
    }
  return(FALSE);
}

int
  get_path_in_direction2(term,path,dir)
octObject *term, *path;
enum Udirection dir;
{
  octGenerator pathGen;
  enum Udirection t_dir;
  
  OCTCHKOK(octInitGenContainers(term, OCT_PATH_MASK, &pathGen));
  while(octGenerate(&pathGen,path) == OCT_OK)
    {
      t_dir = get_term_dir(path, term);
      if(opposite_dir(t_dir) == dir)
	return(TRUE);
    }
  return(FALSE);
}

get_continious_path_length(list,start,stop)
struct obj_list *list;
int  *start, *stop;
{
  struct obj_list *l;
  octObject term, path1;
  int dir,loc;
  struct octPoint p[2];
  struct octBox box;

  (*start) = MAXINT;
  (*stop) = MININT;
  
  if(list->next == NULL)
    {
      printf("INTERNAL ERROR 77\n");
      exit(77);
    }
  get_term_BB(&(list->obj), &box);

  if(list->next->obj.type != OCT_PATH)
    {
      printf("INTERNAL ERROR 79\n");
      exit(79);
    }
  dir = pathDirection(&(list->next->obj));
  if(dir == HOR) 
    (*start) = (box.lowerLeft.x + box.upperRight.x) / 2. ;
  else
    (*start) = (box.lowerLeft.y + box.upperRight.y) / 2. ;

  for(l = list;(l != NULL) && (l->next != NULL);l = l->next)
    {}

  get_term_BB(&(list->obj), &box);

  if(dir == HOR) 
    (*stop) = (box.lowerLeft.x + box.upperRight.x) / 2. ;
  else
    (*stop) = (box.lowerLeft.y + box.upperRight.y) / 2. ;
}

simplify_continuous_path(list,path,dir)
     struct obj_list *list;     
     octObject *path;
     enum Udirection dir;
{
  octObject inst;
  octObject term;
  octObject path1;
  struct obj_list *l;

  for(l = list;(l != NULL);l = l->next)
    if(octIdsEqual(l->obj.objectId, path->objectId))
      break;
  if(l == NULL)
    {
      printf("INTERNAL ERROR 81\n");
      exit(81);
    }
  
  if((dir == U_UP) || (dir == U_RIGHT))
    {
      while(l != NULL)
	{
	  l = l->next;
	  term = l->obj;
	  if(term.type != OCT_TERM)
	    {
	      printf("INTERNAL ERROR 82\n");
	      exit(82);
	    }	
	  l = l->next;
	  if(l == NULL)
	    break;
	  if(l->obj.type != OCT_PATH)
	    {
	      printf("INTERNAL ERROR 83\n");
	      exit(83);
	    }
	  merge_contact(&term, &(l->obj), path);
	}
    }
  else
    {
      while(l->prev != NULL)
	{
	  l = l->prev;
	  term = l->obj;
	  if(term.type != OCT_TERM)
	    {
	      printf("INTERNAL ERROR 84\n");
	      exit(84);
	    }	
	  l = l->prev;
	  if(l == NULL)
	    break;
	  if(l->obj.type != OCT_PATH)
	    {
	      printf("INTERNAL ERROR 85\n");
	      exit(85);
	    }
	  merge_contact(&term, &(l->obj), path);
	}
    }
}

#ifdef OUT_OF_DATE
print_contin_path(ol)
struct obj_list *ol;
{
octObject obj;
struct octPoint p[2];

printf("print path -----------------\n");
for(;ol != NULL;ol = ol->next)
  {
    obj.objectId = ol->id;
    OCTCHKOK(octGetById(&obj));
    printf("id %d  ",ol->id);
    if(obj.type == OCT_PATH)
      {
	get_path(&obj,p);
	printf("PATH %d %d %d %d\n",p[0].x,p[0].y,p[1].x,p[1].y);
      }
    else
      if(obj.type == OCT_TERM)
	{
	  printf("TERM ");
	  if ( !  symConnectorp( &obj ) )
	    printf("of instance\n");
	  else
	    printf("of connector\n");	    
	}
      else
	if(obj.type == OCT_INSTANCE)
	  printf("INSTANCE\n");
	else
	  printf("unknown object -- type %d\n",obj.type);

  }
printf("=============== end =================\n");
}
#endif

get_continous_path_min_width(list)
struct obj_list *list;
{
  struct obj_list *l;
  octObject path1;
  int width;

  width = MAXINT;
  for(l = list;(l != NULL) && (l->next != NULL);l = l->next)
    {
      if(l->obj.type == OCT_PATH)
	width = MIN(width,l->obj.contents.path.width);
    }
return(width);
}

get_continuous_path_at_loc(list,path,loc)
struct obj_list *list;
octObject *path;
int loc;
{
  struct obj_list *l;
  int dir;
  struct octPoint p[2];

  (*path) = list->next->obj;
  dir = pathDirection(path);

  for(l = list;(l != NULL) && (l->next != NULL);l = l->next)
    {
      if(dir == HOR)
	{
	  (*path) = l->obj;
	  if(path->type == OCT_PATH)
	    {
	      get_path(path, p);
	      if((MIN(p[0].x,p[1].x) <= loc) &&
		 (loc <= MAX(p[0].x,p[1].x)))
		return (TRUE);
	    }
	}
      else
	{
	  (*path) = l->obj;
	  if(path->type == OCT_PATH)
	    {
	      get_path(path, p);
	      if((MIN(p[0].y,p[1].y) <= loc) &&
		 (loc <= MAX(p[0].y,p[1].y)))
		return (TRUE);
	    }
	}
    }
printf("ERROR location is outside continuous path\n");
return(FALSE);
}

#ifdef OUT_OF_DATE
print_contin_path_from_path(path)
octObject *path;
{
struct obj_list *list;

find_continuous_path(path, &list);
print_contin_path(list);
}
#endif

get_term_in_dir(path, dir, term)
     octObject *path;		/* The segment connected to two terms. */
     enum Udirection dir;	/* The direction in which we look for term. */
     octObject *term;
{
  octGenerator genTerm;
  enum Udirection term_dir;
  
  OCTCHKOK(octInitGenContents(path, OCT_TERM_MASK, &genTerm));
  
  OCTCHKOK(octGenerate( &genTerm, term ));
  term_dir = get_term_dir(path,term);
  if(dir == term_dir)
    return(TRUE);

  if(dir == opposite_dir(term_dir))
    {
      OCTCHKOK(octGenerate( &genTerm, term ));
      return(TRUE);
    }
  if(term_dir == U_AMBIG)
    return(FALSE);
  printf("ERROR in finding term direction\n");
  exit(8);
}



get_continious_path_terms(path,t1,t2)
     octObject *path,*t1,*t2;
{
  octObject term;
  octId id,save;
  enum Udirection Udir;
  
  /*  move left (down) */
  save = id = path->objectId;
  Udir = (pathDirection(path) == HOR)? U_LEFT : U_DOWN;
  while(TRUE) 
    {
      if ( get_term_in_dir(path, Udir, &term) == FALSE)
	return(FALSE);
      if(is_term_a_connector(&term) == FALSE)
	return(FALSE);
      if(countAdjacentSegments( &term, path ) != 1)
	return(FALSE);
      if(get_path_in_direction2(&term,path,Udir) == FALSE)
	break;
      id = path->objectId;
    }
  (*t1) = term;
  path->objectId = id;
  OCTCHKOK(octGetById(path));
  /* look right (up) */
  Udir = (Udir == U_LEFT)? U_RIGHT: U_UP;
  while(TRUE)
    {
      if( get_term_in_dir(path, Udir, &term) == FALSE)
	return FALSE;
      if(is_term_a_connector(&term) == FALSE)
	return FALSE;
      if(countAdjacentSegments( &term, path ) != 1)
	return FALSE;
      if(get_path_in_direction2(&term,path,Udir) == FALSE)
	break;
    }
  (*t2) = term;
  path->objectId = save;
  OCTCHKOK(octGetById(path));
  return(TRUE);
}
