#include <stdio.h>
#include "U.h"

static int debug = 0;

 printSegment( seg )
    struct octPoint seg[2];
{
    fprintf( stderr, "%12s: %5d,%5d -- %5d,%5d\n",
	    vertical( seg ) ? "VERTICAL":"HORIZONTAL",
	    seg[0].x,seg[0].y, seg[1].x, seg[1].y );
    return;
}

enum Udirection findDirection( center_line, point ) 
    struct octPoint* center_line;
    struct octPoint* point;
{
    enum Udirection dir = U_UNDEFINED;
    octCoord l = 0;
    if ( horizontal( center_line ) ) {
	l =   point->y - center_line[0].y ;
	if ( l != 0) {
	    dir =  (l > 0) ?  U_UP : U_DOWN;
	}
    } else if ( vertical( center_line ) ) {
	l =   point->x - center_line[0].x ;
	if ( l != 0) {
	    dir =  (l > 0) ?  U_RIGHT : U_LEFT;
	}
    } else {
	fprintf( stderr, "Non manhattan wire found\n");
    }
    if (debug) fprintf( stderr, "Direction: %d (based on length of %d) \n", dir, l );
    return dir;
}

int distance( line, point )
    struct octPoint line[2];
    struct octPoint* point;
{
    int distance = -1;
    if (debug) printSegment( line );
    if ( vertical( line ) ) {
	distance =   iabs( point->x - line[0].x );


    } else if ( horizontal( line ) ) {
	distance =   iabs( point->y - line[0].y );
    } else {
	fprintf( stderr, "Non manhattan wire found\n");
    }
    if (debug) fprintf( stderr, "Distance is %d\n", distance );
    return distance;
}

horizontal( seg )
    struct octPoint seg[2];
{
    return (seg[0].y == seg[1].y);
}

int
vertical( seg )
    struct octPoint seg[2];
{
    return (seg[0].x == seg[1].x);
}

int iabs( n )
    int n;
{
    return ( n > 0 ) ? n : -n ;
}

int isignum( n ) 
    int n;
{
    return ( n < 0 ) ? -1 : ( n > 0) ;
}
