#include "myU.h"
#include "symlib.h"
#define OCT_TO_LAMBDA 20

extern char *getOrCreateVia();


move_U(facet,u,box,type)
    int type;
    octObject *facet;
    U *u;
    struct octBox *box;
{
    printf("Doing U move\n");
    return(complex_move(facet,u,box,type));
}

simple_move(facet,u,box,type)
    int type;
    octObject *facet;
    U *u;
    struct octBox *box;
{
    octObject cont1,cont2;
    octObject path1,path2;
    octObject inst1, inst2;
    octObject center_path;
    struct octPoint p1[2], p2[2];
    int loc;
    int old_type, new_type;
    char *c1_name, *c2_name;
    enum octTransformType trans1, trans2;

    cont1.objectId = u->Uc1;
    OCTCHKOK(octGetById(&cont1));

    cont2.objectId = u->Uc2;
    OCTCHKOK(octGetById(&cont2));

    if((u->Udir == U_UP) || (u->Udir == U_DOWN)) 
      {
	loc = (box->upperRight.y + box->lowerLeft.y) / 2;

	if ( get_continuous_path_at_loc(u->list1,&path1, loc) == FALSE ) 
	  return(FALSE);
	simplify_continuous_path(u->list1,&path1, opposite_dir(u->Udir));
	if ( get_continuous_path_at_loc(u->list2,&path2, loc) == FALSE ) 
	  return(FALSE);
	simplify_continuous_path(u->list2,&path2, opposite_dir(u->Udir));

	if(get_contact_side(&cont1, U_RIGHT) < get_contact_side(&cont2, U_RIGHT))
	  {
	    if(get_path_in_direction(&cont1, &center_path, U_RIGHT) == FALSE)
	      return(FALSE);
	  }
	else
	  if(get_path_in_direction(&cont2, &center_path, U_RIGHT) == FALSE)
	    return(FALSE);
	get_path(&center_path,p1);
	p1[0].y = loc;
	p1[1].y = loc;
	OCTCHKOK(octPutPoints(&center_path, 2, p1));
	if(octIsAttached(&metal1,&center_path) == OCT_OK)
	  old_type = MET1;
	else
	  old_type = MET2;
	if((type == MET1) && (old_type == MET2))
	  {
	      OCTCHKOK(octDetach(&metal2,&center_path));
	      OCTCHKOK(octAttach(&metal1,&center_path));
	  }
	else
	  if((type == MET2) && (old_type == MET1))
	    {
		OCTCHKOK(octDetach(&metal1,&center_path));
		OCTCHKOK(octAttach(&metal2,&center_path));
	    }
	if(octIsAttached(&metal1,&center_path) == OCT_OK)
	  new_type = MET1;
	else
	  new_type = MET2;

	fix_vert_leg(facet,&cont1,&center_path,u,loc,new_type);
	fix_vert_leg(facet,&cont2,&center_path,u,loc,new_type);
      }
    else
      {
	loc = (box->upperRight.x + box->lowerLeft.x) / 2;

	if ( get_continuous_path_at_loc(u->list1,&path1, loc) == FALSE ) 
	  return(FALSE);
	simplify_continuous_path(u->list1,&path1, opposite_dir(u->Udir));
	if ( get_continuous_path_at_loc(u->list2,&path2, loc) == FALSE ) 
	  return(FALSE);
	simplify_continuous_path(u->list2,&path2, opposite_dir(u->Udir));

	if(get_contact_side(&cont1, U_UP) < get_contact_side(&cont2, U_UP))
	  {
	    if(get_path_in_direction(&cont1, &center_path, U_UP) == FALSE)
	      return(FALSE);
	  }
	else
	  if(get_path_in_direction(&cont2, &center_path, U_UP) == FALSE)
	    return(FALSE);
	get_path(&center_path,p1);
	p1[0].x = loc;
	p1[1].x = loc;
	OCTCHKOK(octPutPoints(&center_path, 2, p1));
	if(octIsAttached(&metal1,&center_path) == OCT_OK)
	  old_type = MET1;
	else
	  old_type = MET2;
	if((type == MET1) && (old_type == MET2))
	  {
	      OCTCHKOK(octDetach(&metal2,&center_path));
	      OCTCHKOK(octAttach(&metal1,&center_path));
	  }
	else
	  if((type == MET2) && (old_type == MET1))
	    {
		OCTCHKOK(octDetach(&metal1,&center_path));
		OCTCHKOK(octAttach(&metal2,&center_path));
	    }
	if(octIsAttached(&metal1,&center_path) == OCT_OK)
	  new_type = MET1;
	else
	  new_type = MET2;

	fix_hor_leg(facet,&cont1,&center_path,u,loc,new_type);
	fix_hor_leg(facet,&cont2,&center_path,u,loc,new_type);
    }
    return(TRUE);			/* VOID function */
}

createOctInstance(facet,inst,instname, instmaster, instview, x, y, transform)
octObject 	*facet;
octObject 	*inst;
char		*instname;
char		*instmaster;
char		*instview;
octCoord	x, y;
octTransformType transform;
{

/*
 *  Place an instance of the current object in the contents facet of
 *  the oct cell.
 */

inst->type = OCT_INSTANCE;
inst->contents.instance.name = instname;
inst->contents.instance.master = instmaster;
inst->contents.instance.view = instview;
inst->contents.instance.facet = "contents";
inst->contents.instance.version = OCT_CURRENT_VERSION;
inst->contents.instance.transform.translation.x = x;
inst->contents.instance.transform.translation.y = y;
inst->contents.instance.transform.transformType = transform;

/*
if (octCreate(facet, inst) != OCT_OK)  
  {
    octError("createOctInstance:  attaching instance to content facet.\n");
    printf("createOctInstance:  attaching instance to content facet.\n");
    printf("instname=%s, instmaster=%s, instview=%s, x,y=%d,%d\n",
	   instname, instmaster, instview, x, y);
    exit(-10);
  }
*/
}

complex_move(facet,u,box,type)
int type;
octObject *facet;
U *u;
struct octBox *box;
{
octObject inst1;
octObject path;

if((u->center_list == NULL) ||
   (u->center_list->next == NULL))
  return(FALSE);
   
path = u->center_list->next->obj;
if(pathDirection(&path) == HOR)
  {
    simplify_continuous_path(u->center_list,&path, U_RIGHT);
    simplify_continuous_path(u->center_list,&path, U_LEFT);
  }
else
  {
    simplify_continuous_path(u->center_list,&path, U_UP);
    simplify_continuous_path(u->center_list,&path, U_LEFT);
  }
u->center_list = NULL;
return(simple_move(facet,u,box,type));
}


fix_vert_leg(facet,cont,center_path,u,loc,type)
octObject *facet;
octObject *cont;
octObject *center_path;
int loc;
int type;
U *u;
{
octObject path,inst,term1,term2;
struct octPoint p[2];
char *c1_name;
enum octTransformType trans;
octGenerator termGen;

if(get_path_in_direction(cont, &path, u->Udir) == FALSE)
  return;
get_path(&path, p);
if(u->Udir == U_UP)
  {
    if(p[0].y < p[1].y)
      p[0].y = loc;
    else
      p[1].y = loc;
  }
else
  {
    if(p[0].y > p[1].y)
      p[0].y = loc;
    else
      p[1].y = loc;
  }

if(p[0].y == p[1].y)
  {
    OCTCHKOK(octGenFirstContent(cont, OCT_TERM_MASK, &term1));
    OCTCHKOK(octInitGenContents(&path, OCT_TERM_MASK, &termGen));
    while((octGenerate(&termGen, &term2) == OCT_OK) &&
	  (octIdsEqual(term1.objectId, term2.objectId)))
      {}
    OCTCHKOK(octDelete(&path));
    OCTCHKOK(octDelete(cont));
    OCTCHKOK(octAttach(center_path, &term2));
  }
else
  {
    OCTCHKOK(octPutPoints(&path, 2, p));
    cont->contents.instance.transform.translation.y = loc;
    OCTCHKOK(octModify(cont));
    c1_name = getOrCreateVia(facet,
			     path.contents.path.width,
			     center_path->contents.path.width,
			     get_path_layer(&path),
			     type, 
			     &trans);
    createOctInstance(facet,
		      &inst,
		      cont->contents.instance.name,
		      c1_name, 
		      "physical", 
		      cont->contents.instance.transform.translation.x,
		      cont->contents.instance.transform.translation.y,
		      trans);
    symReplaceInstance(cont, &inst);
  }
}


fix_hor_leg(facet,cont,center_path,u,loc,type)
octObject *facet;
octObject *cont;
octObject *center_path;
int loc;
int type;
U *u;
{
octObject path,inst,term1,term2;
struct octPoint p[2];
char *c1_name;
enum octTransformType trans;
octGenerator termGen;

if(get_path_in_direction(cont, &path, u->Udir) == FALSE)
  return;
get_path(&path, p);
if(u->Udir == U_RIGHT)
  {
    if(p[0].x < p[1].x)
      p[0].x = loc;
    else
      p[1].x = loc;
  }
else
  {
    if(p[0].x > p[1].x)
      p[0].x = loc;
    else
      p[1].x = loc;
  }

if(p[0].x == p[1].x)
  {
    OCTCHKOK(octGenFirstContent(cont, OCT_TERM_MASK, &term1));
    OCTCHKOK(octInitGenContents(&path, OCT_TERM_MASK, &termGen));
    while((octGenerate(&termGen, &term2) == OCT_OK) &&
	  (octIdsEqual(term1.objectId, term2.objectId)))
      {}
    OCTCHKOK(octDelete(&path));
    OCTCHKOK(octDelete(cont));
    OCTCHKOK(octAttach(center_path, &term2));
  }
else
  {
    OCTCHKOK(octPutPoints(&path, 2, p));
    cont->contents.instance.transform.translation.x = loc;
    OCTCHKOK(octModify(cont));
    c1_name = getOrCreateVia(facet,
			     path.contents.path.width,
			     center_path->contents.path.width,
			     get_path_layer(&path),
			     type, 
			     &trans);
    createOctInstance(facet,
		      &inst,
		      cont->contents.instance.name,
		      c1_name, 
		      "physical", 
		      cont->contents.instance.transform.translation.x,
		      cont->contents.instance.transform.translation.y,
		      trans);
    symReplaceInstance(cont, &inst);
  }
}

