#include "copyright.h"
#include "port.h"
#include "oct.h"

/**************************************************************/

octStatus openFacet(obj,cell,view,facet,version,mode)
char *cell,*view,*facet,*mode,*version;
octObject *obj;
{
obj->type = OCT_FACET;
obj->contents.facet.cell = cell;
obj->contents.facet.view = view;
obj->contents.facet.facet = facet;
obj->contents.facet.version = version;
obj->contents.facet.mode = mode;

return(octOpenFacet(obj));
}

/**************************************************************/

char *oct_find_str_prop(obj,prop_name)
octObject *obj;
char *prop_name;
{
octObject prop;
char str[50];

prop.type = OCT_PROP;
prop.contents.prop.name = prop_name;
if(octGetByName(obj,&prop) != OCT_OK)
  {
    (void) sprintf(str,"could not find oct property %s",prop_name);
    octError(str);
    return(NULL);
  }
return(prop.contents.prop.value.string);
}

/**************************************************************/

attach(obj1,obj2)
octObject *obj1,*obj2;
{
  if (octAttach(obj1, obj2) != OCT_OK)  
    {
      octError("attach:  attaching two objects.\n");
      exit(-10);
    }
}

/**************************************************************/

closeOctFacet(facet)
octObject *facet;
{

if (octCloseFacet(facet) != OCT_OK)  
  {
    printf("saveOctFacet: saving contents facet for top-level cell");
    octError("saveOctFacet: saving contents facet for top-level cell");
    exit(-10);
  }
printf("End saveOctFacet\n");
}

