#include "myU.h"
#include "region.h"
octObject metal1, metal2, poly, connector_bag;

push_U(facet, u)
U *u;
octObject *facet;
{
octObject cont1,cont2;
octObject path1,path2;
int end,start,side1,side2;
int s1,s2;
int width;
int type;
struct octBox box;
int dist;
octObject obj;
int min1, min2;
int max1, max2;
static int layers = FALSE;

if(layers == FALSE)
  {
    poly.type = OCT_LAYER;
    poly.contents.layer.name = "POLY";
    OCTCHKOK(octGetOrCreate(facet,&poly));
    
    metal1.type = OCT_LAYER;
    metal1.contents.layer.name = "MET1";
    OCTCHKOK(octGetOrCreate(facet,&metal1));
    
    metal2.type = OCT_LAYER;
    metal2.contents.layer.name = "MET2";
    OCTCHKOK(octGetOrCreate(facet,&metal2));

    layers = TRUE;
  }

cont1.objectId = u->Uc1;
OCTCHKOK(octGetById(&cont1));
if(get_path_in_direction(&cont1, &path1, u->Udir) == FALSE)
  return(0);

cont2.objectId = u->Uc2;
OCTCHKOK(octGetById(&cont2));
if(get_path_in_direction(&cont2, &path2, u->Udir) == FALSE)
  return(0);
obj.objectId = u->Ucenter;
OCTCHKOK(octGetById(&obj));

if(find_continuous_path(&path1,&(u->list1)) == FALSE)
  return(0);
if(find_continuous_path(&path2,&(u->list2)) == FALSE)
  return(0);
if(find_continuous_path(&obj,&(u->center_list)) == FALSE)
  return(0);

get_continious_path_length(u->list1,&min1,&max1);
if((u->Udir == U_DOWN) || (u->Udir == U_LEFT))
  max1 = min1;

get_continious_path_length(u->list2,&min2,&max2);
if((u->Udir == U_DOWN) || (u->Udir == U_LEFT))
  max2 = min2;

/*
max1 = get_extreme_dimension(&cont1,&path1,u->Udir);
max2 = get_extreme_dimension(&cont2,&path2,u->Udir);
*/

s1 = get_contact_side(&cont1,u->Udir);
s2 = get_contact_side(&cont2,u->Udir);
width = get_continous_path_min_width(u->center_list) + 2 * SPACING;

switch(u->Udir)
  {
  case U_UP:    
    end = MIN(max1,max2) + width/2.;
    start = MAX(s1,s2) + 1;
    side1 = get_path_location(&path1,VERT);
    side2 = get_path_location(&path2,VERT);
    if(side1 < side2)
      {
	side1 = get_contact_side(&cont1, U_RIGHT) + 1;
	side2 = get_contact_side(&cont2, U_LEFT) - 1;
      }
    else
      {
	side1 = get_contact_side(&cont2, U_RIGHT) + 1;
	side2 = get_contact_side(&cont1, U_LEFT) - 1;
      }
    if((type = sweep(facet,side1,side2,start,end,u->Udir,width,&box)) != NONE)
      {
/*
	show_region(facet, side1,side2,start,end,"NDIF");
*/
	dist = ((box.upperRight.y + box.lowerLeft.y) / 2) - get_path_location(&obj, HOR);
	printf("movement %d\n",dist);
	if(move_U(facet,u,&box,type) == FALSE)
	  return(0);
	return(dist);
      }
    break;
  case U_DOWN:
    end = MAX(max1,max2) - width/2.;
    start = MIN(s1,s2) - 1;
    side1 = get_path_location(&path1,VERT);
    side2 = get_path_location(&path2,VERT);
    if(side1 < side2)
      {
	side1 = get_contact_side(&cont1, U_RIGHT) + 1;
	side2 = get_contact_side(&cont2, U_LEFT) - 1;
      }
    else
      {
	side1 = get_contact_side(&cont2, U_RIGHT) + 1;
	side2 = get_contact_side(&cont1, U_LEFT) - 1;
      }
    if((type = sweep(facet,side1,side2,end,start,u->Udir,width,&box)) != NONE)
      {
/*
	show_region(facet, side1,side2,end,start,"NDIF");
*/
	dist = get_path_location(&obj, HOR) - ((box.upperRight.y + box.lowerLeft.y) / 2);
	printf("movement %d\n",dist);
	if(move_U(facet,u,&box,type) == FALSE)
	  return(0);
	return(dist);
      }
    break;
  case U_RIGHT:
    end = MIN(max1, max2) + width/2.;
    start = MAX(s1,s2) - 1;
    side1 = get_path_location(&path1,HOR);
    side2 = get_path_location(&path2,HOR);
    if(side1 < side2)
      {
	side1 = get_contact_side(&cont1, U_UP) + 1;
	side2 = get_contact_side(&cont2, U_DOWN) - 1;
      }
    else
      {
	side1 = get_contact_side(&cont2, U_UP) + 1;
	side2 = get_contact_side(&cont1, U_DOWN) - 1;
      }
    if((type = sweep(facet,start,end,side1,side2,u->Udir,width,&box)) != NONE)
      {
/*
	show_region(facet, start,end,side1,side2,"NDIF");
*/
	dist = ((box.upperRight.x + box.lowerLeft.x) / 2) - get_path_location(&obj, VERT);
	printf("movement %d\n",dist);
	if(move_U(facet,u,&box,type) == FALSE)
	  return(0);
	return(dist);
      }
    break;
  case U_LEFT:
    end = MAX(max1, max2)  - width/2.;
    start = MIN(s1,s2) + 1;
    side1 = get_path_location(&path1,HOR);
    side2 = get_path_location(&path2,HOR);
    if(side1 < side2)
      {
	side1 = get_contact_side(&cont1, U_UP) + 1;
	side2 = get_contact_side(&cont2, U_DOWN) - 1;
      }
    else
      {
	side1 = get_contact_side(&cont2, U_UP) + 1;
	side2 = get_contact_side(&cont1, U_DOWN) - 1;
      }
    if((type = sweep(facet,end,start,side1,side2,u->Udir,width,&box)) != NONE)
      {
/*
	show_region(facet, end,start,side1,side2,"NDIF");
*/
	dist = get_path_location(&obj, VERT) - ((box.upperRight.x + box.lowerLeft.x) / 2);
	printf("movement %d\n",dist);
	if(move_U(facet,u,&box,type) == FALSE)
	  return(0);
	return(dist);
      }
    break;
  }
return(0);
}


sweep(facet,x1,x2,y1,y2,dir,width,box)
octObject *facet;
enum Udirection dir;
int width;
int x1,x2,y1,y2;
struct octBox *box;
{
int start,end;
regObjGen gen;
int m1,m2,l;
struct octBox intersectionBox;
octObject obj;
int reg_end;

switch(dir)
  {
  case U_UP:    
    start = y2;
    end = y1;
    box->lowerLeft.x = x1;
    box->upperRight.x = x2;
    break;
  case U_DOWN:
    start = y1;
    end = y2;
    box->lowerLeft.x = x1;
    box->upperRight.x = x2;
    break;
  case U_RIGHT:
    start = x2;
    end = x1;
    box->lowerLeft.y = y1;
    box->upperRight.y = y2;
    break;
  case U_LEFT:
    start = x1;
    end = x2;
    box->lowerLeft.y = y1;
    box->upperRight.y = y2;
    break;
  }

while(TRUE)
  {
    switch(dir)
      {
      case U_UP:
	reg_end = start - width;
	if(reg_end < end)
	  return(NONE);
	box->lowerLeft.y = reg_end;
	box->upperRight.y = start;
	m1 = m2 = start;
	if(regObjStart(facet,box,OCT_PATH_MASK | OCT_INSTANCE_MASK, &gen, 0) != REG_OK)
	  {
	    printf("ERROR in initializing region search\n");
	    exit(9);
	  }
	while(regObjNext(gen, &obj) != REG_NOMORE)
	  {
	    if(obj.type == OCT_PATH)	  
	      {
		if(octIsAttached(&metal1,&obj) == OCT_OK)
		  {
		    if(pathDirection(&obj) == HOR)
		      {
			l = get_path_location(&obj, HOR);
			m1 = MIN(m1, l - obj.contents.path.width / 2);
		      }
		    else
		      {
			l = get_path_end(&obj, U_DOWN);
			m1 = MIN(m1,l);
		      }
		  }
		if(octIsAttached(&metal2,&obj) == OCT_OK)
		  {
		    if(pathDirection(&obj) == HOR)
		      {
			l = get_path_location(&obj, HOR);
			m2 = MIN(m2, l - obj.contents.path.width / 2);
		      }
		    else
		      {
			l = get_path_end(&obj, U_DOWN);
			m2 = MIN(m2,l);
		      }
		  }
	      }
	    else
	      {
		if( instanceBoxIntersect( &obj, box, "MET1", &intersectionBox ) != 0)
		  {
		    l = intersectionBox.lowerLeft.y;
		    m1 = MIN(m1,l);
		  }
		if( instanceBoxIntersect( &obj, box, "MET2", &intersectionBox ) != 0)
		  {
		    l = intersectionBox.lowerLeft.y;
		    m2 = MIN(m2,l);
		  }
	      }
	  }
	if(m1 == start)
	  {
	    if(m2 == start)
	      {
		return(BOTH_1_AND_2);
	      }
	    else
	      {
		return(MET1);
	      }
	  }
	else
	  {	
	    if(m2 == start)
	      {
		return(MET2);
	      }
	    else
	      {
		start = MAX(m1,m2);
	      }
	  }
	break;
      case U_DOWN:
	reg_end = start + width;
	if(reg_end > end)
	  return(NONE);
	box->lowerLeft.y = start;
	box->upperRight.y = reg_end;
	m1 = m2 = start;
	if(regObjStart(facet,box,OCT_PATH_MASK | OCT_INSTANCE_MASK, &gen, 0) != REG_OK)
	  {
	    printf("ERROR in initializing region search\n");
	    exit(9);
	  }
	while(regObjNext(gen, &obj) != REG_NOMORE)
	  {
	    if(obj.type == OCT_PATH)	  
	      {
		if(octIsAttached(&metal1,&obj) == OCT_OK)
		  {
		    if(pathDirection(&obj) == HOR)
		      {
			l = get_path_location(&obj, HOR);
			m1 = MAX(m1, l + obj.contents.path.width / 2);
		      }
		    else
		      {
			l = get_path_end(&obj, U_UP);
			m1 = MAX(m1,l);
		      }
		  }
		if(octIsAttached(&metal2,&obj) == OCT_OK)
		  {
		    if(pathDirection(&obj) == HOR)
		      {
			l = get_path_location(&obj, HOR);
			m2 = MAX(m2, l + obj.contents.path.width / 2);
		      }
		    else
		      {
			l = get_path_end(&obj, U_UP);
			m2 = MAX(m2,l);
		      }
		  }
	      }
	    else
	      {
		if( instanceBoxIntersect( &obj, box, "MET1", &intersectionBox ) != 0)
		  {
		    l = intersectionBox.upperRight.y;
		    m1 = MAX(m1,l);
		  }
		if( instanceBoxIntersect( &obj, box, "MET2", &intersectionBox ) != 0)
		  {
		    l = intersectionBox.upperRight.y;
		    m2 = MAX(m2,l);
		  }
	      }
	  }
	if(m1 == start)
	  {
	    if(m2 == start)
	      {
		return(BOTH_1_AND_2);
	      }
	    else
	      {
		return(MET1);
	      }
	  }
	else
	  {	
	    if(m2 == start)
	      {
		return(MET2);
	      }
	    else
	      {
		start = MIN(m1,m2);
	      }
	  }
	break;
      case U_RIGHT:
	reg_end = start - width;
	if(reg_end < end)
	  return(NONE);
	box->lowerLeft.x = reg_end;
	box->upperRight.x = start;
	m1 = m2 = start;
	if(regObjStart(facet,box,OCT_PATH_MASK | OCT_INSTANCE_MASK, &gen, 0) != REG_OK)
	  {
	    printf("ERROR in initializing region search\n");
	    exit(9);
	  }
	while(regObjNext(gen, &obj) != REG_NOMORE)
	  {
	    if(obj.type == OCT_PATH)	  
	      {
		if(octIsAttached(&metal1,&obj) == OCT_OK)
		  {
		    if(pathDirection(&obj) == VERT)
		      {
			l = get_path_location(&obj, VERT);
			m1 = MIN(m1, l - obj.contents.path.width / 2);
		      }
		    else
		      {
			l = get_path_end(&obj, U_LEFT);
			m1 = MIN(m1,l);
		      }
		  }
		if(octIsAttached(&metal2,&obj) == OCT_OK)
		  {
		    if(pathDirection(&obj) == VERT)
		      {
			l = get_path_location(&obj, VERT);
			m2 = MIN(m2, l - obj.contents.path.width / 2);
		      }
		    else
		      {
			l = get_path_end(&obj, U_LEFT);
			m2 = MIN(m2,l);
		      }
		  }
	      }
	    else
	      {
		if( instanceBoxIntersect( &obj, box, "MET1", &intersectionBox ) != 0)
		  {
		    l = intersectionBox.lowerLeft.x;
		    m1 = MIN(m1,l);
		  }
		if( instanceBoxIntersect( &obj, box, "MET2", &intersectionBox ) != 0)
		  {
		    l = intersectionBox.lowerLeft.x;
		    m2 = MIN(m2,l);
		  }
	      }
	  }
	if(m1 == start)
	  {
	    if(m2 == start)
	      {
		return(BOTH_1_AND_2);
	      }
	    else
	      {
		return(MET1);
	      }
	  }
	else
	  {	
	    if(m2 == start)
	      {
		return(MET2);
	      }
	    else
	      {
		start = MAX(m1,m2);
	      }
	  }
	break;
      case U_LEFT:
	reg_end = start + width;
	if(reg_end > end)
	  return(NONE);
	box->lowerLeft.x = start;
	box->upperRight.x = reg_end;
	m1 = m2 = start;
	if(regObjStart(facet,box,OCT_PATH_MASK | OCT_INSTANCE_MASK, &gen, 0) != REG_OK)
	  {
	    printf("ERROR in initializing region search\n");
	    exit(9);
	  }
	while(regObjNext(gen, &obj) != REG_NOMORE)
	  {
	    if(obj.type == OCT_PATH)	  
	      {
		if(octIsAttached(&metal1,&obj) == OCT_OK)
		  {
		    if(pathDirection(&obj) == VERT)
		      {
			l = get_path_location(&obj, VERT);
			m1 = MAX(m1, l + obj.contents.path.width / 2);
		      }
		    else
		      {
			l = get_path_end(&obj, U_RIGHT);
			m1 = MAX(m1,l);
		      }
		  }
		if(octIsAttached(&metal2,&obj) == OCT_OK)
		  {
		    if(pathDirection(&obj) == VERT)
		      {
			l = get_path_location(&obj, VERT);
			m2 = MAX(m2, l + obj.contents.path.width / 2);
		      }
		    else
		      {
			l = get_path_end(&obj, U_RIGHT);
			m2 = MAX(m2,l);
		      }
		  }
	      }
	    else
	      {
		if( instanceBoxIntersect( &obj, box, "MET1", &intersectionBox ) != 0)
		  {
		    l = intersectionBox.upperRight.x;
		    m1 = MAX(m1,l);
		  }
		if( instanceBoxIntersect( &obj, box, "MET2", &intersectionBox ) != 0)
		  {
		    l = intersectionBox.upperRight.x;
		    m2 = MAX(m2,l);
		  }
	      }
	  }
	if(m1 == start)
	  {
	    if(m2 == start)
	      {
		return(BOTH_1_AND_2);
	      }
	    else
	      {
		return(MET1);
	      }
	  }
	else
	  {	
	    if(m2 == start)
	      {
		return(MET2);
	      }
	    else
	      {
		start = MIN(m1,m2);
	      }
	  }
	break;
      }
  }
}
