#include <stdio.h>
#include "copyright.h"
#include "port.h"
#include "rpc.h"
#include "oh.h"
#include "U.h"

char	errmsg[256];

static vemSelSet selset = 0;
static Ulist* listOfAllU = 0;


int rpcFindU();
int rpcClearU();
int rpcReduceU();
int rpcExitU();

RPCFunction CommandArray[] = {
    { rpcFindU,	"Utify", "Find U's in net"},
    { rpcClearU,"Utify", "clear U's"},
    { rpcReduceU, "Utify", "reduce U's"},
    { rpcExitU,	"Utify", "exit"}
};


/*ARGSUSED*/
long UserMain(display, spot, cmdList, uow, array)
    char		*display;
    RPCSpot		*spot;
    lsList		cmdList;
    long		uow;
    RPCFunction		**array;
{
    VEMMSG("Utify ready.\n");
    *array = CommandArray;
    return(sizeof(CommandArray) / sizeof(RPCFunction));
}

/*ARGSUSED*/
int rpcExitU(spot, cmdList, uow)
    RPCSpot		*spot;
    lsList		cmdList;
    long		uow;
{
    if ( selset != 0) vemClearSelSet( selset );
    RPCExit( RPC_OK );
}


int showUs( facetId, list )
    octId facetId;
    Ulist* list;
{
    UlistElement* elt;

    if ( selset == 0 ) {
	selset = vemNewSelSet( facetId, 62000, 62000, 18000, 1, 1, 2 , 2 , "01 10" );
	if ( selset == 0 ) return -1;
    }
    for ( elt = list->first ; elt != 0 ; elt = elt->next ) {
	vemAddSelSet( selset, elt->u->Ucenter);
    }
    return 0;
}

int rpcFindU(spot, cmdList, uow)
    RPCSpot		*spot;
    lsList		cmdList;
    long		uow;
{
    RPCArg *arg;
    octObject argBag;
    octObject net;
    octGenerator genNet;
    Ulist* list;
    char msg[256];
    octCoord max_width = 0;
    octCoord min_depth = 8;

    if (lsLength(cmdList) != 1) {
	VEMMSG("ERROR: [\"net\"] find-U's\n");
	return RPC_OK;
    } 
    lsFirstItem(cmdList, (Pointer *) &arg, (lsHandle *) 0);
    if (arg->argType != VEM_OBJ_ARG) {
	VEMMSG("ERROR: [\"net\"] find-U's\n");
	return RPC_OK;
    }

    OH_ASSERT( ohGetById( &argBag, arg->argData.objArg.theBag ));
    OH_ASSERT( octInitGenContents( &argBag, OCT_NET_MASK, &genNet )) ;
    listOfAllU = createUlist();
    while ( octGenerate( &genNet, &net ) == OCT_OK ) {
	findAllU( &net, listOfAllU, max_width, min_depth );
    }
    showUs( spot->facet,  listOfAllU );
    sprintf( msg , "Found %d U's\n", listOfAllU->count );
    VEMMSG( msg );
    return RPC_OK;
}

int rpcReduceU(spot, cmdList, uow)
    RPCSpot		*spot;
    lsList		cmdList;
    long		uow;
{
    RPCArg *arg;
    octObject argBag;
    octObject net;
    octGenerator genNet;
    char msg[256];
    octObject facet;
    UlistElement* ptr ;
    U* u;

    ohGetById( &facet, spot->facet );
    for ( ptr = listOfAllU->first; ptr != 0 ; ptr = ptr->next ) {
	u = ptr->u;
	push_U( &facet, u );
    }
    sprintf( msg , "Done reducing\n" );
    VEMMSG( msg );
    return RPC_OK;
}



int rpcClearU(spot, cmdList, uow)
    RPCSpot		*spot;
    lsList		cmdList;
    long		uow;
{
    if ( selset != 0) vemClearSelSet( selset );
    return RPC_OK;
}



