#include "myU.h"
#include "region.h"
extern octObject connector_bag;

pathDirection(path)
octObject *path;
{
    struct octPoint p[2];

    get_path(path,p);
    return(direction(p));
}

direction(p)
    struct octPoint *p;
{
    if(p[0].x == p[1].x)
      return VERT;
    if(p[0].y == p[1].y)
      return HOR;
    printf("%d %d %d %d\n",
	   p[0].x,
	   p[0].y,
	   p[1].x,
	   p[1].y);
    printf("ERROR diagonal path\n");
    exit(9);
}

print_path(path)
octObject *path;
{
    struct octPoint p[2];

    get_path(path,p);
    printf("%d %d  %d %d\n",p[0].x, p[0].y, p[1].x, p[1].y);
}


get_other_end(cont, path, obj)
octObject *cont, *obj, *path;
{
octGenerator termGen;
octObject term1, term2;

OCTCHKOK(octGenFirstContent(cont, OCT_TERM_MASK, &term1));
OCTCHKOK(octInitGenContents(path, OCT_TERM_MASK, &termGen));
while((octGenerate(&termGen, &term2) == OCT_OK) &&
	(octIdsEqual(term1.objectId, term2.objectId)))
    {}
OCTCHKOK(octGenFirstContainer(&term2,OCT_INSTANCE_MASK,obj));
/*
if(octIsAttached(&connectors_bag, obj) == OCT_OK)
  return(U_CONNECTOR);
return(U_INSTANCE);
*/

if ( !  symConnectorp( &term2 ) )
  return(U_INSTANCE);
return(U_CONNECTOR);
}

get_extreme_dimension(cont1, path, dir)
octObject *cont1, *path;
enum Udirection dir;
{
octObject cont2;
int type;
int s;
struct octPoint p[2];

type = get_other_end(cont1, path, &cont2);
if(type == U_CONNECTOR)
  {
    s = get_contact_side(&cont2,dir);
    switch(dir)
      {
      case U_UP:    
	return(s + SPACING);
      case U_DOWN:
	return(s - SPACING);
      case U_RIGHT:
	return(s + SPACING);
      case U_LEFT:
	return(s - SPACING);
      }
  }
else
  {
    get_path(path,p);
    switch(dir)
      {
      case U_UP:    
	return(MAX(p[0].y,p[1].y));
      case U_DOWN:
	return(MIN(p[0].y,p[1].y));
      case U_RIGHT:
	return(MAX(p[0].x,p[1].x));
      case U_LEFT:
	return(MIN(p[0].x,p[1].x));
      }
  }
}
 
get_contact_side(cont,dir)
octObject *cont;
enum Udirection dir;
{
struct octBox box;

OCTCHKOK(octBB(cont,&box));
switch(dir)
  {
  case U_UP:    
    return(box.upperRight.y);
  case U_DOWN:
    return(box.lowerLeft.y);
  case U_RIGHT:
    return(box.upperRight.x);
  case U_LEFT:
    return(box.lowerLeft.x);
  }
}

int
get_path_location(path, type)
octObject *path;
int type;
{
    struct octPoint p[2];

    get_path(path,p);
    if(type == VERT) {
	return(p[0].x);
    } else {
	return(p[0].y);
    }
}

show_region(facet,x1,x2,y1,y2,layer_name)
int x1,x2,y1,y2;
octObject *facet;
char *layer_name;
{
octObject box, layer;

box.type = OCT_BOX;
box.contents.box.lowerLeft.x = x1;
box.contents.box.upperRight.x = x2;
box.contents.box.lowerLeft.y = y1;
box.contents.box.upperRight.y = y2;
OCTCHKOK(octCreate(facet,&box));

layer.type = OCT_LAYER;
layer.contents.layer.name = layer_name;
OCTCHKOK(octGetOrCreate(facet,&layer));
OCTCHKOK(octAttach(&layer,&box));
}

get_path_width(pathId)
int pathId;
{
octObject path;

path.objectId = pathId;
OCTCHKOK(octGetById(&path));
return(path.contents.path.width);
}

get_path_layer(path)
octObject *path;
{
if(octIsAttached(&poly,path) == OCT_OK)
  return(POLY);
if(octIsAttached(&metal1,path) == OCT_OK)
  return(MET1);
if(octIsAttached(&metal2,path) == OCT_OK)
  return(MET2);
return(NONE);
}

get_path_end(path,dir)
octObject *path;
enum Udirection dir;
{
struct octPoint p[2];

get_path(path,p);
switch(dir)
  {
  case U_UP:    
    return(MAX(p[0].y,p[1].y));
  case U_DOWN:
    return(MIN(p[0].y,p[1].y));
  case U_RIGHT:
    return(MAX(p[0].x,p[1].x));
  case U_LEFT:
    return(MIN(p[0].x,p[1].x));
  }
}

/* note path2 is always preserved */

merge_contact(term,path1,path2)
octObject *path1,*path2,*term;
{
octObject term1,term2,inst;
struct octPoint p2[2];
octGenerator term_gen;
struct octBox box1,box2;

OCTCHKOK(octInitGenContents(path1,OCT_TERM_MASK,&term_gen));
OCTCHKOK(octGenerate(&term_gen,&term1));
if(octIdsEqual(term1.objectId, term->objectId))
  {
    if(octGenerate(&term_gen,&term1) != OCT_OK)
      {
	printf("(UTIFY): ERROR path has only one terminal\n");
	exit(9);
      }
    if(octIdsEqual(term1.objectId, term->objectId))
      {
	printf("(UTIFY):ERROR - internal problems\n");
	exit(9);
      }
  }
OCTCHKOK(octInitGenContents(path2,OCT_TERM_MASK,&term_gen));
if(octGenerate(&term_gen,&term2) != OCT_OK)
  {
    printf("(UTIFY): ERROR path has no terminals\n");
    exit(9);
  }
if(octIdsEqual(term2.objectId, term->objectId))
  {
    if(octGenerate(&term_gen,&term2) != OCT_OK)
      {
	printf("(UTIFY): ERROR path has only one terminal\n");
	exit(9);
      }
    if(octIdsEqual(term2.objectId, term->objectId))
      {
	printf("(UTIFY):ERROR - internal problems\n");
	exit(9);
      }
  }

get_term_BB(&term1, &box1);
get_term_BB(&term2, &box2);
get_path(path2,p2);

if(direction(p2) == HOR)
  {
    p2[0].x = (box2.upperRight.x + box2.lowerLeft.x) / 2;
    p2[1].x = (box1.upperRight.x + box1.lowerLeft.x) / 2;
    if(p2[0].x == p2[1].x)
      p2[1].x++;
  }
else
  {
    p2[0].y = (box2.upperRight.y + box2.lowerLeft.y) / 2;
    p2[1].y = (box1.upperRight.y + box1.lowerLeft.y) / 2;
    if(p2[0].y == p2[1].y)
      p2[1].y++;
  }

printf("merge %d %d %d %d -- ",
       p2[0].x,
       p2[0].y,
       p2[1].x,
       p2[1].y);
      printf("box1 %d %d %d %d -- ",
	     box1.lowerLeft.x,
	     box1.lowerLeft.y,
	     box1.upperRight.x,
	     box1.upperRight.y);
      printf("box2 %d %d %d %d -- path1 ",
	     box2.lowerLeft.x,
	     box2.lowerLeft.y,
	     box2.upperRight.x,
	     box2.upperRight.y);
print_path(path1);
printf(" -- path2 ");
print_path(path2);
printf("\n");

OCTCHKOK(octDetach(path2,term));
OCTCHKOK(octAttach(path2,&term1));
OCTCHKOK(octPutPoints(path2,2,p2));

OCTCHKOK(octDelete(path1));

OCTCHKOK(octGenFirstContainer(term,OCT_INSTANCE_MASK,&inst));
OCTCHKOK(octDelete(&inst));
}

get_path(path,points)
octObject *path;
struct octPoint *points;
{
    int32 i;

    i = 2;
    if((octGetPoints(path,&i,points) != OCT_OK) || (i != 2))
      {
	  printf("ERROR in getting path points\n");
	  exit(9);
      }
    return;
}

int
get_path_at_loc(path, loc)
octObject *path;
int loc;
{
    octObject term1;
    octObject inst1;
    int status;
    int dir;
    struct octPoint p[2];
    int min,max;
    octId old_id;

    dir = pathDirection(path);
    while(TRUE)
      {
	  get_path(path, p);
	  old_id = path->objectId;
	  if(dir == HOR)
	    {
		min = MIN(p[0].x,p[1].x);
		max = MAX(p[0].x,p[1].x);
		if((min <= loc) && (loc <= max))
		  return;
	
		if(max < loc)
		  {
		      if( get_term_in_dir(path, U_RIGHT, &term1) == FALSE)
			return FALSE;
		      if ( !  symConnectorp( &term1 ) )  
			{
			    printf("ERROR location is outside continuous path\n");
			    return FALSE;
			}
		      OCTCHKOK(octGenFirstContainer(&term1,OCT_INSTANCE_MASK,&inst1));
		      status = get_path_in_direction(&inst1,path,U_RIGHT);
		  }
		else
		  {
		      if( get_term_in_dir(path, U_LEFT, &term1) == FALSE)
			return FALSE;
		      if ( !  symConnectorp( &term1 ) )  
			{
			    printf("ERROR location is outside continuous path\n");
			    return FALSE;
			}
		      OCTCHKOK(octGenFirstContainer(&term1,OCT_INSTANCE_MASK,&inst1));
		      status = get_path_in_direction(&inst1,path,U_LEFT);
		  }
		if(status == FALSE)
		  {
		      printf("ERROR location is outside continuous path\n");
		      return FALSE;
		  }
	    }
	  else
	    {
		min = MIN(p[0].y,p[1].y);
		max = MAX(p[0].y,p[1].y);
		if((min <= loc) && (loc <= max))
		  return;
	
		if(max < loc)
		  {
		      if( get_term_in_dir(path, U_UP, &term1) == FALSE)
			return FALSE;
		      if ( !  symConnectorp( &term1 ) )  
			{
			    printf("ERROR location is outside continuous path\n");
			    return FALSE;
			}
		      OCTCHKOK(octGenFirstContainer(&term1,OCT_INSTANCE_MASK,&inst1));
		      status = get_path_in_direction(&inst1,path,U_UP);
		  }
		else
		  {
		      if( get_term_in_dir(path, U_DOWN, &term1) == FALSE)
			return FALSE;
		      if ( !  symConnectorp( &term1 ) )  
			{
			    printf("ERROR location is outside continuous path\n");
			    return FALSE;
			}
		      OCTCHKOK(octGenFirstContainer(&term1,OCT_INSTANCE_MASK,&inst1));
		      status = get_path_in_direction(&inst1,path,U_DOWN);
		  }
		if(status == FALSE)
		  {
		      printf("ERROR location is outside continuous path\n");
		      return FALSE;
		  }
	      }
	  if(octIdsEqual(path->objectId, old_id))
	    return FALSE;
	  old_id = path->objectId;
      }
}

get_term_BB(term, box)
octObject *term;
struct octBox *box;
{
octObject inst;

OCTCHKOK(octGenFirstContainer(term,OCT_INSTANCE_MASK,&inst));
if ( octIsAttached(&connector_bag,&inst) == OCT_OK)
  {
    OCTCHKOK(octBB(&inst, box));
  }
else
  {
    if(regFindImpl(term, box) != REG_OK)
      {
	printf("problems with region stuff\n");
	exit(9);
      }
  }
}

is_term_a_connector(term)
octObject *term;
{
octObject inst;

OCTCHKOK(octGenFirstContainer(term,OCT_INSTANCE_MASK,&inst));
if ( octIsAttached(&connector_bag,&inst) == OCT_OK)
  return(TRUE);
return(FALSE);
}
