#include "port.h"
#include "oct.h"
#include "wolfe.h"

char *print_location[5] = {"TOP", "BOTTOM", "LEFT", "RIGHT","BOTH"};

pin_t ***channel;		/* Structure describes pins in channels */
block_record_t **block_list;	/* Structure describes the cells in rows */

int debug = 0;			/* debug parameter */
int min_xposition;		/* min x position of all cells */
int max_xposition;		/* max x position of all cells */

int units_per_lambda;		/* Scaling from lambda to Oct units */

char *vlayer_name;		/* Vertical layer design rules */
int vlayer_width ;
int vlayer_pitch;

char *hlayer_name;		/* Horizontal layer design rules */
int hlayer_width;
int hlayer_pitch;

char *feedthru_cell;		/* The feedthru cell information */
char *feedthru_view;
int feedThruWidth;

char *v_contact_name;		/* Vertical-to-vertical contact */
char *v_contact_view;

char *h_contact_name;		/* Horizontal-to-horizontal contact */
char *h_contact_view;

char *hv_contact_name;		/* Horizontal-to-vertical contact */
char *hv_contact_view;
int  hv_contact_width;
int  hv_contact_height;

int complex_feeds = 0;

#ifdef TW4_2
int  fallback = 0;
#endif
#ifdef TW3_3
int att_per_cell = 0;		/* attempts per cell (simulated annealing) */
double do_global_route_cell_swaps = 0.0; /* magic TW parameter */
double indent = 0.96;		/* amount to indent towards the middle */
#endif
int power_width = 20;
int power_position = LEFT;
int extend_terms = 0;
int fast_mode = 0;
int Add_implicit = 1;
int addFeeds = 1;		/* force TW to add feed-thrus */
#ifndef TW5_0
double implicit_feed_thru_range = .25;	/* unused so far */
#endif
double rowSep = 2.0;		/* average row-to-row separation */
int do_global_route = 1;	/* force TW to do a global routing */
int num_rows = -1;		/* number of rows for the macro cell */
double h_net_weight = 1.0;	/* default h-net weight */
double v_net_weight = 1.0;	/* default v-net weight */
double TargetAspectRatio = 1.0;

