%{
#include "port.h"
#include "utility.h"
#include "oct.h"
#include "wolfe.h"

int *timberwolf_density;	/* exported to route.c */
%}

digit		[0-9]
number		{digit}+
whitespace	[ \n\t]*


%%
"MAX OF CHANNEL:"{whitespace}{number}{whitespace}"is:"{whitespace}{number} { 
    int i, density;
    if (sscanf(yytext, "MAX OF CHANNEL: %d is: %d", &i, &density) == 2)
	if (i >= 0 && i <= num_rows+1) 
	    timberwolf_density[i] = density;
}
\n	;
.	;
%%

echo_output_file(prefix)
char *prefix;
{
    extern FILE *yyin;
    char filename[1024];
    int i;

    (void) sprintf(filename, "%s.out", prefix);
    if ((yyin = fopen(filename, "r")) == NULL) {
	perror(filename);
	return 1;
    }
    timberwolf_density = ALLOC(int, num_rows+2);
    for(i = 0; i <= num_rows + 1; i++) {
	timberwolf_density[i] = 0;
    }
    yylex();
    return 0;
}

yywrap()
{
    return 1;
}
